/* DockletManager.c generated by valac 0.56.9, the Vala compiler
 * generated from DockletManager.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
/* portions based on code from Rygel*/
/*
 * Copyright (C) 2008 Nokia Corporation.
 * Copyright (C) 2008 Zeeshan Ali (Khattak) <zeeshanak@gnome.org>.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include "plank.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <config.h>
#include "plank-internal.h"
#include <gmodule.h>

enum  {
	PLANK_DOCKLET_MANAGER_0_PROPERTY,
	PLANK_DOCKLET_MANAGER_NUM_PROPERTIES
};
static GParamSpec* plank_docklet_manager_properties[PLANK_DOCKLET_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
enum  {
	PLANK_DOCKLET_MANAGER_DOCKLET_ADDED_SIGNAL,
	PLANK_DOCKLET_MANAGER_NUM_SIGNALS
};
static guint plank_docklet_manager_signals[PLANK_DOCKLET_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankDockletManagerPrivate {
	GeeHashMap* docklets;
};

struct _Block4Data {
	int _ref_count_;
	PlankDockletManager* self;
	PlankDocklet* docklet;
	gchar* uri;
};

static gint PlankDockletManager_private_offset;
static gpointer plank_docklet_manager_parent_class = NULL;
static GRegex* plank_docklet_manager_docklet_filename_regex;
static GRegex* plank_docklet_manager_docklet_filename_regex = NULL;
static PlankDockletManager* plank_docklet_manager_instance;
static PlankDockletManager* plank_docklet_manager_instance = NULL;

static PlankDockletManager* plank_docklet_manager_new (void);
static PlankDockletManager* plank_docklet_manager_construct (GType object_type);
static void plank_docklet_manager_load_modules_from_dir (PlankDockletManager* self,
                                                  GFile* dir);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda15_ (Block4Data* _data4_,
                      const gchar* k,
                      PlankDocklet* v);
static gboolean ___lambda15__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static void plank_docklet_manager_load_module_from_file (PlankDockletManager* self,
                                                  const gchar* file_path);
static GObject * plank_docklet_manager_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void plank_docklet_manager_finalize (GObject * obj);
static GType plank_docklet_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GRegex* _tmp_regex_0 = NULL;

static inline gpointer
plank_docklet_manager_get_instance_private (PlankDockletManager* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockletManager_private_offset);
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
#line 54 "../lib/Docklets/DockletManager.vala"
	if (g_once_init_enter ((volatile gsize*) re)) {
#line 54 "../lib/Docklets/DockletManager.vala"
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
#line 54 "../lib/Docklets/DockletManager.vala"
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
#line 140 "DockletManager.c"
	}
#line 54 "../lib/Docklets/DockletManager.vala"
	return *re;
#line 144 "DockletManager.c"
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 54 "../lib/Docklets/DockletManager.vala"
	return self ? g_regex_ref (self) : NULL;
#line 152 "DockletManager.c"
}

PlankDockletManager*
plank_docklet_manager_get_default (void)
{
	PlankDockletManager* _tmp0_;
	PlankDockletManager* _tmp2_;
	PlankDockletManager* result;
#line 59 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = plank_docklet_manager_instance;
#line 59 "../lib/Docklets/DockletManager.vala"
	if (_tmp0_ == NULL) {
#line 165 "DockletManager.c"
		PlankDockletManager* _tmp1_;
#line 60 "../lib/Docklets/DockletManager.vala"
		_tmp1_ = plank_docklet_manager_new ();
#line 60 "../lib/Docklets/DockletManager.vala"
		_g_object_unref0 (plank_docklet_manager_instance);
#line 60 "../lib/Docklets/DockletManager.vala"
		plank_docklet_manager_instance = _tmp1_;
#line 173 "DockletManager.c"
	}
#line 62 "../lib/Docklets/DockletManager.vala"
	_tmp2_ = plank_docklet_manager_instance;
#line 62 "../lib/Docklets/DockletManager.vala"
	result = _tmp2_;
#line 62 "../lib/Docklets/DockletManager.vala"
	return result;
#line 181 "DockletManager.c"
}

static PlankDockletManager*
plank_docklet_manager_construct (GType object_type)
{
	PlankDockletManager * self = NULL;
#line 71 "../lib/Docklets/DockletManager.vala"
	self = (PlankDockletManager*) g_object_new (object_type, NULL);
#line 69 "../lib/Docklets/DockletManager.vala"
	return self;
#line 192 "DockletManager.c"
}

static PlankDockletManager*
plank_docklet_manager_new (void)
{
#line 69 "../lib/Docklets/DockletManager.vala"
	return plank_docklet_manager_construct (PLANK_TYPE_DOCKLET_MANAGER);
#line 200 "DockletManager.c"
}

/**
 * Load docklet modules from known directories
 */
void
plank_docklet_manager_load_docklets (PlankDockletManager* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	const gchar* docklet_dirs = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 82 "../lib/Docklets/DockletManager.vala"
	g_return_if_fail (self != NULL);
#line 84 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = g_file_new_for_path (DOCKLETSDIR);
#line 84 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = _tmp0_;
#line 84 "../lib/Docklets/DockletManager.vala"
	plank_docklet_manager_load_modules_from_dir (self, _tmp1_);
#line 84 "../lib/Docklets/DockletManager.vala"
	_g_object_unref0 (_tmp1_);
#line 86 "../lib/Docklets/DockletManager.vala"
	_tmp2_ = g_getenv ("PLANK_DOCKLET_DIRS");
#line 86 "../lib/Docklets/DockletManager.vala"
	docklet_dirs = _tmp2_;
#line 87 "../lib/Docklets/DockletManager.vala"
	_tmp3_ = docklet_dirs;
#line 87 "../lib/Docklets/DockletManager.vala"
	if (_tmp3_ != NULL) {
#line 232 "DockletManager.c"
		const gchar* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
#line 88 "../lib/Docklets/DockletManager.vala"
		_tmp4_ = docklet_dirs;
#line 88 "../lib/Docklets/DockletManager.vala"
		_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ":", 0);
#line 240 "DockletManager.c"
		{
			gchar** dir_collection = NULL;
			gint dir_collection_length1 = 0;
			gint _dir_collection_size_ = 0;
			gint dir_it = 0;
#line 88 "../lib/Docklets/DockletManager.vala"
			dir_collection = _tmp6_;
#line 88 "../lib/Docklets/DockletManager.vala"
			dir_collection_length1 = _vala_array_length (_tmp5_);
#line 88 "../lib/Docklets/DockletManager.vala"
			for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
#line 252 "DockletManager.c"
				const gchar* dir = NULL;
#line 88 "../lib/Docklets/DockletManager.vala"
				dir = dir_collection[dir_it];
#line 256 "DockletManager.c"
				{
					const gchar* _tmp7_;
					GFile* _tmp8_;
					GFile* _tmp9_;
#line 89 "../lib/Docklets/DockletManager.vala"
					_tmp7_ = dir;
#line 89 "../lib/Docklets/DockletManager.vala"
					_tmp8_ = g_file_new_for_path (_tmp7_);
#line 89 "../lib/Docklets/DockletManager.vala"
					_tmp9_ = _tmp8_;
#line 89 "../lib/Docklets/DockletManager.vala"
					plank_docklet_manager_load_modules_from_dir (self, _tmp9_);
#line 89 "../lib/Docklets/DockletManager.vala"
					_g_object_unref0 (_tmp9_);
#line 271 "DockletManager.c"
				}
			}
#line 88 "../lib/Docklets/DockletManager.vala"
			dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_free), NULL);
#line 276 "DockletManager.c"
		}
	}
}

/**
 * Register docklet with given name and type
 *
 * @param type a type
 */
void
plank_docklet_manager_register_docklet (PlankDockletManager* self,
                                        GType type)
{
	PlankDocklet* docklet = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	const gchar* id = NULL;
	PlankDocklet* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	PlankDocklet* _tmp8_;
	PlankDocklet* _tmp9_;
#line 97 "../lib/Docklets/DockletManager.vala"
	g_return_if_fail (self != NULL);
#line 99 "../lib/Docklets/DockletManager.vala"
	if (!g_type_is_a (type, PLANK_TYPE_DOCKLET)) {
#line 305 "DockletManager.c"
		const gchar* _tmp0_;
#line 100 "../lib/Docklets/DockletManager.vala"
		_tmp0_ = g_type_name (type);
#line 100 "../lib/Docklets/DockletManager.vala"
		g_warning ("DockletManager.vala:100: '%s' is not a Docklet", _tmp0_);
#line 101 "../lib/Docklets/DockletManager.vala"
		return;
#line 313 "DockletManager.c"
	}
#line 104 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = g_object_new (type, NULL);
#line 104 "../lib/Docklets/DockletManager.vala"
	_tmp2_ = G_IS_INITIALLY_UNOWNED (_tmp1_) ? g_object_ref_sink (_tmp1_) : _tmp1_;
#line 104 "../lib/Docklets/DockletManager.vala"
	docklet = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PLANK_TYPE_DOCKLET, PlankDocklet);
#line 106 "../lib/Docklets/DockletManager.vala"
	_tmp3_ = docklet;
#line 106 "../lib/Docklets/DockletManager.vala"
	_tmp4_ = plank_docklet_get_id (_tmp3_);
#line 106 "../lib/Docklets/DockletManager.vala"
	id = _tmp4_;
#line 107 "../lib/Docklets/DockletManager.vala"
	_tmp5_ = id;
#line 107 "../lib/Docklets/DockletManager.vala"
	g_message ("DockletManager.vala:107: Docklet '%s' registered", _tmp5_);
#line 108 "../lib/Docklets/DockletManager.vala"
	_tmp6_ = self->priv->docklets;
#line 108 "../lib/Docklets/DockletManager.vala"
	_tmp7_ = id;
#line 108 "../lib/Docklets/DockletManager.vala"
	_tmp8_ = docklet;
#line 108 "../lib/Docklets/DockletManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, _tmp8_);
#line 110 "../lib/Docklets/DockletManager.vala"
	_tmp9_ = docklet;
#line 110 "../lib/Docklets/DockletManager.vala"
	g_signal_emit (self, plank_docklet_manager_signals[PLANK_DOCKLET_MANAGER_DOCKLET_ADDED_SIGNAL], 0, _tmp9_);
#line 104 "../lib/Docklets/DockletManager.vala"
	_g_object_unref0 (docklet);
#line 345 "DockletManager.c"
}

/**
 * Find docklet for given id
 *
 * @param id a unique id
 * @return a docklet or null
 */
PlankDocklet*
plank_docklet_manager_get_docklet_by_id (PlankDockletManager* self,
                                         const gchar* id)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	PlankDocklet* result;
#line 119 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 121 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = self->priv->docklets;
#line 121 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, id);
#line 121 "../lib/Docklets/DockletManager.vala"
	result = (PlankDocklet*) _tmp1_;
#line 121 "../lib/Docklets/DockletManager.vala"
	return result;
#line 373 "DockletManager.c"
}

/**
 * Find docklet wich supports given uri
 *
 * @param uri an URI
 * @return a docklet or null
 */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 130 "../lib/Docklets/DockletManager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 130 "../lib/Docklets/DockletManager.vala"
	return _data4_;
#line 389 "DockletManager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 130 "../lib/Docklets/DockletManager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 399 "DockletManager.c"
		PlankDockletManager* self;
#line 130 "../lib/Docklets/DockletManager.vala"
		self = _data4_->self;
#line 130 "../lib/Docklets/DockletManager.vala"
		_g_object_unref0 (_data4_->docklet);
#line 130 "../lib/Docklets/DockletManager.vala"
		_g_free0 (_data4_->uri);
#line 130 "../lib/Docklets/DockletManager.vala"
		_g_object_unref0 (self);
#line 130 "../lib/Docklets/DockletManager.vala"
		g_slice_free (Block4Data, _data4_);
#line 411 "DockletManager.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 137 "../lib/Docklets/DockletManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 420 "DockletManager.c"
}

static gboolean
__lambda15_ (Block4Data* _data4_,
             const gchar* k,
             PlankDocklet* v)
{
	PlankDockletManager* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 135 "../lib/Docklets/DockletManager.vala"
	self = _data4_->self;
#line 135 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (k != NULL, FALSE);
#line 135 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (v != NULL, FALSE);
#line 136 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = g_strdup_printf ("%s%s", PLANK_DOCKLET_URI_PREFIX, k);
#line 136 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = _tmp0_;
#line 136 "../lib/Docklets/DockletManager.vala"
	_tmp2_ = g_strcmp0 (_data4_->uri, _tmp1_) == 0;
#line 136 "../lib/Docklets/DockletManager.vala"
	_g_free0 (_tmp1_);
#line 136 "../lib/Docklets/DockletManager.vala"
	if (_tmp2_) {
#line 449 "DockletManager.c"
		PlankDocklet* _tmp3_;
#line 137 "../lib/Docklets/DockletManager.vala"
		_tmp3_ = _g_object_ref0 (v);
#line 137 "../lib/Docklets/DockletManager.vala"
		_g_object_unref0 (_data4_->docklet);
#line 137 "../lib/Docklets/DockletManager.vala"
		_data4_->docklet = _tmp3_;
#line 138 "../lib/Docklets/DockletManager.vala"
		result = FALSE;
#line 138 "../lib/Docklets/DockletManager.vala"
		return result;
#line 461 "DockletManager.c"
	}
#line 140 "../lib/Docklets/DockletManager.vala"
	result = TRUE;
#line 140 "../lib/Docklets/DockletManager.vala"
	return result;
#line 467 "DockletManager.c"
}

static gboolean
___lambda15__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda15_ (self, (const gchar*) k, (PlankDocklet*) v);
#line 135 "../lib/Docklets/DockletManager.vala"
	return result;
#line 479 "DockletManager.c"
}

PlankDocklet*
plank_docklet_manager_get_docklet_by_uri (PlankDockletManager* self,
                                          const gchar* uri)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	GeeMapIterator* it = NULL;
	GeeHashMap* _tmp1_;
	GeeMapIterator* _tmp2_;
	PlankDocklet* _tmp3_;
	PlankDocklet* result;
#line 130 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 130 "../lib/Docklets/DockletManager.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 130 "../lib/Docklets/DockletManager.vala"
	_data4_->_ref_count_ = 1;
#line 130 "../lib/Docklets/DockletManager.vala"
	_data4_->self = g_object_ref (self);
#line 130 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = g_strdup (uri);
#line 130 "../lib/Docklets/DockletManager.vala"
	_g_free0 (_data4_->uri);
#line 130 "../lib/Docklets/DockletManager.vala"
	_data4_->uri = _tmp0_;
#line 132 "../lib/Docklets/DockletManager.vala"
	_data4_->docklet = NULL;
#line 134 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = self->priv->docklets;
#line 134 "../lib/Docklets/DockletManager.vala"
	_tmp2_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp1_);
#line 134 "../lib/Docklets/DockletManager.vala"
	it = _tmp2_;
#line 135 "../lib/Docklets/DockletManager.vala"
	gee_map_iterator_foreach (it, ___lambda15__gee_forall_map_func, _data4_);
#line 143 "../lib/Docklets/DockletManager.vala"
	_tmp3_ = _g_object_ref0 (_data4_->docklet);
#line 143 "../lib/Docklets/DockletManager.vala"
	result = _tmp3_;
#line 143 "../lib/Docklets/DockletManager.vala"
	_g_object_unref0 (it);
#line 143 "../lib/Docklets/DockletManager.vala"
	block4_data_unref (_data4_);
#line 143 "../lib/Docklets/DockletManager.vala"
	_data4_ = NULL;
#line 143 "../lib/Docklets/DockletManager.vala"
	return result;
#line 531 "DockletManager.c"
}

/**
 * Get list of all registered docklets
 *
 * @return a list of all registered docklets
 */
GeeCollection*
plank_docklet_manager_list_docklets (PlankDockletManager* self)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* result;
#line 151 "../lib/Docklets/DockletManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = self->priv->docklets;
#line 153 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 153 "../lib/Docklets/DockletManager.vala"
	_tmp2_ = _tmp1_;
#line 153 "../lib/Docklets/DockletManager.vala"
	result = _tmp2_;
#line 153 "../lib/Docklets/DockletManager.vala"
	return result;
#line 558 "DockletManager.c"
}

static void
plank_docklet_manager_load_modules_from_dir (PlankDockletManager* self,
                                             GFile* dir)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* attributes = NULL;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 156 "../lib/Docklets/DockletManager.vala"
	g_return_if_fail (self != NULL);
#line 156 "../lib/Docklets/DockletManager.vala"
	g_return_if_fail (dir != NULL);
#line 158 "../lib/Docklets/DockletManager.vala"
	if (!g_file_query_exists (dir, NULL)) {
#line 159 "../lib/Docklets/DockletManager.vala"
		return;
#line 579 "DockletManager.c"
	}
#line 161 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = g_file_get_path (dir);
#line 161 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = _tmp0_;
#line 161 "../lib/Docklets/DockletManager.vala"
	plank_logger_verbose ("Searching for modules in folder '%s'", _tmp1_, NULL);
#line 161 "../lib/Docklets/DockletManager.vala"
	_g_free0 (_tmp1_);
#line 163 "../lib/Docklets/DockletManager.vala"
	attributes = G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE;
#line 591 "DockletManager.c"
	{
		GFileEnumerator* enumerator = NULL;
		const gchar* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileInfo* info = NULL;
#line 166 "../lib/Docklets/DockletManager.vala"
		_tmp2_ = attributes;
#line 166 "../lib/Docklets/DockletManager.vala"
		_tmp3_ = g_file_enumerate_children (dir, _tmp2_, 0, NULL, &_inner_error0_);
#line 166 "../lib/Docklets/DockletManager.vala"
		enumerator = _tmp3_;
#line 166 "../lib/Docklets/DockletManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 605 "DockletManager.c"
			goto __catch0_g_error;
		}
#line 169 "../lib/Docklets/DockletManager.vala"
		while (TRUE) {
#line 610 "DockletManager.c"
			GFileInfo* _tmp4_ = NULL;
			GFileEnumerator* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			const gchar* name = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			GFile* file = NULL;
			const gchar* _tmp11_;
			GFile* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GFileInfo* _tmp14_;
			const gchar* _tmp15_;
#line 169 "../lib/Docklets/DockletManager.vala"
			_tmp5_ = enumerator;
#line 169 "../lib/Docklets/DockletManager.vala"
			_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error0_);
#line 169 "../lib/Docklets/DockletManager.vala"
			_tmp4_ = _tmp6_;
#line 169 "../lib/Docklets/DockletManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../lib/Docklets/DockletManager.vala"
				_g_object_unref0 (info);
#line 169 "../lib/Docklets/DockletManager.vala"
				_g_object_unref0 (enumerator);
#line 637 "DockletManager.c"
				goto __catch0_g_error;
			}
#line 169 "../lib/Docklets/DockletManager.vala"
			_tmp7_ = _tmp4_;
#line 169 "../lib/Docklets/DockletManager.vala"
			_tmp4_ = NULL;
#line 169 "../lib/Docklets/DockletManager.vala"
			_g_object_unref0 (info);
#line 169 "../lib/Docklets/DockletManager.vala"
			info = _tmp7_;
#line 169 "../lib/Docklets/DockletManager.vala"
			_tmp8_ = info;
#line 169 "../lib/Docklets/DockletManager.vala"
			if (!(_tmp8_ != NULL)) {
#line 169 "../lib/Docklets/DockletManager.vala"
				_g_object_unref0 (_tmp4_);
#line 169 "../lib/Docklets/DockletManager.vala"
				break;
#line 656 "DockletManager.c"
			}
#line 170 "../lib/Docklets/DockletManager.vala"
			_tmp9_ = info;
#line 170 "../lib/Docklets/DockletManager.vala"
			_tmp10_ = g_file_info_get_name (_tmp9_);
#line 170 "../lib/Docklets/DockletManager.vala"
			name = _tmp10_;
#line 171 "../lib/Docklets/DockletManager.vala"
			_tmp11_ = name;
#line 171 "../lib/Docklets/DockletManager.vala"
			_tmp12_ = g_file_get_child (dir, _tmp11_);
#line 171 "../lib/Docklets/DockletManager.vala"
			file = _tmp12_;
#line 172 "../lib/Docklets/DockletManager.vala"
			_tmp14_ = info;
#line 172 "../lib/Docklets/DockletManager.vala"
			_tmp15_ = g_file_info_get_content_type (_tmp14_);
#line 172 "../lib/Docklets/DockletManager.vala"
			if (g_strcmp0 (_tmp15_, "application/x-sharedlib") == 0) {
#line 676 "DockletManager.c"
				GRegex* _tmp16_;
				const gchar* _tmp17_;
#line 173 "../lib/Docklets/DockletManager.vala"
				_tmp16_ = plank_docklet_manager_docklet_filename_regex;
#line 173 "../lib/Docklets/DockletManager.vala"
				_tmp17_ = name;
#line 173 "../lib/Docklets/DockletManager.vala"
				_tmp13_ = g_regex_match (_tmp16_, _tmp17_, 0, NULL);
#line 685 "DockletManager.c"
			} else {
#line 172 "../lib/Docklets/DockletManager.vala"
				_tmp13_ = FALSE;
#line 689 "DockletManager.c"
			}
#line 172 "../lib/Docklets/DockletManager.vala"
			if (_tmp13_) {
#line 693 "DockletManager.c"
				GFile* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 174 "../lib/Docklets/DockletManager.vala"
				_tmp18_ = file;
#line 174 "../lib/Docklets/DockletManager.vala"
				_tmp19_ = g_file_get_path (_tmp18_);
#line 174 "../lib/Docklets/DockletManager.vala"
				_tmp20_ = _tmp19_;
#line 174 "../lib/Docklets/DockletManager.vala"
				plank_docklet_manager_load_module_from_file (self, _tmp20_);
#line 174 "../lib/Docklets/DockletManager.vala"
				_g_free0 (_tmp20_);
#line 707 "DockletManager.c"
			} else {
				GFileInfo* _tmp21_;
#line 175 "../lib/Docklets/DockletManager.vala"
				_tmp21_ = info;
#line 175 "../lib/Docklets/DockletManager.vala"
				if (g_file_info_get_file_type (_tmp21_) == G_FILE_TYPE_DIRECTORY) {
#line 714 "DockletManager.c"
					GFile* _tmp22_;
#line 176 "../lib/Docklets/DockletManager.vala"
					_tmp22_ = file;
#line 176 "../lib/Docklets/DockletManager.vala"
					plank_docklet_manager_load_modules_from_dir (self, _tmp22_);
#line 720 "DockletManager.c"
				}
			}
#line 169 "../lib/Docklets/DockletManager.vala"
			_g_object_unref0 (file);
#line 169 "../lib/Docklets/DockletManager.vala"
			_g_object_unref0 (_tmp4_);
#line 727 "DockletManager.c"
		}
#line 165 "../lib/Docklets/DockletManager.vala"
		_g_object_unref0 (info);
#line 165 "../lib/Docklets/DockletManager.vala"
		_g_object_unref0 (enumerator);
#line 733 "DockletManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 165 "../lib/Docklets/DockletManager.vala"
		_error_ = _inner_error0_;
#line 165 "../lib/Docklets/DockletManager.vala"
		_inner_error0_ = NULL;
#line 179 "../lib/Docklets/DockletManager.vala"
		_tmp23_ = g_file_get_path (dir);
#line 179 "../lib/Docklets/DockletManager.vala"
		_tmp24_ = _tmp23_;
#line 179 "../lib/Docklets/DockletManager.vala"
		_tmp25_ = _error_;
#line 179 "../lib/Docklets/DockletManager.vala"
		_tmp26_ = _tmp25_->message;
#line 179 "../lib/Docklets/DockletManager.vala"
		g_critical ("DockletManager.vala:179: Error listing contents of folder '%s': %s", _tmp24_, _tmp26_);
#line 179 "../lib/Docklets/DockletManager.vala"
		_g_free0 (_tmp24_);
#line 180 "../lib/Docklets/DockletManager.vala"
		_g_error_free0 (_error_);
#line 180 "../lib/Docklets/DockletManager.vala"
		return;
#line 763 "DockletManager.c"
	}
	__finally0:
#line 165 "../lib/Docklets/DockletManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../lib/Docklets/DockletManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../lib/Docklets/DockletManager.vala"
		g_clear_error (&_inner_error0_);
#line 165 "../lib/Docklets/DockletManager.vala"
		return;
#line 774 "DockletManager.c"
	}
#line 183 "../lib/Docklets/DockletManager.vala"
	_tmp27_ = g_file_get_path (dir);
#line 183 "../lib/Docklets/DockletManager.vala"
	_tmp28_ = _tmp27_;
#line 183 "../lib/Docklets/DockletManager.vala"
	plank_logger_verbose ("Finished searching for modules in folder '%s'", _tmp28_, NULL);
#line 183 "../lib/Docklets/DockletManager.vala"
	_g_free0 (_tmp28_);
#line 784 "DockletManager.c"
}

static void
plank_docklet_manager_load_module_from_file (PlankDockletManager* self,
                                             const gchar* file_path)
{
	GModule* module = NULL;
	GModule* _tmp0_;
	GModule* _tmp1_;
	void* function = NULL;
	GModule* _tmp3_;
	void* _tmp4_ = NULL;
	gboolean _tmp5_;
	PlankDockletInitFunc module_init = NULL;
	void* _tmp7_;
	gpointer module_init_target;
	PlankDockletInitFunc _tmp8_;
	gpointer _tmp8__target;
	GModule* _tmp9_;
	const gchar* _tmp10_;
	GModule* _tmp11_;
	PlankDockletInitFunc _tmp12_;
	gpointer _tmp12__target;
#line 186 "../lib/Docklets/DockletManager.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/Docklets/DockletManager.vala"
	g_return_if_fail (file_path != NULL);
#line 188 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = g_module_open (file_path, G_MODULE_BIND_LOCAL);
#line 188 "../lib/Docklets/DockletManager.vala"
	module = _tmp0_;
#line 189 "../lib/Docklets/DockletManager.vala"
	_tmp1_ = module;
#line 189 "../lib/Docklets/DockletManager.vala"
	if (_tmp1_ == NULL) {
#line 820 "DockletManager.c"
		const gchar* _tmp2_;
#line 190 "../lib/Docklets/DockletManager.vala"
		_tmp2_ = g_module_error ();
#line 190 "../lib/Docklets/DockletManager.vala"
		g_warning ("DockletManager.vala:190: Failed to load module '%s': %s", file_path, _tmp2_);
#line 191 "../lib/Docklets/DockletManager.vala"
		_g_module_close0 (module);
#line 191 "../lib/Docklets/DockletManager.vala"
		return;
#line 830 "DockletManager.c"
	}
#line 196 "../lib/Docklets/DockletManager.vala"
	_tmp3_ = module;
#line 196 "../lib/Docklets/DockletManager.vala"
	_tmp5_ = g_module_symbol (_tmp3_, PLANK_DOCKLET_ENTRY_POINT, &_tmp4_);
#line 196 "../lib/Docklets/DockletManager.vala"
	function = _tmp4_;
#line 196 "../lib/Docklets/DockletManager.vala"
	if (!_tmp5_) {
#line 840 "DockletManager.c"
		const gchar* _tmp6_;
#line 197 "../lib/Docklets/DockletManager.vala"
		_tmp6_ = g_module_error ();
#line 197 "../lib/Docklets/DockletManager.vala"
		g_warning ("DockletManager.vala:197: Failed to find entry point function '%s' in '" \
"%s': %s", PLANK_DOCKLET_ENTRY_POINT, file_path, _tmp6_);
#line 198 "../lib/Docklets/DockletManager.vala"
		_g_module_close0 (module);
#line 198 "../lib/Docklets/DockletManager.vala"
		return;
#line 850 "DockletManager.c"
	}
#line 201 "../lib/Docklets/DockletManager.vala"
	_tmp7_ = function;
#line 201 "../lib/Docklets/DockletManager.vala"
	module_init = (PlankDockletInitFunc) _tmp7_;
#line 201 "../lib/Docklets/DockletManager.vala"
	module_init_target = NULL;
#line 202 "../lib/Docklets/DockletManager.vala"
	_tmp8_ = module_init;
#line 202 "../lib/Docklets/DockletManager.vala"
	_tmp8__target = module_init_target;
#line 202 "../lib/Docklets/DockletManager.vala"
	_vala_assert (_tmp8_ != NULL, "module_init != null");
#line 204 "../lib/Docklets/DockletManager.vala"
	_tmp9_ = module;
#line 204 "../lib/Docklets/DockletManager.vala"
	_tmp10_ = g_module_name (_tmp9_);
#line 204 "../lib/Docklets/DockletManager.vala"
	g_debug ("DockletManager.vala:204: Loading module '%s'", _tmp10_);
#line 207 "../lib/Docklets/DockletManager.vala"
	_tmp11_ = module;
#line 207 "../lib/Docklets/DockletManager.vala"
	g_module_make_resident (_tmp11_);
#line 209 "../lib/Docklets/DockletManager.vala"
	_tmp12_ = module_init;
#line 209 "../lib/Docklets/DockletManager.vala"
	_tmp12__target = module_init_target;
#line 209 "../lib/Docklets/DockletManager.vala"
	_tmp12_ (self, _tmp12__target);
#line 186 "../lib/Docklets/DockletManager.vala"
	_g_module_close0 (module);
#line 882 "DockletManager.c"
}

static GObject *
plank_docklet_manager_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockletManager * self;
	GeeHashMap* _tmp0_;
#line 74 "../lib/Docklets/DockletManager.vala"
	parent_class = G_OBJECT_CLASS (plank_docklet_manager_parent_class);
#line 74 "../lib/Docklets/DockletManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 74 "../lib/Docklets/DockletManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCKLET_MANAGER, PlankDockletManager);
#line 76 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, PLANK_TYPE_DOCKLET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 76 "../lib/Docklets/DockletManager.vala"
	_g_object_unref0 (self->priv->docklets);
#line 76 "../lib/Docklets/DockletManager.vala"
	self->priv->docklets = _tmp0_;
#line 74 "../lib/Docklets/DockletManager.vala"
	return obj;
#line 908 "DockletManager.c"
}

static void
plank_docklet_manager_class_init (PlankDockletManagerClass * klass,
                                  gpointer klass_data)
{
	GRegex* _tmp0_;
#line 52 "../lib/Docklets/DockletManager.vala"
	plank_docklet_manager_parent_class = g_type_class_peek_parent (klass);
#line 52 "../lib/Docklets/DockletManager.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockletManager_private_offset);
#line 52 "../lib/Docklets/DockletManager.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_docklet_manager_constructor;
#line 52 "../lib/Docklets/DockletManager.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_docklet_manager_finalize;
#line 52 "../lib/Docklets/DockletManager.vala"
	plank_docklet_manager_signals[PLANK_DOCKLET_MANAGER_DOCKLET_ADDED_SIGNAL] = g_signal_new ("docklet-added", PLANK_TYPE_DOCKLET_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PLANK_TYPE_DOCKLET);
#line 54 "../lib/Docklets/DockletManager.vala"
	_tmp0_ = _g_regex_ref0 (_thread_safe_regex_init (&_tmp_regex_0, "^libdocklet-.+.so$", 0));
#line 54 "../lib/Docklets/DockletManager.vala"
	plank_docklet_manager_docklet_filename_regex = _tmp0_;
#line 930 "DockletManager.c"
}

static void
plank_docklet_manager_instance_init (PlankDockletManager * self,
                                     gpointer klass)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	self->priv = plank_docklet_manager_get_instance_private (self);
#line 939 "DockletManager.c"
}

static void
plank_docklet_manager_finalize (GObject * obj)
{
	PlankDockletManager * self;
#line 52 "../lib/Docklets/DockletManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCKLET_MANAGER, PlankDockletManager);
#line 67 "../lib/Docklets/DockletManager.vala"
	_g_object_unref0 (self->priv->docklets);
#line 97 "../lib/Docklets/DockletManager.vala"
	G_OBJECT_CLASS (plank_docklet_manager_parent_class)->finalize (obj);
#line 952 "DockletManager.c"
}

/**
 * A controller class for managing all available docklets.
 */
static GType
plank_docklet_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockletManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_docklet_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockletManager), 0, (GInstanceInitFunc) plank_docklet_manager_instance_init, NULL };
	GType plank_docklet_manager_type_id;
	plank_docklet_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDockletManager", &g_define_type_info, 0);
	PlankDockletManager_private_offset = g_type_add_instance_private (plank_docklet_manager_type_id, sizeof (PlankDockletManagerPrivate));
	return plank_docklet_manager_type_id;
}

GType
plank_docklet_manager_get_type (void)
{
	static volatile gsize plank_docklet_manager_type_id__once = 0;
	if (g_once_init_enter (&plank_docklet_manager_type_id__once)) {
		GType plank_docklet_manager_type_id;
		plank_docklet_manager_type_id = plank_docklet_manager_get_type_once ();
		g_once_init_leave (&plank_docklet_manager_type_id__once, plank_docklet_manager_type_id);
	}
	return plank_docklet_manager_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 987 "DockletManager.c"
		gssize i;
#line 52 "../lib/Docklets/DockletManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 52 "../lib/Docklets/DockletManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 52 "../lib/Docklets/DockletManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 995 "DockletManager.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 52 "../lib/Docklets/DockletManager.vala"
	g_free (array);
#line 1010 "DockletManager.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 52 "../lib/Docklets/DockletManager.vala"
	if (array) {
#line 52 "../lib/Docklets/DockletManager.vala"
		while (((gpointer*) array)[length]) {
#line 52 "../lib/Docklets/DockletManager.vala"
			length++;
#line 1024 "DockletManager.c"
		}
	}
#line 52 "../lib/Docklets/DockletManager.vala"
	return length;
#line 1029 "DockletManager.c"
}

