/* DrawingService.c generated by valac 0.56.9, the Vala compiler
 * generated from DrawingService.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>

#define PLANK_DRAWING_SERVICE_DEFAULT_ICON "application-default-icon"
#define PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "metadata::custom-icon"
#define PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "metadata::custom-icon-name"
#define PLANK_DRAWING_SERVICE_SATURATION_WEIGHT 1.5
#define PLANK_DRAWING_SERVICE_WEIGHT_THRESHOLD 1.0
#define PLANK_DRAWING_SERVICE_ALPHA_THRESHOLD ((guint8) 24)

enum  {
	PLANK_DRAWING_SERVICE_0_PROPERTY,
	PLANK_DRAWING_SERVICE_NUM_PROPERTIES
};
static GParamSpec* plank_drawing_service_properties[PLANK_DRAWING_SERVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

static gpointer plank_drawing_service_parent_class = NULL;
static GMutex plank_drawing_service_icon_theme_mutex;
static GMutex plank_drawing_service_icon_theme_mutex = {0};
static GtkIconTheme* plank_drawing_service_icon_theme;
static GtkIconTheme* plank_drawing_service_icon_theme = NULL;

static PlankDrawingService* plank_drawing_service_new (void);
static PlankDrawingService* plank_drawing_service_construct (GType object_type);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GdkPixbuf* plank_drawing_service_load_pixbuf_from_file (GFile* file,
                                                        gint width,
                                                        gint height);
static GdkPixbuf* plank_drawing_service_load_pixbuf (const gchar* icon,
                                              gint size);
static GdkPixbuf* plank_drawing_service_load_pixbuf_from_resource (const gchar* resource,
                                                            gint width,
                                                            gint height);
static GdkPixbuf* plank_drawing_service_get_empty_pixbuf (gint width,
                                                   gint height);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static cairo_surface_t* plank_drawing_service_load_surface (const gchar* icon,
                                                     gint size,
                                                     gint scale);
static cairo_surface_t* plank_drawing_service_load_surface_from_resource_at_scale (const gchar* resource,
                                                                            gint width,
                                                                            gint height,
                                                                            gint scale);
static void plank_drawing_service_finalize (GObject * obj);
static GType plank_drawing_service_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static PlankDrawingService*
plank_drawing_service_construct (GType object_type)
{
	PlankDrawingService * self = NULL;
#line 40 "../lib/Drawing/DrawingService.vala"
	self = (PlankDrawingService*) g_object_new (object_type, NULL);
#line 40 "../lib/Drawing/DrawingService.vala"
	return self;
#line 106 "DrawingService.c"
}

static PlankDrawingService*
plank_drawing_service_new (void)
{
#line 40 "../lib/Drawing/DrawingService.vala"
	return plank_drawing_service_construct (PLANK_TYPE_DRAWING_SERVICE);
#line 114 "DrawingService.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../lib/Drawing/DrawingService.vala"
	return self ? g_object_ref (self) : NULL;
#line 122 "DrawingService.c"
}

GtkIconTheme*
plank_drawing_service_get_icon_theme (void)
{
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp4_;
	GtkIconTheme* result;
#line 46 "../lib/Drawing/DrawingService.vala"
	g_mutex_lock (&plank_drawing_service_icon_theme_mutex);
#line 48 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = plank_drawing_service_icon_theme;
#line 48 "../lib/Drawing/DrawingService.vala"
	if (_tmp0_ == NULL) {
#line 137 "DrawingService.c"
		GdkScreen* _tmp1_;
		GtkIconTheme* _tmp2_;
		GtkIconTheme* _tmp3_;
#line 49 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = gdk_screen_get_default ();
#line 49 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = gtk_icon_theme_get_for_screen (_tmp1_);
#line 49 "../lib/Drawing/DrawingService.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 49 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (plank_drawing_service_icon_theme);
#line 49 "../lib/Drawing/DrawingService.vala"
		plank_drawing_service_icon_theme = _tmp3_;
#line 151 "DrawingService.c"
	}
#line 51 "../lib/Drawing/DrawingService.vala"
	g_mutex_unlock (&plank_drawing_service_icon_theme_mutex);
#line 53 "../lib/Drawing/DrawingService.vala"
	_tmp4_ = plank_drawing_service_icon_theme;
#line 53 "../lib/Drawing/DrawingService.vala"
	result = _tmp4_;
#line 53 "../lib/Drawing/DrawingService.vala"
	return result;
#line 161 "DrawingService.c"
}

/**
 * Gets the icon name from a {@link GLib.File}.
 *
 * @param file the file to get the icon name for
 * @return the icon name for the file, or null if none exists
 */
gchar*
plank_drawing_service_get_icon_from_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 62 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 177 "DrawingService.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		const gchar* custom_icon_name = NULL;
		GFileInfo* _tmp1_;
		const gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
		const gchar* custom_icon = NULL;
		GFileInfo* _tmp8_;
		const gchar* _tmp9_;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		const gchar* thumb_icon = NULL;
		GFileInfo* _tmp21_;
		const gchar* _tmp22_;
		gboolean _tmp23_ = FALSE;
		const gchar* _tmp24_;
		GFileInfo* _tmp28_;
		GIcon* _tmp29_;
		gchar* _tmp30_;
#line 65 "../lib/Drawing/DrawingService.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_ICON "," PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME "," PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON "," G_FILE_ATTRIBUTE_THUMBNAIL_PATH, 0, NULL, &_inner_error0_);
#line 65 "../lib/Drawing/DrawingService.vala"
		info = _tmp0_;
#line 65 "../lib/Drawing/DrawingService.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "DrawingService.c"
			goto __catch0_g_error;
		}
#line 70 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = info;
#line 70 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = g_file_info_get_attribute_string (_tmp1_, PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON_NAME);
#line 70 "../lib/Drawing/DrawingService.vala"
		custom_icon_name = _tmp2_;
#line 71 "../lib/Drawing/DrawingService.vala"
		_tmp4_ = custom_icon_name;
#line 71 "../lib/Drawing/DrawingService.vala"
		if (_tmp4_ != NULL) {
#line 218 "DrawingService.c"
			const gchar* _tmp5_;
#line 71 "../lib/Drawing/DrawingService.vala"
			_tmp5_ = custom_icon_name;
#line 71 "../lib/Drawing/DrawingService.vala"
			_tmp3_ = g_strcmp0 (_tmp5_, "") != 0;
#line 224 "DrawingService.c"
		} else {
#line 71 "../lib/Drawing/DrawingService.vala"
			_tmp3_ = FALSE;
#line 228 "DrawingService.c"
		}
#line 71 "../lib/Drawing/DrawingService.vala"
		if (_tmp3_) {
#line 232 "DrawingService.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 72 "../lib/Drawing/DrawingService.vala"
			_tmp6_ = custom_icon_name;
#line 72 "../lib/Drawing/DrawingService.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 72 "../lib/Drawing/DrawingService.vala"
			result = _tmp7_;
#line 72 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (info);
#line 72 "../lib/Drawing/DrawingService.vala"
			return result;
#line 245 "DrawingService.c"
		}
#line 75 "../lib/Drawing/DrawingService.vala"
		_tmp8_ = info;
#line 75 "../lib/Drawing/DrawingService.vala"
		_tmp9_ = g_file_info_get_attribute_string (_tmp8_, PLANK_DRAWING_SERVICE_FILE_ATTRIBUTE_CUSTOM_ICON);
#line 75 "../lib/Drawing/DrawingService.vala"
		custom_icon = _tmp9_;
#line 76 "../lib/Drawing/DrawingService.vala"
		_tmp11_ = custom_icon;
#line 76 "../lib/Drawing/DrawingService.vala"
		if (_tmp11_ != NULL) {
#line 257 "DrawingService.c"
			const gchar* _tmp12_;
#line 76 "../lib/Drawing/DrawingService.vala"
			_tmp12_ = custom_icon;
#line 76 "../lib/Drawing/DrawingService.vala"
			_tmp10_ = g_strcmp0 (_tmp12_, "") != 0;
#line 263 "DrawingService.c"
		} else {
#line 76 "../lib/Drawing/DrawingService.vala"
			_tmp10_ = FALSE;
#line 267 "DrawingService.c"
		}
#line 76 "../lib/Drawing/DrawingService.vala"
		if (_tmp10_) {
#line 271 "DrawingService.c"
			const gchar* _tmp13_;
			const gchar* _tmp16_;
			GFile* _tmp17_;
			GFile* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 77 "../lib/Drawing/DrawingService.vala"
			_tmp13_ = custom_icon;
#line 77 "../lib/Drawing/DrawingService.vala"
			if (g_str_has_prefix (_tmp13_, "file://")) {
#line 282 "DrawingService.c"
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 78 "../lib/Drawing/DrawingService.vala"
				_tmp14_ = custom_icon;
#line 78 "../lib/Drawing/DrawingService.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 78 "../lib/Drawing/DrawingService.vala"
				result = _tmp15_;
#line 78 "../lib/Drawing/DrawingService.vala"
				_g_object_unref0 (info);
#line 78 "../lib/Drawing/DrawingService.vala"
				return result;
#line 295 "DrawingService.c"
			}
#line 79 "../lib/Drawing/DrawingService.vala"
			_tmp16_ = custom_icon;
#line 79 "../lib/Drawing/DrawingService.vala"
			_tmp17_ = g_file_get_child (file, _tmp16_);
#line 79 "../lib/Drawing/DrawingService.vala"
			_tmp18_ = _tmp17_;
#line 79 "../lib/Drawing/DrawingService.vala"
			_tmp19_ = g_file_get_path (_tmp18_);
#line 79 "../lib/Drawing/DrawingService.vala"
			_tmp20_ = _tmp19_;
#line 79 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (_tmp18_);
#line 79 "../lib/Drawing/DrawingService.vala"
			result = _tmp20_;
#line 79 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (info);
#line 79 "../lib/Drawing/DrawingService.vala"
			return result;
#line 315 "DrawingService.c"
		}
#line 83 "../lib/Drawing/DrawingService.vala"
		_tmp21_ = info;
#line 83 "../lib/Drawing/DrawingService.vala"
		_tmp22_ = g_file_info_get_attribute_byte_string (_tmp21_, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
#line 83 "../lib/Drawing/DrawingService.vala"
		thumb_icon = _tmp22_;
#line 84 "../lib/Drawing/DrawingService.vala"
		_tmp24_ = thumb_icon;
#line 84 "../lib/Drawing/DrawingService.vala"
		if (_tmp24_ != NULL) {
#line 327 "DrawingService.c"
			const gchar* _tmp25_;
#line 84 "../lib/Drawing/DrawingService.vala"
			_tmp25_ = thumb_icon;
#line 84 "../lib/Drawing/DrawingService.vala"
			_tmp23_ = g_strcmp0 (_tmp25_, "") != 0;
#line 333 "DrawingService.c"
		} else {
#line 84 "../lib/Drawing/DrawingService.vala"
			_tmp23_ = FALSE;
#line 337 "DrawingService.c"
		}
#line 84 "../lib/Drawing/DrawingService.vala"
		if (_tmp23_) {
#line 341 "DrawingService.c"
			const gchar* _tmp26_;
			gchar* _tmp27_;
#line 85 "../lib/Drawing/DrawingService.vala"
			_tmp26_ = thumb_icon;
#line 85 "../lib/Drawing/DrawingService.vala"
			_tmp27_ = g_strdup (_tmp26_);
#line 85 "../lib/Drawing/DrawingService.vala"
			result = _tmp27_;
#line 85 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (info);
#line 85 "../lib/Drawing/DrawingService.vala"
			return result;
#line 354 "DrawingService.c"
		}
#line 88 "../lib/Drawing/DrawingService.vala"
		_tmp28_ = info;
#line 88 "../lib/Drawing/DrawingService.vala"
		_tmp29_ = g_file_info_get_icon (_tmp28_);
#line 88 "../lib/Drawing/DrawingService.vala"
		_tmp30_ = plank_drawing_service_get_icon_from_gicon (_tmp29_);
#line 88 "../lib/Drawing/DrawingService.vala"
		result = _tmp30_;
#line 88 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (info);
#line 88 "../lib/Drawing/DrawingService.vala"
		return result;
#line 368 "DrawingService.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		gchar* _tmp31_ = NULL;
		gchar* _tmp32_;
#line 64 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../lib/Drawing/DrawingService.vala"
		_tmp32_ = g_file_get_path (file);
#line 90 "../lib/Drawing/DrawingService.vala"
		_tmp31_ = _tmp32_;
#line 90 "../lib/Drawing/DrawingService.vala"
		if (_tmp31_ == NULL) {
#line 383 "DrawingService.c"
			gchar* _tmp33_;
#line 90 "../lib/Drawing/DrawingService.vala"
			_tmp33_ = g_strdup ("");
#line 90 "../lib/Drawing/DrawingService.vala"
			_g_free0 (_tmp31_);
#line 90 "../lib/Drawing/DrawingService.vala"
			_tmp31_ = _tmp33_;
#line 391 "DrawingService.c"
		}
#line 90 "../lib/Drawing/DrawingService.vala"
		g_debug ("DrawingService.vala:90: Could not get file info for '%s'", _tmp31_);
#line 64 "../lib/Drawing/DrawingService.vala"
		_g_free0 (_tmp31_);
#line 397 "DrawingService.c"
	}
	__finally0:
#line 64 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 408 "DrawingService.c"
	}
#line 93 "../lib/Drawing/DrawingService.vala"
	result = NULL;
#line 93 "../lib/Drawing/DrawingService.vala"
	return result;
#line 414 "DrawingService.c"
}

/**
 * Gets an icon from a {@link GLib.Icon}.
 *
 * @param icon the icon to get the name for
 * @return the icon name, or null if none exists
 */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 434 "DrawingService.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 438 "DrawingService.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 444 "DrawingService.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 449 "DrawingService.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 455 "DrawingService.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 459 "DrawingService.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 463 "DrawingService.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 467 "DrawingService.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 471 "DrawingService.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 475 "DrawingService.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 490 "DrawingService.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 499 "DrawingService.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 506 "DrawingService.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 512 "DrawingService.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 520 "DrawingService.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 524 "DrawingService.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 530 "DrawingService.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 535 "DrawingService.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 541 "DrawingService.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 545 "DrawingService.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 549 "DrawingService.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 555 "DrawingService.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 561 "DrawingService.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 573 "DrawingService.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 577 "DrawingService.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 581 "DrawingService.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 586 "DrawingService.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 594 "DrawingService.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 612 "DrawingService.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 618 "DrawingService.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 622 "DrawingService.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 630 "DrawingService.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 639 "DrawingService.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 648 "DrawingService.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 654 "DrawingService.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 662 "DrawingService.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 674 "DrawingService.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 680 "DrawingService.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 684 "DrawingService.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 692 "DrawingService.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 703 "DrawingService.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 712 "DrawingService.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 735 "DrawingService.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 739 "DrawingService.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 745 "DrawingService.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 749 "DrawingService.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 753 "DrawingService.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 761 "DrawingService.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 789 "DrawingService.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 798 "DrawingService.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 812 "DrawingService.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 821 "DrawingService.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 835 "DrawingService.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 844 "DrawingService.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 853 "DrawingService.c"
}

gchar*
plank_drawing_service_get_icon_from_gicon (GIcon* icon)
{
	gchar* result;
#line 104 "../lib/Drawing/DrawingService.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (icon, g_themed_icon_get_type ())) {
#line 862 "DrawingService.c"
		gchar* icons = NULL;
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 105 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = _tmp0_ = g_themed_icon_get_names (G_TYPE_CHECK_INSTANCE_CAST (icon, g_themed_icon_get_type (), GThemedIcon));
#line 105 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = _vala_g_strjoinv (";;", _tmp1_, (gint) _vala_array_length (_tmp0_));
#line 105 "../lib/Drawing/DrawingService.vala"
		icons = _tmp2_;
#line 107 "../lib/Drawing/DrawingService.vala"
		_tmp3_ = icons;
#line 107 "../lib/Drawing/DrawingService.vala"
		_tmp4_ = string_replace (_tmp3_, "(null);;", "");
#line 107 "../lib/Drawing/DrawingService.vala"
		result = _tmp4_;
#line 107 "../lib/Drawing/DrawingService.vala"
		_g_free0 (icons);
#line 107 "../lib/Drawing/DrawingService.vala"
		return result;
#line 885 "DrawingService.c"
	}
#line 110 "../lib/Drawing/DrawingService.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (icon, g_file_icon_get_type ())) {
#line 889 "DrawingService.c"
		GFile* _tmp5_;
		gchar* _tmp6_;
#line 111 "../lib/Drawing/DrawingService.vala"
		_tmp5_ = g_file_icon_get_file (G_TYPE_CHECK_INSTANCE_CAST (icon, g_file_icon_get_type (), GFileIcon));
#line 111 "../lib/Drawing/DrawingService.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 111 "../lib/Drawing/DrawingService.vala"
		result = _tmp6_;
#line 111 "../lib/Drawing/DrawingService.vala"
		return result;
#line 900 "DrawingService.c"
	}
#line 113 "../lib/Drawing/DrawingService.vala"
	result = NULL;
#line 113 "../lib/Drawing/DrawingService.vala"
	return result;
#line 906 "DrawingService.c"
}

/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @return the pixbuf representing the requested icon
 */
static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 129 "../lib/Drawing/DrawingService.vala"
	if ((*length) == (*size)) {
#line 129 "../lib/Drawing/DrawingService.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 129 "../lib/Drawing/DrawingService.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 929 "DrawingService.c"
	}
#line 129 "../lib/Drawing/DrawingService.vala"
	(*array)[(*length)++] = value;
#line 129 "../lib/Drawing/DrawingService.vala"
	(*array)[*length] = NULL;
#line 935 "DrawingService.c"
}

GdkPixbuf*
plank_drawing_service_load_icon (const gchar* names,
                                 gint width,
                                 gint height)
{
	GdkPixbuf* pbuf = NULL;
	gchar** all_names = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint all_names_length1;
	gint _all_names_size_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GdkPixbuf* _tmp15_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* _tmp29_;
	GdkPixbuf* result;
#line 124 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (names != NULL, NULL);
#line 126 "../lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 128 "../lib/Drawing/DrawingService.vala"
	_tmp1_ = _tmp0_ = g_strsplit (names, ";;", 0);
#line 128 "../lib/Drawing/DrawingService.vala"
	all_names = _tmp1_;
#line 128 "../lib/Drawing/DrawingService.vala"
	all_names_length1 = _vala_array_length (_tmp0_);
#line 128 "../lib/Drawing/DrawingService.vala"
	_all_names_size_ = all_names_length1;
#line 129 "../lib/Drawing/DrawingService.vala"
	_tmp2_ = g_strdup (PLANK_DRAWING_SERVICE_DEFAULT_ICON);
#line 129 "../lib/Drawing/DrawingService.vala"
	_vala_array_add3 (&all_names, &all_names_length1, &_all_names_size_, _tmp2_);
#line 131 "../lib/Drawing/DrawingService.vala"
	_tmp3_ = all_names;
#line 131 "../lib/Drawing/DrawingService.vala"
	_tmp3__length1 = all_names_length1;
#line 976 "DrawingService.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 131 "../lib/Drawing/DrawingService.vala"
		name_collection = _tmp3_;
#line 131 "../lib/Drawing/DrawingService.vala"
		name_collection_length1 = _tmp3__length1;
#line 131 "../lib/Drawing/DrawingService.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 988 "DrawingService.c"
			const gchar* name = NULL;
#line 131 "../lib/Drawing/DrawingService.vala"
			name = name_collection[name_it];
#line 992 "DrawingService.c"
			{
				GFile* file = NULL;
				const gchar* _tmp4_;
				GFile* _tmp5_;
				GFile* _tmp6_;
				const gchar* _tmp10_;
				GdkPixbuf* _tmp11_;
				GdkPixbuf* _tmp12_;
				const gchar* _tmp13_;
#line 132 "../lib/Drawing/DrawingService.vala"
				_tmp4_ = name;
#line 132 "../lib/Drawing/DrawingService.vala"
				_tmp5_ = plank_drawing_service_try_get_icon_file (_tmp4_);
#line 132 "../lib/Drawing/DrawingService.vala"
				file = _tmp5_;
#line 133 "../lib/Drawing/DrawingService.vala"
				_tmp6_ = file;
#line 133 "../lib/Drawing/DrawingService.vala"
				if (_tmp6_ != NULL) {
#line 1012 "DrawingService.c"
					GFile* _tmp7_;
					GdkPixbuf* _tmp8_;
					GdkPixbuf* _tmp9_;
#line 134 "../lib/Drawing/DrawingService.vala"
					_tmp7_ = file;
#line 134 "../lib/Drawing/DrawingService.vala"
					_tmp8_ = plank_drawing_service_load_pixbuf_from_file (_tmp7_, width, height);
#line 134 "../lib/Drawing/DrawingService.vala"
					_g_object_unref0 (pbuf);
#line 134 "../lib/Drawing/DrawingService.vala"
					pbuf = _tmp8_;
#line 135 "../lib/Drawing/DrawingService.vala"
					_tmp9_ = pbuf;
#line 135 "../lib/Drawing/DrawingService.vala"
					if (_tmp9_ != NULL) {
#line 136 "../lib/Drawing/DrawingService.vala"
						_g_object_unref0 (file);
#line 136 "../lib/Drawing/DrawingService.vala"
						break;
#line 1032 "DrawingService.c"
					}
				}
#line 139 "../lib/Drawing/DrawingService.vala"
				_tmp10_ = name;
#line 139 "../lib/Drawing/DrawingService.vala"
				_tmp11_ = plank_drawing_service_load_pixbuf (_tmp10_, MAX (width, height));
#line 139 "../lib/Drawing/DrawingService.vala"
				_g_object_unref0 (pbuf);
#line 139 "../lib/Drawing/DrawingService.vala"
				pbuf = _tmp11_;
#line 140 "../lib/Drawing/DrawingService.vala"
				_tmp12_ = pbuf;
#line 140 "../lib/Drawing/DrawingService.vala"
				if (_tmp12_ != NULL) {
#line 141 "../lib/Drawing/DrawingService.vala"
					_g_object_unref0 (file);
#line 141 "../lib/Drawing/DrawingService.vala"
					break;
#line 1051 "DrawingService.c"
				}
#line 143 "../lib/Drawing/DrawingService.vala"
				_tmp13_ = name;
#line 143 "../lib/Drawing/DrawingService.vala"
				if (g_strcmp0 (_tmp13_, PLANK_DRAWING_SERVICE_DEFAULT_ICON) != 0) {
#line 1057 "DrawingService.c"
					const gchar* _tmp14_;
#line 144 "../lib/Drawing/DrawingService.vala"
					_tmp14_ = name;
#line 144 "../lib/Drawing/DrawingService.vala"
					g_message ("DrawingService.vala:144: Could not find icon '%s'", _tmp14_);
#line 1063 "DrawingService.c"
				}
#line 131 "../lib/Drawing/DrawingService.vala"
				_g_object_unref0 (file);
#line 1067 "DrawingService.c"
			}
		}
	}
#line 148 "../lib/Drawing/DrawingService.vala"
	_tmp15_ = pbuf;
#line 148 "../lib/Drawing/DrawingService.vala"
	if (_tmp15_ == NULL) {
#line 1075 "DrawingService.c"
		GdkPixbuf* _tmp16_;
#line 149 "../lib/Drawing/DrawingService.vala"
		_tmp16_ = plank_drawing_service_load_pixbuf_from_resource (PLANK_G_RESOURCE_PATH "/img/application-default-icon.svg", width, height);
#line 149 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 149 "../lib/Drawing/DrawingService.vala"
		pbuf = _tmp16_;
#line 1083 "DrawingService.c"
	}
#line 151 "../lib/Drawing/DrawingService.vala"
	_tmp17_ = pbuf;
#line 151 "../lib/Drawing/DrawingService.vala"
	if (_tmp17_ != NULL) {
#line 1089 "DrawingService.c"
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
#line 152 "../lib/Drawing/DrawingService.vala"
		if (width != -1) {
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp19_ = height != -1;
#line 1096 "DrawingService.c"
		} else {
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp19_ = FALSE;
#line 1100 "DrawingService.c"
		}
#line 152 "../lib/Drawing/DrawingService.vala"
		if (_tmp19_) {
#line 1104 "DrawingService.c"
			gboolean _tmp20_ = FALSE;
			GdkPixbuf* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp21_ = pbuf;
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp22_ = gdk_pixbuf_get_width (_tmp21_);
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp23_ = _tmp22_;
#line 152 "../lib/Drawing/DrawingService.vala"
			if (width != _tmp23_) {
#line 152 "../lib/Drawing/DrawingService.vala"
				_tmp20_ = TRUE;
#line 1119 "DrawingService.c"
			} else {
				GdkPixbuf* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
#line 152 "../lib/Drawing/DrawingService.vala"
				_tmp24_ = pbuf;
#line 152 "../lib/Drawing/DrawingService.vala"
				_tmp25_ = gdk_pixbuf_get_height (_tmp24_);
#line 152 "../lib/Drawing/DrawingService.vala"
				_tmp26_ = _tmp25_;
#line 152 "../lib/Drawing/DrawingService.vala"
				_tmp20_ = height != _tmp26_;
#line 1132 "DrawingService.c"
			}
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp18_ = _tmp20_;
#line 1136 "DrawingService.c"
		} else {
#line 152 "../lib/Drawing/DrawingService.vala"
			_tmp18_ = FALSE;
#line 1140 "DrawingService.c"
		}
#line 152 "../lib/Drawing/DrawingService.vala"
		if (_tmp18_) {
#line 1144 "DrawingService.c"
			GdkPixbuf* _tmp27_;
			GdkPixbuf* _tmp28_;
#line 153 "../lib/Drawing/DrawingService.vala"
			_tmp27_ = pbuf;
#line 153 "../lib/Drawing/DrawingService.vala"
			_tmp28_ = plank_drawing_service_ar_scale (_tmp27_, width, height);
#line 153 "../lib/Drawing/DrawingService.vala"
			result = _tmp28_;
#line 153 "../lib/Drawing/DrawingService.vala"
			all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
#line 153 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 153 "../lib/Drawing/DrawingService.vala"
			return result;
#line 1159 "DrawingService.c"
		}
#line 154 "../lib/Drawing/DrawingService.vala"
		result = pbuf;
#line 154 "../lib/Drawing/DrawingService.vala"
		all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
#line 154 "../lib/Drawing/DrawingService.vala"
		return result;
#line 1167 "DrawingService.c"
	}
#line 157 "../lib/Drawing/DrawingService.vala"
	g_warning ("DrawingService.vala:157: No icon found, return empty pixbuf");
#line 159 "../lib/Drawing/DrawingService.vala"
	_tmp29_ = plank_drawing_service_get_empty_pixbuf (MAX (1, width), MAX (1, height));
#line 159 "../lib/Drawing/DrawingService.vala"
	result = _tmp29_;
#line 159 "../lib/Drawing/DrawingService.vala"
	all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
#line 159 "../lib/Drawing/DrawingService.vala"
	_g_object_unref0 (pbuf);
#line 159 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1181 "DrawingService.c"
}

static GdkPixbuf*
plank_drawing_service_get_empty_pixbuf (gint width,
                                        gint height)
{
	GdkPixbuf* pbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* result;
#line 164 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, width, height);
#line 164 "../lib/Drawing/DrawingService.vala"
	pbuf = _tmp0_;
#line 165 "../lib/Drawing/DrawingService.vala"
	gdk_pixbuf_fill (pbuf, (guint32) 0x00000000);
#line 166 "../lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 166 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1201 "DrawingService.c"
}

/**
 * Try to get a {@link GLib.File} for the given icon name
 *
 * @param name a string which might represent an existing file
 * @return a {@link GLib.File}, or null if it failed
 */
GFile*
plank_drawing_service_try_get_icon_file (const gchar* name)
{
	GFile* file = NULL;
	gchar* name_down = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp11_;
	GFile* result;
#line 175 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 177 "../lib/Drawing/DrawingService.vala"
	file = NULL;
#line 178 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = g_utf8_strdown (name, (gssize) -1);
#line 178 "../lib/Drawing/DrawingService.vala"
	name_down = _tmp0_;
#line 180 "../lib/Drawing/DrawingService.vala"
	_tmp1_ = name_down;
#line 180 "../lib/Drawing/DrawingService.vala"
	if (g_str_has_prefix (_tmp1_, "resource://")) {
#line 1232 "DrawingService.c"
		GFile* _tmp2_;
#line 181 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = g_file_new_for_uri (name);
#line 181 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (file);
#line 181 "../lib/Drawing/DrawingService.vala"
		file = _tmp2_;
#line 1240 "DrawingService.c"
	} else {
		const gchar* _tmp3_;
#line 182 "../lib/Drawing/DrawingService.vala"
		_tmp3_ = name_down;
#line 182 "../lib/Drawing/DrawingService.vala"
		if (g_str_has_prefix (_tmp3_, "file://")) {
#line 1247 "DrawingService.c"
			GFile* _tmp4_;
#line 183 "../lib/Drawing/DrawingService.vala"
			_tmp4_ = g_file_new_for_uri (name);
#line 183 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (file);
#line 183 "../lib/Drawing/DrawingService.vala"
			file = _tmp4_;
#line 1255 "DrawingService.c"
		} else {
#line 184 "../lib/Drawing/DrawingService.vala"
			if (g_str_has_prefix (name, "~/")) {
#line 1259 "DrawingService.c"
				const gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				GFile* _tmp8_;
#line 185 "../lib/Drawing/DrawingService.vala"
				_tmp5_ = g_get_home_dir ();
#line 185 "../lib/Drawing/DrawingService.vala"
				_tmp6_ = string_replace (name, "~", _tmp5_);
#line 185 "../lib/Drawing/DrawingService.vala"
				_tmp7_ = _tmp6_;
#line 185 "../lib/Drawing/DrawingService.vala"
				_tmp8_ = g_file_new_for_path (_tmp7_);
#line 185 "../lib/Drawing/DrawingService.vala"
				_g_object_unref0 (file);
#line 185 "../lib/Drawing/DrawingService.vala"
				file = _tmp8_;
#line 185 "../lib/Drawing/DrawingService.vala"
				_g_free0 (_tmp7_);
#line 1278 "DrawingService.c"
			} else {
#line 186 "../lib/Drawing/DrawingService.vala"
				if (g_str_has_prefix (name, "/")) {
#line 1282 "DrawingService.c"
					GFile* _tmp9_;
#line 187 "../lib/Drawing/DrawingService.vala"
					_tmp9_ = g_file_new_for_path (name);
#line 187 "../lib/Drawing/DrawingService.vala"
					_g_object_unref0 (file);
#line 187 "../lib/Drawing/DrawingService.vala"
					file = _tmp9_;
#line 1290 "DrawingService.c"
				}
			}
		}
	}
#line 189 "../lib/Drawing/DrawingService.vala"
	_tmp11_ = file;
#line 189 "../lib/Drawing/DrawingService.vala"
	if (_tmp11_ != NULL) {
#line 1299 "DrawingService.c"
		GFile* _tmp12_;
#line 189 "../lib/Drawing/DrawingService.vala"
		_tmp12_ = file;
#line 189 "../lib/Drawing/DrawingService.vala"
		_tmp10_ = g_file_query_exists (_tmp12_, NULL);
#line 1305 "DrawingService.c"
	} else {
#line 189 "../lib/Drawing/DrawingService.vala"
		_tmp10_ = FALSE;
#line 1309 "DrawingService.c"
	}
#line 189 "../lib/Drawing/DrawingService.vala"
	if (_tmp10_) {
#line 190 "../lib/Drawing/DrawingService.vala"
		result = file;
#line 190 "../lib/Drawing/DrawingService.vala"
		_g_free0 (name_down);
#line 190 "../lib/Drawing/DrawingService.vala"
		return result;
#line 1319 "DrawingService.c"
	}
#line 192 "../lib/Drawing/DrawingService.vala"
	result = NULL;
#line 192 "../lib/Drawing/DrawingService.vala"
	_g_free0 (name_down);
#line 192 "../lib/Drawing/DrawingService.vala"
	_g_object_unref0 (file);
#line 192 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1329 "DrawingService.c"
}

static GdkPixbuf*
plank_drawing_service_load_pixbuf_from_file (GFile* file,
                                             gint width,
                                             gint height)
{
	GdkPixbuf* pbuf = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 195 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 197 "../lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 1344 "DrawingService.c"
	{
		GFileInputStream* fis = NULL;
		GFileInputStream* _tmp0_;
		GdkPixbuf* _tmp1_ = NULL;
		GFileInputStream* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 200 "../lib/Drawing/DrawingService.vala"
		_tmp0_ = g_file_read (file, NULL, &_inner_error0_);
#line 200 "../lib/Drawing/DrawingService.vala"
		fis = _tmp0_;
#line 200 "../lib/Drawing/DrawingService.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1358 "DrawingService.c"
			goto __catch0_g_error;
		}
#line 201 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = fis;
#line 201 "../lib/Drawing/DrawingService.vala"
		_tmp3_ = gdk_pixbuf_new_from_stream_at_scale ((GInputStream*) _tmp2_, width, height, TRUE, NULL, &_inner_error0_);
#line 201 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = _tmp3_;
#line 201 "../lib/Drawing/DrawingService.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (fis);
#line 1371 "DrawingService.c"
			goto __catch0_g_error;
		}
#line 201 "../lib/Drawing/DrawingService.vala"
		_tmp4_ = _tmp1_;
#line 201 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = NULL;
#line 201 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 201 "../lib/Drawing/DrawingService.vala"
		pbuf = _tmp4_;
#line 199 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (_tmp1_);
#line 199 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (fis);
#line 1386 "DrawingService.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 199 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 1393 "DrawingService.c"
	}
	__finally0:
#line 199 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 199 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 199 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 1406 "DrawingService.c"
	}
#line 204 "../lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 204 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1412 "DrawingService.c"
}

static GdkPixbuf*
plank_drawing_service_load_pixbuf_from_resource (const gchar* resource,
                                                 gint width,
                                                 gint height)
{
	GdkPixbuf* pbuf = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 207 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (resource != NULL, NULL);
#line 209 "../lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 1427 "DrawingService.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 212 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = gdk_pixbuf_new_from_resource_at_scale (resource, width, height, TRUE, &_inner_error0_);
#line 212 "../lib/Drawing/DrawingService.vala"
		_tmp0_ = _tmp1_;
#line 212 "../lib/Drawing/DrawingService.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1438 "DrawingService.c"
			goto __catch0_g_error;
		}
#line 212 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = _tmp0_;
#line 212 "../lib/Drawing/DrawingService.vala"
		_tmp0_ = NULL;
#line 212 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 212 "../lib/Drawing/DrawingService.vala"
		pbuf = _tmp2_;
#line 211 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (_tmp0_);
#line 1451 "DrawingService.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 211 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 1458 "DrawingService.c"
	}
	__finally0:
#line 211 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 211 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 211 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 1471 "DrawingService.c"
	}
#line 215 "../lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 215 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1477 "DrawingService.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 1496 "DrawingService.c"
}

static GdkPixbuf*
plank_drawing_service_load_pixbuf (const gchar* icon,
                                   gint size)
{
	GdkPixbuf* pbuf = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 218 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 220 "../lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 221 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = plank_drawing_service_get_icon_theme ();
#line 221 "../lib/Drawing/DrawingService.vala"
	icon_theme = _tmp0_;
#line 223 "../lib/Drawing/DrawingService.vala"
	g_mutex_lock (&plank_drawing_service_icon_theme_mutex);
#line 1518 "DrawingService.c"
	{
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 226 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = gtk_icon_theme_load_icon (icon_theme, icon, size, 0, &_inner_error0_);
#line 226 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = _tmp2_;
#line 226 "../lib/Drawing/DrawingService.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1529 "DrawingService.c"
			goto __catch0_g_error;
		}
#line 226 "../lib/Drawing/DrawingService.vala"
		_tmp3_ = _tmp1_;
#line 226 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = NULL;
#line 226 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 226 "../lib/Drawing/DrawingService.vala"
		pbuf = _tmp3_;
#line 225 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (_tmp1_);
#line 1542 "DrawingService.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 225 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 1549 "DrawingService.c"
	}
	__finally0:
#line 225 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 225 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 225 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 1562 "DrawingService.c"
	}
	{
		gboolean _tmp4_ = FALSE;
		GdkPixbuf* _tmp5_;
#line 230 "../lib/Drawing/DrawingService.vala"
		_tmp5_ = pbuf;
#line 230 "../lib/Drawing/DrawingService.vala"
		if (_tmp5_ == NULL) {
#line 230 "../lib/Drawing/DrawingService.vala"
			_tmp4_ = string_contains (icon, ".");
#line 1573 "DrawingService.c"
		} else {
#line 230 "../lib/Drawing/DrawingService.vala"
			_tmp4_ = FALSE;
#line 1577 "DrawingService.c"
		}
#line 230 "../lib/Drawing/DrawingService.vala"
		if (_tmp4_) {
#line 1581 "DrawingService.c"
			gchar** parts = NULL;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint parts_length1;
			gint _parts_size_;
			GdkPixbuf* _tmp8_ = NULL;
			gchar** _tmp9_;
			gint _tmp9__length1;
			const gchar* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
#line 231 "../lib/Drawing/DrawingService.vala"
			_tmp7_ = _tmp6_ = g_strsplit (icon, ".", 0);
#line 231 "../lib/Drawing/DrawingService.vala"
			parts = _tmp7_;
#line 231 "../lib/Drawing/DrawingService.vala"
			parts_length1 = _vala_array_length (_tmp6_);
#line 231 "../lib/Drawing/DrawingService.vala"
			_parts_size_ = parts_length1;
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp9_ = parts;
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp9__length1 = parts_length1;
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp10_ = _tmp9_[0];
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp11_ = gtk_icon_theme_load_icon (icon_theme, _tmp10_, size, 0, &_inner_error0_);
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp8_ = _tmp11_;
#line 232 "../lib/Drawing/DrawingService.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "../lib/Drawing/DrawingService.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1615 "DrawingService.c"
				goto __catch1_g_error;
			}
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp12_ = _tmp8_;
#line 232 "../lib/Drawing/DrawingService.vala"
			_tmp8_ = NULL;
#line 232 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (pbuf);
#line 232 "../lib/Drawing/DrawingService.vala"
			pbuf = _tmp12_;
#line 230 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (_tmp8_);
#line 230 "../lib/Drawing/DrawingService.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1630 "DrawingService.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 229 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 1638 "DrawingService.c"
	}
	__finally1:
#line 229 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 229 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 229 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 1651 "DrawingService.c"
	}
#line 236 "../lib/Drawing/DrawingService.vala"
	g_mutex_unlock (&plank_drawing_service_icon_theme_mutex);
#line 238 "../lib/Drawing/DrawingService.vala"
	result = pbuf;
#line 238 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1659 "DrawingService.c"
}

/**
 * Loads an icon based on names and the given width/height
 *
 * @param names a delimited (with ";;") list of icon names, first one found is used
 * @param width the requested width of the icon
 * @param height the requested height of the icon
 * @param scale the implicit requested scale of the icon
 * @return the {link Cairo.Surface} containing the requested icon, do not alter this surface
 */
static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 255 "../lib/Drawing/DrawingService.vala"
	if ((*length) == (*size)) {
#line 255 "../lib/Drawing/DrawingService.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 255 "../lib/Drawing/DrawingService.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1683 "DrawingService.c"
	}
#line 255 "../lib/Drawing/DrawingService.vala"
	(*array)[(*length)++] = value;
#line 255 "../lib/Drawing/DrawingService.vala"
	(*array)[*length] = NULL;
#line 1689 "DrawingService.c"
}

cairo_surface_t*
plank_drawing_service_load_icon_for_scale (const gchar* names,
                                           gint width,
                                           gint height,
                                           gint scale)
{
	cairo_surface_t* surface = NULL;
	gchar** all_names = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint all_names_length1;
	gint _all_names_size_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	cairo_surface_t* _tmp28_;
	cairo_surface_t* result;
#line 250 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (names != NULL, NULL);
#line 252 "../lib/Drawing/DrawingService.vala"
	surface = NULL;
#line 254 "../lib/Drawing/DrawingService.vala"
	_tmp1_ = _tmp0_ = g_strsplit (names, ";;", 0);
#line 254 "../lib/Drawing/DrawingService.vala"
	all_names = _tmp1_;
#line 254 "../lib/Drawing/DrawingService.vala"
	all_names_length1 = _vala_array_length (_tmp0_);
#line 254 "../lib/Drawing/DrawingService.vala"
	_all_names_size_ = all_names_length1;
#line 255 "../lib/Drawing/DrawingService.vala"
	_tmp2_ = g_strdup (PLANK_DRAWING_SERVICE_DEFAULT_ICON);
#line 255 "../lib/Drawing/DrawingService.vala"
	_vala_array_add4 (&all_names, &all_names_length1, &_all_names_size_, _tmp2_);
#line 257 "../lib/Drawing/DrawingService.vala"
	_tmp3_ = all_names;
#line 257 "../lib/Drawing/DrawingService.vala"
	_tmp3__length1 = all_names_length1;
#line 1729 "DrawingService.c"
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 257 "../lib/Drawing/DrawingService.vala"
		name_collection = _tmp3_;
#line 257 "../lib/Drawing/DrawingService.vala"
		name_collection_length1 = _tmp3__length1;
#line 257 "../lib/Drawing/DrawingService.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 1741 "DrawingService.c"
			const gchar* name = NULL;
#line 257 "../lib/Drawing/DrawingService.vala"
			name = name_collection[name_it];
#line 1745 "DrawingService.c"
			{
				GFile* file = NULL;
				const gchar* _tmp4_;
				GFile* _tmp5_;
				GFile* _tmp6_;
				const gchar* _tmp23_;
				cairo_surface_t* _tmp24_;
				cairo_surface_t* _tmp25_;
				const gchar* _tmp26_;
#line 258 "../lib/Drawing/DrawingService.vala"
				_tmp4_ = name;
#line 258 "../lib/Drawing/DrawingService.vala"
				_tmp5_ = plank_drawing_service_try_get_icon_file (_tmp4_);
#line 258 "../lib/Drawing/DrawingService.vala"
				file = _tmp5_;
#line 259 "../lib/Drawing/DrawingService.vala"
				_tmp6_ = file;
#line 259 "../lib/Drawing/DrawingService.vala"
				if (_tmp6_ != NULL) {
#line 1765 "DrawingService.c"
					GdkPixbuf* pbuf = NULL;
					GFile* _tmp7_;
					GdkPixbuf* _tmp8_;
					GdkPixbuf* _tmp9_;
#line 260 "../lib/Drawing/DrawingService.vala"
					_tmp7_ = file;
#line 260 "../lib/Drawing/DrawingService.vala"
					_tmp8_ = plank_drawing_service_load_pixbuf_from_file (_tmp7_, width, height);
#line 260 "../lib/Drawing/DrawingService.vala"
					pbuf = _tmp8_;
#line 261 "../lib/Drawing/DrawingService.vala"
					_tmp9_ = pbuf;
#line 261 "../lib/Drawing/DrawingService.vala"
					if (_tmp9_ != NULL) {
#line 1780 "DrawingService.c"
						cairo_surface_t* _tmp10_;
						cairo_t* cr = NULL;
						cairo_surface_t* _tmp11_;
						cairo_t* _tmp12_;
						cairo_t* _tmp13_;
						GdkPixbuf* _tmp14_;
						GdkPixbuf* _tmp15_;
						gint _tmp16_;
						gint _tmp17_;
						GdkPixbuf* _tmp18_;
						gint _tmp19_;
						gint _tmp20_;
						cairo_t* _tmp21_;
						cairo_surface_t* _tmp22_;
#line 262 "../lib/Drawing/DrawingService.vala"
						_tmp10_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
#line 262 "../lib/Drawing/DrawingService.vala"
						_cairo_surface_destroy0 (surface);
#line 262 "../lib/Drawing/DrawingService.vala"
						surface = _tmp10_;
#line 263 "../lib/Drawing/DrawingService.vala"
						_tmp11_ = surface;
#line 263 "../lib/Drawing/DrawingService.vala"
						_tmp12_ = cairo_create (_tmp11_);
#line 263 "../lib/Drawing/DrawingService.vala"
						cr = _tmp12_;
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp13_ = cr;
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp14_ = pbuf;
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp15_ = pbuf;
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp16_ = gdk_pixbuf_get_width (_tmp15_);
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp17_ = _tmp16_;
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp18_ = pbuf;
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 264 "../lib/Drawing/DrawingService.vala"
						_tmp20_ = _tmp19_;
#line 264 "../lib/Drawing/DrawingService.vala"
						gdk_cairo_set_source_pixbuf (_tmp13_, _tmp14_, (gdouble) ((width - _tmp17_) / 2), (gdouble) ((height - _tmp20_) / 2));
#line 265 "../lib/Drawing/DrawingService.vala"
						_tmp21_ = cr;
#line 265 "../lib/Drawing/DrawingService.vala"
						cairo_paint (_tmp21_);
#line 266 "../lib/Drawing/DrawingService.vala"
						_tmp22_ = surface;
#line 266 "../lib/Drawing/DrawingService.vala"
						cairo_surface_set_device_scale (_tmp22_, (gdouble) scale, (gdouble) scale);
#line 267 "../lib/Drawing/DrawingService.vala"
						_cairo_destroy0 (cr);
#line 267 "../lib/Drawing/DrawingService.vala"
						_g_object_unref0 (pbuf);
#line 267 "../lib/Drawing/DrawingService.vala"
						_g_object_unref0 (file);
#line 267 "../lib/Drawing/DrawingService.vala"
						break;
#line 1841 "DrawingService.c"
					}
#line 259 "../lib/Drawing/DrawingService.vala"
					_g_object_unref0 (pbuf);
#line 1845 "DrawingService.c"
				}
#line 271 "../lib/Drawing/DrawingService.vala"
				_tmp23_ = name;
#line 271 "../lib/Drawing/DrawingService.vala"
				_tmp24_ = plank_drawing_service_load_surface (_tmp23_, MAX (width, height) / scale, scale);
#line 271 "../lib/Drawing/DrawingService.vala"
				_cairo_surface_destroy0 (surface);
#line 271 "../lib/Drawing/DrawingService.vala"
				surface = _tmp24_;
#line 272 "../lib/Drawing/DrawingService.vala"
				_tmp25_ = surface;
#line 272 "../lib/Drawing/DrawingService.vala"
				if (_tmp25_ != NULL) {
#line 273 "../lib/Drawing/DrawingService.vala"
					_g_object_unref0 (file);
#line 273 "../lib/Drawing/DrawingService.vala"
					break;
#line 1863 "DrawingService.c"
				}
#line 275 "../lib/Drawing/DrawingService.vala"
				_tmp26_ = name;
#line 275 "../lib/Drawing/DrawingService.vala"
				if (g_strcmp0 (_tmp26_, PLANK_DRAWING_SERVICE_DEFAULT_ICON) != 0) {
#line 1869 "DrawingService.c"
					const gchar* _tmp27_;
#line 276 "../lib/Drawing/DrawingService.vala"
					_tmp27_ = name;
#line 276 "../lib/Drawing/DrawingService.vala"
					g_message ("DrawingService.vala:276: Could not find icon '%s'", _tmp27_);
#line 1875 "DrawingService.c"
				}
#line 257 "../lib/Drawing/DrawingService.vala"
				_g_object_unref0 (file);
#line 1879 "DrawingService.c"
			}
		}
	}
#line 280 "../lib/Drawing/DrawingService.vala"
	_tmp28_ = surface;
#line 280 "../lib/Drawing/DrawingService.vala"
	if (_tmp28_ == NULL) {
#line 1887 "DrawingService.c"
		cairo_surface_t* _tmp29_;
#line 281 "../lib/Drawing/DrawingService.vala"
		_tmp29_ = plank_drawing_service_load_surface_from_resource_at_scale (PLANK_G_RESOURCE_PATH "/img/application-default-icon.svg", width, height, scale);
#line 281 "../lib/Drawing/DrawingService.vala"
		_cairo_surface_destroy0 (surface);
#line 281 "../lib/Drawing/DrawingService.vala"
		surface = _tmp29_;
#line 1895 "DrawingService.c"
	}
#line 283 "../lib/Drawing/DrawingService.vala"
	result = surface;
#line 283 "../lib/Drawing/DrawingService.vala"
	all_names = (_vala_array_free (all_names, all_names_length1, (GDestroyNotify) g_free), NULL);
#line 283 "../lib/Drawing/DrawingService.vala"
	return result;
#line 1903 "DrawingService.c"
}

static cairo_surface_t*
plank_drawing_service_load_surface_from_resource_at_scale (const gchar* resource,
                                                           gint width,
                                                           gint height,
                                                           gint scale)
{
	GdkPixbuf* pbuf = NULL;
	cairo_surface_t* surface = NULL;
	GdkPixbuf* _tmp3_;
	GError* _inner_error0_ = NULL;
	cairo_surface_t* result;
#line 286 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (resource != NULL, NULL);
#line 288 "../lib/Drawing/DrawingService.vala"
	pbuf = NULL;
#line 289 "../lib/Drawing/DrawingService.vala"
	surface = NULL;
#line 1923 "DrawingService.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 292 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = gdk_pixbuf_new_from_resource_at_scale (resource, width, height, TRUE, &_inner_error0_);
#line 292 "../lib/Drawing/DrawingService.vala"
		_tmp0_ = _tmp1_;
#line 292 "../lib/Drawing/DrawingService.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1934 "DrawingService.c"
			goto __catch0_g_error;
		}
#line 292 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = _tmp0_;
#line 292 "../lib/Drawing/DrawingService.vala"
		_tmp0_ = NULL;
#line 292 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 292 "../lib/Drawing/DrawingService.vala"
		pbuf = _tmp2_;
#line 291 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (_tmp0_);
#line 1947 "DrawingService.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 291 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 1954 "DrawingService.c"
	}
	__finally0:
#line 291 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "../lib/Drawing/DrawingService.vala"
		_cairo_surface_destroy0 (surface);
#line 291 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (pbuf);
#line 291 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 291 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 291 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 1969 "DrawingService.c"
	}
#line 295 "../lib/Drawing/DrawingService.vala"
	_tmp3_ = pbuf;
#line 295 "../lib/Drawing/DrawingService.vala"
	if (_tmp3_ != NULL) {
#line 1975 "DrawingService.c"
		cairo_surface_t* _tmp4_;
		cairo_t* cr = NULL;
		cairo_surface_t* _tmp5_;
		cairo_t* _tmp6_;
		cairo_t* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		GdkPixbuf* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		cairo_t* _tmp15_;
		cairo_surface_t* _tmp16_;
#line 296 "../lib/Drawing/DrawingService.vala"
		_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
#line 296 "../lib/Drawing/DrawingService.vala"
		_cairo_surface_destroy0 (surface);
#line 296 "../lib/Drawing/DrawingService.vala"
		surface = _tmp4_;
#line 297 "../lib/Drawing/DrawingService.vala"
		_tmp5_ = surface;
#line 297 "../lib/Drawing/DrawingService.vala"
		_tmp6_ = cairo_create (_tmp5_);
#line 297 "../lib/Drawing/DrawingService.vala"
		cr = _tmp6_;
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp7_ = cr;
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp8_ = pbuf;
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp9_ = pbuf;
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp10_ = gdk_pixbuf_get_width (_tmp9_);
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp11_ = _tmp10_;
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp12_ = pbuf;
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp13_ = gdk_pixbuf_get_height (_tmp12_);
#line 298 "../lib/Drawing/DrawingService.vala"
		_tmp14_ = _tmp13_;
#line 298 "../lib/Drawing/DrawingService.vala"
		gdk_cairo_set_source_pixbuf (_tmp7_, _tmp8_, (gdouble) ((width - _tmp11_) / 2), (gdouble) ((height - _tmp14_) / 2));
#line 299 "../lib/Drawing/DrawingService.vala"
		_tmp15_ = cr;
#line 299 "../lib/Drawing/DrawingService.vala"
		cairo_paint (_tmp15_);
#line 300 "../lib/Drawing/DrawingService.vala"
		_tmp16_ = surface;
#line 300 "../lib/Drawing/DrawingService.vala"
		cairo_surface_set_device_scale (_tmp16_, (gdouble) scale, (gdouble) scale);
#line 295 "../lib/Drawing/DrawingService.vala"
		_cairo_destroy0 (cr);
#line 2030 "DrawingService.c"
	}
#line 303 "../lib/Drawing/DrawingService.vala"
	result = surface;
#line 303 "../lib/Drawing/DrawingService.vala"
	_g_object_unref0 (pbuf);
#line 303 "../lib/Drawing/DrawingService.vala"
	return result;
#line 2038 "DrawingService.c"
}

static cairo_surface_t*
plank_drawing_service_load_surface (const gchar* icon,
                                    gint size,
                                    gint scale)
{
	cairo_surface_t* surface = NULL;
	GtkIconInfo* info = NULL;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_;
	GError* _inner_error0_ = NULL;
	cairo_surface_t* result;
#line 306 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 308 "../lib/Drawing/DrawingService.vala"
	surface = NULL;
#line 309 "../lib/Drawing/DrawingService.vala"
	info = NULL;
#line 310 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = plank_drawing_service_get_icon_theme ();
#line 310 "../lib/Drawing/DrawingService.vala"
	icon_theme = _tmp0_;
#line 312 "../lib/Drawing/DrawingService.vala"
	g_mutex_lock (&plank_drawing_service_icon_theme_mutex);
#line 2064 "DrawingService.c"
	{
		GtkIconTheme* _tmp1_;
		GtkIconInfo* _tmp2_;
		GtkIconInfo* _tmp3_;
#line 315 "../lib/Drawing/DrawingService.vala"
		_tmp1_ = icon_theme;
#line 315 "../lib/Drawing/DrawingService.vala"
		_tmp2_ = gtk_icon_theme_lookup_icon_for_scale (_tmp1_, icon, size, scale, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 315 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (info);
#line 315 "../lib/Drawing/DrawingService.vala"
		info = _tmp2_;
#line 316 "../lib/Drawing/DrawingService.vala"
		_tmp3_ = info;
#line 316 "../lib/Drawing/DrawingService.vala"
		if (_tmp3_ != NULL) {
#line 2081 "DrawingService.c"
			cairo_surface_t* _tmp4_ = NULL;
			GtkIconInfo* _tmp5_;
			cairo_surface_t* _tmp6_;
			cairo_surface_t* _tmp7_;
#line 317 "../lib/Drawing/DrawingService.vala"
			_tmp5_ = info;
#line 317 "../lib/Drawing/DrawingService.vala"
			_tmp6_ = gtk_icon_info_load_surface (_tmp5_, NULL, &_inner_error0_);
#line 317 "../lib/Drawing/DrawingService.vala"
			_tmp4_ = _tmp6_;
#line 317 "../lib/Drawing/DrawingService.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2094 "DrawingService.c"
				goto __catch0_g_error;
			}
#line 317 "../lib/Drawing/DrawingService.vala"
			_tmp7_ = _tmp4_;
#line 317 "../lib/Drawing/DrawingService.vala"
			_tmp4_ = NULL;
#line 317 "../lib/Drawing/DrawingService.vala"
			_cairo_surface_destroy0 (surface);
#line 317 "../lib/Drawing/DrawingService.vala"
			surface = _tmp7_;
#line 316 "../lib/Drawing/DrawingService.vala"
			_cairo_surface_destroy0 (_tmp4_);
#line 2107 "DrawingService.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 314 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 2115 "DrawingService.c"
	}
	__finally0:
#line 314 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 314 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (info);
#line 314 "../lib/Drawing/DrawingService.vala"
		_cairo_surface_destroy0 (surface);
#line 314 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 314 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 314 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 2130 "DrawingService.c"
	}
	{
		gboolean _tmp8_ = FALSE;
		cairo_surface_t* _tmp9_;
#line 321 "../lib/Drawing/DrawingService.vala"
		_tmp9_ = surface;
#line 321 "../lib/Drawing/DrawingService.vala"
		if (_tmp9_ == NULL) {
#line 321 "../lib/Drawing/DrawingService.vala"
			_tmp8_ = string_contains (icon, ".");
#line 2141 "DrawingService.c"
		} else {
#line 321 "../lib/Drawing/DrawingService.vala"
			_tmp8_ = FALSE;
#line 2145 "DrawingService.c"
		}
#line 321 "../lib/Drawing/DrawingService.vala"
		if (_tmp8_) {
#line 2149 "DrawingService.c"
			gchar** parts = NULL;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint parts_length1;
			gint _parts_size_;
			GtkIconTheme* _tmp12_;
			gchar** _tmp13_;
			gint _tmp13__length1;
			const gchar* _tmp14_;
			GtkIconInfo* _tmp15_;
			GtkIconInfo* _tmp16_;
#line 322 "../lib/Drawing/DrawingService.vala"
			_tmp11_ = _tmp10_ = g_strsplit (icon, ".", 0);
#line 322 "../lib/Drawing/DrawingService.vala"
			parts = _tmp11_;
#line 322 "../lib/Drawing/DrawingService.vala"
			parts_length1 = _vala_array_length (_tmp10_);
#line 322 "../lib/Drawing/DrawingService.vala"
			_parts_size_ = parts_length1;
#line 323 "../lib/Drawing/DrawingService.vala"
			_tmp12_ = icon_theme;
#line 323 "../lib/Drawing/DrawingService.vala"
			_tmp13_ = parts;
#line 323 "../lib/Drawing/DrawingService.vala"
			_tmp13__length1 = parts_length1;
#line 323 "../lib/Drawing/DrawingService.vala"
			_tmp14_ = _tmp13_[0];
#line 323 "../lib/Drawing/DrawingService.vala"
			_tmp15_ = gtk_icon_theme_lookup_icon_for_scale (_tmp12_, _tmp14_, size, scale, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 323 "../lib/Drawing/DrawingService.vala"
			_g_object_unref0 (info);
#line 323 "../lib/Drawing/DrawingService.vala"
			info = _tmp15_;
#line 324 "../lib/Drawing/DrawingService.vala"
			_tmp16_ = info;
#line 324 "../lib/Drawing/DrawingService.vala"
			if (_tmp16_ != NULL) {
#line 2187 "DrawingService.c"
				cairo_surface_t* _tmp17_ = NULL;
				GtkIconInfo* _tmp18_;
				cairo_surface_t* _tmp19_;
				cairo_surface_t* _tmp20_;
#line 325 "../lib/Drawing/DrawingService.vala"
				_tmp18_ = info;
#line 325 "../lib/Drawing/DrawingService.vala"
				_tmp19_ = gtk_icon_info_load_surface (_tmp18_, NULL, &_inner_error0_);
#line 325 "../lib/Drawing/DrawingService.vala"
				_tmp17_ = _tmp19_;
#line 325 "../lib/Drawing/DrawingService.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "../lib/Drawing/DrawingService.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 2202 "DrawingService.c"
					goto __catch1_g_error;
				}
#line 325 "../lib/Drawing/DrawingService.vala"
				_tmp20_ = _tmp17_;
#line 325 "../lib/Drawing/DrawingService.vala"
				_tmp17_ = NULL;
#line 325 "../lib/Drawing/DrawingService.vala"
				_cairo_surface_destroy0 (surface);
#line 325 "../lib/Drawing/DrawingService.vala"
				surface = _tmp20_;
#line 324 "../lib/Drawing/DrawingService.vala"
				_cairo_surface_destroy0 (_tmp17_);
#line 2215 "DrawingService.c"
			}
#line 321 "../lib/Drawing/DrawingService.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 2219 "DrawingService.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 320 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 2227 "DrawingService.c"
	}
	__finally1:
#line 320 "../lib/Drawing/DrawingService.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 320 "../lib/Drawing/DrawingService.vala"
		_g_object_unref0 (info);
#line 320 "../lib/Drawing/DrawingService.vala"
		_cairo_surface_destroy0 (surface);
#line 320 "../lib/Drawing/DrawingService.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 320 "../lib/Drawing/DrawingService.vala"
		g_clear_error (&_inner_error0_);
#line 320 "../lib/Drawing/DrawingService.vala"
		return NULL;
#line 2242 "DrawingService.c"
	}
#line 329 "../lib/Drawing/DrawingService.vala"
	g_mutex_unlock (&plank_drawing_service_icon_theme_mutex);
#line 331 "../lib/Drawing/DrawingService.vala"
	result = surface;
#line 331 "../lib/Drawing/DrawingService.vala"
	_g_object_unref0 (info);
#line 331 "../lib/Drawing/DrawingService.vala"
	return result;
#line 2252 "DrawingService.c"
}

/**
 * Scales a {@link Gdk.Pixbuf}, maintaining the original aspect ratio.
 *
 * @param source the pixbuf to scale
 * @param width the width of the scaled pixbuf
 * @param height the height of the scaled pixbuf
 * @return the scaled pixbuf
 */
GdkPixbuf*
plank_drawing_service_ar_scale (GdkPixbuf* source,
                                gint width,
                                gint height)
{
	gdouble source_width = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble source_height = 0.0;
	gint _tmp2_;
	gint _tmp3_;
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	gdouble scale = 0.0;
	gint scaled_width = 0;
	gint scaled_height = 0;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* result;
#line 342 "../lib/Drawing/DrawingService.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 344 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = gdk_pixbuf_get_width (source);
#line 344 "../lib/Drawing/DrawingService.vala"
	_tmp1_ = _tmp0_;
#line 344 "../lib/Drawing/DrawingService.vala"
	source_width = (gdouble) _tmp1_;
#line 345 "../lib/Drawing/DrawingService.vala"
	_tmp2_ = gdk_pixbuf_get_height (source);
#line 345 "../lib/Drawing/DrawingService.vala"
	_tmp3_ = _tmp2_;
#line 345 "../lib/Drawing/DrawingService.vala"
	source_height = (gdouble) _tmp3_;
#line 347 "../lib/Drawing/DrawingService.vala"
	x_scale = width / source_width;
#line 348 "../lib/Drawing/DrawingService.vala"
	y_scale = height / source_height;
#line 349 "../lib/Drawing/DrawingService.vala"
	scale = MIN (x_scale, y_scale);
#line 351 "../lib/Drawing/DrawingService.vala"
	if (scale == ((gdouble) 1)) {
#line 2303 "DrawingService.c"
		GdkPixbuf* _tmp4_;
#line 352 "../lib/Drawing/DrawingService.vala"
		_tmp4_ = _g_object_ref0 (source);
#line 352 "../lib/Drawing/DrawingService.vala"
		result = _tmp4_;
#line 352 "../lib/Drawing/DrawingService.vala"
		return result;
#line 2311 "DrawingService.c"
	}
#line 354 "../lib/Drawing/DrawingService.vala"
	scaled_width = MAX (1, (gint) (source_width * scale));
#line 355 "../lib/Drawing/DrawingService.vala"
	scaled_height = MAX (1, (gint) (source_height * scale));
#line 357 "../lib/Drawing/DrawingService.vala"
	_tmp5_ = gdk_pixbuf_scale_simple (source, scaled_width, scaled_height, GDK_INTERP_HYPER);
#line 357 "../lib/Drawing/DrawingService.vala"
	result = _tmp5_;
#line 357 "../lib/Drawing/DrawingService.vala"
	return result;
#line 2323 "DrawingService.c"
}

/**
 * Computes and returns the average color of a {@link Gdk.Pixbuf}.
 * The resulting color is the average of all pixels which aren't
 * nearly transparent while saturated pixels are weighted more than
 * "grey" ones.
 *
 * @param source the pixbuf to use
 * @return the average color of the pixbuf
 */
void
plank_drawing_service_average_color (GdkPixbuf* source,
                                     PlankColor* result)
{
	guint8 r = 0U;
	guint8 g = 0U;
	guint8 b = 0U;
	guint8 a = 0U;
	guint8 min = 0U;
	guint8 max = 0U;
	gdouble delta = 0.0;
	gdouble rTotal = 0.0;
	gdouble gTotal = 0.0;
	gdouble bTotal = 0.0;
	gdouble bTotal2 = 0.0;
	gdouble gTotal2 = 0.0;
	gdouble rTotal2 = 0.0;
	gdouble aTotal2 = 0.0;
	guint8* dataPtr = NULL;
	guint8* _tmp0_;
	gint n_channels = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint width = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint height = 0;
	gint _tmp5_;
	gint _tmp6_;
	gint rowstride = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint length = 0;
	gint pixels = 0;
	gdouble scoreTotal = 0.0;
	gdouble max_val = 0.0;
	PlankColor _tmp24_ = {0};
#line 369 "../lib/Drawing/DrawingService.vala"
	g_return_if_fail (source != NULL);
#line 374 "../lib/Drawing/DrawingService.vala"
	rTotal = 0.0;
#line 375 "../lib/Drawing/DrawingService.vala"
	gTotal = 0.0;
#line 376 "../lib/Drawing/DrawingService.vala"
	bTotal = 0.0;
#line 378 "../lib/Drawing/DrawingService.vala"
	bTotal2 = 0.0;
#line 379 "../lib/Drawing/DrawingService.vala"
	gTotal2 = 0.0;
#line 380 "../lib/Drawing/DrawingService.vala"
	rTotal2 = 0.0;
#line 381 "../lib/Drawing/DrawingService.vala"
	aTotal2 = 0.0;
#line 383 "../lib/Drawing/DrawingService.vala"
	_tmp0_ = gdk_pixbuf_get_pixels (source);
#line 383 "../lib/Drawing/DrawingService.vala"
	dataPtr = _tmp0_;
#line 384 "../lib/Drawing/DrawingService.vala"
	_tmp1_ = gdk_pixbuf_get_n_channels (source);
#line 384 "../lib/Drawing/DrawingService.vala"
	_tmp2_ = _tmp1_;
#line 384 "../lib/Drawing/DrawingService.vala"
	n_channels = _tmp2_;
#line 385 "../lib/Drawing/DrawingService.vala"
	_tmp3_ = gdk_pixbuf_get_width (source);
#line 385 "../lib/Drawing/DrawingService.vala"
	_tmp4_ = _tmp3_;
#line 385 "../lib/Drawing/DrawingService.vala"
	width = _tmp4_;
#line 386 "../lib/Drawing/DrawingService.vala"
	_tmp5_ = gdk_pixbuf_get_height (source);
#line 386 "../lib/Drawing/DrawingService.vala"
	_tmp6_ = _tmp5_;
#line 386 "../lib/Drawing/DrawingService.vala"
	height = _tmp6_;
#line 387 "../lib/Drawing/DrawingService.vala"
	_tmp7_ = gdk_pixbuf_get_rowstride (source);
#line 387 "../lib/Drawing/DrawingService.vala"
	_tmp8_ = _tmp7_;
#line 387 "../lib/Drawing/DrawingService.vala"
	rowstride = _tmp8_;
#line 388 "../lib/Drawing/DrawingService.vala"
	length = width * height;
#line 389 "../lib/Drawing/DrawingService.vala"
	pixels = (height * rowstride) / n_channels;
#line 390 "../lib/Drawing/DrawingService.vala"
	scoreTotal = 0.0;
#line 2422 "DrawingService.c"
	{
		gint i = 0;
#line 392 "../lib/Drawing/DrawingService.vala"
		i = 0;
#line 2427 "DrawingService.c"
		{
			gboolean _tmp9_ = FALSE;
#line 392 "../lib/Drawing/DrawingService.vala"
			_tmp9_ = TRUE;
#line 392 "../lib/Drawing/DrawingService.vala"
			while (TRUE) {
#line 2434 "DrawingService.c"
				guint8* _tmp11_;
				guint8 _tmp12_;
				guint8* _tmp13_;
				guint8 _tmp14_;
				guint8* _tmp15_;
				guint8 _tmp16_;
				guint8* _tmp17_;
				guint8 _tmp18_;
				gdouble _tmp21_ = 0.0;
				gdouble score = 0.0;
				guint8* _tmp22_;
#line 392 "../lib/Drawing/DrawingService.vala"
				if (!_tmp9_) {
#line 2448 "DrawingService.c"
					gint _tmp10_;
#line 392 "../lib/Drawing/DrawingService.vala"
					_tmp10_ = i;
#line 392 "../lib/Drawing/DrawingService.vala"
					i = _tmp10_ + 1;
#line 2454 "DrawingService.c"
				}
#line 392 "../lib/Drawing/DrawingService.vala"
				_tmp9_ = FALSE;
#line 392 "../lib/Drawing/DrawingService.vala"
				if (!(i < pixels)) {
#line 392 "../lib/Drawing/DrawingService.vala"
					break;
#line 2462 "DrawingService.c"
				}
#line 393 "../lib/Drawing/DrawingService.vala"
				_tmp11_ = dataPtr;
#line 393 "../lib/Drawing/DrawingService.vala"
				_tmp12_ = _tmp11_[0];
#line 393 "../lib/Drawing/DrawingService.vala"
				r = _tmp12_;
#line 394 "../lib/Drawing/DrawingService.vala"
				_tmp13_ = dataPtr;
#line 394 "../lib/Drawing/DrawingService.vala"
				_tmp14_ = _tmp13_[1];
#line 394 "../lib/Drawing/DrawingService.vala"
				g = _tmp14_;
#line 395 "../lib/Drawing/DrawingService.vala"
				_tmp15_ = dataPtr;
#line 395 "../lib/Drawing/DrawingService.vala"
				_tmp16_ = _tmp15_[2];
#line 395 "../lib/Drawing/DrawingService.vala"
				b = _tmp16_;
#line 396 "../lib/Drawing/DrawingService.vala"
				_tmp17_ = dataPtr;
#line 396 "../lib/Drawing/DrawingService.vala"
				_tmp18_ = _tmp17_[3];
#line 396 "../lib/Drawing/DrawingService.vala"
				a = _tmp18_;
#line 399 "../lib/Drawing/DrawingService.vala"
				if (a <= PLANK_DRAWING_SERVICE_ALPHA_THRESHOLD) {
#line 2490 "DrawingService.c"
					gint _tmp19_;
					guint8* _tmp20_;
#line 400 "../lib/Drawing/DrawingService.vala"
					_tmp19_ = length;
#line 400 "../lib/Drawing/DrawingService.vala"
					length = _tmp19_ - 1;
#line 401 "../lib/Drawing/DrawingService.vala"
					_tmp20_ = dataPtr;
#line 401 "../lib/Drawing/DrawingService.vala"
					dataPtr = _tmp20_ + n_channels;
#line 402 "../lib/Drawing/DrawingService.vala"
					continue;
#line 2503 "DrawingService.c"
				}
#line 405 "../lib/Drawing/DrawingService.vala"
				min = MIN (r, MIN (g, b));
#line 406 "../lib/Drawing/DrawingService.vala"
				max = MAX (r, MAX (g, b));
#line 407 "../lib/Drawing/DrawingService.vala"
				delta = (gdouble) (max - min);
#line 410 "../lib/Drawing/DrawingService.vala"
				if (delta == ((gdouble) 0)) {
#line 410 "../lib/Drawing/DrawingService.vala"
					_tmp21_ = 0.0;
#line 2515 "DrawingService.c"
				} else {
#line 410 "../lib/Drawing/DrawingService.vala"
					_tmp21_ = delta / max;
#line 2519 "DrawingService.c"
				}
#line 410 "../lib/Drawing/DrawingService.vala"
				score = PLANK_DRAWING_SERVICE_SATURATION_WEIGHT * _tmp21_;
#line 413 "../lib/Drawing/DrawingService.vala"
				bTotal += (score * b) / a;
#line 414 "../lib/Drawing/DrawingService.vala"
				gTotal += (score * g) / a;
#line 415 "../lib/Drawing/DrawingService.vala"
				rTotal += (score * r) / a;
#line 416 "../lib/Drawing/DrawingService.vala"
				scoreTotal += score;
#line 419 "../lib/Drawing/DrawingService.vala"
				bTotal2 += (gdouble) b;
#line 420 "../lib/Drawing/DrawingService.vala"
				gTotal2 += (gdouble) g;
#line 421 "../lib/Drawing/DrawingService.vala"
				rTotal2 += (gdouble) r;
#line 422 "../lib/Drawing/DrawingService.vala"
				aTotal2 += (gdouble) a;
#line 424 "../lib/Drawing/DrawingService.vala"
				_tmp22_ = dataPtr;
#line 424 "../lib/Drawing/DrawingService.vala"
				dataPtr = _tmp22_ + n_channels;
#line 2543 "DrawingService.c"
			}
		}
	}
#line 428 "../lib/Drawing/DrawingService.vala"
	if (length <= 0) {
#line 2549 "DrawingService.c"
		PlankColor _tmp23_ = {0};
#line 429 "../lib/Drawing/DrawingService.vala"
		_tmp23_.red = 0.0;
#line 429 "../lib/Drawing/DrawingService.vala"
		_tmp23_.green = 0.0;
#line 429 "../lib/Drawing/DrawingService.vala"
		_tmp23_.blue = 0.0;
#line 429 "../lib/Drawing/DrawingService.vala"
		_tmp23_.alpha = 0.0;
#line 429 "../lib/Drawing/DrawingService.vala"
		*result = _tmp23_;
#line 429 "../lib/Drawing/DrawingService.vala"
		return;
#line 2563 "DrawingService.c"
	}
#line 431 "../lib/Drawing/DrawingService.vala"
	scoreTotal /= (gdouble) length;
#line 432 "../lib/Drawing/DrawingService.vala"
	bTotal /= (gdouble) length;
#line 433 "../lib/Drawing/DrawingService.vala"
	gTotal /= (gdouble) length;
#line 434 "../lib/Drawing/DrawingService.vala"
	rTotal /= (gdouble) length;
#line 436 "../lib/Drawing/DrawingService.vala"
	if (scoreTotal > 0.0) {
#line 437 "../lib/Drawing/DrawingService.vala"
		bTotal /= scoreTotal;
#line 438 "../lib/Drawing/DrawingService.vala"
		gTotal /= scoreTotal;
#line 439 "../lib/Drawing/DrawingService.vala"
		rTotal /= scoreTotal;
#line 2581 "DrawingService.c"
	}
#line 442 "../lib/Drawing/DrawingService.vala"
	bTotal2 /= (gdouble) (length * G_MAXUINT8);
#line 443 "../lib/Drawing/DrawingService.vala"
	gTotal2 /= (gdouble) (length * G_MAXUINT8);
#line 444 "../lib/Drawing/DrawingService.vala"
	rTotal2 /= (gdouble) (length * G_MAXUINT8);
#line 445 "../lib/Drawing/DrawingService.vala"
	aTotal2 /= (gdouble) (length * G_MAXUINT8);
#line 450 "../lib/Drawing/DrawingService.vala"
	if (scoreTotal <= PLANK_DRAWING_SERVICE_WEIGHT_THRESHOLD) {
#line 2593 "DrawingService.c"
		gdouble f = 0.0;
		gdouble rf = 0.0;
#line 451 "../lib/Drawing/DrawingService.vala"
		f = (1.0 / PLANK_DRAWING_SERVICE_WEIGHT_THRESHOLD) * scoreTotal;
#line 452 "../lib/Drawing/DrawingService.vala"
		rf = 1.0 - f;
#line 453 "../lib/Drawing/DrawingService.vala"
		bTotal = (bTotal * f) + (bTotal2 * rf);
#line 454 "../lib/Drawing/DrawingService.vala"
		gTotal = (gTotal * f) + (gTotal2 * rf);
#line 455 "../lib/Drawing/DrawingService.vala"
		rTotal = (rTotal * f) + (rTotal2 * rf);
#line 2606 "DrawingService.c"
	}
#line 459 "../lib/Drawing/DrawingService.vala"
	max_val = MAX (rTotal, MAX (gTotal, bTotal));
#line 460 "../lib/Drawing/DrawingService.vala"
	if (max_val > 1.0) {
#line 461 "../lib/Drawing/DrawingService.vala"
		bTotal /= max_val;
#line 462 "../lib/Drawing/DrawingService.vala"
		gTotal /= max_val;
#line 463 "../lib/Drawing/DrawingService.vala"
		rTotal /= max_val;
#line 2618 "DrawingService.c"
	}
#line 466 "../lib/Drawing/DrawingService.vala"
	_tmp24_.red = rTotal;
#line 466 "../lib/Drawing/DrawingService.vala"
	_tmp24_.green = gTotal;
#line 466 "../lib/Drawing/DrawingService.vala"
	_tmp24_.blue = bTotal;
#line 466 "../lib/Drawing/DrawingService.vala"
	_tmp24_.alpha = aTotal2;
#line 466 "../lib/Drawing/DrawingService.vala"
	*result = _tmp24_;
#line 466 "../lib/Drawing/DrawingService.vala"
	return;
#line 2632 "DrawingService.c"
}

static void
plank_drawing_service_class_init (PlankDrawingServiceClass * klass,
                                  gpointer klass_data)
{
#line 25 "../lib/Drawing/DrawingService.vala"
	plank_drawing_service_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Drawing/DrawingService.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_drawing_service_finalize;
#line 2643 "DrawingService.c"
}

static void
plank_drawing_service_instance_init (PlankDrawingService * self,
                                     gpointer klass)
{
}

static void
plank_drawing_service_finalize (GObject * obj)
{
	PlankDrawingService * self;
#line 25 "../lib/Drawing/DrawingService.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DRAWING_SERVICE, PlankDrawingService);
#line 25 "../lib/Drawing/DrawingService.vala"
	G_OBJECT_CLASS (plank_drawing_service_parent_class)->finalize (obj);
#line 2660 "DrawingService.c"
}

/**
 * Utility service for loading icons and working with pixbufs.
 */
static GType
plank_drawing_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDrawingServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_drawing_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDrawingService), 0, (GInstanceInitFunc) plank_drawing_service_instance_init, NULL };
	GType plank_drawing_service_type_id;
	plank_drawing_service_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankDrawingService", &g_define_type_info, 0);
	return plank_drawing_service_type_id;
}

GType
plank_drawing_service_get_type (void)
{
	static volatile gsize plank_drawing_service_type_id__once = 0;
	if (g_once_init_enter (&plank_drawing_service_type_id__once)) {
		GType plank_drawing_service_type_id;
		plank_drawing_service_type_id = plank_drawing_service_get_type_once ();
		g_once_init_leave (&plank_drawing_service_type_id__once, plank_drawing_service_type_id);
	}
	return plank_drawing_service_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2694 "DrawingService.c"
		gssize i;
#line 52 "../lib/Docklets/DockletManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 52 "../lib/Docklets/DockletManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 52 "../lib/Docklets/DockletManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2702 "DrawingService.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 52 "../lib/Docklets/DockletManager.vala"
	g_free (array);
#line 2717 "DrawingService.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 52 "../lib/Docklets/DockletManager.vala"
	if (array) {
#line 52 "../lib/Docklets/DockletManager.vala"
		while (((gpointer*) array)[length]) {
#line 52 "../lib/Docklets/DockletManager.vala"
			length++;
#line 2731 "DrawingService.c"
		}
	}
#line 52 "../lib/Docklets/DockletManager.vala"
	return length;
#line 2736 "DrawingService.c"
}

