/* ItemFactory.c generated by valac 0.56.9, the Vala compiler
 * generated from ItemFactory.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include "plank-internal.h"
#include <gio/gdesktopappinfo.h>

enum  {
	PLANK_ITEM_FACTORY_0_PROPERTY,
	PLANK_ITEM_FACTORY_NUM_PROPERTIES
};
static GParamSpec* plank_item_factory_properties[PLANK_ITEM_FACTORY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

static gpointer plank_item_factory_parent_class = NULL;

static PlankDockElement* plank_item_factory_real_make_element (PlankItemFactory* self,
                                                        GFile* file);
static PlankDockItem* plank_item_factory_real_get_item_for_dock (PlankItemFactory* self);
static PlankDockItem* plank_item_factory_find_item_for_uri (PlankItemFactory* self,
                                                     GeeArrayList* elements,
                                                     const gchar* uri);
static void plank_item_factory_make_dock_item_for_desktop_id (PlankItemFactory* self,
                                                       const gchar* id);
static gboolean plank_item_factory_make_default_gnome_items (PlankItemFactory* self);
static void plank_item_factory_finalize (GObject * obj);
static GType plank_item_factory_get_type_once (void);

static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_WEB[6] = {"file:///usr/share/applications/chromium-browser.desktop", "file:///usr/share/applications/google-chrome.desktop", "file:///usr/share/applications/firefox.desktop", "file:///usr/share/applications/epiphany.desktop", "file:///usr/share/applications/midori.desktop", "file:///usr/share/applications/kde4/konqbrowser.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_MAIL[4] = {"file:///usr/share/applications/thunderbird.desktop", "file:///usr/share/applications/evolution.desktop", "file:///usr/share/applications/geary.desktop", "file:///usr/share/applications/kde4/KMail2.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_CALENDAR[4] = {"file:///usr/share/applications/thunderbird.desktop", "file:///usr/share/applications/evolution.desktop", "file:///usr/share/applications/maya-calendar.desktop", "file:///usr/share/applications/kde4/korganizer.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_TERMINAL[4] = {"file:///usr/share/applications/terminator.desktop", "file:///usr/share/applications/gnome-terminal.desktop", "file:///usr/share/applications/pantheon-terminal.desktop", "file:///usr/share/applications/kde4/konsole.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_AUDIO[6] = {"file:///usr/share/applications/exaile.desktop", "file:///usr/share/applications/songbird.desktop", "file:///usr/share/applications/rhythmbox.desktop", "file:///usr/share/applications/noise.desktop", "file:///usr/share/applications/banshee-1.desktop", "file:///usr/share/applications/kde4/amarok.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_VIDEO[4] = {"file:///usr/share/applications/vlc.desktop", "file:///usr/share/applications/totem.desktop", "file:///usr/share/applications/audience.desktop", "file:///usr/share/applications/kde4/amarok.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_PHOTO[5] = {"file:///usr/share/applications/eog.desktop", "file:///usr/share/applications/gnome-photos.desktop", "file:///usr/share/applications/org.gnome.Photos.desktop", "file:///usr/share/applications/shotwell.desktop", "file:///usr/share/applications/kde4/digikam.desktop"};
static const gchar* PLANK_ITEM_FACTORY_DEFAULT_APP_MESSENGER[4] = {"file:///usr/share/applications/pidgin.desktop", "file:///usr/share/applications/empathy.desktop", "file:///usr/share/applications/birdie.desktop", "file:///usr/share/applications/kde4/kopete.desktop"};

/**
 * Creates a new {@link DockElement} from a .dockitem.
 *
 * @param file the {@link GLib.File} of .dockitem file to parse
 * @return the new {@link DockElement} created
 */
static PlankDockElement*
plank_item_factory_real_make_element (PlankItemFactory* self,
                                      GFile* file)
{
	gchar* launcher = NULL;
	gchar* _tmp0_;
	PlankDocklet* docklet = NULL;
	PlankDockletManager* _tmp1_;
	const gchar* _tmp2_;
	PlankDocklet* _tmp3_;
	PlankDocklet* _tmp4_;
	const gchar* _tmp8_;
	PlankDockElement* _tmp9_;
	PlankDockElement* result;
#line 99 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 101 "../lib/Factories/ItemFactory.vala"
	_tmp0_ = plank_item_factory_get_launcher_from_dockitem (self, file);
#line 101 "../lib/Factories/ItemFactory.vala"
	launcher = _tmp0_;
#line 104 "../lib/Factories/ItemFactory.vala"
	_tmp1_ = plank_docklet_manager_get_default ();
#line 104 "../lib/Factories/ItemFactory.vala"
	_tmp2_ = launcher;
#line 104 "../lib/Factories/ItemFactory.vala"
	_tmp3_ = plank_docklet_manager_get_docklet_by_uri (_tmp1_, _tmp2_);
#line 104 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (docklet);
#line 104 "../lib/Factories/ItemFactory.vala"
	docklet = _tmp3_;
#line 104 "../lib/Factories/ItemFactory.vala"
	_tmp4_ = docklet;
#line 104 "../lib/Factories/ItemFactory.vala"
	if (_tmp4_ != NULL) {
#line 107 "ItemFactory.c"
		PlankDocklet* _tmp5_;
		const gchar* _tmp6_;
		PlankDockElement* _tmp7_;
#line 105 "../lib/Factories/ItemFactory.vala"
		_tmp5_ = docklet;
#line 105 "../lib/Factories/ItemFactory.vala"
		_tmp6_ = launcher;
#line 105 "../lib/Factories/ItemFactory.vala"
		_tmp7_ = plank_docklet_make_element (_tmp5_, _tmp6_, file);
#line 105 "../lib/Factories/ItemFactory.vala"
		result = _tmp7_;
#line 105 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (docklet);
#line 105 "../lib/Factories/ItemFactory.vala"
		_g_free0 (launcher);
#line 105 "../lib/Factories/ItemFactory.vala"
		return result;
#line 125 "ItemFactory.c"
	}
#line 107 "../lib/Factories/ItemFactory.vala"
	_tmp8_ = launcher;
#line 107 "../lib/Factories/ItemFactory.vala"
	_tmp9_ = plank_item_factory_default_make_element (self, file, _tmp8_);
#line 107 "../lib/Factories/ItemFactory.vala"
	result = _tmp9_;
#line 107 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (docklet);
#line 107 "../lib/Factories/ItemFactory.vala"
	_g_free0 (launcher);
#line 107 "../lib/Factories/ItemFactory.vala"
	return result;
#line 139 "ItemFactory.c"
}

PlankDockElement*
plank_item_factory_make_element (PlankItemFactory* self,
                                 GFile* file)
{
	PlankItemFactoryClass* _klass_;
#line 99 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../lib/Factories/ItemFactory.vala"
	_klass_ = PLANK_ITEM_FACTORY_GET_CLASS (self);
#line 99 "../lib/Factories/ItemFactory.vala"
	if (_klass_->make_element) {
#line 99 "../lib/Factories/ItemFactory.vala"
		return _klass_->make_element (self, file);
#line 155 "ItemFactory.c"
	}
#line 99 "../lib/Factories/ItemFactory.vala"
	return NULL;
#line 159 "ItemFactory.c"
}

/**
 * Creates a new {@link PlankDockItem} for the dock itself.
 *
 * @return the new {@link PlankDockItem} created
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 117 "../lib/Factories/ItemFactory.vala"
	return self ? g_object_ref (self) : NULL;
#line 172 "ItemFactory.c"
}

static PlankDockItem*
plank_item_factory_real_get_item_for_dock (PlankItemFactory* self)
{
	PlankPlankDockItem* _tmp0_;
	PlankDockItem* _tmp1_;
	PlankDockItem* result;
#line 117 "../lib/Factories/ItemFactory.vala"
	_tmp0_ = plank_plank_dock_item_get_instance ();
#line 117 "../lib/Factories/ItemFactory.vala"
	_tmp1_ = _g_object_ref0 ((PlankDockItem*) _tmp0_);
#line 117 "../lib/Factories/ItemFactory.vala"
	result = _tmp1_;
#line 117 "../lib/Factories/ItemFactory.vala"
	return result;
#line 189 "ItemFactory.c"
}

PlankDockItem*
plank_item_factory_get_item_for_dock (PlankItemFactory* self)
{
	PlankItemFactoryClass* _klass_;
#line 115 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../lib/Factories/ItemFactory.vala"
	_klass_ = PLANK_ITEM_FACTORY_GET_CLASS (self);
#line 115 "../lib/Factories/ItemFactory.vala"
	if (_klass_->get_item_for_dock) {
#line 115 "../lib/Factories/ItemFactory.vala"
		return _klass_->get_item_for_dock (self);
#line 204 "ItemFactory.c"
	}
#line 115 "../lib/Factories/ItemFactory.vala"
	return NULL;
#line 208 "ItemFactory.c"
}

/**
 * Creates a new {@link DockElement} for a launcher parsed from a .dockitem.
 *
 * @param file the {@link GLib.File} of .dockitem file that was parsed
 * @param launcher the launcher name from the .dockitem
 * @return the new {@link DockElement} created
 */
PlankDockElement*
plank_item_factory_default_make_element (PlankItemFactory* self,
                                         GFile* file,
                                         const gchar* launcher)
{
	PlankFileDockItem* _tmp1_;
	PlankDockElement* result;
#line 127 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 127 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (launcher != NULL, NULL);
#line 129 "../lib/Factories/ItemFactory.vala"
	if (g_str_has_suffix (launcher, ".desktop")) {
#line 233 "ItemFactory.c"
		PlankApplicationDockItem* _tmp0_;
#line 130 "../lib/Factories/ItemFactory.vala"
		_tmp0_ = plank_application_dock_item_new_with_dockitem_file (file);
#line 130 "../lib/Factories/ItemFactory.vala"
		result = (PlankDockElement*) _tmp0_;
#line 130 "../lib/Factories/ItemFactory.vala"
		return result;
#line 241 "ItemFactory.c"
	}
#line 131 "../lib/Factories/ItemFactory.vala"
	_tmp1_ = plank_file_dock_item_new_with_dockitem_file (file);
#line 131 "../lib/Factories/ItemFactory.vala"
	result = (PlankDockElement*) _tmp1_;
#line 131 "../lib/Factories/ItemFactory.vala"
	return result;
#line 249 "ItemFactory.c"
}

/**
 * Parses a .dockitem to get the launcher from it.
 *
 * @param file the {@link GLib.File} of .dockitem to parse
 * @return the launcher from the .dockitem
 */
gchar*
plank_item_factory_get_launcher_from_dockitem (PlankItemFactory* self,
                                               GFile* file)
{
	gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 140 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 269 "ItemFactory.c"
	{
		GKeyFile* keyfile = NULL;
		GKeyFile* _tmp0_;
		GKeyFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* group_name = NULL;
		const gchar* _tmp4_;
		GKeyFile* _tmp5_;
		const gchar* _tmp6_;
		GKeyFile* _tmp12_;
#line 143 "../lib/Factories/ItemFactory.vala"
		_tmp0_ = g_key_file_new ();
#line 143 "../lib/Factories/ItemFactory.vala"
		keyfile = _tmp0_;
#line 144 "../lib/Factories/ItemFactory.vala"
		_tmp1_ = keyfile;
#line 144 "../lib/Factories/ItemFactory.vala"
		_tmp2_ = g_file_get_path (file);
#line 144 "../lib/Factories/ItemFactory.vala"
		_tmp3_ = _tmp2_;
#line 144 "../lib/Factories/ItemFactory.vala"
		g_key_file_load_from_file (_tmp1_, _tmp3_, G_KEY_FILE_NONE, &_inner_error0_);
#line 144 "../lib/Factories/ItemFactory.vala"
		_g_free0 (_tmp3_);
#line 144 "../lib/Factories/ItemFactory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../lib/Factories/ItemFactory.vala"
			_g_key_file_unref0 (keyfile);
#line 299 "ItemFactory.c"
			goto __catch0_g_error;
		}
#line 146 "../lib/Factories/ItemFactory.vala"
		_tmp4_ = g_type_name (PLANK_TYPE_DOCK_ITEM_PREFERENCES);
#line 146 "../lib/Factories/ItemFactory.vala"
		group_name = _tmp4_;
#line 147 "../lib/Factories/ItemFactory.vala"
		_tmp5_ = keyfile;
#line 147 "../lib/Factories/ItemFactory.vala"
		_tmp6_ = group_name;
#line 147 "../lib/Factories/ItemFactory.vala"
		if (g_key_file_has_group (_tmp5_, _tmp6_)) {
#line 312 "ItemFactory.c"
			gchar* _tmp7_ = NULL;
			GKeyFile* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 148 "../lib/Factories/ItemFactory.vala"
			_tmp8_ = keyfile;
#line 148 "../lib/Factories/ItemFactory.vala"
			_tmp9_ = group_name;
#line 148 "../lib/Factories/ItemFactory.vala"
			_tmp10_ = g_key_file_get_string (_tmp8_, _tmp9_, "Launcher", &_inner_error0_);
#line 148 "../lib/Factories/ItemFactory.vala"
			_tmp7_ = _tmp10_;
#line 148 "../lib/Factories/ItemFactory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../lib/Factories/ItemFactory.vala"
				_g_key_file_unref0 (keyfile);
#line 330 "ItemFactory.c"
				goto __catch0_g_error;
			}
#line 148 "../lib/Factories/ItemFactory.vala"
			_tmp11_ = _tmp7_;
#line 148 "../lib/Factories/ItemFactory.vala"
			_tmp7_ = NULL;
#line 148 "../lib/Factories/ItemFactory.vala"
			result = _tmp11_;
#line 148 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp7_);
#line 148 "../lib/Factories/ItemFactory.vala"
			_g_key_file_unref0 (keyfile);
#line 148 "../lib/Factories/ItemFactory.vala"
			return result;
#line 345 "ItemFactory.c"
		}
#line 151 "../lib/Factories/ItemFactory.vala"
		_tmp12_ = keyfile;
#line 151 "../lib/Factories/ItemFactory.vala"
		if (g_key_file_has_group (_tmp12_, "PlankItemsDockItemPreferences")) {
#line 351 "ItemFactory.c"
			gchar* _tmp13_ = NULL;
			GKeyFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 152 "../lib/Factories/ItemFactory.vala"
			_tmp14_ = keyfile;
#line 152 "../lib/Factories/ItemFactory.vala"
			_tmp15_ = g_key_file_get_string (_tmp14_, "PlankItemsDockItemPreferences", "Launcher", &_inner_error0_);
#line 152 "../lib/Factories/ItemFactory.vala"
			_tmp13_ = _tmp15_;
#line 152 "../lib/Factories/ItemFactory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "../lib/Factories/ItemFactory.vala"
				_g_key_file_unref0 (keyfile);
#line 366 "ItemFactory.c"
				goto __catch0_g_error;
			}
#line 152 "../lib/Factories/ItemFactory.vala"
			_tmp16_ = _tmp13_;
#line 152 "../lib/Factories/ItemFactory.vala"
			_tmp13_ = NULL;
#line 152 "../lib/Factories/ItemFactory.vala"
			result = _tmp16_;
#line 152 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp13_);
#line 152 "../lib/Factories/ItemFactory.vala"
			_g_key_file_unref0 (keyfile);
#line 152 "../lib/Factories/ItemFactory.vala"
			return result;
#line 381 "ItemFactory.c"
		}
#line 142 "../lib/Factories/ItemFactory.vala"
		_g_key_file_unref0 (keyfile);
#line 385 "ItemFactory.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 142 "../lib/Factories/ItemFactory.vala"
		e = _inner_error0_;
#line 142 "../lib/Factories/ItemFactory.vala"
		_inner_error0_ = NULL;
#line 154 "../lib/Factories/ItemFactory.vala"
		_tmp17_ = e;
#line 154 "../lib/Factories/ItemFactory.vala"
		_tmp18_ = _tmp17_->message;
#line 154 "../lib/Factories/ItemFactory.vala"
		_tmp19_ = g_file_get_basename (file);
#line 154 "../lib/Factories/ItemFactory.vala"
		_tmp20_ = _tmp19_;
#line 154 "../lib/Factories/ItemFactory.vala"
		g_warning ("ItemFactory.vala:154: %s (%s)", _tmp18_, _tmp20_);
#line 154 "../lib/Factories/ItemFactory.vala"
		_g_free0 (_tmp20_);
#line 142 "../lib/Factories/ItemFactory.vala"
		_g_error_free0 (e);
#line 413 "ItemFactory.c"
	}
	__finally0:
#line 142 "../lib/Factories/ItemFactory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../lib/Factories/ItemFactory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../lib/Factories/ItemFactory.vala"
		g_clear_error (&_inner_error0_);
#line 142 "../lib/Factories/ItemFactory.vala"
		return NULL;
#line 424 "ItemFactory.c"
	}
#line 157 "../lib/Factories/ItemFactory.vala"
	_tmp21_ = g_strdup ("");
#line 157 "../lib/Factories/ItemFactory.vala"
	result = _tmp21_;
#line 157 "../lib/Factories/ItemFactory.vala"
	return result;
#line 432 "ItemFactory.c"
}

/**
 * Creates a list of Dockitems based on .dockitem files found in the given source_dir.
 *
 * @param source_dir the folder where to load .dockitem from
 * @param ordering a ";;"-separated string to be used to order the loaded DockItems
 * @return the new List of DockItems
 */
GeeArrayList*
plank_item_factory_load_elements (PlankItemFactory* self,
                                  GFile* source_dir,
                                  gchar** ordering,
                                  gint ordering_length1)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GeeHashMap* elements = NULL;
	GeeHashMap* _tmp5_;
	guint count = 0U;
	GeeArrayList* _tmp79_;
	GeeHashMap* _tmp80_;
	GeeCollection* _tmp81_;
	GeeCollection* _tmp82_;
	GeeCollection* _tmp83_;
	GeeHashMap* _tmp84_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 167 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (source_dir != NULL, NULL);
#line 169 "../lib/Factories/ItemFactory.vala"
	_tmp0_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 169 "../lib/Factories/ItemFactory.vala"
	_result_ = _tmp0_;
#line 171 "../lib/Factories/ItemFactory.vala"
	if (!g_file_query_exists (source_dir, NULL)) {
#line 473 "ItemFactory.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 172 "../lib/Factories/ItemFactory.vala"
		_tmp1_ = g_file_get_path (source_dir);
#line 172 "../lib/Factories/ItemFactory.vala"
		_tmp2_ = _tmp1_;
#line 172 "../lib/Factories/ItemFactory.vala"
		g_critical ("ItemFactory.vala:172: Given folder '%s' does not exist.", _tmp2_);
#line 172 "../lib/Factories/ItemFactory.vala"
		_g_free0 (_tmp2_);
#line 173 "../lib/Factories/ItemFactory.vala"
		result = _result_;
#line 173 "../lib/Factories/ItemFactory.vala"
		return result;
#line 488 "ItemFactory.c"
	}
#line 176 "../lib/Factories/ItemFactory.vala"
	_tmp3_ = g_file_get_path (source_dir);
#line 176 "../lib/Factories/ItemFactory.vala"
	_tmp4_ = _tmp3_;
#line 176 "../lib/Factories/ItemFactory.vala"
	g_debug ("ItemFactory.vala:176: Loading dock elements from '%s'", _tmp4_);
#line 176 "../lib/Factories/ItemFactory.vala"
	_g_free0 (_tmp4_);
#line 178 "../lib/Factories/ItemFactory.vala"
	_tmp5_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 178 "../lib/Factories/ItemFactory.vala"
	elements = _tmp5_;
#line 179 "../lib/Factories/ItemFactory.vala"
	count = 0U;
#line 504 "ItemFactory.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp6_;
		GFileInfo* info = NULL;
#line 182 "../lib/Factories/ItemFactory.vala"
		_tmp6_ = g_file_enumerate_children (source_dir, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN, 0, NULL, &_inner_error0_);
#line 182 "../lib/Factories/ItemFactory.vala"
		enumerator = _tmp6_;
#line 182 "../lib/Factories/ItemFactory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 515 "ItemFactory.c"
			goto __catch0_g_error;
		}
#line 184 "../lib/Factories/ItemFactory.vala"
		while (TRUE) {
#line 520 "ItemFactory.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* filename = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_ = FALSE;
			GFileInfo* _tmp16_;
			guint _tmp18_;
			GFile* file = NULL;
			const gchar* _tmp21_;
			GFile* _tmp22_;
			PlankDockElement* element = NULL;
			GFile* _tmp23_;
			PlankDockElement* _tmp24_;
			PlankDockItemProvider* provider = NULL;
			PlankDockElement* _tmp25_;
			PlankDockItemProvider* _tmp26_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp30_;
			PlankDockItem* _tmp31_;
			PlankDockItem* dupe = NULL;
			GeeArrayList* _tmp32_;
			PlankDockItem* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			PlankDockItem* _tmp36_;
			PlankDockItem* _tmp37_;
#line 184 "../lib/Factories/ItemFactory.vala"
			_tmp8_ = enumerator;
#line 184 "../lib/Factories/ItemFactory.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 184 "../lib/Factories/ItemFactory.vala"
			_tmp7_ = _tmp9_;
#line 184 "../lib/Factories/ItemFactory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (info);
#line 184 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (enumerator);
#line 564 "ItemFactory.c"
				goto __catch0_g_error;
			}
#line 184 "../lib/Factories/ItemFactory.vala"
			_tmp10_ = _tmp7_;
#line 184 "../lib/Factories/ItemFactory.vala"
			_tmp7_ = NULL;
#line 184 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (info);
#line 184 "../lib/Factories/ItemFactory.vala"
			info = _tmp10_;
#line 184 "../lib/Factories/ItemFactory.vala"
			_tmp11_ = info;
#line 184 "../lib/Factories/ItemFactory.vala"
			if (!(_tmp11_ != NULL)) {
#line 184 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp7_);
#line 184 "../lib/Factories/ItemFactory.vala"
				break;
#line 583 "ItemFactory.c"
			}
#line 185 "../lib/Factories/ItemFactory.vala"
			_tmp12_ = info;
#line 185 "../lib/Factories/ItemFactory.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 185 "../lib/Factories/ItemFactory.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 185 "../lib/Factories/ItemFactory.vala"
			filename = _tmp14_;
#line 186 "../lib/Factories/ItemFactory.vala"
			_tmp16_ = info;
#line 186 "../lib/Factories/ItemFactory.vala"
			if (g_file_info_get_is_hidden (_tmp16_)) {
#line 186 "../lib/Factories/ItemFactory.vala"
				_tmp15_ = TRUE;
#line 599 "ItemFactory.c"
			} else {
				const gchar* _tmp17_;
#line 186 "../lib/Factories/ItemFactory.vala"
				_tmp17_ = filename;
#line 186 "../lib/Factories/ItemFactory.vala"
				_tmp15_ = !g_str_has_suffix (_tmp17_, ".dockitem");
#line 606 "ItemFactory.c"
			}
#line 186 "../lib/Factories/ItemFactory.vala"
			if (_tmp15_) {
#line 187 "../lib/Factories/ItemFactory.vala"
				_g_free0 (filename);
#line 187 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp7_);
#line 187 "../lib/Factories/ItemFactory.vala"
				continue;
#line 616 "ItemFactory.c"
			}
#line 189 "../lib/Factories/ItemFactory.vala"
			_tmp18_ = count;
#line 189 "../lib/Factories/ItemFactory.vala"
			count = _tmp18_ + 1;
#line 189 "../lib/Factories/ItemFactory.vala"
			if (_tmp18_ >= PLANK_LAUNCHER_DIR_MAX_FILE_COUNT) {
#line 624 "ItemFactory.c"
				gchar* _tmp19_;
				gchar* _tmp20_;
#line 190 "../lib/Factories/ItemFactory.vala"
				_tmp19_ = g_file_get_path (source_dir);
#line 190 "../lib/Factories/ItemFactory.vala"
				_tmp20_ = _tmp19_;
#line 190 "../lib/Factories/ItemFactory.vala"
				g_critical ("ItemFactory.vala:190: There are way too many files (%u+) in '%s'.", PLANK_LAUNCHER_DIR_MAX_FILE_COUNT, _tmp20_);
#line 190 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp20_);
#line 191 "../lib/Factories/ItemFactory.vala"
				_g_free0 (filename);
#line 191 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp7_);
#line 191 "../lib/Factories/ItemFactory.vala"
				break;
#line 641 "ItemFactory.c"
			}
#line 194 "../lib/Factories/ItemFactory.vala"
			_tmp21_ = filename;
#line 194 "../lib/Factories/ItemFactory.vala"
			_tmp22_ = g_file_get_child (source_dir, _tmp21_);
#line 194 "../lib/Factories/ItemFactory.vala"
			file = _tmp22_;
#line 195 "../lib/Factories/ItemFactory.vala"
			_tmp23_ = file;
#line 195 "../lib/Factories/ItemFactory.vala"
			_tmp24_ = plank_item_factory_make_element (self, _tmp23_);
#line 195 "../lib/Factories/ItemFactory.vala"
			element = _tmp24_;
#line 197 "../lib/Factories/ItemFactory.vala"
			_tmp25_ = element;
#line 197 "../lib/Factories/ItemFactory.vala"
			provider = PLANK_IS_DOCK_ITEM_PROVIDER (_tmp25_) ? ((PlankDockItemProvider*) _tmp25_) : NULL;
#line 198 "../lib/Factories/ItemFactory.vala"
			_tmp26_ = provider;
#line 198 "../lib/Factories/ItemFactory.vala"
			if (_tmp26_ != NULL) {
#line 663 "ItemFactory.c"
				GeeHashMap* _tmp27_;
				const gchar* _tmp28_;
				PlankDockElement* _tmp29_;
#line 199 "../lib/Factories/ItemFactory.vala"
				_tmp27_ = elements;
#line 199 "../lib/Factories/ItemFactory.vala"
				_tmp28_ = filename;
#line 199 "../lib/Factories/ItemFactory.vala"
				_tmp29_ = element;
#line 199 "../lib/Factories/ItemFactory.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp27_, _tmp28_, _tmp29_);
#line 200 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (element);
#line 200 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (file);
#line 200 "../lib/Factories/ItemFactory.vala"
				_g_free0 (filename);
#line 200 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp7_);
#line 200 "../lib/Factories/ItemFactory.vala"
				continue;
#line 685 "ItemFactory.c"
			}
#line 203 "../lib/Factories/ItemFactory.vala"
			_tmp30_ = element;
#line 203 "../lib/Factories/ItemFactory.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp30_) ? ((PlankDockItem*) _tmp30_) : NULL;
#line 204 "../lib/Factories/ItemFactory.vala"
			_tmp31_ = item;
#line 204 "../lib/Factories/ItemFactory.vala"
			if (_tmp31_ == NULL) {
#line 205 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (element);
#line 205 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (file);
#line 205 "../lib/Factories/ItemFactory.vala"
				_g_free0 (filename);
#line 205 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp7_);
#line 205 "../lib/Factories/ItemFactory.vala"
				continue;
#line 705 "ItemFactory.c"
			}
#line 208 "../lib/Factories/ItemFactory.vala"
			_tmp32_ = _result_;
#line 208 "../lib/Factories/ItemFactory.vala"
			_tmp33_ = item;
#line 208 "../lib/Factories/ItemFactory.vala"
			_tmp34_ = plank_dock_item_get_Launcher (_tmp33_);
#line 208 "../lib/Factories/ItemFactory.vala"
			_tmp35_ = _tmp34_;
#line 208 "../lib/Factories/ItemFactory.vala"
			_tmp36_ = plank_item_factory_find_item_for_uri (self, _tmp32_, _tmp35_);
#line 208 "../lib/Factories/ItemFactory.vala"
			dupe = _tmp36_;
#line 208 "../lib/Factories/ItemFactory.vala"
			_tmp37_ = dupe;
#line 208 "../lib/Factories/ItemFactory.vala"
			if (_tmp37_ != NULL) {
#line 723 "ItemFactory.c"
				PlankDockItem* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				GFile* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				PlankDockItem* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				PlankDockItem* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				PlankDockItem* _tmp52_;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp38_ = item;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp39_ = plank_dock_item_get_Launcher (_tmp38_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp40_ = _tmp39_;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp41_ = file;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp42_ = g_file_get_path (_tmp41_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp43_ = _tmp42_;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp44_ = dupe;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp45_ = plank_dock_item_get_DockItemFilename (_tmp44_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp46_ = _tmp45_;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp47_ = _tmp46_;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp48_ = item;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp49_ = plank_dock_item_get_DockItemFilename (_tmp48_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp50_ = _tmp49_;
#line 209 "../lib/Factories/ItemFactory.vala"
				_tmp51_ = _tmp50_;
#line 209 "../lib/Factories/ItemFactory.vala"
				g_warning ("ItemFactory.vala:209: The launcher '%s' in dock item '%s' is already m" \
"anaged by dock item '%s'. Removing '%s'.", _tmp40_, _tmp43_, _tmp47_, _tmp51_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp51_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp47_);
#line 209 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp43_);
#line 211 "../lib/Factories/ItemFactory.vala"
				_tmp52_ = item;
#line 211 "../lib/Factories/ItemFactory.vala"
				plank_dock_item_delete (_tmp52_);
#line 779 "ItemFactory.c"
			} else {
				PlankDockItem* _tmp53_;
#line 212 "../lib/Factories/ItemFactory.vala"
				_tmp53_ = item;
#line 212 "../lib/Factories/ItemFactory.vala"
				if (!plank_dock_item_is_valid (_tmp53_)) {
#line 786 "ItemFactory.c"
					PlankDockItem* _tmp54_;
					const gchar* _tmp55_;
					const gchar* _tmp56_;
					GFile* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
					PlankDockItem* _tmp60_;
					gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
					PlankDockItem* _tmp64_;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp54_ = item;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp55_ = plank_dock_item_get_Launcher (_tmp54_);
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp56_ = _tmp55_;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp57_ = file;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp58_ = g_file_get_path (_tmp57_);
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp59_ = _tmp58_;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp60_ = item;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp61_ = plank_dock_item_get_DockItemFilename (_tmp60_);
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp62_ = _tmp61_;
#line 213 "../lib/Factories/ItemFactory.vala"
					_tmp63_ = _tmp62_;
#line 213 "../lib/Factories/ItemFactory.vala"
					g_warning ("ItemFactory.vala:213: The launcher '%s' in dock item '%s' does not exi" \
"st. Removing '%s'.", _tmp56_, _tmp59_, _tmp63_);
#line 213 "../lib/Factories/ItemFactory.vala"
					_g_free0 (_tmp63_);
#line 213 "../lib/Factories/ItemFactory.vala"
					_g_free0 (_tmp59_);
#line 214 "../lib/Factories/ItemFactory.vala"
					_tmp64_ = item;
#line 214 "../lib/Factories/ItemFactory.vala"
					plank_dock_item_delete (_tmp64_);
#line 828 "ItemFactory.c"
				} else {
					GeeHashMap* _tmp65_;
					const gchar* _tmp66_;
					PlankDockElement* _tmp67_;
#line 216 "../lib/Factories/ItemFactory.vala"
					_tmp65_ = elements;
#line 216 "../lib/Factories/ItemFactory.vala"
					_tmp66_ = filename;
#line 216 "../lib/Factories/ItemFactory.vala"
					_tmp67_ = element;
#line 216 "../lib/Factories/ItemFactory.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp65_, _tmp66_, _tmp67_);
#line 841 "ItemFactory.c"
				}
			}
#line 184 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (element);
#line 184 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (file);
#line 184 "../lib/Factories/ItemFactory.vala"
			_g_free0 (filename);
#line 184 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (_tmp7_);
#line 852 "ItemFactory.c"
		}
#line 181 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (info);
#line 181 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (enumerator);
#line 858 "ItemFactory.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp68_ = NULL;
		gchar* _tmp69_;
		GError* _tmp71_;
		const gchar* _tmp72_;
#line 181 "../lib/Factories/ItemFactory.vala"
		e = _inner_error0_;
#line 181 "../lib/Factories/ItemFactory.vala"
		_inner_error0_ = NULL;
#line 220 "../lib/Factories/ItemFactory.vala"
		_tmp69_ = g_file_get_path (source_dir);
#line 220 "../lib/Factories/ItemFactory.vala"
		_tmp68_ = _tmp69_;
#line 220 "../lib/Factories/ItemFactory.vala"
		if (_tmp68_ == NULL) {
#line 878 "ItemFactory.c"
			gchar* _tmp70_;
#line 220 "../lib/Factories/ItemFactory.vala"
			_tmp70_ = g_strdup ("");
#line 220 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp68_);
#line 220 "../lib/Factories/ItemFactory.vala"
			_tmp68_ = _tmp70_;
#line 886 "ItemFactory.c"
		}
#line 220 "../lib/Factories/ItemFactory.vala"
		_tmp71_ = e;
#line 220 "../lib/Factories/ItemFactory.vala"
		_tmp72_ = _tmp71_->message;
#line 220 "../lib/Factories/ItemFactory.vala"
		g_critical ("ItemFactory.vala:220: Error loading dock elements from '%s'. (%s)", _tmp68_, _tmp72_);
#line 181 "../lib/Factories/ItemFactory.vala"
		_g_free0 (_tmp68_);
#line 181 "../lib/Factories/ItemFactory.vala"
		_g_error_free0 (e);
#line 898 "ItemFactory.c"
	}
	__finally0:
#line 181 "../lib/Factories/ItemFactory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (elements);
#line 181 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (_result_);
#line 181 "../lib/Factories/ItemFactory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../lib/Factories/ItemFactory.vala"
		g_clear_error (&_inner_error0_);
#line 181 "../lib/Factories/ItemFactory.vala"
		return NULL;
#line 913 "ItemFactory.c"
	}
#line 223 "../lib/Factories/ItemFactory.vala"
	if (ordering != NULL) {
#line 917 "ItemFactory.c"
		{
			gchar** dockitem_collection = NULL;
			gint dockitem_collection_length1 = 0;
			gint _dockitem_collection_size_ = 0;
			gint dockitem_it = 0;
#line 224 "../lib/Factories/ItemFactory.vala"
			dockitem_collection = ordering;
#line 224 "../lib/Factories/ItemFactory.vala"
			dockitem_collection_length1 = ordering_length1;
#line 224 "../lib/Factories/ItemFactory.vala"
			for (dockitem_it = 0; dockitem_it < dockitem_collection_length1; dockitem_it = dockitem_it + 1) {
#line 929 "ItemFactory.c"
				const gchar* dockitem = NULL;
#line 224 "../lib/Factories/ItemFactory.vala"
				dockitem = dockitem_collection[dockitem_it];
#line 933 "ItemFactory.c"
				{
					PlankDockElement* element = NULL;
					GeeHashMap* _tmp73_;
					const gchar* _tmp74_;
					gpointer _tmp75_ = NULL;
					PlankDockElement* _tmp76_;
#line 226 "../lib/Factories/ItemFactory.vala"
					_tmp73_ = elements;
#line 226 "../lib/Factories/ItemFactory.vala"
					_tmp74_ = dockitem;
#line 226 "../lib/Factories/ItemFactory.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp73_, _tmp74_, &_tmp75_);
#line 226 "../lib/Factories/ItemFactory.vala"
					_g_object_unref0 (element);
#line 226 "../lib/Factories/ItemFactory.vala"
					element = (PlankDockElement*) _tmp75_;
#line 227 "../lib/Factories/ItemFactory.vala"
					_tmp76_ = element;
#line 227 "../lib/Factories/ItemFactory.vala"
					if (_tmp76_ != NULL) {
#line 954 "ItemFactory.c"
						GeeArrayList* _tmp77_;
						PlankDockElement* _tmp78_;
#line 228 "../lib/Factories/ItemFactory.vala"
						_tmp77_ = _result_;
#line 228 "../lib/Factories/ItemFactory.vala"
						_tmp78_ = element;
#line 228 "../lib/Factories/ItemFactory.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp77_, _tmp78_);
#line 963 "ItemFactory.c"
					}
#line 224 "../lib/Factories/ItemFactory.vala"
					_g_object_unref0 (element);
#line 967 "ItemFactory.c"
				}
			}
		}
	}
#line 231 "../lib/Factories/ItemFactory.vala"
	_tmp79_ = _result_;
#line 231 "../lib/Factories/ItemFactory.vala"
	_tmp80_ = elements;
#line 231 "../lib/Factories/ItemFactory.vala"
	_tmp81_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp80_);
#line 231 "../lib/Factories/ItemFactory.vala"
	_tmp82_ = _tmp81_;
#line 231 "../lib/Factories/ItemFactory.vala"
	_tmp83_ = _tmp82_;
#line 231 "../lib/Factories/ItemFactory.vala"
	gee_array_list_add_all (_tmp79_, _tmp83_);
#line 231 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (_tmp83_);
#line 232 "../lib/Factories/ItemFactory.vala"
	_tmp84_ = elements;
#line 232 "../lib/Factories/ItemFactory.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp84_);
#line 234 "../lib/Factories/ItemFactory.vala"
	result = _result_;
#line 234 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (elements);
#line 234 "../lib/Factories/ItemFactory.vala"
	return result;
#line 996 "ItemFactory.c"
}

static PlankDockItem*
plank_item_factory_find_item_for_uri (PlankItemFactory* self,
                                      GeeArrayList* elements,
                                      const gchar* uri)
{
	PlankDockItem* result;
#line 237 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 237 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (elements != NULL, NULL);
#line 237 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 1011 "ItemFactory.c"
	{
		GeeArrayList* _element_list = NULL;
		gint _element_size = 0;
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _element_index = 0;
#line 239 "../lib/Factories/ItemFactory.vala"
		_element_list = elements;
#line 239 "../lib/Factories/ItemFactory.vala"
		_tmp0_ = _element_list;
#line 239 "../lib/Factories/ItemFactory.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 239 "../lib/Factories/ItemFactory.vala"
		_tmp2_ = _tmp1_;
#line 239 "../lib/Factories/ItemFactory.vala"
		_element_size = _tmp2_;
#line 239 "../lib/Factories/ItemFactory.vala"
		_element_index = -1;
#line 239 "../lib/Factories/ItemFactory.vala"
		while (TRUE) {
#line 1033 "ItemFactory.c"
			gint _tmp3_;
			gint _tmp4_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp7_;
			gboolean _tmp8_ = FALSE;
			PlankDockItem* _tmp9_;
#line 239 "../lib/Factories/ItemFactory.vala"
			_element_index = _element_index + 1;
#line 239 "../lib/Factories/ItemFactory.vala"
			_tmp3_ = _element_index;
#line 239 "../lib/Factories/ItemFactory.vala"
			_tmp4_ = _element_size;
#line 239 "../lib/Factories/ItemFactory.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 239 "../lib/Factories/ItemFactory.vala"
				break;
#line 1053 "ItemFactory.c"
			}
#line 239 "../lib/Factories/ItemFactory.vala"
			_tmp5_ = _element_list;
#line 239 "../lib/Factories/ItemFactory.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _element_index);
#line 239 "../lib/Factories/ItemFactory.vala"
			element = (PlankDockElement*) _tmp6_;
#line 240 "../lib/Factories/ItemFactory.vala"
			_tmp7_ = element;
#line 240 "../lib/Factories/ItemFactory.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp7_) ? ((PlankDockItem*) _tmp7_) : NULL;
#line 241 "../lib/Factories/ItemFactory.vala"
			_tmp9_ = item;
#line 241 "../lib/Factories/ItemFactory.vala"
			if (_tmp9_ != NULL) {
#line 1069 "ItemFactory.c"
				PlankDockItem* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 241 "../lib/Factories/ItemFactory.vala"
				_tmp10_ = item;
#line 241 "../lib/Factories/ItemFactory.vala"
				_tmp11_ = plank_dock_item_get_Launcher (_tmp10_);
#line 241 "../lib/Factories/ItemFactory.vala"
				_tmp12_ = _tmp11_;
#line 241 "../lib/Factories/ItemFactory.vala"
				_tmp8_ = g_strcmp0 (_tmp12_, uri) == 0;
#line 1081 "ItemFactory.c"
			} else {
#line 241 "../lib/Factories/ItemFactory.vala"
				_tmp8_ = FALSE;
#line 1085 "ItemFactory.c"
			}
#line 241 "../lib/Factories/ItemFactory.vala"
			if (_tmp8_) {
#line 1089 "ItemFactory.c"
				PlankDockItem* _tmp13_;
#line 242 "../lib/Factories/ItemFactory.vala"
				_tmp13_ = item;
#line 242 "../lib/Factories/ItemFactory.vala"
				result = _tmp13_;
#line 242 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (element);
#line 242 "../lib/Factories/ItemFactory.vala"
				return result;
#line 1099 "ItemFactory.c"
			}
#line 239 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (element);
#line 1103 "ItemFactory.c"
		}
	}
#line 245 "../lib/Factories/ItemFactory.vala"
	result = NULL;
#line 245 "../lib/Factories/ItemFactory.vala"
	return result;
#line 1110 "ItemFactory.c"
}

static void
plank_item_factory_make_dock_item_for_desktop_id (PlankItemFactory* self,
                                                  const gchar* id)
{
	GDesktopAppInfo* app_info = NULL;
	GDesktopAppInfo* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	const gchar* filename = NULL;
	GDesktopAppInfo* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 248 "../lib/Factories/ItemFactory.vala"
	g_return_if_fail (self != NULL);
#line 248 "../lib/Factories/ItemFactory.vala"
	g_return_if_fail (id != NULL);
#line 250 "../lib/Factories/ItemFactory.vala"
	_tmp0_ = g_desktop_app_info_new (id);
#line 250 "../lib/Factories/ItemFactory.vala"
	app_info = _tmp0_;
#line 251 "../lib/Factories/ItemFactory.vala"
	_tmp1_ = app_info;
#line 251 "../lib/Factories/ItemFactory.vala"
	if (_tmp1_ == NULL) {
#line 252 "../lib/Factories/ItemFactory.vala"
		g_warning ("ItemFactory.vala:252: Failed to create dock item for '%s'", id);
#line 253 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (app_info);
#line 253 "../lib/Factories/ItemFactory.vala"
		return;
#line 1143 "ItemFactory.c"
	}
#line 256 "../lib/Factories/ItemFactory.vala"
	_tmp2_ = app_info;
#line 256 "../lib/Factories/ItemFactory.vala"
	_tmp3_ = g_desktop_app_info_get_filename (_tmp2_);
#line 256 "../lib/Factories/ItemFactory.vala"
	filename = _tmp3_;
#line 257 "../lib/Factories/ItemFactory.vala"
	_tmp4_ = filename;
#line 257 "../lib/Factories/ItemFactory.vala"
	if (_tmp4_ == NULL) {
#line 258 "../lib/Factories/ItemFactory.vala"
		g_warning ("ItemFactory.vala:258: Failed to create dock item for '%s'", id);
#line 259 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (app_info);
#line 259 "../lib/Factories/ItemFactory.vala"
		return;
#line 1161 "ItemFactory.c"
	}
	{
		gchar* uri = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		gboolean _tmp10_;
#line 263 "../lib/Factories/ItemFactory.vala"
		_tmp5_ = filename;
#line 263 "../lib/Factories/ItemFactory.vala"
		_tmp6_ = g_filename_to_uri (_tmp5_, NULL, &_inner_error0_);
#line 263 "../lib/Factories/ItemFactory.vala"
		uri = _tmp6_;
#line 263 "../lib/Factories/ItemFactory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../lib/Factories/ItemFactory.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 1181 "ItemFactory.c"
				goto __catch0_g_convert_error;
			}
#line 263 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (app_info);
#line 263 "../lib/Factories/ItemFactory.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 263 "../lib/Factories/ItemFactory.vala"
			g_clear_error (&_inner_error0_);
#line 263 "../lib/Factories/ItemFactory.vala"
			return;
#line 1192 "ItemFactory.c"
		}
#line 264 "../lib/Factories/ItemFactory.vala"
		_tmp7_ = uri;
#line 264 "../lib/Factories/ItemFactory.vala"
		_tmp8_ = plank_item_factory_make_dock_item (self, _tmp7_, NULL);
#line 264 "../lib/Factories/ItemFactory.vala"
		_tmp9_ = _tmp8_;
#line 264 "../lib/Factories/ItemFactory.vala"
		_tmp10_ = _tmp9_ == NULL;
#line 264 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (_tmp9_);
#line 264 "../lib/Factories/ItemFactory.vala"
		if (_tmp10_) {
#line 1206 "ItemFactory.c"
			const gchar* _tmp11_;
#line 265 "../lib/Factories/ItemFactory.vala"
			_tmp11_ = uri;
#line 265 "../lib/Factories/ItemFactory.vala"
			g_warning ("ItemFactory.vala:265: Failed to create dock item for '%s' ('%s')", id, _tmp11_);
#line 1212 "ItemFactory.c"
		}
#line 262 "../lib/Factories/ItemFactory.vala"
		_g_free0 (uri);
#line 1216 "ItemFactory.c"
	}
	goto __finally0;
	__catch0_g_convert_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 262 "../lib/Factories/ItemFactory.vala"
		e = _inner_error0_;
#line 262 "../lib/Factories/ItemFactory.vala"
		_inner_error0_ = NULL;
#line 267 "../lib/Factories/ItemFactory.vala"
		g_warning ("ItemFactory.vala:267: Failed to create dock item for '%s'", id);
#line 268 "../lib/Factories/ItemFactory.vala"
		_tmp12_ = e;
#line 268 "../lib/Factories/ItemFactory.vala"
		_tmp13_ = _tmp12_->message;
#line 268 "../lib/Factories/ItemFactory.vala"
		g_warning ("ItemFactory.vala:268: %s", _tmp13_);
#line 262 "../lib/Factories/ItemFactory.vala"
		_g_error_free0 (e);
#line 1238 "ItemFactory.c"
	}
	__finally0:
#line 262 "../lib/Factories/ItemFactory.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (app_info);
#line 262 "../lib/Factories/ItemFactory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 262 "../lib/Factories/ItemFactory.vala"
		g_clear_error (&_inner_error0_);
#line 262 "../lib/Factories/ItemFactory.vala"
		return;
#line 1251 "ItemFactory.c"
	}
#line 248 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (app_info);
#line 1255 "ItemFactory.c"
}

static gboolean
plank_item_factory_make_default_gnome_items (PlankItemFactory* self)
{
	GAppInfo* browser = NULL;
	GAppInfo* _tmp0_;
	GAppInfo* mail = NULL;
	GAppInfo* _tmp1_;
	GAppInfo* terminal = NULL;
	GAppInfo* _tmp2_;
	GAppInfo* calendar = NULL;
	GAppInfo* _tmp3_;
	GAppInfo* audio = NULL;
	GAppInfo* _tmp4_;
	GAppInfo* video = NULL;
	GAppInfo* _tmp5_;
	GAppInfo* photo = NULL;
	GAppInfo* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GAppInfo* _tmp13_;
	GAppInfo* _tmp20_;
	GAppInfo* _tmp23_;
	GAppInfo* _tmp26_;
	GAppInfo* _tmp29_;
	GAppInfo* _tmp32_;
	GAppInfo* _tmp35_;
	GAppInfo* _tmp38_;
	gboolean result;
#line 272 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "../lib/Factories/ItemFactory.vala"
	_tmp0_ = g_app_info_get_default_for_type ("x-scheme-handler/http", FALSE);
#line 274 "../lib/Factories/ItemFactory.vala"
	browser = _tmp0_;
#line 275 "../lib/Factories/ItemFactory.vala"
	_tmp1_ = g_app_info_get_default_for_type ("x-scheme-handler/mailto", FALSE);
#line 275 "../lib/Factories/ItemFactory.vala"
	mail = _tmp1_;
#line 277 "../lib/Factories/ItemFactory.vala"
	_tmp2_ = g_app_info_get_default_for_uri_scheme ("ssh");
#line 277 "../lib/Factories/ItemFactory.vala"
	terminal = _tmp2_;
#line 278 "../lib/Factories/ItemFactory.vala"
	_tmp3_ = g_app_info_get_default_for_type ("text/calendar", FALSE);
#line 278 "../lib/Factories/ItemFactory.vala"
	calendar = _tmp3_;
#line 279 "../lib/Factories/ItemFactory.vala"
	_tmp4_ = g_app_info_get_default_for_type ("audio/x-vorbis+ogg", FALSE);
#line 279 "../lib/Factories/ItemFactory.vala"
	audio = _tmp4_;
#line 280 "../lib/Factories/ItemFactory.vala"
	_tmp5_ = g_app_info_get_default_for_type ("video/x-ogm+ogg", FALSE);
#line 280 "../lib/Factories/ItemFactory.vala"
	video = _tmp5_;
#line 281 "../lib/Factories/ItemFactory.vala"
	_tmp6_ = g_app_info_get_default_for_type ("image/jpeg", FALSE);
#line 281 "../lib/Factories/ItemFactory.vala"
	photo = _tmp6_;
#line 283 "../lib/Factories/ItemFactory.vala"
	_tmp13_ = browser;
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp13_ == NULL) {
#line 1324 "ItemFactory.c"
		GAppInfo* _tmp14_;
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp14_ = mail;
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp12_ = _tmp14_ == NULL;
#line 1330 "ItemFactory.c"
	} else {
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp12_ = FALSE;
#line 1334 "ItemFactory.c"
	}
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp12_) {
#line 1338 "ItemFactory.c"
		GAppInfo* _tmp15_;
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp15_ = calendar;
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp11_ = _tmp15_ == NULL;
#line 1344 "ItemFactory.c"
	} else {
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp11_ = FALSE;
#line 1348 "ItemFactory.c"
	}
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp11_) {
#line 1352 "ItemFactory.c"
		GAppInfo* _tmp16_;
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp16_ = terminal;
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp10_ = _tmp16_ == NULL;
#line 1358 "ItemFactory.c"
	} else {
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp10_ = FALSE;
#line 1362 "ItemFactory.c"
	}
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp10_) {
#line 1366 "ItemFactory.c"
		GAppInfo* _tmp17_;
#line 284 "../lib/Factories/ItemFactory.vala"
		_tmp17_ = audio;
#line 284 "../lib/Factories/ItemFactory.vala"
		_tmp9_ = _tmp17_ == NULL;
#line 1372 "ItemFactory.c"
	} else {
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp9_ = FALSE;
#line 1376 "ItemFactory.c"
	}
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp9_) {
#line 1380 "ItemFactory.c"
		GAppInfo* _tmp18_;
#line 284 "../lib/Factories/ItemFactory.vala"
		_tmp18_ = video;
#line 284 "../lib/Factories/ItemFactory.vala"
		_tmp8_ = _tmp18_ == NULL;
#line 1386 "ItemFactory.c"
	} else {
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp8_ = FALSE;
#line 1390 "ItemFactory.c"
	}
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp8_) {
#line 1394 "ItemFactory.c"
		GAppInfo* _tmp19_;
#line 284 "../lib/Factories/ItemFactory.vala"
		_tmp19_ = photo;
#line 284 "../lib/Factories/ItemFactory.vala"
		_tmp7_ = _tmp19_ == NULL;
#line 1400 "ItemFactory.c"
	} else {
#line 283 "../lib/Factories/ItemFactory.vala"
		_tmp7_ = FALSE;
#line 1404 "ItemFactory.c"
	}
#line 283 "../lib/Factories/ItemFactory.vala"
	if (_tmp7_) {
#line 285 "../lib/Factories/ItemFactory.vala"
		result = FALSE;
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (photo);
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (video);
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (audio);
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (calendar);
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (terminal);
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (mail);
#line 285 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (browser);
#line 285 "../lib/Factories/ItemFactory.vala"
		return result;
#line 1426 "ItemFactory.c"
	}
#line 287 "../lib/Factories/ItemFactory.vala"
	_tmp20_ = browser;
#line 287 "../lib/Factories/ItemFactory.vala"
	if (_tmp20_ != NULL) {
#line 1432 "ItemFactory.c"
		GAppInfo* _tmp21_;
		const gchar* _tmp22_;
#line 288 "../lib/Factories/ItemFactory.vala"
		_tmp21_ = browser;
#line 288 "../lib/Factories/ItemFactory.vala"
		_tmp22_ = g_app_info_get_id (_tmp21_);
#line 288 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp22_);
#line 1441 "ItemFactory.c"
	}
#line 289 "../lib/Factories/ItemFactory.vala"
	_tmp23_ = mail;
#line 289 "../lib/Factories/ItemFactory.vala"
	if (_tmp23_ != NULL) {
#line 1447 "ItemFactory.c"
		GAppInfo* _tmp24_;
		const gchar* _tmp25_;
#line 290 "../lib/Factories/ItemFactory.vala"
		_tmp24_ = mail;
#line 290 "../lib/Factories/ItemFactory.vala"
		_tmp25_ = g_app_info_get_id (_tmp24_);
#line 290 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp25_);
#line 1456 "ItemFactory.c"
	}
#line 291 "../lib/Factories/ItemFactory.vala"
	_tmp26_ = terminal;
#line 291 "../lib/Factories/ItemFactory.vala"
	if (_tmp26_ != NULL) {
#line 1462 "ItemFactory.c"
		GAppInfo* _tmp27_;
		const gchar* _tmp28_;
#line 292 "../lib/Factories/ItemFactory.vala"
		_tmp27_ = terminal;
#line 292 "../lib/Factories/ItemFactory.vala"
		_tmp28_ = g_app_info_get_id (_tmp27_);
#line 292 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp28_);
#line 1471 "ItemFactory.c"
	}
#line 293 "../lib/Factories/ItemFactory.vala"
	_tmp29_ = calendar;
#line 293 "../lib/Factories/ItemFactory.vala"
	if (_tmp29_ != NULL) {
#line 1477 "ItemFactory.c"
		GAppInfo* _tmp30_;
		const gchar* _tmp31_;
#line 294 "../lib/Factories/ItemFactory.vala"
		_tmp30_ = calendar;
#line 294 "../lib/Factories/ItemFactory.vala"
		_tmp31_ = g_app_info_get_id (_tmp30_);
#line 294 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp31_);
#line 1486 "ItemFactory.c"
	}
#line 295 "../lib/Factories/ItemFactory.vala"
	_tmp32_ = audio;
#line 295 "../lib/Factories/ItemFactory.vala"
	if (_tmp32_ != NULL) {
#line 1492 "ItemFactory.c"
		GAppInfo* _tmp33_;
		const gchar* _tmp34_;
#line 296 "../lib/Factories/ItemFactory.vala"
		_tmp33_ = audio;
#line 296 "../lib/Factories/ItemFactory.vala"
		_tmp34_ = g_app_info_get_id (_tmp33_);
#line 296 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp34_);
#line 1501 "ItemFactory.c"
	}
#line 297 "../lib/Factories/ItemFactory.vala"
	_tmp35_ = video;
#line 297 "../lib/Factories/ItemFactory.vala"
	if (_tmp35_ != NULL) {
#line 1507 "ItemFactory.c"
		GAppInfo* _tmp36_;
		const gchar* _tmp37_;
#line 298 "../lib/Factories/ItemFactory.vala"
		_tmp36_ = video;
#line 298 "../lib/Factories/ItemFactory.vala"
		_tmp37_ = g_app_info_get_id (_tmp36_);
#line 298 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp37_);
#line 1516 "ItemFactory.c"
	}
#line 299 "../lib/Factories/ItemFactory.vala"
	_tmp38_ = photo;
#line 299 "../lib/Factories/ItemFactory.vala"
	if (_tmp38_ != NULL) {
#line 1522 "ItemFactory.c"
		GAppInfo* _tmp39_;
		const gchar* _tmp40_;
#line 300 "../lib/Factories/ItemFactory.vala"
		_tmp39_ = photo;
#line 300 "../lib/Factories/ItemFactory.vala"
		_tmp40_ = g_app_info_get_id (_tmp39_);
#line 300 "../lib/Factories/ItemFactory.vala"
		plank_item_factory_make_dock_item_for_desktop_id (self, _tmp40_);
#line 1531 "ItemFactory.c"
	}
#line 302 "../lib/Factories/ItemFactory.vala"
	result = TRUE;
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (photo);
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (video);
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (audio);
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (calendar);
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (terminal);
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (mail);
#line 302 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (browser);
#line 302 "../lib/Factories/ItemFactory.vala"
	return result;
#line 1551 "ItemFactory.c"
}

/**
 * Creates a bunch of default .dockitem's.
 */
void
plank_item_factory_make_default_items (PlankItemFactory* self)
{
#line 308 "../lib/Factories/ItemFactory.vala"
	g_return_if_fail (self != NULL);
#line 310 "../lib/Factories/ItemFactory.vala"
	if (plank_item_factory_make_default_gnome_items (self)) {
#line 311 "../lib/Factories/ItemFactory.vala"
		return;
#line 1566 "ItemFactory.c"
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 314 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_WEB;
#line 314 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_WEB);
#line 314 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1579 "ItemFactory.c"
			const gchar* uri = NULL;
#line 314 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1583 "ItemFactory.c"
			{
				const gchar* _tmp0_;
				GFile* _tmp1_;
				GFile* _tmp2_;
				gboolean _tmp3_;
#line 315 "../lib/Factories/ItemFactory.vala"
				_tmp0_ = uri;
#line 315 "../lib/Factories/ItemFactory.vala"
				_tmp1_ = plank_item_factory_make_dock_item (self, _tmp0_, NULL);
#line 315 "../lib/Factories/ItemFactory.vala"
				_tmp2_ = _tmp1_;
#line 315 "../lib/Factories/ItemFactory.vala"
				_tmp3_ = _tmp2_ != NULL;
#line 315 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp2_);
#line 315 "../lib/Factories/ItemFactory.vala"
				if (_tmp3_) {
#line 316 "../lib/Factories/ItemFactory.vala"
					break;
#line 1603 "ItemFactory.c"
				}
			}
		}
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 319 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_MAIL;
#line 319 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_MAIL);
#line 319 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1619 "ItemFactory.c"
			const gchar* uri = NULL;
#line 319 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1623 "ItemFactory.c"
			{
				const gchar* _tmp4_;
				GFile* _tmp5_;
				GFile* _tmp6_;
				gboolean _tmp7_;
#line 320 "../lib/Factories/ItemFactory.vala"
				_tmp4_ = uri;
#line 320 "../lib/Factories/ItemFactory.vala"
				_tmp5_ = plank_item_factory_make_dock_item (self, _tmp4_, NULL);
#line 320 "../lib/Factories/ItemFactory.vala"
				_tmp6_ = _tmp5_;
#line 320 "../lib/Factories/ItemFactory.vala"
				_tmp7_ = _tmp6_ != NULL;
#line 320 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp6_);
#line 320 "../lib/Factories/ItemFactory.vala"
				if (_tmp7_) {
#line 321 "../lib/Factories/ItemFactory.vala"
					break;
#line 1643 "ItemFactory.c"
				}
			}
		}
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 324 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_TERMINAL;
#line 324 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_TERMINAL);
#line 324 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1659 "ItemFactory.c"
			const gchar* uri = NULL;
#line 324 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1663 "ItemFactory.c"
			{
				const gchar* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				gboolean _tmp11_;
#line 325 "../lib/Factories/ItemFactory.vala"
				_tmp8_ = uri;
#line 325 "../lib/Factories/ItemFactory.vala"
				_tmp9_ = plank_item_factory_make_dock_item (self, _tmp8_, NULL);
#line 325 "../lib/Factories/ItemFactory.vala"
				_tmp10_ = _tmp9_;
#line 325 "../lib/Factories/ItemFactory.vala"
				_tmp11_ = _tmp10_ != NULL;
#line 325 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp10_);
#line 325 "../lib/Factories/ItemFactory.vala"
				if (_tmp11_) {
#line 326 "../lib/Factories/ItemFactory.vala"
					break;
#line 1683 "ItemFactory.c"
				}
			}
		}
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 329 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_AUDIO;
#line 329 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_AUDIO);
#line 329 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1699 "ItemFactory.c"
			const gchar* uri = NULL;
#line 329 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1703 "ItemFactory.c"
			{
				const gchar* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				gboolean _tmp15_;
#line 330 "../lib/Factories/ItemFactory.vala"
				_tmp12_ = uri;
#line 330 "../lib/Factories/ItemFactory.vala"
				_tmp13_ = plank_item_factory_make_dock_item (self, _tmp12_, NULL);
#line 330 "../lib/Factories/ItemFactory.vala"
				_tmp14_ = _tmp13_;
#line 330 "../lib/Factories/ItemFactory.vala"
				_tmp15_ = _tmp14_ != NULL;
#line 330 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp14_);
#line 330 "../lib/Factories/ItemFactory.vala"
				if (_tmp15_) {
#line 331 "../lib/Factories/ItemFactory.vala"
					break;
#line 1723 "ItemFactory.c"
				}
			}
		}
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 334 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_VIDEO;
#line 334 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_VIDEO);
#line 334 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1739 "ItemFactory.c"
			const gchar* uri = NULL;
#line 334 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1743 "ItemFactory.c"
			{
				const gchar* _tmp16_;
				GFile* _tmp17_;
				GFile* _tmp18_;
				gboolean _tmp19_;
#line 335 "../lib/Factories/ItemFactory.vala"
				_tmp16_ = uri;
#line 335 "../lib/Factories/ItemFactory.vala"
				_tmp17_ = plank_item_factory_make_dock_item (self, _tmp16_, NULL);
#line 335 "../lib/Factories/ItemFactory.vala"
				_tmp18_ = _tmp17_;
#line 335 "../lib/Factories/ItemFactory.vala"
				_tmp19_ = _tmp18_ != NULL;
#line 335 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp18_);
#line 335 "../lib/Factories/ItemFactory.vala"
				if (_tmp19_) {
#line 336 "../lib/Factories/ItemFactory.vala"
					break;
#line 1763 "ItemFactory.c"
				}
			}
		}
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 339 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_PHOTO;
#line 339 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_PHOTO);
#line 339 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1779 "ItemFactory.c"
			const gchar* uri = NULL;
#line 339 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1783 "ItemFactory.c"
			{
				const gchar* _tmp20_;
				GFile* _tmp21_;
				GFile* _tmp22_;
				gboolean _tmp23_;
#line 340 "../lib/Factories/ItemFactory.vala"
				_tmp20_ = uri;
#line 340 "../lib/Factories/ItemFactory.vala"
				_tmp21_ = plank_item_factory_make_dock_item (self, _tmp20_, NULL);
#line 340 "../lib/Factories/ItemFactory.vala"
				_tmp22_ = _tmp21_;
#line 340 "../lib/Factories/ItemFactory.vala"
				_tmp23_ = _tmp22_ != NULL;
#line 340 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp22_);
#line 340 "../lib/Factories/ItemFactory.vala"
				if (_tmp23_) {
#line 341 "../lib/Factories/ItemFactory.vala"
					break;
#line 1803 "ItemFactory.c"
				}
			}
		}
	}
	{
		const gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 344 "../lib/Factories/ItemFactory.vala"
		uri_collection = PLANK_ITEM_FACTORY_DEFAULT_APP_MESSENGER;
#line 344 "../lib/Factories/ItemFactory.vala"
		uri_collection_length1 = G_N_ELEMENTS (PLANK_ITEM_FACTORY_DEFAULT_APP_MESSENGER);
#line 344 "../lib/Factories/ItemFactory.vala"
		for (uri_it = 0; uri_it < uri_collection_length1; uri_it = uri_it + 1) {
#line 1819 "ItemFactory.c"
			const gchar* uri = NULL;
#line 344 "../lib/Factories/ItemFactory.vala"
			uri = uri_collection[uri_it];
#line 1823 "ItemFactory.c"
			{
				const gchar* _tmp24_;
				GFile* _tmp25_;
				GFile* _tmp26_;
				gboolean _tmp27_;
#line 345 "../lib/Factories/ItemFactory.vala"
				_tmp24_ = uri;
#line 345 "../lib/Factories/ItemFactory.vala"
				_tmp25_ = plank_item_factory_make_dock_item (self, _tmp24_, NULL);
#line 345 "../lib/Factories/ItemFactory.vala"
				_tmp26_ = _tmp25_;
#line 345 "../lib/Factories/ItemFactory.vala"
				_tmp27_ = _tmp26_ != NULL;
#line 345 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp26_);
#line 345 "../lib/Factories/ItemFactory.vala"
				if (_tmp27_) {
#line 346 "../lib/Factories/ItemFactory.vala"
					break;
#line 1843 "ItemFactory.c"
				}
			}
		}
	}
}

/**
 * Creates a new .dockitem for a uri.
 *
 * @param uri the uri or path to create a .dockitem for
 * @param target_dir the folder where to put the newly created .dockitem (defaults to launchers_dir)
 * @return the new {@link GLib.File} of the new .dockitem created
 */
static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 1877 "ItemFactory.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 1886 "ItemFactory.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1905 "ItemFactory.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1909 "ItemFactory.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1915 "ItemFactory.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1925 "ItemFactory.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1933 "ItemFactory.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1937 "ItemFactory.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1943 "ItemFactory.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1953 "ItemFactory.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1152 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1152 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1154 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1154 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1977 "ItemFactory.c"
		gchar* _tmp2_;
#line 1155 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1155 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1155 "glib-2.0.vapi"
		return result;
#line 1985 "ItemFactory.c"
	} else {
#line 1157 "glib-2.0.vapi"
		result = -1;
#line 1157 "glib-2.0.vapi"
		return result;
#line 1991 "ItemFactory.c"
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 2019 "ItemFactory.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 2025 "ItemFactory.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 2031 "ItemFactory.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 2035 "ItemFactory.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 2043 "ItemFactory.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 2047 "ItemFactory.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 2059 "ItemFactory.c"
}

GFile*
plank_item_factory_make_dock_item (PlankItemFactory* self,
                                   const gchar* uri,
                                   GFile* target_dir)
{
	gboolean is_valid = FALSE;
	gchar* basename = NULL;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 356 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 356 "../lib/Factories/ItemFactory.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 358 "../lib/Factories/ItemFactory.vala"
	if (target_dir == NULL) {
#line 2077 "ItemFactory.c"
		GFile* _tmp0_;
#line 359 "../lib/Factories/ItemFactory.vala"
		_tmp0_ = self->launchers_dir;
#line 359 "../lib/Factories/ItemFactory.vala"
		target_dir = _tmp0_;
#line 2083 "ItemFactory.c"
	}
#line 361 "../lib/Factories/ItemFactory.vala"
	is_valid = FALSE;
#line 363 "../lib/Factories/ItemFactory.vala"
	if (g_str_has_prefix (uri, PLANK_DOCKLET_URI_PREFIX)) {
#line 2089 "ItemFactory.c"
		gchar* _tmp1_;
#line 364 "../lib/Factories/ItemFactory.vala"
		is_valid = TRUE;
#line 365 "../lib/Factories/ItemFactory.vala"
		_tmp1_ = string_substring (uri, (glong) 10, (glong) -1);
#line 365 "../lib/Factories/ItemFactory.vala"
		_g_free0 (basename);
#line 365 "../lib/Factories/ItemFactory.vala"
		basename = _tmp1_;
#line 2099 "ItemFactory.c"
	} else {
		GFile* launcher_file = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp8_;
#line 367 "../lib/Factories/ItemFactory.vala"
		_tmp2_ = g_file_new_for_uri (uri);
#line 367 "../lib/Factories/ItemFactory.vala"
		launcher_file = _tmp2_;
#line 368 "../lib/Factories/ItemFactory.vala"
		_tmp3_ = launcher_file;
#line 368 "../lib/Factories/ItemFactory.vala"
		is_valid = g_file_query_exists (_tmp3_, NULL);
#line 369 "../lib/Factories/ItemFactory.vala"
		_tmp5_ = launcher_file;
#line 369 "../lib/Factories/ItemFactory.vala"
		_tmp6_ = g_file_get_basename (_tmp5_);
#line 369 "../lib/Factories/ItemFactory.vala"
		_tmp4_ = _tmp6_;
#line 369 "../lib/Factories/ItemFactory.vala"
		if (_tmp4_ == NULL) {
#line 2124 "ItemFactory.c"
			gchar* _tmp7_;
#line 369 "../lib/Factories/ItemFactory.vala"
			_tmp7_ = g_strdup ("unknown");
#line 369 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp4_);
#line 369 "../lib/Factories/ItemFactory.vala"
			_tmp4_ = _tmp7_;
#line 2132 "ItemFactory.c"
		}
#line 369 "../lib/Factories/ItemFactory.vala"
		_tmp8_ = _tmp4_;
#line 369 "../lib/Factories/ItemFactory.vala"
		_tmp4_ = NULL;
#line 369 "../lib/Factories/ItemFactory.vala"
		_g_free0 (basename);
#line 369 "../lib/Factories/ItemFactory.vala"
		basename = _tmp8_;
#line 363 "../lib/Factories/ItemFactory.vala"
		_g_free0 (_tmp4_);
#line 363 "../lib/Factories/ItemFactory.vala"
		_g_object_unref0 (launcher_file);
#line 2146 "ItemFactory.c"
	}
#line 372 "../lib/Factories/ItemFactory.vala"
	if (is_valid) {
#line 2150 "ItemFactory.c"
		GKeyFile* file = NULL;
		GKeyFile* _tmp9_;
		GKeyFile* _tmp10_;
		const gchar* _tmp11_;
#line 373 "../lib/Factories/ItemFactory.vala"
		_tmp9_ = g_key_file_new ();
#line 373 "../lib/Factories/ItemFactory.vala"
		file = _tmp9_;
#line 375 "../lib/Factories/ItemFactory.vala"
		_tmp10_ = file;
#line 375 "../lib/Factories/ItemFactory.vala"
		_tmp11_ = g_type_name (PLANK_TYPE_DOCK_ITEM_PREFERENCES);
#line 375 "../lib/Factories/ItemFactory.vala"
		g_key_file_set_string (_tmp10_, _tmp11_, "Launcher", uri);
#line 2165 "ItemFactory.c"
		{
			gint index_of_last_dot = 0;
			const gchar* _tmp12_;
			gchar* _tmp13_ = NULL;
			gchar* launcher_base = NULL;
			gchar* _tmp18_;
			gchar* dockitem = NULL;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			GFile* dockitem_file = NULL;
			const gchar* _tmp21_;
			GFile* _tmp22_;
			gint counter = 0;
			GFileOutputStream* _tmp29_ = NULL;
			GFile* _tmp30_;
			GFileOutputStream* _tmp31_;
			GDataOutputStream* stream = NULL;
			GDataOutputStream* _tmp32_;
			GDataOutputStream* _tmp33_;
			GKeyFile* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			GDataOutputStream* _tmp37_;
			GFile* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 379 "../lib/Factories/ItemFactory.vala"
			_tmp12_ = basename;
#line 379 "../lib/Factories/ItemFactory.vala"
			index_of_last_dot = string_last_index_of (_tmp12_, ".", 0);
#line 380 "../lib/Factories/ItemFactory.vala"
			if (index_of_last_dot >= 0) {
#line 2198 "ItemFactory.c"
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 380 "../lib/Factories/ItemFactory.vala"
				_tmp14_ = basename;
#line 380 "../lib/Factories/ItemFactory.vala"
				_tmp15_ = string_slice (_tmp14_, (glong) 0, (glong) index_of_last_dot);
#line 380 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp13_);
#line 380 "../lib/Factories/ItemFactory.vala"
				_tmp13_ = _tmp15_;
#line 2209 "ItemFactory.c"
			} else {
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 380 "../lib/Factories/ItemFactory.vala"
				_tmp16_ = basename;
#line 380 "../lib/Factories/ItemFactory.vala"
				_tmp17_ = g_strdup (_tmp16_);
#line 380 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp13_);
#line 380 "../lib/Factories/ItemFactory.vala"
				_tmp13_ = _tmp17_;
#line 2221 "ItemFactory.c"
			}
#line 380 "../lib/Factories/ItemFactory.vala"
			_tmp18_ = g_strdup (_tmp13_);
#line 380 "../lib/Factories/ItemFactory.vala"
			launcher_base = _tmp18_;
#line 381 "../lib/Factories/ItemFactory.vala"
			_tmp19_ = launcher_base;
#line 381 "../lib/Factories/ItemFactory.vala"
			_tmp20_ = g_strdup_printf ("%s.dockitem", _tmp19_);
#line 381 "../lib/Factories/ItemFactory.vala"
			dockitem = _tmp20_;
#line 382 "../lib/Factories/ItemFactory.vala"
			_tmp21_ = dockitem;
#line 382 "../lib/Factories/ItemFactory.vala"
			_tmp22_ = g_file_get_child (target_dir, _tmp21_);
#line 382 "../lib/Factories/ItemFactory.vala"
			dockitem_file = _tmp22_;
#line 383 "../lib/Factories/ItemFactory.vala"
			counter = 1;
#line 385 "../lib/Factories/ItemFactory.vala"
			while (TRUE) {
#line 2243 "ItemFactory.c"
				GFile* _tmp23_;
				const gchar* _tmp24_;
				gint _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				GFile* _tmp28_;
#line 385 "../lib/Factories/ItemFactory.vala"
				_tmp23_ = dockitem_file;
#line 385 "../lib/Factories/ItemFactory.vala"
				if (!g_file_query_exists (_tmp23_, NULL)) {
#line 385 "../lib/Factories/ItemFactory.vala"
					break;
#line 2256 "ItemFactory.c"
				}
#line 386 "../lib/Factories/ItemFactory.vala"
				_tmp24_ = launcher_base;
#line 386 "../lib/Factories/ItemFactory.vala"
				_tmp25_ = counter;
#line 386 "../lib/Factories/ItemFactory.vala"
				counter = _tmp25_ + 1;
#line 386 "../lib/Factories/ItemFactory.vala"
				_tmp26_ = g_strdup_printf ("%s-%d.dockitem", _tmp24_, _tmp25_);
#line 386 "../lib/Factories/ItemFactory.vala"
				_g_free0 (dockitem);
#line 386 "../lib/Factories/ItemFactory.vala"
				dockitem = _tmp26_;
#line 387 "../lib/Factories/ItemFactory.vala"
				_tmp27_ = dockitem;
#line 387 "../lib/Factories/ItemFactory.vala"
				_tmp28_ = g_file_get_child (target_dir, _tmp27_);
#line 387 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (dockitem_file);
#line 387 "../lib/Factories/ItemFactory.vala"
				dockitem_file = _tmp28_;
#line 2278 "ItemFactory.c"
			}
#line 391 "../lib/Factories/ItemFactory.vala"
			_tmp30_ = dockitem_file;
#line 391 "../lib/Factories/ItemFactory.vala"
			_tmp31_ = g_file_create (_tmp30_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 391 "../lib/Factories/ItemFactory.vala"
			_tmp29_ = _tmp31_;
#line 391 "../lib/Factories/ItemFactory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 391 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (dockitem_file);
#line 391 "../lib/Factories/ItemFactory.vala"
				_g_free0 (dockitem);
#line 391 "../lib/Factories/ItemFactory.vala"
				_g_free0 (launcher_base);
#line 391 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp13_);
#line 2296 "ItemFactory.c"
				goto __catch0_g_error;
			}
#line 391 "../lib/Factories/ItemFactory.vala"
			_tmp32_ = g_data_output_stream_new ((GOutputStream*) _tmp29_);
#line 391 "../lib/Factories/ItemFactory.vala"
			stream = _tmp32_;
#line 392 "../lib/Factories/ItemFactory.vala"
			_tmp33_ = stream;
#line 392 "../lib/Factories/ItemFactory.vala"
			_tmp34_ = file;
#line 392 "../lib/Factories/ItemFactory.vala"
			_tmp35_ = g_key_file_to_data (_tmp34_, NULL, NULL);
#line 392 "../lib/Factories/ItemFactory.vala"
			_tmp36_ = _tmp35_;
#line 392 "../lib/Factories/ItemFactory.vala"
			g_data_output_stream_put_string (_tmp33_, _tmp36_, NULL, &_inner_error0_);
#line 392 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp36_);
#line 392 "../lib/Factories/ItemFactory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (stream);
#line 392 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp29_);
#line 392 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (dockitem_file);
#line 392 "../lib/Factories/ItemFactory.vala"
				_g_free0 (dockitem);
#line 392 "../lib/Factories/ItemFactory.vala"
				_g_free0 (launcher_base);
#line 392 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp13_);
#line 2329 "ItemFactory.c"
				goto __catch0_g_error;
			}
#line 393 "../lib/Factories/ItemFactory.vala"
			_tmp37_ = stream;
#line 393 "../lib/Factories/ItemFactory.vala"
			g_output_stream_close ((GOutputStream*) _tmp37_, NULL, &_inner_error0_);
#line 393 "../lib/Factories/ItemFactory.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 393 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (stream);
#line 393 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (_tmp29_);
#line 393 "../lib/Factories/ItemFactory.vala"
				_g_object_unref0 (dockitem_file);
#line 393 "../lib/Factories/ItemFactory.vala"
				_g_free0 (dockitem);
#line 393 "../lib/Factories/ItemFactory.vala"
				_g_free0 (launcher_base);
#line 393 "../lib/Factories/ItemFactory.vala"
				_g_free0 (_tmp13_);
#line 2350 "ItemFactory.c"
				goto __catch0_g_error;
			}
#line 395 "../lib/Factories/ItemFactory.vala"
			_tmp38_ = dockitem_file;
#line 395 "../lib/Factories/ItemFactory.vala"
			_tmp39_ = g_file_get_path (_tmp38_);
#line 395 "../lib/Factories/ItemFactory.vala"
			_tmp40_ = _tmp39_;
#line 395 "../lib/Factories/ItemFactory.vala"
			g_debug ("ItemFactory.vala:395: Created dock item '%s' for launcher '%s'", _tmp40_, uri);
#line 395 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp40_);
#line 396 "../lib/Factories/ItemFactory.vala"
			result = dockitem_file;
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (stream);
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_object_unref0 (_tmp29_);
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_free0 (dockitem);
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_free0 (launcher_base);
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_free0 (_tmp13_);
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_key_file_unref0 (file);
#line 396 "../lib/Factories/ItemFactory.vala"
			_g_free0 (basename);
#line 396 "../lib/Factories/ItemFactory.vala"
			return result;
#line 2381 "ItemFactory.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 377 "../lib/Factories/ItemFactory.vala"
			g_clear_error (&_inner_error0_);
#line 2388 "ItemFactory.c"
		}
		__finally0:
#line 377 "../lib/Factories/ItemFactory.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "../lib/Factories/ItemFactory.vala"
			_g_key_file_unref0 (file);
#line 377 "../lib/Factories/ItemFactory.vala"
			_g_free0 (basename);
#line 377 "../lib/Factories/ItemFactory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 377 "../lib/Factories/ItemFactory.vala"
			g_clear_error (&_inner_error0_);
#line 377 "../lib/Factories/ItemFactory.vala"
			return NULL;
#line 2403 "ItemFactory.c"
		}
#line 372 "../lib/Factories/ItemFactory.vala"
		_g_key_file_unref0 (file);
#line 2407 "ItemFactory.c"
	}
#line 400 "../lib/Factories/ItemFactory.vala"
	result = NULL;
#line 400 "../lib/Factories/ItemFactory.vala"
	_g_free0 (basename);
#line 400 "../lib/Factories/ItemFactory.vala"
	return result;
#line 2415 "ItemFactory.c"
}

PlankItemFactory*
plank_item_factory_construct (GType object_type)
{
	PlankItemFactory * self = NULL;
#line 25 "../lib/Factories/ItemFactory.vala"
	self = (PlankItemFactory*) g_object_new (object_type, NULL);
#line 25 "../lib/Factories/ItemFactory.vala"
	return self;
#line 2426 "ItemFactory.c"
}

PlankItemFactory*
plank_item_factory_new (void)
{
#line 25 "../lib/Factories/ItemFactory.vala"
	return plank_item_factory_construct (PLANK_TYPE_ITEM_FACTORY);
#line 2434 "ItemFactory.c"
}

static void
plank_item_factory_class_init (PlankItemFactoryClass * klass,
                               gpointer klass_data)
{
#line 25 "../lib/Factories/ItemFactory.vala"
	plank_item_factory_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Factories/ItemFactory.vala"
	((PlankItemFactoryClass *) klass)->make_element = (PlankDockElement* (*) (PlankItemFactory*, GFile*)) plank_item_factory_real_make_element;
#line 25 "../lib/Factories/ItemFactory.vala"
	((PlankItemFactoryClass *) klass)->get_item_for_dock = (PlankDockItem* (*) (PlankItemFactory*)) plank_item_factory_real_get_item_for_dock;
#line 25 "../lib/Factories/ItemFactory.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_item_factory_finalize;
#line 2449 "ItemFactory.c"
}

static void
plank_item_factory_instance_init (PlankItemFactory * self,
                                  gpointer klass)
{
}

static void
plank_item_factory_finalize (GObject * obj)
{
	PlankItemFactory * self;
#line 25 "../lib/Factories/ItemFactory.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_ITEM_FACTORY, PlankItemFactory);
#line 91 "../lib/Factories/ItemFactory.vala"
	_g_object_unref0 (self->launchers_dir);
#line 25 "../lib/Factories/ItemFactory.vala"
	G_OBJECT_CLASS (plank_item_factory_parent_class)->finalize (obj);
#line 2468 "ItemFactory.c"
}

/**
 * An item factory.  Creates {@link DockItem}s based on .dockitem files.
 */
static GType
plank_item_factory_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankItemFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_item_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankItemFactory), 0, (GInstanceInitFunc) plank_item_factory_instance_init, NULL };
	GType plank_item_factory_type_id;
	plank_item_factory_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankItemFactory", &g_define_type_info, 0);
	return plank_item_factory_type_id;
}

GType
plank_item_factory_get_type (void)
{
	static volatile gsize plank_item_factory_type_id__once = 0;
	if (g_once_init_enter (&plank_item_factory_type_id__once)) {
		GType plank_item_factory_type_id;
		plank_item_factory_type_id = plank_item_factory_get_type_once ();
		g_once_init_leave (&plank_item_factory_type_id__once, plank_item_factory_type_id);
	}
	return plank_item_factory_type_id__once;
}

