/* DockRenderer.c generated by valac 0.56.9, the Vala compiler
 * generated from DockRenderer.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include "plank-internal.h"

enum  {
	PLANK_DOCK_RENDERER_0_PROPERTY,
	PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY,
	PLANK_DOCK_RENDERER_THEME_PROPERTY,
	PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY,
	PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY,
	PLANK_DOCK_RENDERER_NUM_PROPERTIES
};
static GParamSpec* plank_dock_renderer_properties[PLANK_DOCK_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define PLANK_TYPE_ENVIRONMENT_SETTINGS (plank_environment_settings_get_type ())
#define PLANK_ENVIRONMENT_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_ENVIRONMENT_SETTINGS, PlankEnvironmentSettings))
#define PLANK_ENVIRONMENT_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_ENVIRONMENT_SETTINGS, PlankEnvironmentSettingsClass))
#define PLANK_IS_ENVIRONMENT_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_ENVIRONMENT_SETTINGS))
#define PLANK_IS_ENVIRONMENT_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_ENVIRONMENT_SETTINGS))
#define PLANK_ENVIRONMENT_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_ENVIRONMENT_SETTINGS, PlankEnvironmentSettingsClass))

typedef struct _PlankEnvironmentSettings PlankEnvironmentSettings;
typedef struct _PlankEnvironmentSettingsClass PlankEnvironmentSettingsClass;
typedef struct _Block1Data Block1Data;
#define _plank_dock_item_draw_value_unref0(var) ((var == NULL) ? NULL : (var = (plank_dock_item_draw_value_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankDockRendererPrivate {
	PlankDockController* _controller;
	PlankDockTheme* _theme;
	gdouble _hide_progress;
	gdouble _opacity;
	gdouble _zoom_in_progress;
	GdkPoint _local_cursor;
	PlankSurface* main_buffer;
	PlankSurface* fade_buffer;
	PlankSurface* item_buffer;
	PlankSurface* shadow_buffer;
	PlankSurface* background_buffer;
	GdkRectangle background_rect;
	PlankSurface* indicator_buffer;
	PlankSurface* urgent_indicator_buffer;
	PlankSurface* urgent_glow_buffer;
	gint64 last_hide;
	gint64 last_hovered_changed;
	gboolean screen_is_composited;
	gboolean show_notifications;
	guint reset_position_manager_timer_id;
	gint window_scale_factor;
	gboolean is_first_frame;
	gboolean zoom_changed;
	gulong gtk_theme_name_changed_handler_id;
	gulong granite_prefers_color_scheme_handler_id;
	gdouble dynamic_animation_offset;
	GeeArrayList* current_items;
	GeeHashSet* transient_items;
};

struct _Block1Data {
	int _ref_count_;
	PlankDockRenderer* self;
	gint64 frame_time;
};

struct _Block2Data {
	int _ref_count_;
	PlankDockRenderer* self;
	GtkPositionType position;
	gdouble x_offset;
};

static gint PlankDockRenderer_private_offset;
static gpointer plank_dock_renderer_parent_class = NULL;

static PlankDockController* plank_dock_renderer_get_controller (PlankDockRenderer* self);
static void plank_dock_renderer_prefs_changed (PlankDockRenderer* self,
                                        GObject* prefs,
                                        GParamSpec* prop);
static void _plank_dock_renderer_prefs_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void plank_dock_renderer_theme_changed (PlankDockRenderer* self);
static void _plank_dock_renderer_theme_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void plank_dock_renderer_hidden_changed (PlankDockRenderer* self);
static void _plank_dock_renderer_hidden_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void plank_dock_renderer_hovered_changed (PlankDockRenderer* self);
static void _plank_dock_renderer_hovered_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void _plank_renderer_animated_draw_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void plank_dock_renderer_reset_position_manager (PlankDockRenderer* self);
static void plank_dock_renderer_load_theme (PlankDockRenderer* self);
static gboolean __lambda45_ (PlankDockRenderer* self);
static void plank_dock_renderer_reset_item_buffers (PlankDockRenderer* self);
static gboolean ___lambda45__gsource_func (gpointer self);
static void _plank_dock_renderer_load_theme_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void plank_dock_renderer_set_theme (PlankDockRenderer* self,
                                    PlankDockTheme* value);
static void plank_dock_renderer_real_initialize_frame (PlankRenderer* base,
                                                gint64 frame_time);
 G_GNUC_INTERNAL GType plank_environment_settings_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
 G_GNUC_INTERNAL PlankEnvironmentSettings* plank_environment_settings_get_instance (void);
 G_GNUC_INTERNAL gboolean plank_environment_settings_get_ShowNotifications (PlankEnvironmentSettings* self);
static void plank_dock_renderer_set_hide_progress (PlankDockRenderer* self,
                                            gdouble value);
static void plank_dock_renderer_set_zoom_in_progress (PlankDockRenderer* self,
                                               gdouble value);
static void plank_dock_renderer_set_opacity (PlankDockRenderer* self,
                                      gdouble value);
static gint plank_dock_renderer_compare_dock_item_position (PlankDockItem* i1,
                                                     PlankDockItem* i2);
static void plank_dock_renderer_animate_draw_value_for_item (PlankDockItem* item,
                                                      PlankDockItemDrawValue* draw_value,
                                                      PlankDockRenderer* self);
static void plank_dock_renderer_post_process_draw_values (GeeHashMap* draw_values,
                                                   PlankDockRenderer* self);
static void plank_dock_renderer_real_draw (PlankRenderer* base,
                                    cairo_t* cr,
                                    gint64 frame_time);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gdouble plank_dock_renderer_get_opacity (PlankDockRenderer* self);
static void plank_dock_renderer_draw_urgent_glow (PlankDockRenderer* self,
                                           PlankDockItem* item,
                                           cairo_t* cr,
                                           gint64 frame_time);
static void plank_dock_renderer_draw_dock_background (PlankDockRenderer* self,
                                               cairo_t* cr,
                                               GdkRectangle* background_rect,
                                               gint x_offset,
                                               gint y_offset);
static void plank_dock_renderer_draw_item (PlankDockRenderer* self,
                                    cairo_t* cr,
                                    PlankDockItem* item,
                                    PlankDockItemDrawValue* draw_value,
                                    gint64 frame_time);
static void plank_dock_renderer_draw_item_shadow (PlankDockRenderer* self,
                                           cairo_t* cr,
                                           PlankDockItem* item,
                                           PlankDockItemDrawValue* draw_value);
static const gchar* plank_dock_renderer_cairo_surface_type_to_string (cairo_surface_type_t type);
static gboolean ___lambda47_ (Block1Data* _data1_);
static gboolean ____lambda47__gsource_func (gpointer self);
static gdouble plank_dock_renderer_easing_bounce (gdouble t,
                                           gdouble d,
                                           gdouble n);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda46_ (Block2Data* _data2_,
                      PlankDockElement* i,
                      PlankDockItemDrawValue* val);
static gboolean ___lambda46__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static inline PlankSurface* plank_dock_renderer_get_item_surface (PlankDockRenderer* self,
                                                    PlankDockItem* item,
                                                    gint icon_size);
static PlankSurface* plank_dock_renderer_draw_item_foreground (gint width,
                                                        gint height,
                                                        PlankSurface* model,
                                                        PlankDockItem* item,
                                                        PlankDockRenderer* self);
static void plank_dock_renderer_draw_indicator_state (PlankDockRenderer* self,
                                               cairo_t* cr,
                                               GdkRectangle* item_rect,
                                               PlankIndicatorState indicator,
                                               PlankItemState item_state);
static PlankSurface* plank_dock_renderer_draw_item_background (gint width,
                                                        gint height,
                                                        PlankSurface* model,
                                                        PlankDockItem* item,
                                                        PlankDockRenderer* self);
static void plank_dock_renderer_get_styled_color (PlankDockRenderer* self,
                                           PlankColor* result);
static gboolean _gdk_point_equal (const GdkPoint * s1,
                           const GdkPoint * s2);
static void plank_dock_renderer_set_local_cursor (PlankDockRenderer* self,
                                           GdkPoint * value);
static gboolean plank_dock_renderer_real_animation_needed (PlankRenderer* base,
                                                    gint64 frame_time);
static inline gboolean plank_dock_renderer_item_animation_needed (PlankDockRenderer* self,
                                                    PlankDockItem* item,
                                                    gint64 render_time);
static GObject * plank_dock_renderer_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void plank_dock_renderer_finalize (GObject * obj);
static GType plank_dock_renderer_get_type_once (void);
static void _vala_plank_dock_renderer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_plank_dock_renderer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
plank_dock_renderer_get_instance_private (PlankDockRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockRenderer_private_offset);
}

static void
_plank_dock_renderer_prefs_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 125 "../lib/DockRenderer.vala"
	plank_dock_renderer_prefs_changed ((PlankDockRenderer*) self, _sender, pspec);
#line 258 "DockRenderer.c"
}

static void
_plank_dock_renderer_theme_changed_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 126 "../lib/DockRenderer.vala"
	plank_dock_renderer_theme_changed ((PlankDockRenderer*) self);
#line 268 "DockRenderer.c"
}

static void
_plank_dock_renderer_hidden_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 128 "../lib/DockRenderer.vala"
	plank_dock_renderer_hidden_changed ((PlankDockRenderer*) self);
#line 278 "DockRenderer.c"
}

static void
_plank_dock_renderer_hovered_changed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 129 "../lib/DockRenderer.vala"
	plank_dock_renderer_hovered_changed ((PlankDockRenderer*) self);
#line 288 "DockRenderer.c"
}

static void
_plank_renderer_animated_draw_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 130 "../lib/DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 298 "DockRenderer.c"
}

/**
 * Create a new dock renderer for a dock.
 *
 * @param controller the dock controller to manage drawing for
 * @param window the dock window to be animated
 */
PlankDockRenderer*
plank_dock_renderer_construct (GType object_type,
                               PlankDockController* controller,
                               GtkWindow* window)
{
	PlankDockRenderer * self = NULL;
#line 93 "../lib/DockRenderer.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 93 "../lib/DockRenderer.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 95 "../lib/DockRenderer.vala"
	self = (PlankDockRenderer*) g_object_new (object_type, "controller", controller, "widget", window, NULL);
#line 93 "../lib/DockRenderer.vala"
	return self;
#line 321 "DockRenderer.c"
}

PlankDockRenderer*
plank_dock_renderer_new (PlankDockController* controller,
                         GtkWindow* window)
{
#line 93 "../lib/DockRenderer.vala"
	return plank_dock_renderer_construct (PLANK_TYPE_DOCK_RENDERER, controller, window);
#line 330 "DockRenderer.c"
}

/**
 * Initializes the renderer.  Call after the DockWindow is constructed.
 */
void
plank_dock_renderer_initialize (PlankDockRenderer* self)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	PlankDockController* _tmp3_;
	PlankPositionManager* _tmp4_;
	PlankPositionManager* _tmp5_;
	PlankDockTheme* _tmp6_;
	PlankDockController* _tmp7_;
	PlankDockWindow* _tmp8_;
	PlankDockWindow* _tmp9_;
	PlankDockController* _tmp10_;
	PlankHideManager* _tmp11_;
	PlankHideManager* _tmp12_;
	PlankDockController* _tmp13_;
	PlankHideManager* _tmp14_;
	PlankHideManager* _tmp15_;
#line 113 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 113 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 113 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 113 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 113 "../lib/DockRenderer.vala"
	_vala_return_if_fail (_tmp2_ != NULL, "controller.window != null");
#line 116 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 116 "../lib/DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_position_manager (_tmp3_);
#line 116 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 116 "../lib/DockRenderer.vala"
	_tmp6_ = self->priv->_theme;
#line 116 "../lib/DockRenderer.vala"
	plank_position_manager_update (_tmp5_, _tmp6_);
#line 118 "../lib/DockRenderer.vala"
	_tmp7_ = self->priv->_controller;
#line 118 "../lib/DockRenderer.vala"
	_tmp8_ = plank_dock_controller_get_window (_tmp7_);
#line 118 "../lib/DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 118 "../lib/DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::HoveredItem", (GCallback) _plank_renderer_animated_draw_g_object_notify, (PlankRenderer*) self, 0);
#line 119 "../lib/DockRenderer.vala"
	_tmp10_ = self->priv->_controller;
#line 119 "../lib/DockRenderer.vala"
	_tmp11_ = plank_dock_controller_get_hide_manager (_tmp10_);
#line 119 "../lib/DockRenderer.vala"
	_tmp12_ = _tmp11_;
#line 119 "../lib/DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::Hidden", (GCallback) _plank_dock_renderer_hidden_changed_g_object_notify, self, 0);
#line 120 "../lib/DockRenderer.vala"
	_tmp13_ = self->priv->_controller;
#line 120 "../lib/DockRenderer.vala"
	_tmp14_ = plank_dock_controller_get_hide_manager (_tmp13_);
#line 120 "../lib/DockRenderer.vala"
	_tmp15_ = _tmp14_;
#line 120 "../lib/DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::Hovered", (GCallback) _plank_dock_renderer_hovered_changed_g_object_notify, self, 0);
#line 399 "DockRenderer.c"
}

static void
plank_dock_renderer_prefs_changed (PlankDockRenderer* self,
                                   GObject* prefs,
                                   GParamSpec* prop)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 135 "../lib/DockRenderer.vala"
	static GQuark _tmp2_label0 = 0;
#line 135 "../lib/DockRenderer.vala"
	static GQuark _tmp2_label1 = 0;
#line 135 "../lib/DockRenderer.vala"
	static GQuark _tmp2_label2 = 0;
#line 135 "../lib/DockRenderer.vala"
	static GQuark _tmp2_label3 = 0;
#line 135 "../lib/DockRenderer.vala"
	static GQuark _tmp2_label4 = 0;
#line 135 "../lib/DockRenderer.vala"
	static GQuark _tmp2_label5 = 0;
#line 133 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 133 "../lib/DockRenderer.vala"
	g_return_if_fail (prefs != NULL);
#line 133 "../lib/DockRenderer.vala"
	g_return_if_fail (prop != NULL);
#line 135 "../lib/DockRenderer.vala"
	_tmp0_ = prop->name;
#line 135 "../lib/DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 135 "../lib/DockRenderer.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 135 "../lib/DockRenderer.vala"
	if (((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Alignment")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("IconSize"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ItemsAlignment"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("Offset"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("Position"))))) {
#line 135 "../lib/DockRenderer.vala"
		switch (0) {
#line 438 "DockRenderer.c"
			default:
			{
#line 141 "../lib/DockRenderer.vala"
				plank_dock_renderer_reset_position_manager (self);
#line 142 "../lib/DockRenderer.vala"
				break;
#line 445 "DockRenderer.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("Theme")))) {
#line 135 "../lib/DockRenderer.vala"
		switch (0) {
#line 451 "DockRenderer.c"
			default:
			{
#line 144 "../lib/DockRenderer.vala"
				plank_dock_renderer_load_theme (self);
#line 145 "../lib/DockRenderer.vala"
				break;
#line 458 "DockRenderer.c"
			}
		}
	} else {
#line 135 "../lib/DockRenderer.vala"
		switch (0) {
#line 464 "DockRenderer.c"
			default:
			{
#line 148 "../lib/DockRenderer.vala"
				break;
#line 469 "DockRenderer.c"
			}
		}
	}
}

static void
plank_dock_renderer_theme_changed (PlankDockRenderer* self)
{
#line 152 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 154 "../lib/DockRenderer.vala"
	plank_dock_renderer_reset_position_manager (self);
#line 482 "DockRenderer.c"
}

static gboolean
__lambda45_ (PlankDockRenderer* self)
{
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankDockTheme* _tmp3_;
	gboolean result;
#line 166 "../lib/DockRenderer.vala"
	self->priv->reset_position_manager_timer_id = 0U;
#line 168 "../lib/DockRenderer.vala"
	plank_dock_renderer_reset_buffers (self);
#line 169 "../lib/DockRenderer.vala"
	plank_dock_renderer_reset_item_buffers (self);
#line 170 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 170 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 170 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 170 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->_theme;
#line 170 "../lib/DockRenderer.vala"
	plank_position_manager_update (_tmp2_, _tmp3_);
#line 172 "../lib/DockRenderer.vala"
	result = FALSE;
#line 172 "../lib/DockRenderer.vala"
	return result;
#line 513 "DockRenderer.c"
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((PlankDockRenderer*) self);
#line 165 "../lib/DockRenderer.vala"
	return result;
#line 523 "DockRenderer.c"
}

static void
plank_dock_renderer_reset_position_manager (PlankDockRenderer* self)
{
#line 157 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 162 "../lib/DockRenderer.vala"
	if (self->priv->reset_position_manager_timer_id > 0U) {
#line 163 "../lib/DockRenderer.vala"
		g_source_remove (self->priv->reset_position_manager_timer_id);
#line 535 "DockRenderer.c"
	}
#line 165 "../lib/DockRenderer.vala"
	self->priv->reset_position_manager_timer_id = gdk_threads_add_timeout ((guint) 50, ___lambda45__gsource_func, self);
#line 539 "DockRenderer.c"
}

static void
_plank_dock_renderer_load_theme_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 186 "../lib/DockRenderer.vala"
	plank_dock_renderer_load_theme ((PlankDockRenderer*) self);
#line 549 "DockRenderer.c"
}

static void
plank_dock_renderer_load_theme (PlankDockRenderer* self)
{
	gboolean is_reload = FALSE;
	PlankDockTheme* _tmp0_;
	const gchar* name = NULL;
	PlankDockController* _tmp3_;
	PlankDockPreferences* _tmp4_;
	PlankDockPreferences* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp15_;
	PlankDockTheme* _tmp16_;
	PlankDockTheme* _tmp17_;
	PlankDockTheme* _tmp18_;
	PlankDockTheme* _tmp19_;
#line 176 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 178 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 178 "../lib/DockRenderer.vala"
	is_reload = _tmp0_ != NULL;
#line 180 "../lib/DockRenderer.vala"
	if (is_reload) {
#line 577 "DockRenderer.c"
		PlankDockTheme* _tmp1_;
		guint _tmp2_;
#line 181 "../lib/DockRenderer.vala"
		_tmp1_ = self->priv->_theme;
#line 181 "../lib/DockRenderer.vala"
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
#line 181 "../lib/DockRenderer.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_dock_renderer_theme_changed_g_object_notify, self);
#line 586 "DockRenderer.c"
	}
#line 183 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 183 "../lib/DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_prefs (_tmp3_);
#line 183 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 183 "../lib/DockRenderer.vala"
	_tmp6_ = plank_dock_preferences_get_Theme (_tmp5_);
#line 183 "../lib/DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 183 "../lib/DockRenderer.vala"
	name = _tmp7_;
#line 184 "../lib/DockRenderer.vala"
	_tmp8_ = name;
#line 184 "../lib/DockRenderer.vala"
	if (g_strcmp0 (_tmp8_, PLANK_THEME_GTK_THEME_NAME) == 0) {
#line 185 "../lib/DockRenderer.vala"
		if (self->priv->gtk_theme_name_changed_handler_id == 0UL) {
#line 606 "DockRenderer.c"
			GtkSettings* _tmp9_;
			gulong _tmp10_;
#line 186 "../lib/DockRenderer.vala"
			_tmp9_ = gtk_settings_get_default ();
#line 186 "../lib/DockRenderer.vala"
			_tmp10_ = g_signal_connect_object ((GObject*) _tmp9_, "notify::gtk-theme-name", (GCallback) _plank_dock_renderer_load_theme_g_object_notify, self, 0);
#line 186 "../lib/DockRenderer.vala"
			self->priv->gtk_theme_name_changed_handler_id = _tmp10_;
#line 615 "DockRenderer.c"
		}
#line 187 "../lib/DockRenderer.vala"
		if (self->priv->granite_prefers_color_scheme_handler_id == 0UL) {
#line 619 "DockRenderer.c"
			GraniteSettings* _tmp11_;
			gulong _tmp12_;
#line 188 "../lib/DockRenderer.vala"
			_tmp11_ = granite_settings_get_default ();
#line 188 "../lib/DockRenderer.vala"
			_tmp12_ = g_signal_connect_object ((GObject*) _tmp11_, "notify::prefers-color-scheme", (GCallback) _plank_dock_renderer_load_theme_g_object_notify, self, 0);
#line 188 "../lib/DockRenderer.vala"
			self->priv->granite_prefers_color_scheme_handler_id = _tmp12_;
#line 628 "DockRenderer.c"
		}
	} else {
#line 190 "../lib/DockRenderer.vala"
		if (self->priv->gtk_theme_name_changed_handler_id > 0UL) {
#line 633 "DockRenderer.c"
			GtkSettings* _tmp13_;
#line 191 "../lib/DockRenderer.vala"
			_tmp13_ = gtk_settings_get_default ();
#line 191 "../lib/DockRenderer.vala"
			g_signal_handler_disconnect (_tmp13_, self->priv->gtk_theme_name_changed_handler_id);
#line 192 "../lib/DockRenderer.vala"
			self->priv->gtk_theme_name_changed_handler_id = 0UL;
#line 641 "DockRenderer.c"
		}
#line 195 "../lib/DockRenderer.vala"
		if (self->priv->granite_prefers_color_scheme_handler_id > 0UL) {
#line 645 "DockRenderer.c"
			GraniteSettings* _tmp14_;
#line 196 "../lib/DockRenderer.vala"
			_tmp14_ = granite_settings_get_default ();
#line 196 "../lib/DockRenderer.vala"
			g_signal_handler_disconnect (_tmp14_, self->priv->granite_prefers_color_scheme_handler_id);
#line 197 "../lib/DockRenderer.vala"
			self->priv->granite_prefers_color_scheme_handler_id = 0UL;
#line 653 "DockRenderer.c"
		}
	}
#line 201 "../lib/DockRenderer.vala"
	_tmp15_ = name;
#line 201 "../lib/DockRenderer.vala"
	_tmp16_ = plank_dock_theme_new (_tmp15_);
#line 201 "../lib/DockRenderer.vala"
	_tmp17_ = _tmp16_;
#line 201 "../lib/DockRenderer.vala"
	plank_dock_renderer_set_theme (self, _tmp17_);
#line 201 "../lib/DockRenderer.vala"
	_g_object_unref0 (_tmp17_);
#line 202 "../lib/DockRenderer.vala"
	_tmp18_ = self->priv->_theme;
#line 202 "../lib/DockRenderer.vala"
	plank_theme_load ((PlankTheme*) _tmp18_, "dock");
#line 203 "../lib/DockRenderer.vala"
	_tmp19_ = self->priv->_theme;
#line 203 "../lib/DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp19_, "notify", (GCallback) _plank_dock_renderer_theme_changed_g_object_notify, self, 0);
#line 205 "../lib/DockRenderer.vala"
	if (is_reload) {
#line 206 "../lib/DockRenderer.vala"
		plank_dock_renderer_theme_changed (self);
#line 678 "DockRenderer.c"
	}
}

/**
 * Resets all internal buffers and forces a redraw.
 */
void
plank_dock_renderer_reset_buffers (PlankDockRenderer* self)
{
#line 212 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 214 "../lib/DockRenderer.vala"
	plank_logger_verbose ("DockRenderer.reset_buffers ()", NULL);
#line 216 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->main_buffer);
#line 216 "../lib/DockRenderer.vala"
	self->priv->main_buffer = NULL;
#line 217 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->fade_buffer);
#line 217 "../lib/DockRenderer.vala"
	self->priv->fade_buffer = NULL;
#line 218 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->item_buffer);
#line 218 "../lib/DockRenderer.vala"
	self->priv->item_buffer = NULL;
#line 219 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->shadow_buffer);
#line 219 "../lib/DockRenderer.vala"
	self->priv->shadow_buffer = NULL;
#line 221 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->background_buffer);
#line 221 "../lib/DockRenderer.vala"
	self->priv->background_buffer = NULL;
#line 222 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->indicator_buffer);
#line 222 "../lib/DockRenderer.vala"
	self->priv->indicator_buffer = NULL;
#line 223 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_indicator_buffer);
#line 223 "../lib/DockRenderer.vala"
	self->priv->urgent_indicator_buffer = NULL;
#line 224 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_glow_buffer);
#line 224 "../lib/DockRenderer.vala"
	self->priv->urgent_glow_buffer = NULL;
#line 226 "../lib/DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 726 "DockRenderer.c"
}

/**
 * Resets all internal item buffers and forces a redraw.
 */
static void
plank_dock_renderer_reset_item_buffers (PlankDockRenderer* self)
{
	PlankDockController* _tmp0_;
#line 232 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 234 "../lib/DockRenderer.vala"
	plank_logger_verbose ("DockRenderer.reset_item_buffers ()", NULL);
#line 236 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 236 "../lib/DockRenderer.vala"
	plank_dock_element_reset_buffers ((PlankDockElement*) _tmp0_);
#line 238 "../lib/DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 746 "DockRenderer.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_dock_renderer_real_initialize_frame (PlankRenderer* base,
                                           gint64 frame_time)
{
	PlankDockRenderer * self;
	PlankDockTheme* _tmp0_;
	GeeArrayList* new_items = NULL;
	PlankDockController* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp7_;
	PlankPositionManager* _tmp8_;
	PlankPositionManager* _tmp9_;
	PlankPositionManager* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	PlankEnvironmentSettings* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gdouble fade_opacity = 0.0;
	PlankDockTheme* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	GeeArrayList* _tmp50_;
	GeeArrayList* _tmp51_;
	GeeArrayList* _tmp52_;
	GeeArrayList* _tmp78_;
	PlankPositionManager* _tmp79_;
	GeeArrayList* _tmp80_;
	PlankPositionManager* _tmp81_;
	GdkRectangle _tmp82_ = {0};
#line 244 "../lib/DockRenderer.vala"
	self = (PlankDockRenderer*) base;
#line 246 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 246 "../lib/DockRenderer.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 248 "../lib/DockRenderer.vala"
	_tmp1_ = self->priv->_controller;
#line 248 "../lib/DockRenderer.vala"
	_tmp2_ = plank_dock_controller_get_VisibleItems (_tmp1_);
#line 248 "../lib/DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 248 "../lib/DockRenderer.vala"
	new_items = _tmp3_;
#line 251 "../lib/DockRenderer.vala"
	_tmp4_ = new_items;
#line 251 "../lib/DockRenderer.vala"
	_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 251 "../lib/DockRenderer.vala"
	_tmp6_ = _tmp5_;
#line 251 "../lib/DockRenderer.vala"
	if (_tmp6_ <= 0) {
#line 252 "../lib/DockRenderer.vala"
		g_critical ("DockRenderer.vala:252: No items available to initialize frame");
#line 253 "../lib/DockRenderer.vala"
		return;
#line 813 "DockRenderer.c"
	}
#line 256 "../lib/DockRenderer.vala"
	_tmp7_ = self->priv->_controller;
#line 256 "../lib/DockRenderer.vala"
	_tmp8_ = plank_dock_controller_get_position_manager (_tmp7_);
#line 256 "../lib/DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 256 "../lib/DockRenderer.vala"
	position_manager = _tmp9_;
#line 258 "../lib/DockRenderer.vala"
	_tmp10_ = position_manager;
#line 258 "../lib/DockRenderer.vala"
	_tmp11_ = plank_position_manager_get_screen_is_composited (_tmp10_);
#line 258 "../lib/DockRenderer.vala"
	_tmp12_ = _tmp11_;
#line 258 "../lib/DockRenderer.vala"
	self->priv->screen_is_composited = _tmp12_;
#line 259 "../lib/DockRenderer.vala"
	_tmp13_ = plank_environment_settings_get_instance ();
#line 259 "../lib/DockRenderer.vala"
	_tmp14_ = plank_environment_settings_get_ShowNotifications (_tmp13_);
#line 259 "../lib/DockRenderer.vala"
	_tmp15_ = _tmp14_;
#line 259 "../lib/DockRenderer.vala"
	self->priv->show_notifications = _tmp15_;
#line 260 "../lib/DockRenderer.vala"
	self->priv->dynamic_animation_offset = 0.0;
#line 262 "../lib/DockRenderer.vala"
	_tmp16_ = self->priv->_theme;
#line 262 "../lib/DockRenderer.vala"
	_tmp17_ = plank_dock_theme_get_FadeOpacity (_tmp16_);
#line 262 "../lib/DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 262 "../lib/DockRenderer.vala"
	fade_opacity = _tmp18_;
#line 264 "../lib/DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 851 "DockRenderer.c"
		gint _tmp19_ = 0;
		gint hide_duration = 0;
		gint64 hide_time = 0LL;
		guint zoom_duration = 0U;
		gint64 zoom_time = 0LL;
		gdouble zoom_progress = 0.0;
		gdouble _tmp48_;
#line 265 "../lib/DockRenderer.vala"
		if (fade_opacity == 1.0) {
#line 861 "DockRenderer.c"
			PlankDockTheme* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 265 "../lib/DockRenderer.vala"
			_tmp20_ = self->priv->_theme;
#line 265 "../lib/DockRenderer.vala"
			_tmp21_ = plank_dock_theme_get_HideTime (_tmp20_);
#line 265 "../lib/DockRenderer.vala"
			_tmp22_ = _tmp21_;
#line 265 "../lib/DockRenderer.vala"
			_tmp19_ = _tmp22_;
#line 873 "DockRenderer.c"
		} else {
			PlankDockTheme* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
#line 265 "../lib/DockRenderer.vala"
			_tmp23_ = self->priv->_theme;
#line 265 "../lib/DockRenderer.vala"
			_tmp24_ = plank_dock_theme_get_FadeTime (_tmp23_);
#line 265 "../lib/DockRenderer.vala"
			_tmp25_ = _tmp24_;
#line 265 "../lib/DockRenderer.vala"
			_tmp19_ = _tmp25_;
#line 886 "DockRenderer.c"
		}
#line 265 "../lib/DockRenderer.vala"
		hide_duration = _tmp19_ * 1000;
#line 266 "../lib/DockRenderer.vala"
		hide_time = MAX (0LL, frame_time - self->priv->last_hide);
#line 267 "../lib/DockRenderer.vala"
		if (hide_time < ((gint64) hide_duration)) {
#line 894 "DockRenderer.c"
			PlankDockController* _tmp26_;
			PlankHideManager* _tmp27_;
			PlankHideManager* _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
#line 268 "../lib/DockRenderer.vala"
			_tmp26_ = self->priv->_controller;
#line 268 "../lib/DockRenderer.vala"
			_tmp27_ = plank_dock_controller_get_hide_manager (_tmp26_);
#line 268 "../lib/DockRenderer.vala"
			_tmp28_ = _tmp27_;
#line 268 "../lib/DockRenderer.vala"
			_tmp29_ = plank_hide_manager_get_Hidden (_tmp28_);
#line 268 "../lib/DockRenderer.vala"
			_tmp30_ = _tmp29_;
#line 268 "../lib/DockRenderer.vala"
			if (_tmp30_) {
#line 269 "../lib/DockRenderer.vala"
				plank_dock_renderer_set_hide_progress (self, plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_CUBIC, (gdouble) hide_time, (gdouble) hide_duration));
#line 914 "DockRenderer.c"
			} else {
#line 271 "../lib/DockRenderer.vala"
				plank_dock_renderer_set_hide_progress (self, 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, (gdouble) hide_time, (gdouble) hide_duration));
#line 918 "DockRenderer.c"
			}
		} else {
			gdouble _tmp31_ = 0.0;
			PlankDockController* _tmp32_;
			PlankHideManager* _tmp33_;
			PlankHideManager* _tmp34_;
			gboolean _tmp35_;
			gboolean _tmp36_;
#line 273 "../lib/DockRenderer.vala"
			_tmp32_ = self->priv->_controller;
#line 273 "../lib/DockRenderer.vala"
			_tmp33_ = plank_dock_controller_get_hide_manager (_tmp32_);
#line 273 "../lib/DockRenderer.vala"
			_tmp34_ = _tmp33_;
#line 273 "../lib/DockRenderer.vala"
			_tmp35_ = plank_hide_manager_get_Hidden (_tmp34_);
#line 273 "../lib/DockRenderer.vala"
			_tmp36_ = _tmp35_;
#line 273 "../lib/DockRenderer.vala"
			if (_tmp36_) {
#line 273 "../lib/DockRenderer.vala"
				_tmp31_ = 1.0;
#line 941 "DockRenderer.c"
			} else {
#line 273 "../lib/DockRenderer.vala"
				_tmp31_ = 0.0;
#line 945 "DockRenderer.c"
			}
#line 273 "../lib/DockRenderer.vala"
			plank_dock_renderer_set_hide_progress (self, _tmp31_);
#line 949 "DockRenderer.c"
		}
#line 276 "../lib/DockRenderer.vala"
		zoom_duration = PLANK_DOCK_ZOOM_DURATION * 1000;
#line 277 "../lib/DockRenderer.vala"
		zoom_time = MAX (0LL, frame_time - self->priv->last_hovered_changed);
#line 279 "../lib/DockRenderer.vala"
		if (zoom_time < ((gint64) zoom_duration)) {
#line 957 "DockRenderer.c"
			PlankDockController* _tmp37_;
			PlankHideManager* _tmp38_;
			PlankHideManager* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
#line 280 "../lib/DockRenderer.vala"
			_tmp37_ = self->priv->_controller;
#line 280 "../lib/DockRenderer.vala"
			_tmp38_ = plank_dock_controller_get_hide_manager (_tmp37_);
#line 280 "../lib/DockRenderer.vala"
			_tmp39_ = _tmp38_;
#line 280 "../lib/DockRenderer.vala"
			_tmp40_ = plank_hide_manager_get_Hovered (_tmp39_);
#line 280 "../lib/DockRenderer.vala"
			_tmp41_ = _tmp40_;
#line 280 "../lib/DockRenderer.vala"
			if (_tmp41_) {
#line 281 "../lib/DockRenderer.vala"
				zoom_progress = plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_CUBIC, (gdouble) zoom_time, (gdouble) zoom_duration);
#line 977 "DockRenderer.c"
			} else {
#line 283 "../lib/DockRenderer.vala"
				zoom_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_CUBIC, (gdouble) zoom_time, (gdouble) zoom_duration);
#line 981 "DockRenderer.c"
			}
		} else {
			gdouble _tmp42_ = 0.0;
			PlankDockController* _tmp43_;
			PlankHideManager* _tmp44_;
			PlankHideManager* _tmp45_;
			gboolean _tmp46_;
			gboolean _tmp47_;
#line 285 "../lib/DockRenderer.vala"
			_tmp43_ = self->priv->_controller;
#line 285 "../lib/DockRenderer.vala"
			_tmp44_ = plank_dock_controller_get_hide_manager (_tmp43_);
#line 285 "../lib/DockRenderer.vala"
			_tmp45_ = _tmp44_;
#line 285 "../lib/DockRenderer.vala"
			_tmp46_ = plank_hide_manager_get_Hovered (_tmp45_);
#line 285 "../lib/DockRenderer.vala"
			_tmp47_ = _tmp46_;
#line 285 "../lib/DockRenderer.vala"
			if (_tmp47_) {
#line 285 "../lib/DockRenderer.vala"
				_tmp42_ = 1.0;
#line 1004 "DockRenderer.c"
			} else {
#line 285 "../lib/DockRenderer.vala"
				_tmp42_ = 0.0;
#line 1008 "DockRenderer.c"
			}
#line 285 "../lib/DockRenderer.vala"
			zoom_progress = _tmp42_;
#line 1012 "DockRenderer.c"
		}
#line 287 "../lib/DockRenderer.vala"
		_tmp48_ = self->priv->_hide_progress;
#line 287 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_zoom_in_progress (self, zoom_progress * (1.0 - _tmp48_));
#line 1018 "DockRenderer.c"
	} else {
#line 289 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_hide_progress (self, 0.0);
#line 290 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_zoom_in_progress (self, 0.0);
#line 1024 "DockRenderer.c"
	}
#line 293 "../lib/DockRenderer.vala"
	if (fade_opacity < 1.0) {
#line 1028 "DockRenderer.c"
		gdouble _tmp49_;
#line 294 "../lib/DockRenderer.vala"
		_tmp49_ = self->priv->_hide_progress;
#line 294 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_opacity (self, 1.0 - ((1.0 - fade_opacity) * _tmp49_));
#line 1034 "DockRenderer.c"
	} else {
#line 296 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_opacity (self, 1.0);
#line 1038 "DockRenderer.c"
	}
#line 299 "../lib/DockRenderer.vala"
	_tmp50_ = self->priv->current_items;
#line 299 "../lib/DockRenderer.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp50_);
#line 300 "../lib/DockRenderer.vala"
	_tmp51_ = self->priv->current_items;
#line 300 "../lib/DockRenderer.vala"
	_tmp52_ = new_items;
#line 300 "../lib/DockRenderer.vala"
	gee_array_list_add_all (_tmp51_, (GeeCollection*) _tmp52_);
#line 302 "../lib/DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 1052 "DockRenderer.c"
		gint64 add_time = 0LL;
		gint64 remove_time = 0LL;
		gint64 move_time = 0LL;
		gint move_duration = 0;
		PlankDockTheme* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		GeeIterator* transient_items_it = NULL;
		GeeHashSet* _tmp56_;
		GeeIterator* _tmp57_;
#line 303 "../lib/DockRenderer.vala"
		add_time = 0LL;
#line 304 "../lib/DockRenderer.vala"
		remove_time = 0LL;
#line 305 "../lib/DockRenderer.vala"
		move_time = 0LL;
#line 306 "../lib/DockRenderer.vala"
		_tmp53_ = self->priv->_theme;
#line 306 "../lib/DockRenderer.vala"
		_tmp54_ = plank_dock_theme_get_ItemMoveTime (_tmp53_);
#line 306 "../lib/DockRenderer.vala"
		_tmp55_ = _tmp54_;
#line 306 "../lib/DockRenderer.vala"
		move_duration = _tmp55_ * 1000;
#line 308 "../lib/DockRenderer.vala"
		_tmp56_ = self->priv->transient_items;
#line 308 "../lib/DockRenderer.vala"
		_tmp57_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp56_);
#line 308 "../lib/DockRenderer.vala"
		transient_items_it = _tmp57_;
#line 309 "../lib/DockRenderer.vala"
		while (TRUE) {
#line 1085 "DockRenderer.c"
			GeeIterator* _tmp58_;
			PlankDockItem* item = NULL;
			GeeIterator* _tmp59_;
			gpointer _tmp60_;
			PlankDockItem* _tmp61_;
			gint64 _tmp62_;
			gint64 _tmp63_;
			PlankDockItem* _tmp64_;
			gint64 _tmp65_;
			gint64 _tmp66_;
#line 309 "../lib/DockRenderer.vala"
			_tmp58_ = transient_items_it;
#line 309 "../lib/DockRenderer.vala"
			if (!gee_iterator_next (_tmp58_)) {
#line 309 "../lib/DockRenderer.vala"
				break;
#line 1102 "DockRenderer.c"
			}
#line 310 "../lib/DockRenderer.vala"
			_tmp59_ = transient_items_it;
#line 310 "../lib/DockRenderer.vala"
			_tmp60_ = gee_iterator_get (_tmp59_);
#line 310 "../lib/DockRenderer.vala"
			item = (PlankDockItem*) _tmp60_;
#line 311 "../lib/DockRenderer.vala"
			_tmp61_ = item;
#line 311 "../lib/DockRenderer.vala"
			_tmp62_ = plank_dock_element_get_AddTime ((PlankDockElement*) _tmp61_);
#line 311 "../lib/DockRenderer.vala"
			_tmp63_ = _tmp62_;
#line 311 "../lib/DockRenderer.vala"
			add_time = _tmp63_;
#line 312 "../lib/DockRenderer.vala"
			_tmp64_ = item;
#line 312 "../lib/DockRenderer.vala"
			_tmp65_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) _tmp64_);
#line 312 "../lib/DockRenderer.vala"
			_tmp66_ = _tmp65_;
#line 312 "../lib/DockRenderer.vala"
			remove_time = _tmp66_;
#line 314 "../lib/DockRenderer.vala"
			if (add_time > remove_time) {
#line 315 "../lib/DockRenderer.vala"
				move_time = frame_time - add_time;
#line 316 "../lib/DockRenderer.vala"
				if (move_time < ((gint64) move_duration)) {
#line 1132 "DockRenderer.c"
					GeeArrayList* _tmp67_;
					PlankDockItem* _tmp68_;
#line 317 "../lib/DockRenderer.vala"
					_tmp67_ = self->priv->current_items;
#line 317 "../lib/DockRenderer.vala"
					_tmp68_ = item;
#line 317 "../lib/DockRenderer.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp67_, _tmp68_)) {
#line 1141 "DockRenderer.c"
						GeeArrayList* _tmp69_;
						PlankDockItem* _tmp70_;
#line 318 "../lib/DockRenderer.vala"
						_tmp69_ = self->priv->current_items;
#line 318 "../lib/DockRenderer.vala"
						_tmp70_ = item;
#line 318 "../lib/DockRenderer.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp69_, _tmp70_);
#line 1150 "DockRenderer.c"
					}
				} else {
					GeeIterator* _tmp71_;
#line 320 "../lib/DockRenderer.vala"
					_tmp71_ = transient_items_it;
#line 320 "../lib/DockRenderer.vala"
					gee_iterator_remove (_tmp71_);
#line 1158 "DockRenderer.c"
				}
			} else {
#line 322 "../lib/DockRenderer.vala"
				if (remove_time > ((gint64) 0)) {
#line 323 "../lib/DockRenderer.vala"
					move_time = frame_time - remove_time;
#line 324 "../lib/DockRenderer.vala"
					if (move_time < ((gint64) move_duration)) {
#line 1167 "DockRenderer.c"
						GeeArrayList* _tmp72_;
						PlankDockItem* _tmp73_;
#line 325 "../lib/DockRenderer.vala"
						_tmp72_ = self->priv->current_items;
#line 325 "../lib/DockRenderer.vala"
						_tmp73_ = item;
#line 325 "../lib/DockRenderer.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp72_, _tmp73_)) {
#line 1176 "DockRenderer.c"
							GeeArrayList* _tmp74_;
							PlankDockItem* _tmp75_;
#line 326 "../lib/DockRenderer.vala"
							_tmp74_ = self->priv->current_items;
#line 326 "../lib/DockRenderer.vala"
							_tmp75_ = item;
#line 326 "../lib/DockRenderer.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp74_, _tmp75_);
#line 1185 "DockRenderer.c"
						}
					} else {
						GeeIterator* _tmp76_;
#line 328 "../lib/DockRenderer.vala"
						_tmp76_ = transient_items_it;
#line 328 "../lib/DockRenderer.vala"
						gee_iterator_remove (_tmp76_);
#line 1193 "DockRenderer.c"
					}
				}
			}
#line 309 "../lib/DockRenderer.vala"
			_g_object_unref0 (item);
#line 1199 "DockRenderer.c"
		}
#line 302 "../lib/DockRenderer.vala"
		_g_object_unref0 (transient_items_it);
#line 1203 "DockRenderer.c"
	} else {
		GeeHashSet* _tmp77_;
#line 333 "../lib/DockRenderer.vala"
		_tmp77_ = self->priv->transient_items;
#line 333 "../lib/DockRenderer.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp77_);
#line 1210 "DockRenderer.c"
	}
#line 336 "../lib/DockRenderer.vala"
	_tmp78_ = self->priv->current_items;
#line 336 "../lib/DockRenderer.vala"
	gee_list_sort ((GeeList*) _tmp78_, (GCompareDataFunc) plank_dock_renderer_compare_dock_item_position, NULL, NULL);
#line 339 "../lib/DockRenderer.vala"
	_tmp79_ = position_manager;
#line 339 "../lib/DockRenderer.vala"
	_tmp80_ = self->priv->current_items;
#line 339 "../lib/DockRenderer.vala"
	plank_position_manager_update_draw_values (_tmp79_, _tmp80_, (PlankDrawValueFunc) plank_dock_renderer_animate_draw_value_for_item, self, (PlankDrawValuesFunc) plank_dock_renderer_post_process_draw_values, self);
#line 343 "../lib/DockRenderer.vala"
	_tmp81_ = position_manager;
#line 343 "../lib/DockRenderer.vala"
	plank_position_manager_get_background_region (_tmp81_, &_tmp82_);
#line 343 "../lib/DockRenderer.vala"
	self->priv->background_rect = _tmp82_;
#line 1228 "DockRenderer.c"
}

/**
 * {@inheritDoc}
 */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 349 "../lib/DockRenderer.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 349 "../lib/DockRenderer.vala"
	return _data1_;
#line 1241 "DockRenderer.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 349 "../lib/DockRenderer.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1251 "DockRenderer.c"
		PlankDockRenderer* self;
#line 349 "../lib/DockRenderer.vala"
		self = _data1_->self;
#line 349 "../lib/DockRenderer.vala"
		_g_object_unref0 (self);
#line 349 "../lib/DockRenderer.vala"
		g_slice_free (Block1Data, _data1_);
#line 1259 "DockRenderer.c"
	}
}

static gboolean
___lambda47_ (Block1Data* _data1_)
{
	PlankDockRenderer* self;
	PlankHideManager* hide_manager = NULL;
	PlankDockController* _tmp0_;
	PlankHideManager* _tmp1_;
	PlankHideManager* _tmp2_;
	PlankHideManager* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	PlankHideManager* _tmp6_;
	gboolean result;
#line 493 "../lib/DockRenderer.vala"
	self = _data1_->self;
#line 494 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 494 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_hide_manager (_tmp0_);
#line 494 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 494 "../lib/DockRenderer.vala"
	hide_manager = _tmp2_;
#line 499 "../lib/DockRenderer.vala"
	_tmp3_ = hide_manager;
#line 499 "../lib/DockRenderer.vala"
	_tmp4_ = plank_hide_manager_get_Hidden (_tmp3_);
#line 499 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 499 "../lib/DockRenderer.vala"
	if (_tmp5_) {
#line 500 "../lib/DockRenderer.vala"
		result = FALSE;
#line 500 "../lib/DockRenderer.vala"
		return result;
#line 1298 "DockRenderer.c"
	}
#line 503 "../lib/DockRenderer.vala"
	_tmp6_ = hide_manager;
#line 503 "../lib/DockRenderer.vala"
	plank_hide_manager_update_hovered (_tmp6_);
#line 507 "../lib/DockRenderer.vala"
	plank_renderer_force_frame_time_update ((PlankRenderer*) self);
#line 508 "../lib/DockRenderer.vala"
	self->priv->last_hide = _data1_->frame_time;
#line 510 "../lib/DockRenderer.vala"
	plank_dock_renderer_hidden_changed (self);
#line 511 "../lib/DockRenderer.vala"
	result = FALSE;
#line 511 "../lib/DockRenderer.vala"
	return result;
#line 1314 "DockRenderer.c"
}

static gboolean
____lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda47_ (self);
#line 493 "../lib/DockRenderer.vala"
	return result;
#line 1324 "DockRenderer.c"
}

static void
plank_dock_renderer_real_draw (PlankRenderer* base,
                               cairo_t* cr,
                               gint64 frame_time)
{
	PlankDockRenderer * self;
	Block1Data* _data1_;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	PlankDockController* _tmp3_;
	PlankDockWindow* _tmp4_;
	PlankDockWindow* _tmp5_;
	GdkWindow* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean no_full_draw_needed = FALSE;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp11_;
	PlankPositionManager* _tmp12_;
	PlankPositionManager* _tmp13_;
	PlankDockItem* dragged_item = NULL;
	PlankDockController* _tmp14_;
	PlankDragManager* _tmp15_;
	PlankDragManager* _tmp16_;
	PlankDockItem* _tmp17_;
	PlankDockItem* _tmp18_;
	GdkRectangle win_rect = {0};
	PlankPositionManager* _tmp19_;
	GdkRectangle _tmp20_ = {0};
	PlankSurface* _tmp21_;
	PlankSurface* _tmp29_;
	PlankSurface* _tmp37_;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gdouble _tmp59_;
	PlankSurface* _tmp68_;
	PlankSurface* _tmp69_;
	PlankSurface* _tmp70_;
	cairo_t* item_cr = NULL;
	PlankSurface* _tmp71_;
	cairo_t* _tmp72_;
	cairo_t* _tmp73_;
	cairo_t* shadow_cr = NULL;
	PlankSurface* _tmp74_;
	cairo_t* _tmp75_;
	cairo_t* _tmp76_;
	gint x_offset = 0;
	gint y_offset = 0;
	gdouble _tmp77_;
	PlankSurface* _tmp81_;
	cairo_t* main_cr = NULL;
	PlankSurface* _tmp82_;
	cairo_t* _tmp83_;
	cairo_t* _tmp84_;
	cairo_t* _tmp85_;
	cairo_t* _tmp86_;
	GdkRectangle _tmp87_;
	cairo_t* _tmp111_;
	PlankSurface* _tmp112_;
	cairo_surface_t* _tmp113_;
	cairo_surface_t* _tmp114_;
	cairo_t* _tmp115_;
	cairo_t* _tmp116_;
	PlankSurface* _tmp117_;
	cairo_surface_t* _tmp118_;
	cairo_surface_t* _tmp119_;
	cairo_t* _tmp120_;
	gdouble _tmp121_;
	gboolean _tmp139_ = FALSE;
#line 349 "../lib/DockRenderer.vala"
	self = (PlankDockRenderer*) base;
#line 349 "../lib/DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 349 "../lib/DockRenderer.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 349 "../lib/DockRenderer.vala"
	_data1_->_ref_count_ = 1;
#line 349 "../lib/DockRenderer.vala"
	_data1_->self = g_object_ref (self);
#line 349 "../lib/DockRenderer.vala"
	_data1_->frame_time = frame_time;
#line 352 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->current_items;
#line 352 "../lib/DockRenderer.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 352 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 352 "../lib/DockRenderer.vala"
	if (_tmp2_ <= 0) {
#line 353 "../lib/DockRenderer.vala"
		g_critical ("DockRenderer.vala:353: No items available to draw frame");
#line 354 "../lib/DockRenderer.vala"
		block1_data_unref (_data1_);
#line 354 "../lib/DockRenderer.vala"
		_data1_ = NULL;
#line 354 "../lib/DockRenderer.vala"
		return;
#line 1426 "DockRenderer.c"
	}
#line 357 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 357 "../lib/DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 357 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 357 "../lib/DockRenderer.vala"
	_tmp6_ = gtk_widget_get_window ((GtkWidget*) _tmp5_);
#line 357 "../lib/DockRenderer.vala"
	self->priv->window_scale_factor = gdk_window_get_scale_factor (_tmp6_);
#line 360 "../lib/DockRenderer.vala"
	if (!self->priv->is_first_frame) {
#line 1440 "DockRenderer.c"
		gdouble _tmp9_;
#line 360 "../lib/DockRenderer.vala"
		_tmp9_ = self->priv->_hide_progress;
#line 360 "../lib/DockRenderer.vala"
		_tmp8_ = _tmp9_ == 1.0;
#line 1446 "DockRenderer.c"
	} else {
#line 360 "../lib/DockRenderer.vala"
		_tmp8_ = FALSE;
#line 1450 "DockRenderer.c"
	}
#line 360 "../lib/DockRenderer.vala"
	if (_tmp8_) {
#line 1454 "DockRenderer.c"
		gdouble _tmp10_;
#line 360 "../lib/DockRenderer.vala"
		_tmp10_ = self->priv->_opacity;
#line 360 "../lib/DockRenderer.vala"
		_tmp7_ = _tmp10_ == 1.0;
#line 1460 "DockRenderer.c"
	} else {
#line 360 "../lib/DockRenderer.vala"
		_tmp7_ = FALSE;
#line 1464 "DockRenderer.c"
	}
#line 360 "../lib/DockRenderer.vala"
	no_full_draw_needed = _tmp7_;
#line 362 "../lib/DockRenderer.vala"
	_tmp11_ = self->priv->_controller;
#line 362 "../lib/DockRenderer.vala"
	_tmp12_ = plank_dock_controller_get_position_manager (_tmp11_);
#line 362 "../lib/DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 362 "../lib/DockRenderer.vala"
	position_manager = _tmp13_;
#line 363 "../lib/DockRenderer.vala"
	_tmp14_ = self->priv->_controller;
#line 363 "../lib/DockRenderer.vala"
	_tmp15_ = plank_dock_controller_get_drag_manager (_tmp14_);
#line 363 "../lib/DockRenderer.vala"
	_tmp16_ = _tmp15_;
#line 363 "../lib/DockRenderer.vala"
	_tmp17_ = plank_drag_manager_get_DragItem (_tmp16_);
#line 363 "../lib/DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 363 "../lib/DockRenderer.vala"
	dragged_item = _tmp18_;
#line 364 "../lib/DockRenderer.vala"
	_tmp19_ = position_manager;
#line 364 "../lib/DockRenderer.vala"
	plank_position_manager_get_dock_window_region (_tmp19_, &_tmp20_);
#line 364 "../lib/DockRenderer.vala"
	win_rect = _tmp20_;
#line 366 "../lib/DockRenderer.vala"
	_tmp21_ = self->priv->main_buffer;
#line 366 "../lib/DockRenderer.vala"
	if (_tmp21_ == NULL) {
#line 1498 "DockRenderer.c"
		GdkRectangle _tmp22_;
		GdkRectangle _tmp23_;
		cairo_surface_t* _tmp24_;
		PlankSurface* _tmp25_;
		PlankSurface* _tmp26_;
		cairo_surface_t* _tmp27_;
		cairo_surface_t* _tmp28_;
#line 367 "../lib/DockRenderer.vala"
		_tmp22_ = win_rect;
#line 367 "../lib/DockRenderer.vala"
		_tmp23_ = win_rect;
#line 367 "../lib/DockRenderer.vala"
		_tmp24_ = cairo_get_target (cr);
#line 367 "../lib/DockRenderer.vala"
		_tmp25_ = plank_surface_new_with_cairo_surface (_tmp22_.width, _tmp23_.height, _tmp24_);
#line 367 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->main_buffer);
#line 367 "../lib/DockRenderer.vala"
		self->priv->main_buffer = _tmp25_;
#line 368 "../lib/DockRenderer.vala"
		_tmp26_ = self->priv->main_buffer;
#line 368 "../lib/DockRenderer.vala"
		_tmp27_ = plank_surface_get_Internal (_tmp26_);
#line 368 "../lib/DockRenderer.vala"
		_tmp28_ = _tmp27_;
#line 368 "../lib/DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp28_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1526 "DockRenderer.c"
	}
#line 371 "../lib/DockRenderer.vala"
	_tmp29_ = self->priv->item_buffer;
#line 371 "../lib/DockRenderer.vala"
	if (_tmp29_ == NULL) {
#line 1532 "DockRenderer.c"
		GdkRectangle _tmp30_;
		GdkRectangle _tmp31_;
		cairo_surface_t* _tmp32_;
		PlankSurface* _tmp33_;
		PlankSurface* _tmp34_;
		cairo_surface_t* _tmp35_;
		cairo_surface_t* _tmp36_;
#line 372 "../lib/DockRenderer.vala"
		_tmp30_ = win_rect;
#line 372 "../lib/DockRenderer.vala"
		_tmp31_ = win_rect;
#line 372 "../lib/DockRenderer.vala"
		_tmp32_ = cairo_get_target (cr);
#line 372 "../lib/DockRenderer.vala"
		_tmp33_ = plank_surface_new_with_cairo_surface (_tmp30_.width, _tmp31_.height, _tmp32_);
#line 372 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->item_buffer);
#line 372 "../lib/DockRenderer.vala"
		self->priv->item_buffer = _tmp33_;
#line 373 "../lib/DockRenderer.vala"
		_tmp34_ = self->priv->item_buffer;
#line 373 "../lib/DockRenderer.vala"
		_tmp35_ = plank_surface_get_Internal (_tmp34_);
#line 373 "../lib/DockRenderer.vala"
		_tmp36_ = _tmp35_;
#line 373 "../lib/DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp36_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1560 "DockRenderer.c"
	}
#line 376 "../lib/DockRenderer.vala"
	_tmp37_ = self->priv->shadow_buffer;
#line 376 "../lib/DockRenderer.vala"
	if (_tmp37_ == NULL) {
#line 1566 "DockRenderer.c"
		GdkRectangle _tmp38_;
		GdkRectangle _tmp39_;
		cairo_surface_t* _tmp40_;
		PlankSurface* _tmp41_;
		PlankSurface* _tmp42_;
		cairo_surface_t* _tmp43_;
		cairo_surface_t* _tmp44_;
#line 377 "../lib/DockRenderer.vala"
		_tmp38_ = win_rect;
#line 377 "../lib/DockRenderer.vala"
		_tmp39_ = win_rect;
#line 377 "../lib/DockRenderer.vala"
		_tmp40_ = cairo_get_target (cr);
#line 377 "../lib/DockRenderer.vala"
		_tmp41_ = plank_surface_new_with_cairo_surface (_tmp38_.width, _tmp39_.height, _tmp40_);
#line 377 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->shadow_buffer);
#line 377 "../lib/DockRenderer.vala"
		self->priv->shadow_buffer = _tmp41_;
#line 378 "../lib/DockRenderer.vala"
		_tmp42_ = self->priv->shadow_buffer;
#line 378 "../lib/DockRenderer.vala"
		_tmp43_ = plank_surface_get_Internal (_tmp42_);
#line 378 "../lib/DockRenderer.vala"
		_tmp44_ = _tmp43_;
#line 378 "../lib/DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp44_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1594 "DockRenderer.c"
	}
#line 384 "../lib/DockRenderer.vala"
	if (no_full_draw_needed) {
#line 1598 "DockRenderer.c"
		gdouble _tmp47_;
#line 384 "../lib/DockRenderer.vala"
		_tmp47_ = self->priv->_hide_progress;
#line 384 "../lib/DockRenderer.vala"
		_tmp46_ = _tmp47_ == 1.0;
#line 1604 "DockRenderer.c"
	} else {
#line 384 "../lib/DockRenderer.vala"
		_tmp46_ = FALSE;
#line 1608 "DockRenderer.c"
	}
#line 384 "../lib/DockRenderer.vala"
	if (_tmp46_) {
#line 1612 "DockRenderer.c"
		gdouble _tmp48_;
#line 384 "../lib/DockRenderer.vala"
		_tmp48_ = self->priv->_opacity;
#line 384 "../lib/DockRenderer.vala"
		_tmp45_ = _tmp48_ == 1.0;
#line 1618 "DockRenderer.c"
	} else {
#line 384 "../lib/DockRenderer.vala"
		_tmp45_ = FALSE;
#line 1622 "DockRenderer.c"
	}
#line 384 "../lib/DockRenderer.vala"
	if (_tmp45_) {
#line 386 "../lib/DockRenderer.vala"
		cairo_save (cr);
#line 387 "../lib/DockRenderer.vala"
		cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
#line 388 "../lib/DockRenderer.vala"
		cairo_paint (cr);
#line 389 "../lib/DockRenderer.vala"
		cairo_restore (cr);
#line 391 "../lib/DockRenderer.vala"
		if (self->priv->show_notifications) {
#line 1636 "DockRenderer.c"
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp49_;
				gint _item_size = 0;
				GeeArrayList* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				gint _item_index = 0;
#line 392 "../lib/DockRenderer.vala"
				_tmp49_ = self->priv->current_items;
#line 392 "../lib/DockRenderer.vala"
				_item_list = _tmp49_;
#line 392 "../lib/DockRenderer.vala"
				_tmp50_ = _item_list;
#line 392 "../lib/DockRenderer.vala"
				_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
#line 392 "../lib/DockRenderer.vala"
				_tmp52_ = _tmp51_;
#line 392 "../lib/DockRenderer.vala"
				_item_size = _tmp52_;
#line 392 "../lib/DockRenderer.vala"
				_item_index = -1;
#line 392 "../lib/DockRenderer.vala"
				while (TRUE) {
#line 1661 "DockRenderer.c"
					gint _tmp53_;
					gint _tmp54_;
					PlankDockItem* item = NULL;
					GeeArrayList* _tmp55_;
					gpointer _tmp56_;
					PlankDockItem* _tmp57_;
#line 392 "../lib/DockRenderer.vala"
					_item_index = _item_index + 1;
#line 392 "../lib/DockRenderer.vala"
					_tmp53_ = _item_index;
#line 392 "../lib/DockRenderer.vala"
					_tmp54_ = _item_size;
#line 392 "../lib/DockRenderer.vala"
					if (!(_tmp53_ < _tmp54_)) {
#line 392 "../lib/DockRenderer.vala"
						break;
#line 1678 "DockRenderer.c"
					}
#line 392 "../lib/DockRenderer.vala"
					_tmp55_ = _item_list;
#line 392 "../lib/DockRenderer.vala"
					_tmp56_ = gee_abstract_list_get ((GeeAbstractList*) _tmp55_, _item_index);
#line 392 "../lib/DockRenderer.vala"
					item = (PlankDockItem*) _tmp56_;
#line 393 "../lib/DockRenderer.vala"
					_tmp57_ = item;
#line 393 "../lib/DockRenderer.vala"
					plank_dock_renderer_draw_urgent_glow (self, _tmp57_, cr, _data1_->frame_time);
#line 1690 "DockRenderer.c"
				}
			}
		}
#line 395 "../lib/DockRenderer.vala"
		block1_data_unref (_data1_);
#line 395 "../lib/DockRenderer.vala"
		_data1_ = NULL;
#line 395 "../lib/DockRenderer.vala"
		return;
#line 1700 "DockRenderer.c"
	}
#line 398 "../lib/DockRenderer.vala"
	_tmp59_ = self->priv->_opacity;
#line 398 "../lib/DockRenderer.vala"
	if (_tmp59_ < 1.0) {
#line 1706 "DockRenderer.c"
		PlankSurface* _tmp60_;
#line 398 "../lib/DockRenderer.vala"
		_tmp60_ = self->priv->fade_buffer;
#line 398 "../lib/DockRenderer.vala"
		_tmp58_ = _tmp60_ == NULL;
#line 1712 "DockRenderer.c"
	} else {
#line 398 "../lib/DockRenderer.vala"
		_tmp58_ = FALSE;
#line 1716 "DockRenderer.c"
	}
#line 398 "../lib/DockRenderer.vala"
	if (_tmp58_) {
#line 1720 "DockRenderer.c"
		GdkRectangle _tmp61_;
		GdkRectangle _tmp62_;
		cairo_surface_t* _tmp63_;
		PlankSurface* _tmp64_;
		PlankSurface* _tmp65_;
		cairo_surface_t* _tmp66_;
		cairo_surface_t* _tmp67_;
#line 399 "../lib/DockRenderer.vala"
		_tmp61_ = win_rect;
#line 399 "../lib/DockRenderer.vala"
		_tmp62_ = win_rect;
#line 399 "../lib/DockRenderer.vala"
		_tmp63_ = cairo_get_target (cr);
#line 399 "../lib/DockRenderer.vala"
		_tmp64_ = plank_surface_new_with_cairo_surface (_tmp61_.width, _tmp62_.height, _tmp63_);
#line 399 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->fade_buffer);
#line 399 "../lib/DockRenderer.vala"
		self->priv->fade_buffer = _tmp64_;
#line 400 "../lib/DockRenderer.vala"
		_tmp65_ = self->priv->fade_buffer;
#line 400 "../lib/DockRenderer.vala"
		_tmp66_ = plank_surface_get_Internal (_tmp65_);
#line 400 "../lib/DockRenderer.vala"
		_tmp67_ = _tmp66_;
#line 400 "../lib/DockRenderer.vala"
		cairo_surface_set_device_scale (_tmp67_, (gdouble) self->priv->window_scale_factor, (gdouble) self->priv->window_scale_factor);
#line 1748 "DockRenderer.c"
	}
#line 409 "../lib/DockRenderer.vala"
	_tmp68_ = self->priv->main_buffer;
#line 409 "../lib/DockRenderer.vala"
	plank_surface_clear (_tmp68_);
#line 410 "../lib/DockRenderer.vala"
	_tmp69_ = self->priv->item_buffer;
#line 410 "../lib/DockRenderer.vala"
	plank_surface_clear (_tmp69_);
#line 411 "../lib/DockRenderer.vala"
	_tmp70_ = self->priv->shadow_buffer;
#line 411 "../lib/DockRenderer.vala"
	plank_surface_clear (_tmp70_);
#line 412 "../lib/DockRenderer.vala"
	_tmp71_ = self->priv->item_buffer;
#line 412 "../lib/DockRenderer.vala"
	_tmp72_ = plank_surface_get_Context (_tmp71_);
#line 412 "../lib/DockRenderer.vala"
	_tmp73_ = _tmp72_;
#line 412 "../lib/DockRenderer.vala"
	item_cr = _tmp73_;
#line 413 "../lib/DockRenderer.vala"
	_tmp74_ = self->priv->shadow_buffer;
#line 413 "../lib/DockRenderer.vala"
	_tmp75_ = plank_surface_get_Context (_tmp74_);
#line 413 "../lib/DockRenderer.vala"
	_tmp76_ = _tmp75_;
#line 413 "../lib/DockRenderer.vala"
	shadow_cr = _tmp76_;
#line 416 "../lib/DockRenderer.vala"
	x_offset = 0;
#line 416 "../lib/DockRenderer.vala"
	y_offset = 0;
#line 417 "../lib/DockRenderer.vala"
	_tmp77_ = self->priv->_opacity;
#line 417 "../lib/DockRenderer.vala"
	if (_tmp77_ == 1.0) {
#line 1786 "DockRenderer.c"
		PlankPositionManager* _tmp78_;
		gint _tmp79_ = 0;
		gint _tmp80_ = 0;
#line 418 "../lib/DockRenderer.vala"
		_tmp78_ = position_manager;
#line 418 "../lib/DockRenderer.vala"
		plank_position_manager_get_dock_draw_position (_tmp78_, &_tmp79_, &_tmp80_);
#line 418 "../lib/DockRenderer.vala"
		x_offset = _tmp79_;
#line 418 "../lib/DockRenderer.vala"
		y_offset = _tmp80_;
#line 1798 "DockRenderer.c"
	}
#line 421 "../lib/DockRenderer.vala"
	_tmp81_ = self->priv->main_buffer;
#line 421 "../lib/DockRenderer.vala"
	plank_surface_clear (_tmp81_);
#line 422 "../lib/DockRenderer.vala"
	_tmp82_ = self->priv->main_buffer;
#line 422 "../lib/DockRenderer.vala"
	_tmp83_ = plank_surface_get_Context (_tmp82_);
#line 422 "../lib/DockRenderer.vala"
	_tmp84_ = _tmp83_;
#line 422 "../lib/DockRenderer.vala"
	main_cr = _tmp84_;
#line 423 "../lib/DockRenderer.vala"
	_tmp85_ = main_cr;
#line 423 "../lib/DockRenderer.vala"
	cairo_set_operator (_tmp85_, CAIRO_OPERATOR_OVER);
#line 429 "../lib/DockRenderer.vala"
	_tmp86_ = main_cr;
#line 429 "../lib/DockRenderer.vala"
	_tmp87_ = self->priv->background_rect;
#line 429 "../lib/DockRenderer.vala"
	plank_dock_renderer_draw_dock_background (self, _tmp86_, &_tmp87_, x_offset, y_offset);
#line 1822 "DockRenderer.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp88_;
		gint _item_size = 0;
		GeeArrayList* _tmp89_;
		gint _tmp90_;
		gint _tmp91_;
		gint _item_index = 0;
#line 436 "../lib/DockRenderer.vala"
		_tmp88_ = self->priv->current_items;
#line 436 "../lib/DockRenderer.vala"
		_item_list = _tmp88_;
#line 436 "../lib/DockRenderer.vala"
		_tmp89_ = _item_list;
#line 436 "../lib/DockRenderer.vala"
		_tmp90_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp89_);
#line 436 "../lib/DockRenderer.vala"
		_tmp91_ = _tmp90_;
#line 436 "../lib/DockRenderer.vala"
		_item_size = _tmp91_;
#line 436 "../lib/DockRenderer.vala"
		_item_index = -1;
#line 436 "../lib/DockRenderer.vala"
		while (TRUE) {
#line 1847 "DockRenderer.c"
			gint _tmp92_;
			gint _tmp93_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp94_;
			gpointer _tmp95_;
			gboolean _tmp96_ = FALSE;
			PlankDockItem* _tmp97_;
			gboolean _tmp98_;
			gboolean _tmp99_;
#line 436 "../lib/DockRenderer.vala"
			_item_index = _item_index + 1;
#line 436 "../lib/DockRenderer.vala"
			_tmp92_ = _item_index;
#line 436 "../lib/DockRenderer.vala"
			_tmp93_ = _item_size;
#line 436 "../lib/DockRenderer.vala"
			if (!(_tmp92_ < _tmp93_)) {
#line 436 "../lib/DockRenderer.vala"
				break;
#line 1867 "DockRenderer.c"
			}
#line 436 "../lib/DockRenderer.vala"
			_tmp94_ = _item_list;
#line 436 "../lib/DockRenderer.vala"
			_tmp95_ = gee_abstract_list_get ((GeeAbstractList*) _tmp94_, _item_index);
#line 436 "../lib/DockRenderer.vala"
			item = (PlankDockItem*) _tmp95_;
#line 441 "../lib/DockRenderer.vala"
			_tmp97_ = item;
#line 441 "../lib/DockRenderer.vala"
			_tmp98_ = plank_dock_element_get_IsVisible ((PlankDockElement*) _tmp97_);
#line 441 "../lib/DockRenderer.vala"
			_tmp99_ = _tmp98_;
#line 441 "../lib/DockRenderer.vala"
			if (_tmp99_) {
#line 1883 "DockRenderer.c"
				PlankDockItem* _tmp100_;
				PlankDockItem* _tmp101_;
#line 441 "../lib/DockRenderer.vala"
				_tmp100_ = dragged_item;
#line 441 "../lib/DockRenderer.vala"
				_tmp101_ = item;
#line 441 "../lib/DockRenderer.vala"
				_tmp96_ = _tmp100_ != _tmp101_;
#line 1892 "DockRenderer.c"
			} else {
#line 441 "../lib/DockRenderer.vala"
				_tmp96_ = FALSE;
#line 1896 "DockRenderer.c"
			}
#line 441 "../lib/DockRenderer.vala"
			if (_tmp96_) {
#line 1900 "DockRenderer.c"
				PlankDockItemDrawValue* draw_value = NULL;
				PlankPositionManager* _tmp102_;
				PlankDockItem* _tmp103_;
				PlankDockItemDrawValue* _tmp104_;
				cairo_t* _tmp105_;
				PlankDockItem* _tmp106_;
				PlankDockItemDrawValue* _tmp107_;
				cairo_t* _tmp108_;
				PlankDockItem* _tmp109_;
				PlankDockItemDrawValue* _tmp110_;
#line 442 "../lib/DockRenderer.vala"
				_tmp102_ = position_manager;
#line 442 "../lib/DockRenderer.vala"
				_tmp103_ = item;
#line 442 "../lib/DockRenderer.vala"
				_tmp104_ = plank_position_manager_get_draw_value_for_item (_tmp102_, _tmp103_);
#line 442 "../lib/DockRenderer.vala"
				draw_value = _tmp104_;
#line 443 "../lib/DockRenderer.vala"
				_tmp105_ = item_cr;
#line 443 "../lib/DockRenderer.vala"
				_tmp106_ = item;
#line 443 "../lib/DockRenderer.vala"
				_tmp107_ = draw_value;
#line 443 "../lib/DockRenderer.vala"
				plank_dock_renderer_draw_item (self, _tmp105_, _tmp106_, _tmp107_, _data1_->frame_time);
#line 444 "../lib/DockRenderer.vala"
				_tmp108_ = shadow_cr;
#line 444 "../lib/DockRenderer.vala"
				_tmp109_ = item;
#line 444 "../lib/DockRenderer.vala"
				_tmp110_ = draw_value;
#line 444 "../lib/DockRenderer.vala"
				plank_dock_renderer_draw_item_shadow (self, _tmp108_, _tmp109_, _tmp110_);
#line 441 "../lib/DockRenderer.vala"
				_plank_dock_item_draw_value_unref0 (draw_value);
#line 1937 "DockRenderer.c"
			}
		}
	}
#line 453 "../lib/DockRenderer.vala"
	_tmp111_ = main_cr;
#line 453 "../lib/DockRenderer.vala"
	_tmp112_ = self->priv->shadow_buffer;
#line 453 "../lib/DockRenderer.vala"
	_tmp113_ = plank_surface_get_Internal (_tmp112_);
#line 453 "../lib/DockRenderer.vala"
	_tmp114_ = _tmp113_;
#line 453 "../lib/DockRenderer.vala"
	cairo_set_source_surface (_tmp111_, _tmp114_, (gdouble) x_offset, (gdouble) y_offset);
#line 454 "../lib/DockRenderer.vala"
	_tmp115_ = main_cr;
#line 454 "../lib/DockRenderer.vala"
	cairo_paint (_tmp115_);
#line 457 "../lib/DockRenderer.vala"
	_tmp116_ = main_cr;
#line 457 "../lib/DockRenderer.vala"
	_tmp117_ = self->priv->item_buffer;
#line 457 "../lib/DockRenderer.vala"
	_tmp118_ = plank_surface_get_Internal (_tmp117_);
#line 457 "../lib/DockRenderer.vala"
	_tmp119_ = _tmp118_;
#line 457 "../lib/DockRenderer.vala"
	cairo_set_source_surface (_tmp116_, _tmp119_, (gdouble) x_offset, (gdouble) y_offset);
#line 458 "../lib/DockRenderer.vala"
	_tmp120_ = main_cr;
#line 458 "../lib/DockRenderer.vala"
	cairo_paint (_tmp120_);
#line 461 "../lib/DockRenderer.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 462 "../lib/DockRenderer.vala"
	_tmp121_ = self->priv->_opacity;
#line 462 "../lib/DockRenderer.vala"
	if (_tmp121_ < 1.0) {
#line 1975 "DockRenderer.c"
		PlankSurface* _tmp122_;
		cairo_t* fade_cr = NULL;
		PlankSurface* _tmp123_;
		cairo_t* _tmp124_;
		cairo_t* _tmp125_;
		cairo_t* _tmp126_;
		cairo_t* _tmp127_;
		PlankSurface* _tmp128_;
		cairo_surface_t* _tmp129_;
		cairo_surface_t* _tmp130_;
		cairo_t* _tmp131_;
		gdouble _tmp132_;
		PlankSurface* _tmp133_;
		cairo_surface_t* _tmp134_;
		cairo_surface_t* _tmp135_;
#line 463 "../lib/DockRenderer.vala"
		_tmp122_ = self->priv->fade_buffer;
#line 463 "../lib/DockRenderer.vala"
		plank_surface_clear (_tmp122_);
#line 464 "../lib/DockRenderer.vala"
		_tmp123_ = self->priv->fade_buffer;
#line 464 "../lib/DockRenderer.vala"
		_tmp124_ = plank_surface_get_Context (_tmp123_);
#line 464 "../lib/DockRenderer.vala"
		_tmp125_ = _tmp124_;
#line 464 "../lib/DockRenderer.vala"
		fade_cr = _tmp125_;
#line 465 "../lib/DockRenderer.vala"
		_tmp126_ = fade_cr;
#line 465 "../lib/DockRenderer.vala"
		cairo_set_operator (_tmp126_, CAIRO_OPERATOR_OVER);
#line 466 "../lib/DockRenderer.vala"
		_tmp127_ = fade_cr;
#line 466 "../lib/DockRenderer.vala"
		_tmp128_ = self->priv->main_buffer;
#line 466 "../lib/DockRenderer.vala"
		_tmp129_ = plank_surface_get_Internal (_tmp128_);
#line 466 "../lib/DockRenderer.vala"
		_tmp130_ = _tmp129_;
#line 466 "../lib/DockRenderer.vala"
		cairo_set_source_surface (_tmp127_, _tmp130_, (gdouble) 0, (gdouble) 0);
#line 467 "../lib/DockRenderer.vala"
		_tmp131_ = fade_cr;
#line 467 "../lib/DockRenderer.vala"
		_tmp132_ = self->priv->_opacity;
#line 467 "../lib/DockRenderer.vala"
		cairo_paint_with_alpha (_tmp131_, _tmp132_);
#line 469 "../lib/DockRenderer.vala"
		_tmp133_ = self->priv->fade_buffer;
#line 469 "../lib/DockRenderer.vala"
		_tmp134_ = plank_surface_get_Internal (_tmp133_);
#line 469 "../lib/DockRenderer.vala"
		_tmp135_ = _tmp134_;
#line 469 "../lib/DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp135_, (gdouble) 0, (gdouble) 0);
#line 2031 "DockRenderer.c"
	} else {
		PlankSurface* _tmp136_;
		cairo_surface_t* _tmp137_;
		cairo_surface_t* _tmp138_;
#line 471 "../lib/DockRenderer.vala"
		_tmp136_ = self->priv->main_buffer;
#line 471 "../lib/DockRenderer.vala"
		_tmp137_ = plank_surface_get_Internal (_tmp136_);
#line 471 "../lib/DockRenderer.vala"
		_tmp138_ = _tmp137_;
#line 471 "../lib/DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp138_, (gdouble) 0, (gdouble) 0);
#line 2044 "DockRenderer.c"
	}
#line 473 "../lib/DockRenderer.vala"
	cairo_paint (cr);
#line 476 "../lib/DockRenderer.vala"
	if (self->priv->show_notifications) {
#line 2050 "DockRenderer.c"
		gdouble _tmp140_;
#line 476 "../lib/DockRenderer.vala"
		_tmp140_ = self->priv->_hide_progress;
#line 476 "../lib/DockRenderer.vala"
		_tmp139_ = _tmp140_ == 1.0;
#line 2056 "DockRenderer.c"
	} else {
#line 476 "../lib/DockRenderer.vala"
		_tmp139_ = FALSE;
#line 2060 "DockRenderer.c"
	}
#line 476 "../lib/DockRenderer.vala"
	if (_tmp139_) {
#line 2064 "DockRenderer.c"
		{
			GeeArrayList* _item_list = NULL;
			GeeArrayList* _tmp141_;
			gint _item_size = 0;
			GeeArrayList* _tmp142_;
			gint _tmp143_;
			gint _tmp144_;
			gint _item_index = 0;
#line 477 "../lib/DockRenderer.vala"
			_tmp141_ = self->priv->current_items;
#line 477 "../lib/DockRenderer.vala"
			_item_list = _tmp141_;
#line 477 "../lib/DockRenderer.vala"
			_tmp142_ = _item_list;
#line 477 "../lib/DockRenderer.vala"
			_tmp143_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp142_);
#line 477 "../lib/DockRenderer.vala"
			_tmp144_ = _tmp143_;
#line 477 "../lib/DockRenderer.vala"
			_item_size = _tmp144_;
#line 477 "../lib/DockRenderer.vala"
			_item_index = -1;
#line 477 "../lib/DockRenderer.vala"
			while (TRUE) {
#line 2089 "DockRenderer.c"
				gint _tmp145_;
				gint _tmp146_;
				PlankDockItem* item = NULL;
				GeeArrayList* _tmp147_;
				gpointer _tmp148_;
				PlankDockItem* _tmp149_;
#line 477 "../lib/DockRenderer.vala"
				_item_index = _item_index + 1;
#line 477 "../lib/DockRenderer.vala"
				_tmp145_ = _item_index;
#line 477 "../lib/DockRenderer.vala"
				_tmp146_ = _item_size;
#line 477 "../lib/DockRenderer.vala"
				if (!(_tmp145_ < _tmp146_)) {
#line 477 "../lib/DockRenderer.vala"
					break;
#line 2106 "DockRenderer.c"
				}
#line 477 "../lib/DockRenderer.vala"
				_tmp147_ = _item_list;
#line 477 "../lib/DockRenderer.vala"
				_tmp148_ = gee_abstract_list_get ((GeeAbstractList*) _tmp147_, _item_index);
#line 477 "../lib/DockRenderer.vala"
				item = (PlankDockItem*) _tmp148_;
#line 478 "../lib/DockRenderer.vala"
				_tmp149_ = item;
#line 478 "../lib/DockRenderer.vala"
				plank_dock_renderer_draw_urgent_glow (self, _tmp149_, cr, _data1_->frame_time);
#line 2118 "DockRenderer.c"
			}
		}
	}
#line 490 "../lib/DockRenderer.vala"
	if (self->priv->is_first_frame) {
#line 2124 "DockRenderer.c"
		cairo_surface_t* _tmp150_;
		const gchar* _tmp151_;
#line 491 "../lib/DockRenderer.vala"
		_tmp150_ = cairo_get_target (cr);
#line 491 "../lib/DockRenderer.vala"
		_tmp151_ = plank_dock_renderer_cairo_surface_type_to_string (cairo_surface_get_type (_tmp150_));
#line 491 "../lib/DockRenderer.vala"
		g_message ("DockRenderer.vala:491: Cairo.SurfaceType: %s", _tmp151_);
#line 493 "../lib/DockRenderer.vala"
		gdk_threads_add_idle_full (G_PRIORITY_LOW, ____lambda47__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 514 "../lib/DockRenderer.vala"
		self->priv->is_first_frame = FALSE;
#line 2137 "DockRenderer.c"
	}
#line 349 "../lib/DockRenderer.vala"
	block1_data_unref (_data1_);
#line 349 "../lib/DockRenderer.vala"
	_data1_ = NULL;
#line 2143 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_dock_background (PlankDockRenderer* self,
                                          cairo_t* cr,
                                          GdkRectangle* background_rect,
                                          gint x_offset,
                                          gint y_offset)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GdkRectangle _tmp4_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	PlankSurface* _tmp8_;
	gboolean _tmp25_ = FALSE;
	gdouble _tmp26_;
	PlankSurface* _tmp35_;
	cairo_surface_t* _tmp36_;
	cairo_surface_t* _tmp37_;
	GdkRectangle _tmp38_;
	GdkRectangle _tmp39_;
#line 518 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 518 "../lib/DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 518 "../lib/DockRenderer.vala"
	g_return_if_fail (background_rect != NULL);
#line 520 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 520 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 520 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 520 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 522 "../lib/DockRenderer.vala"
	_tmp4_ = *background_rect;
#line 522 "../lib/DockRenderer.vala"
	if (_tmp4_.width <= 0) {
#line 522 "../lib/DockRenderer.vala"
		_tmp3_ = TRUE;
#line 2189 "DockRenderer.c"
	} else {
		GdkRectangle _tmp5_;
#line 522 "../lib/DockRenderer.vala"
		_tmp5_ = *background_rect;
#line 522 "../lib/DockRenderer.vala"
		_tmp3_ = _tmp5_.height <= 0;
#line 2196 "DockRenderer.c"
	}
#line 522 "../lib/DockRenderer.vala"
	if (_tmp3_) {
#line 523 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->background_buffer);
#line 523 "../lib/DockRenderer.vala"
		self->priv->background_buffer = NULL;
#line 524 "../lib/DockRenderer.vala"
		return;
#line 2206 "DockRenderer.c"
	}
#line 527 "../lib/DockRenderer.vala"
	_tmp8_ = self->priv->background_buffer;
#line 527 "../lib/DockRenderer.vala"
	if (_tmp8_ == NULL) {
#line 527 "../lib/DockRenderer.vala"
		_tmp7_ = TRUE;
#line 2214 "DockRenderer.c"
	} else {
		PlankSurface* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		GdkRectangle _tmp12_;
#line 527 "../lib/DockRenderer.vala"
		_tmp9_ = self->priv->background_buffer;
#line 527 "../lib/DockRenderer.vala"
		_tmp10_ = plank_surface_get_Width (_tmp9_);
#line 527 "../lib/DockRenderer.vala"
		_tmp11_ = _tmp10_;
#line 527 "../lib/DockRenderer.vala"
		_tmp12_ = *background_rect;
#line 527 "../lib/DockRenderer.vala"
		_tmp7_ = _tmp11_ != _tmp12_.width;
#line 2230 "DockRenderer.c"
	}
#line 527 "../lib/DockRenderer.vala"
	if (_tmp7_) {
#line 527 "../lib/DockRenderer.vala"
		_tmp6_ = TRUE;
#line 2236 "DockRenderer.c"
	} else {
		PlankSurface* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkRectangle _tmp16_;
#line 528 "../lib/DockRenderer.vala"
		_tmp13_ = self->priv->background_buffer;
#line 528 "../lib/DockRenderer.vala"
		_tmp14_ = plank_surface_get_Height (_tmp13_);
#line 528 "../lib/DockRenderer.vala"
		_tmp15_ = _tmp14_;
#line 528 "../lib/DockRenderer.vala"
		_tmp16_ = *background_rect;
#line 528 "../lib/DockRenderer.vala"
		_tmp6_ = _tmp15_ != _tmp16_.height;
#line 2252 "DockRenderer.c"
	}
#line 527 "../lib/DockRenderer.vala"
	if (_tmp6_) {
#line 2256 "DockRenderer.c"
		PlankDockTheme* _tmp17_;
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
		PlankPositionManager* _tmp20_;
		GtkPositionType _tmp21_;
		GtkPositionType _tmp22_;
		PlankSurface* _tmp23_;
		PlankSurface* _tmp24_;
#line 529 "../lib/DockRenderer.vala"
		_tmp17_ = self->priv->_theme;
#line 529 "../lib/DockRenderer.vala"
		_tmp18_ = *background_rect;
#line 529 "../lib/DockRenderer.vala"
		_tmp19_ = *background_rect;
#line 529 "../lib/DockRenderer.vala"
		_tmp20_ = position_manager;
#line 529 "../lib/DockRenderer.vala"
		_tmp21_ = plank_position_manager_get_Position (_tmp20_);
#line 529 "../lib/DockRenderer.vala"
		_tmp22_ = _tmp21_;
#line 529 "../lib/DockRenderer.vala"
		_tmp23_ = self->priv->main_buffer;
#line 529 "../lib/DockRenderer.vala"
		_tmp24_ = plank_dock_theme_create_background (_tmp17_, _tmp18_.width, _tmp19_.height, _tmp22_, _tmp23_);
#line 529 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->background_buffer);
#line 529 "../lib/DockRenderer.vala"
		self->priv->background_buffer = _tmp24_;
#line 2285 "DockRenderer.c"
	}
#line 532 "../lib/DockRenderer.vala"
	_tmp26_ = self->priv->_hide_progress;
#line 532 "../lib/DockRenderer.vala"
	if (_tmp26_ > 0.0) {
#line 2291 "DockRenderer.c"
		PlankDockTheme* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 532 "../lib/DockRenderer.vala"
		_tmp27_ = self->priv->_theme;
#line 532 "../lib/DockRenderer.vala"
		_tmp28_ = plank_dock_theme_get_CascadeHide (_tmp27_);
#line 532 "../lib/DockRenderer.vala"
		_tmp29_ = _tmp28_;
#line 532 "../lib/DockRenderer.vala"
		_tmp25_ = _tmp29_;
#line 2303 "DockRenderer.c"
	} else {
#line 532 "../lib/DockRenderer.vala"
		_tmp25_ = FALSE;
#line 2307 "DockRenderer.c"
	}
#line 532 "../lib/DockRenderer.vala"
	if (_tmp25_) {
#line 2311 "DockRenderer.c"
		gint x = 0;
		gint y = 0;
		PlankPositionManager* _tmp30_;
		gint _tmp31_ = 0;
		gint _tmp32_ = 0;
		gdouble _tmp33_;
		gdouble _tmp34_;
#line 534 "../lib/DockRenderer.vala"
		_tmp30_ = position_manager;
#line 534 "../lib/DockRenderer.vala"
		plank_position_manager_get_background_padding (_tmp30_, &_tmp31_, &_tmp32_);
#line 534 "../lib/DockRenderer.vala"
		x = _tmp31_;
#line 534 "../lib/DockRenderer.vala"
		y = _tmp32_;
#line 535 "../lib/DockRenderer.vala"
		_tmp33_ = self->priv->_hide_progress;
#line 535 "../lib/DockRenderer.vala"
		x_offset = x_offset - ((gint) (x * _tmp33_));
#line 536 "../lib/DockRenderer.vala"
		_tmp34_ = self->priv->_hide_progress;
#line 536 "../lib/DockRenderer.vala"
		y_offset = y_offset - ((gint) (y * _tmp34_));
#line 2335 "DockRenderer.c"
	}
#line 539 "../lib/DockRenderer.vala"
	_tmp35_ = self->priv->background_buffer;
#line 539 "../lib/DockRenderer.vala"
	_tmp36_ = plank_surface_get_Internal (_tmp35_);
#line 539 "../lib/DockRenderer.vala"
	_tmp37_ = _tmp36_;
#line 539 "../lib/DockRenderer.vala"
	_tmp38_ = *background_rect;
#line 539 "../lib/DockRenderer.vala"
	_tmp39_ = *background_rect;
#line 539 "../lib/DockRenderer.vala"
	cairo_set_source_surface (cr, _tmp37_, (gdouble) (_tmp38_.x + x_offset), (gdouble) (_tmp39_.y + y_offset));
#line 540 "../lib/DockRenderer.vala"
	cairo_paint (cr);
#line 2351 "DockRenderer.c"
}

static void
plank_dock_renderer_animate_draw_value_for_item (PlankDockItem* item,
                                                 PlankDockItemDrawValue* draw_value,
                                                 PlankDockRenderer* self)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankDockItem* hovered_item = NULL;
	PlankDockController* _tmp3_;
	PlankDockWindow* _tmp4_;
	PlankDockWindow* _tmp5_;
	PlankDockItem* _tmp6_;
	PlankDockItem* _tmp7_;
	PlankDragManager* drag_manager = NULL;
	PlankDockController* _tmp8_;
	PlankDragManager* _tmp9_;
	PlankDragManager* _tmp10_;
	gint icon_size = 0;
	GtkPositionType position = 0;
	PlankPositionManager* _tmp11_;
	GtkPositionType _tmp12_;
	GtkPositionType _tmp13_;
	gdouble x_offset = 0.0;
	gdouble y_offset = 0.0;
	gint _tmp14_ = 0;
	PlankAnimationType _tmp15_;
	PlankAnimationType _tmp16_;
	gint max_click_time = 0;
	gint64 click_time = 0LL;
	gint64 _tmp23_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	gint64 _tmp26_;
	guint max_scroll_time = 0U;
	gint64 scroll_time = 0LL;
	gint64 _tmp32_;
	gint64 _tmp33_;
	gint64 _tmp34_;
	gint64 _tmp35_;
	guint max_hover_time = 0U;
	gint64 hover_time = 0LL;
	gint64 _tmp38_;
	gint64 _tmp39_;
	gint64 _tmp40_;
	gint64 _tmp41_;
	gboolean _tmp46_ = FALSE;
	PlankDockItem* _tmp47_;
	gboolean _tmp60_ = FALSE;
	gboolean _tmp61_ = FALSE;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp74_;
	PlankDockContainer* _tmp75_;
	gboolean _tmp76_ = FALSE;
	gboolean allow_animation = FALSE;
	gboolean _tmp84_ = FALSE;
	PlankItemState _tmp121_;
	PlankItemState _tmp122_;
	PlankItemState _tmp141_;
	PlankItemState _tmp142_;
#line 544 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 544 "../lib/DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 544 "../lib/DockRenderer.vala"
	g_return_if_fail (draw_value != NULL);
#line 546 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 546 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 546 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 546 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 547 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->_controller;
#line 547 "../lib/DockRenderer.vala"
	_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 547 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 547 "../lib/DockRenderer.vala"
	_tmp6_ = plank_dock_window_get_HoveredItem (_tmp5_);
#line 547 "../lib/DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 547 "../lib/DockRenderer.vala"
	hovered_item = _tmp7_;
#line 548 "../lib/DockRenderer.vala"
	_tmp8_ = self->priv->_controller;
#line 548 "../lib/DockRenderer.vala"
	_tmp9_ = plank_dock_controller_get_drag_manager (_tmp8_);
#line 548 "../lib/DockRenderer.vala"
	_tmp10_ = _tmp9_;
#line 548 "../lib/DockRenderer.vala"
	drag_manager = _tmp10_;
#line 550 "../lib/DockRenderer.vala"
	icon_size = (gint) draw_value->icon_size;
#line 551 "../lib/DockRenderer.vala"
	_tmp11_ = position_manager;
#line 551 "../lib/DockRenderer.vala"
	_tmp12_ = plank_position_manager_get_Position (_tmp11_);
#line 551 "../lib/DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 551 "../lib/DockRenderer.vala"
	position = _tmp13_;
#line 552 "../lib/DockRenderer.vala"
	x_offset = 0.0;
#line 552 "../lib/DockRenderer.vala"
	y_offset = 0.0;
#line 555 "../lib/DockRenderer.vala"
	_tmp15_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 555 "../lib/DockRenderer.vala"
	_tmp16_ = _tmp15_;
#line 555 "../lib/DockRenderer.vala"
	if (_tmp16_ == PLANK_ANIMATION_TYPE_BOUNCE) {
#line 2469 "DockRenderer.c"
		PlankDockTheme* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 555 "../lib/DockRenderer.vala"
		_tmp17_ = self->priv->_theme;
#line 555 "../lib/DockRenderer.vala"
		_tmp18_ = plank_dock_theme_get_LaunchBounceTime (_tmp17_);
#line 555 "../lib/DockRenderer.vala"
		_tmp19_ = _tmp18_;
#line 555 "../lib/DockRenderer.vala"
		_tmp14_ = _tmp19_;
#line 2481 "DockRenderer.c"
	} else {
		PlankDockTheme* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 555 "../lib/DockRenderer.vala"
		_tmp20_ = self->priv->_theme;
#line 555 "../lib/DockRenderer.vala"
		_tmp21_ = plank_dock_theme_get_ClickTime (_tmp20_);
#line 555 "../lib/DockRenderer.vala"
		_tmp22_ = _tmp21_;
#line 555 "../lib/DockRenderer.vala"
		_tmp14_ = _tmp22_;
#line 2494 "DockRenderer.c"
	}
#line 555 "../lib/DockRenderer.vala"
	max_click_time = _tmp14_;
#line 556 "../lib/DockRenderer.vala"
	max_click_time *= 1000;
#line 557 "../lib/DockRenderer.vala"
	_tmp23_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 557 "../lib/DockRenderer.vala"
	_tmp24_ = _tmp23_;
#line 557 "../lib/DockRenderer.vala"
	_tmp25_ = plank_dock_element_get_LastClicked ((PlankDockElement*) item);
#line 557 "../lib/DockRenderer.vala"
	_tmp26_ = _tmp25_;
#line 557 "../lib/DockRenderer.vala"
	click_time = MAX (0LL, _tmp24_ - _tmp26_);
#line 558 "../lib/DockRenderer.vala"
	if (click_time < ((gint64) max_click_time)) {
#line 2512 "DockRenderer.c"
		gdouble click_animation_progress = 0.0;
		PlankAnimationType _tmp27_;
		PlankAnimationType _tmp28_;
#line 559 "../lib/DockRenderer.vala"
		click_animation_progress = click_time / ((gdouble) max_click_time);
#line 561 "../lib/DockRenderer.vala"
		_tmp27_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 561 "../lib/DockRenderer.vala"
		_tmp28_ = _tmp27_;
#line 561 "../lib/DockRenderer.vala"
		switch (_tmp28_) {
#line 2524 "DockRenderer.c"
			default:
#line 561 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_NONE:
#line 2528 "DockRenderer.c"
			{
#line 564 "../lib/DockRenderer.vala"
				break;
#line 2532 "DockRenderer.c"
			}
#line 561 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_BOUNCE:
#line 2536 "DockRenderer.c"
			{
#line 566 "../lib/DockRenderer.vala"
				if (self->priv->screen_is_composited) {
#line 2540 "DockRenderer.c"
					PlankPositionManager* _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
#line 567 "../lib/DockRenderer.vala"
					_tmp29_ = position_manager;
#line 567 "../lib/DockRenderer.vala"
					_tmp30_ = plank_position_manager_get_LaunchBounceHeight (_tmp29_);
#line 567 "../lib/DockRenderer.vala"
					_tmp31_ = _tmp30_;
#line 567 "../lib/DockRenderer.vala"
					y_offset += _tmp31_ * plank_dock_renderer_easing_bounce ((gdouble) click_time, (gdouble) max_click_time, (gdouble) 2);
#line 2552 "DockRenderer.c"
				}
#line 568 "../lib/DockRenderer.vala"
				break;
#line 2556 "DockRenderer.c"
			}
#line 561 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_DARKEN:
#line 2560 "DockRenderer.c"
			{
#line 570 "../lib/DockRenderer.vala"
				draw_value->darken = MAX ((gdouble) 0, sin (G_PI * click_animation_progress)) * 0.5;
#line 571 "../lib/DockRenderer.vala"
				break;
#line 2566 "DockRenderer.c"
			}
#line 561 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_LIGHTEN:
#line 2570 "DockRenderer.c"
			{
#line 573 "../lib/DockRenderer.vala"
				draw_value->lighten = MAX ((gdouble) 0, sin (G_PI * click_animation_progress)) * 0.5;
#line 574 "../lib/DockRenderer.vala"
				break;
#line 2576 "DockRenderer.c"
			}
		}
	}
#line 579 "../lib/DockRenderer.vala"
	max_scroll_time = PLANK_ITEM_SCROLL_DURATION * 1000;
#line 580 "../lib/DockRenderer.vala"
	_tmp32_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 580 "../lib/DockRenderer.vala"
	_tmp33_ = _tmp32_;
#line 580 "../lib/DockRenderer.vala"
	_tmp34_ = plank_dock_element_get_LastScrolled ((PlankDockElement*) item);
#line 580 "../lib/DockRenderer.vala"
	_tmp35_ = _tmp34_;
#line 580 "../lib/DockRenderer.vala"
	scroll_time = MAX (0LL, _tmp33_ - _tmp35_);
#line 581 "../lib/DockRenderer.vala"
	if (scroll_time < ((gint64) max_scroll_time)) {
#line 2594 "DockRenderer.c"
		gdouble scroll_animation_progress = 0.0;
		PlankAnimationType _tmp36_;
		PlankAnimationType _tmp37_;
#line 582 "../lib/DockRenderer.vala"
		scroll_animation_progress = scroll_time / ((gdouble) max_scroll_time);
#line 584 "../lib/DockRenderer.vala"
		_tmp36_ = plank_dock_element_get_ScrolledAnimation ((PlankDockElement*) item);
#line 584 "../lib/DockRenderer.vala"
		_tmp37_ = _tmp36_;
#line 584 "../lib/DockRenderer.vala"
		switch (_tmp37_) {
#line 2606 "DockRenderer.c"
			default:
#line 584 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_NONE:
#line 2610 "DockRenderer.c"
			{
#line 587 "../lib/DockRenderer.vala"
				break;
#line 2614 "DockRenderer.c"
			}
#line 584 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_DARKEN:
#line 2618 "DockRenderer.c"
			{
#line 589 "../lib/DockRenderer.vala"
				draw_value->darken = MAX ((gdouble) 0, sin (G_PI * scroll_animation_progress)) * 0.5;
#line 590 "../lib/DockRenderer.vala"
				break;
#line 2624 "DockRenderer.c"
			}
#line 584 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_LIGHTEN:
#line 2628 "DockRenderer.c"
			{
#line 592 "../lib/DockRenderer.vala"
				draw_value->lighten = MAX ((gdouble) 0, sin (G_PI * scroll_animation_progress)) * 0.5;
#line 593 "../lib/DockRenderer.vala"
				break;
#line 2634 "DockRenderer.c"
			}
		}
	}
#line 598 "../lib/DockRenderer.vala"
	max_hover_time = PLANK_ITEM_HOVER_DURATION * 1000;
#line 599 "../lib/DockRenderer.vala"
	_tmp38_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 599 "../lib/DockRenderer.vala"
	_tmp39_ = _tmp38_;
#line 599 "../lib/DockRenderer.vala"
	_tmp40_ = plank_dock_element_get_LastHovered ((PlankDockElement*) item);
#line 599 "../lib/DockRenderer.vala"
	_tmp41_ = _tmp40_;
#line 599 "../lib/DockRenderer.vala"
	hover_time = MAX (0LL, _tmp39_ - _tmp41_);
#line 600 "../lib/DockRenderer.vala"
	if (hover_time < ((gint64) max_hover_time)) {
#line 2652 "DockRenderer.c"
		gdouble hover_animation_progress = 0.0;
		PlankDockItem* _tmp42_;
		PlankAnimationType _tmp43_;
		PlankAnimationType _tmp44_;
#line 601 "../lib/DockRenderer.vala"
		hover_animation_progress = 0.0;
#line 602 "../lib/DockRenderer.vala"
		_tmp42_ = hovered_item;
#line 602 "../lib/DockRenderer.vala"
		if (_tmp42_ == item) {
#line 603 "../lib/DockRenderer.vala"
			hover_animation_progress = plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) hover_time, (gdouble) max_hover_time);
#line 2665 "DockRenderer.c"
		} else {
#line 605 "../lib/DockRenderer.vala"
			hover_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) hover_time, (gdouble) max_hover_time);
#line 2669 "DockRenderer.c"
		}
#line 608 "../lib/DockRenderer.vala"
		_tmp43_ = plank_dock_element_get_HoveredAnimation ((PlankDockElement*) item);
#line 608 "../lib/DockRenderer.vala"
		_tmp44_ = _tmp43_;
#line 608 "../lib/DockRenderer.vala"
		switch (_tmp44_) {
#line 2677 "DockRenderer.c"
			default:
#line 608 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_NONE:
#line 2681 "DockRenderer.c"
			{
#line 611 "../lib/DockRenderer.vala"
				break;
#line 2685 "DockRenderer.c"
			}
#line 608 "../lib/DockRenderer.vala"
			case PLANK_ANIMATION_TYPE_LIGHTEN:
#line 2689 "DockRenderer.c"
			{
#line 613 "../lib/DockRenderer.vala"
				draw_value->lighten = hover_animation_progress * 0.2;
#line 614 "../lib/DockRenderer.vala"
				break;
#line 2695 "DockRenderer.c"
			}
		}
	} else {
		PlankDockItem* _tmp45_;
#line 616 "../lib/DockRenderer.vala"
		_tmp45_ = hovered_item;
#line 616 "../lib/DockRenderer.vala"
		if (_tmp45_ == item) {
#line 617 "../lib/DockRenderer.vala"
			draw_value->lighten = 0.2;
#line 2706 "DockRenderer.c"
		}
	}
#line 620 "../lib/DockRenderer.vala"
	_tmp47_ = hovered_item;
#line 620 "../lib/DockRenderer.vala"
	if (_tmp47_ == item) {
#line 2713 "DockRenderer.c"
		PlankDockController* _tmp48_;
		PlankDockWindow* _tmp49_;
		PlankDockWindow* _tmp50_;
#line 620 "../lib/DockRenderer.vala"
		_tmp48_ = self->priv->_controller;
#line 620 "../lib/DockRenderer.vala"
		_tmp49_ = plank_dock_controller_get_window (_tmp48_);
#line 620 "../lib/DockRenderer.vala"
		_tmp50_ = _tmp49_;
#line 620 "../lib/DockRenderer.vala"
		_tmp46_ = plank_dock_window_menu_is_visible (_tmp50_);
#line 2725 "DockRenderer.c"
	} else {
#line 620 "../lib/DockRenderer.vala"
		_tmp46_ = FALSE;
#line 2729 "DockRenderer.c"
	}
#line 620 "../lib/DockRenderer.vala"
	if (_tmp46_) {
#line 621 "../lib/DockRenderer.vala"
		draw_value->darken = draw_value->darken + 0.4;
#line 2735 "DockRenderer.c"
	} else {
		gboolean _tmp51_ = FALSE;
		gboolean _tmp52_ = FALSE;
		PlankDragManager* _tmp53_;
		gboolean _tmp54_;
		gboolean _tmp55_;
#line 622 "../lib/DockRenderer.vala"
		_tmp53_ = drag_manager;
#line 622 "../lib/DockRenderer.vala"
		_tmp54_ = plank_drag_manager_get_ExternalDragActive (_tmp53_);
#line 622 "../lib/DockRenderer.vala"
		_tmp55_ = _tmp54_;
#line 622 "../lib/DockRenderer.vala"
		if (_tmp55_) {
#line 2750 "DockRenderer.c"
			PlankDragManager* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
#line 623 "../lib/DockRenderer.vala"
			_tmp56_ = drag_manager;
#line 623 "../lib/DockRenderer.vala"
			_tmp57_ = plank_drag_manager_get_DragNeedsCheck (_tmp56_);
#line 623 "../lib/DockRenderer.vala"
			_tmp58_ = _tmp57_;
#line 623 "../lib/DockRenderer.vala"
			_tmp52_ = _tmp58_;
#line 2762 "DockRenderer.c"
		} else {
#line 622 "../lib/DockRenderer.vala"
			_tmp52_ = FALSE;
#line 2766 "DockRenderer.c"
		}
#line 622 "../lib/DockRenderer.vala"
		if (_tmp52_) {
#line 2770 "DockRenderer.c"
			PlankDragManager* _tmp59_;
#line 624 "../lib/DockRenderer.vala"
			_tmp59_ = drag_manager;
#line 624 "../lib/DockRenderer.vala"
			_tmp51_ = !plank_drag_manager_drop_is_accepted_by (_tmp59_, item);
#line 2776 "DockRenderer.c"
		} else {
#line 622 "../lib/DockRenderer.vala"
			_tmp51_ = FALSE;
#line 2780 "DockRenderer.c"
		}
#line 622 "../lib/DockRenderer.vala"
		if (_tmp51_) {
#line 625 "../lib/DockRenderer.vala"
			draw_value->darken = draw_value->darken + 0.6;
#line 2786 "DockRenderer.c"
		}
	}
#line 628 "../lib/DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 628 "../lib/DockRenderer.vala"
		_tmp61_ = self->priv->show_notifications;
#line 2793 "DockRenderer.c"
	} else {
#line 628 "../lib/DockRenderer.vala"
		_tmp61_ = FALSE;
#line 2797 "DockRenderer.c"
	}
#line 628 "../lib/DockRenderer.vala"
	if (_tmp61_) {
#line 2801 "DockRenderer.c"
		PlankItemState _tmp62_;
		PlankItemState _tmp63_;
#line 628 "../lib/DockRenderer.vala"
		_tmp62_ = plank_dock_item_get_State (item);
#line 628 "../lib/DockRenderer.vala"
		_tmp63_ = _tmp62_;
#line 628 "../lib/DockRenderer.vala"
		_tmp60_ = (_tmp63_ & PLANK_ITEM_STATE_URGENT) != 0;
#line 2810 "DockRenderer.c"
	} else {
#line 628 "../lib/DockRenderer.vala"
		_tmp60_ = FALSE;
#line 2814 "DockRenderer.c"
	}
#line 628 "../lib/DockRenderer.vala"
	if (_tmp60_) {
#line 2818 "DockRenderer.c"
		gint urgent_duration = 0;
		PlankDockTheme* _tmp64_;
		gint _tmp65_;
		gint _tmp66_;
		gint64 urgent_time = 0LL;
		gint64 _tmp67_;
		gint64 _tmp68_;
		gint64 _tmp69_;
		gint64 _tmp70_;
#line 629 "../lib/DockRenderer.vala"
		_tmp64_ = self->priv->_theme;
#line 629 "../lib/DockRenderer.vala"
		_tmp65_ = plank_dock_theme_get_UrgentBounceTime (_tmp64_);
#line 629 "../lib/DockRenderer.vala"
		_tmp66_ = _tmp65_;
#line 629 "../lib/DockRenderer.vala"
		urgent_duration = _tmp66_ * 1000;
#line 630 "../lib/DockRenderer.vala"
		_tmp67_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 630 "../lib/DockRenderer.vala"
		_tmp68_ = _tmp67_;
#line 630 "../lib/DockRenderer.vala"
		_tmp69_ = plank_dock_element_get_LastUrgent ((PlankDockElement*) item);
#line 630 "../lib/DockRenderer.vala"
		_tmp70_ = _tmp69_;
#line 630 "../lib/DockRenderer.vala"
		urgent_time = MAX (0LL, _tmp68_ - _tmp70_);
#line 631 "../lib/DockRenderer.vala"
		if (urgent_time < ((gint64) urgent_duration)) {
#line 2848 "DockRenderer.c"
			PlankPositionManager* _tmp71_;
			gint _tmp72_;
			gint _tmp73_;
#line 632 "../lib/DockRenderer.vala"
			_tmp71_ = position_manager;
#line 632 "../lib/DockRenderer.vala"
			_tmp72_ = plank_position_manager_get_UrgentBounceHeight (_tmp71_);
#line 632 "../lib/DockRenderer.vala"
			_tmp73_ = _tmp72_;
#line 632 "../lib/DockRenderer.vala"
			y_offset += _tmp73_ * plank_dock_renderer_easing_bounce ((gdouble) urgent_time, (gdouble) urgent_duration, 1.0);
#line 2860 "DockRenderer.c"
		}
	}
#line 636 "../lib/DockRenderer.vala"
	_tmp74_ = plank_dock_element_get_Container ((PlankDockElement*) item);
#line 636 "../lib/DockRenderer.vala"
	_tmp75_ = _tmp74_;
#line 636 "../lib/DockRenderer.vala"
	container = _tmp75_;
#line 637 "../lib/DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 2871 "DockRenderer.c"
		gboolean _tmp77_ = FALSE;
		PlankDockContainer* _tmp78_;
#line 637 "../lib/DockRenderer.vala"
		_tmp78_ = container;
#line 637 "../lib/DockRenderer.vala"
		if (_tmp78_ == NULL) {
#line 637 "../lib/DockRenderer.vala"
			_tmp77_ = TRUE;
#line 2880 "DockRenderer.c"
		} else {
			PlankDockContainer* _tmp79_;
			gint64 _tmp80_;
			gint64 _tmp81_;
			gint64 _tmp82_;
			gint64 _tmp83_;
#line 637 "../lib/DockRenderer.vala"
			_tmp79_ = container;
#line 637 "../lib/DockRenderer.vala"
			_tmp80_ = plank_dock_element_get_AddTime ((PlankDockElement*) _tmp79_);
#line 637 "../lib/DockRenderer.vala"
			_tmp81_ = _tmp80_;
#line 637 "../lib/DockRenderer.vala"
			_tmp82_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 637 "../lib/DockRenderer.vala"
			_tmp83_ = _tmp82_;
#line 637 "../lib/DockRenderer.vala"
			_tmp77_ = _tmp81_ < _tmp83_;
#line 2899 "DockRenderer.c"
		}
#line 637 "../lib/DockRenderer.vala"
		_tmp76_ = _tmp77_;
#line 2903 "DockRenderer.c"
	} else {
#line 637 "../lib/DockRenderer.vala"
		_tmp76_ = FALSE;
#line 2907 "DockRenderer.c"
	}
#line 637 "../lib/DockRenderer.vala"
	allow_animation = _tmp76_;
#line 638 "../lib/DockRenderer.vala"
	if (allow_animation) {
#line 2913 "DockRenderer.c"
		gint64 _tmp85_;
		gint64 _tmp86_;
		gint64 _tmp87_;
		gint64 _tmp88_;
#line 638 "../lib/DockRenderer.vala"
		_tmp85_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 638 "../lib/DockRenderer.vala"
		_tmp86_ = _tmp85_;
#line 638 "../lib/DockRenderer.vala"
		_tmp87_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 638 "../lib/DockRenderer.vala"
		_tmp88_ = _tmp87_;
#line 638 "../lib/DockRenderer.vala"
		_tmp84_ = _tmp86_ > _tmp88_;
#line 2928 "DockRenderer.c"
	} else {
#line 638 "../lib/DockRenderer.vala"
		_tmp84_ = FALSE;
#line 2932 "DockRenderer.c"
	}
#line 638 "../lib/DockRenderer.vala"
	if (_tmp84_) {
#line 2936 "DockRenderer.c"
		gint move_duration = 0;
		PlankDockTheme* _tmp89_;
		gint _tmp90_;
		gint _tmp91_;
		gint64 move_time = 0LL;
		gint64 _tmp92_;
		gint64 _tmp93_;
		gint64 _tmp94_;
		gint64 _tmp95_;
#line 639 "../lib/DockRenderer.vala"
		_tmp89_ = self->priv->_theme;
#line 639 "../lib/DockRenderer.vala"
		_tmp90_ = plank_dock_theme_get_ItemMoveTime (_tmp89_);
#line 639 "../lib/DockRenderer.vala"
		_tmp91_ = _tmp90_;
#line 639 "../lib/DockRenderer.vala"
		move_duration = _tmp91_ * 1000;
#line 640 "../lib/DockRenderer.vala"
		_tmp92_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 640 "../lib/DockRenderer.vala"
		_tmp93_ = _tmp92_;
#line 640 "../lib/DockRenderer.vala"
		_tmp94_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 640 "../lib/DockRenderer.vala"
		_tmp95_ = _tmp94_;
#line 640 "../lib/DockRenderer.vala"
		move_time = MAX (0LL, _tmp93_ - _tmp95_);
#line 641 "../lib/DockRenderer.vala"
		if (move_time < ((gint64) move_duration)) {
#line 2966 "DockRenderer.c"
			gdouble move_animation_progress = 0.0;
			PlankPositionManager* _tmp96_;
			gint _tmp97_;
			gint _tmp98_;
			PlankPositionManager* _tmp99_;
			gint _tmp100_;
			gint _tmp101_;
#line 642 "../lib/DockRenderer.vala"
			move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) move_time, (gdouble) move_duration);
#line 643 "../lib/DockRenderer.vala"
			draw_value->opacity = plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_EXPO, (gdouble) move_time, (gdouble) move_duration);
#line 644 "../lib/DockRenderer.vala"
			_tmp96_ = position_manager;
#line 644 "../lib/DockRenderer.vala"
			_tmp97_ = plank_position_manager_get_BottomPadding (_tmp96_);
#line 644 "../lib/DockRenderer.vala"
			_tmp98_ = _tmp97_;
#line 644 "../lib/DockRenderer.vala"
			y_offset -= move_animation_progress * (icon_size + _tmp98_);
#line 645 "../lib/DockRenderer.vala"
			draw_value->show_indicator = FALSE;
#line 648 "../lib/DockRenderer.vala"
			move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 649 "../lib/DockRenderer.vala"
			_tmp99_ = position_manager;
#line 649 "../lib/DockRenderer.vala"
			_tmp100_ = plank_position_manager_get_ItemPadding (_tmp99_);
#line 649 "../lib/DockRenderer.vala"
			_tmp101_ = _tmp100_;
#line 649 "../lib/DockRenderer.vala"
			self->priv->dynamic_animation_offset = self->priv->dynamic_animation_offset - (move_animation_progress * (icon_size + _tmp101_));
#line 650 "../lib/DockRenderer.vala"
			x_offset += self->priv->dynamic_animation_offset;
#line 3000 "DockRenderer.c"
		}
	} else {
		gboolean _tmp102_ = FALSE;
#line 652 "../lib/DockRenderer.vala"
		if (allow_animation) {
#line 3006 "DockRenderer.c"
			gint64 _tmp103_;
			gint64 _tmp104_;
#line 652 "../lib/DockRenderer.vala"
			_tmp103_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 652 "../lib/DockRenderer.vala"
			_tmp104_ = _tmp103_;
#line 652 "../lib/DockRenderer.vala"
			_tmp102_ = _tmp104_ > ((gint64) 0);
#line 3015 "DockRenderer.c"
		} else {
#line 652 "../lib/DockRenderer.vala"
			_tmp102_ = FALSE;
#line 3019 "DockRenderer.c"
		}
#line 652 "../lib/DockRenderer.vala"
		if (_tmp102_) {
#line 3023 "DockRenderer.c"
			gint move_duration = 0;
			PlankDockTheme* _tmp105_;
			gint _tmp106_;
			gint _tmp107_;
			gint64 move_time = 0LL;
			gint64 _tmp108_;
			gint64 _tmp109_;
			gint64 _tmp110_;
			gint64 _tmp111_;
#line 653 "../lib/DockRenderer.vala"
			_tmp105_ = self->priv->_theme;
#line 653 "../lib/DockRenderer.vala"
			_tmp106_ = plank_dock_theme_get_ItemMoveTime (_tmp105_);
#line 653 "../lib/DockRenderer.vala"
			_tmp107_ = _tmp106_;
#line 653 "../lib/DockRenderer.vala"
			move_duration = _tmp107_ * 1000;
#line 654 "../lib/DockRenderer.vala"
			_tmp108_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 654 "../lib/DockRenderer.vala"
			_tmp109_ = _tmp108_;
#line 654 "../lib/DockRenderer.vala"
			_tmp110_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 654 "../lib/DockRenderer.vala"
			_tmp111_ = _tmp110_;
#line 654 "../lib/DockRenderer.vala"
			move_time = MAX (0LL, _tmp109_ - _tmp111_);
#line 655 "../lib/DockRenderer.vala"
			if (move_time < ((gint64) move_duration)) {
#line 3053 "DockRenderer.c"
				gdouble move_animation_progress = 0.0;
				PlankPositionManager* _tmp112_;
				gint _tmp113_;
				gint _tmp114_;
				PlankPositionManager* _tmp115_;
				gint _tmp116_;
				gint _tmp117_;
				PlankPositionManager* _tmp118_;
				gint _tmp119_;
				gint _tmp120_;
#line 656 "../lib/DockRenderer.vala"
				move_animation_progress = plank_easing_for_mode (PLANK_ANIMATION_MODE_LINEAR, (gdouble) move_time, (gdouble) move_duration);
#line 657 "../lib/DockRenderer.vala"
				draw_value->opacity = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_EXPO, (gdouble) move_time, (gdouble) move_duration);
#line 658 "../lib/DockRenderer.vala"
				_tmp112_ = position_manager;
#line 658 "../lib/DockRenderer.vala"
				_tmp113_ = plank_position_manager_get_BottomPadding (_tmp112_);
#line 658 "../lib/DockRenderer.vala"
				_tmp114_ = _tmp113_;
#line 658 "../lib/DockRenderer.vala"
				y_offset -= move_animation_progress * (icon_size + _tmp114_);
#line 659 "../lib/DockRenderer.vala"
				draw_value->show_indicator = FALSE;
#line 662 "../lib/DockRenderer.vala"
				move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 663 "../lib/DockRenderer.vala"
				_tmp115_ = position_manager;
#line 663 "../lib/DockRenderer.vala"
				_tmp116_ = plank_position_manager_get_ItemPadding (_tmp115_);
#line 663 "../lib/DockRenderer.vala"
				_tmp117_ = _tmp116_;
#line 663 "../lib/DockRenderer.vala"
				self->priv->dynamic_animation_offset = self->priv->dynamic_animation_offset + (move_animation_progress * (icon_size + _tmp117_));
#line 664 "../lib/DockRenderer.vala"
				_tmp118_ = position_manager;
#line 664 "../lib/DockRenderer.vala"
				_tmp119_ = plank_position_manager_get_ItemPadding (_tmp118_);
#line 664 "../lib/DockRenderer.vala"
				_tmp120_ = _tmp119_;
#line 664 "../lib/DockRenderer.vala"
				x_offset += self->priv->dynamic_animation_offset - (icon_size + _tmp120_);
#line 3096 "DockRenderer.c"
			}
		}
	}
#line 669 "../lib/DockRenderer.vala"
	_tmp121_ = plank_dock_item_get_State (item);
#line 669 "../lib/DockRenderer.vala"
	_tmp122_ = _tmp121_;
#line 669 "../lib/DockRenderer.vala"
	if ((_tmp122_ & PLANK_ITEM_STATE_MOVE) != 0) {
#line 3106 "DockRenderer.c"
		gint move_duration = 0;
		PlankDockTheme* _tmp123_;
		gint _tmp124_;
		gint _tmp125_;
		gint64 move_time = 0LL;
		gint64 _tmp126_;
		gint64 _tmp127_;
		gint64 _tmp128_;
		gint64 _tmp129_;
#line 670 "../lib/DockRenderer.vala"
		_tmp123_ = self->priv->_theme;
#line 670 "../lib/DockRenderer.vala"
		_tmp124_ = plank_dock_theme_get_ItemMoveTime (_tmp123_);
#line 670 "../lib/DockRenderer.vala"
		_tmp125_ = _tmp124_;
#line 670 "../lib/DockRenderer.vala"
		move_duration = _tmp125_ * 1000;
#line 671 "../lib/DockRenderer.vala"
		_tmp126_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 671 "../lib/DockRenderer.vala"
		_tmp127_ = _tmp126_;
#line 671 "../lib/DockRenderer.vala"
		_tmp128_ = plank_dock_element_get_LastMove ((PlankDockElement*) item);
#line 671 "../lib/DockRenderer.vala"
		_tmp129_ = _tmp128_;
#line 671 "../lib/DockRenderer.vala"
		move_time = MAX (0LL, _tmp127_ - _tmp129_);
#line 672 "../lib/DockRenderer.vala"
		if (move_time < ((gint64) move_duration)) {
#line 3136 "DockRenderer.c"
			gdouble move_animation_progress = 0.0;
			GeeHashSet* _tmp130_;
			gint _tmp131_;
			gint _tmp132_;
			gdouble change = 0.0;
			PlankPositionManager* _tmp133_;
			gint _tmp134_;
			gint _tmp135_;
			gdouble _tmp136_ = 0.0;
			gint _tmp137_;
			gint _tmp138_;
			gint _tmp139_;
			gint _tmp140_;
#line 673 "../lib/DockRenderer.vala"
			move_animation_progress = 0.0;
#line 674 "../lib/DockRenderer.vala"
			_tmp130_ = self->priv->transient_items;
#line 674 "../lib/DockRenderer.vala"
			_tmp131_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp130_);
#line 674 "../lib/DockRenderer.vala"
			_tmp132_ = _tmp131_;
#line 674 "../lib/DockRenderer.vala"
			if (_tmp132_ > 0) {
#line 675 "../lib/DockRenderer.vala"
				if (self->priv->dynamic_animation_offset > ((gdouble) 0)) {
#line 676 "../lib/DockRenderer.vala"
					move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_IN_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 3164 "DockRenderer.c"
				} else {
#line 678 "../lib/DockRenderer.vala"
					move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_QUINT, (gdouble) move_time, (gdouble) move_duration);
#line 3168 "DockRenderer.c"
				}
			} else {
#line 680 "../lib/DockRenderer.vala"
				move_animation_progress = 1.0 - plank_easing_for_mode (PLANK_ANIMATION_MODE_EASE_OUT_CIRC, (gdouble) move_time, (gdouble) move_duration);
#line 3173 "DockRenderer.c"
			}
#line 682 "../lib/DockRenderer.vala"
			_tmp133_ = position_manager;
#line 682 "../lib/DockRenderer.vala"
			_tmp134_ = plank_position_manager_get_ItemPadding (_tmp133_);
#line 682 "../lib/DockRenderer.vala"
			_tmp135_ = _tmp134_;
#line 682 "../lib/DockRenderer.vala"
			change = move_animation_progress * (icon_size + _tmp135_);
#line 683 "../lib/DockRenderer.vala"
			_tmp137_ = plank_dock_item_get_Position (item);
#line 683 "../lib/DockRenderer.vala"
			_tmp138_ = _tmp137_;
#line 683 "../lib/DockRenderer.vala"
			_tmp139_ = plank_dock_item_get_LastPosition (item);
#line 683 "../lib/DockRenderer.vala"
			_tmp140_ = _tmp139_;
#line 683 "../lib/DockRenderer.vala"
			if (_tmp138_ < _tmp140_) {
#line 683 "../lib/DockRenderer.vala"
				_tmp136_ = change;
#line 3195 "DockRenderer.c"
			} else {
#line 683 "../lib/DockRenderer.vala"
				_tmp136_ = -change;
#line 3199 "DockRenderer.c"
			}
#line 683 "../lib/DockRenderer.vala"
			x_offset += _tmp136_;
#line 3203 "DockRenderer.c"
		} else {
#line 685 "../lib/DockRenderer.vala"
			plank_dock_item_unset_move_state (item);
#line 3207 "DockRenderer.c"
		}
	}
#line 690 "../lib/DockRenderer.vala"
	_tmp141_ = plank_dock_item_get_State (item);
#line 690 "../lib/DockRenderer.vala"
	_tmp142_ = _tmp141_;
#line 690 "../lib/DockRenderer.vala"
	if ((_tmp142_ & PLANK_ITEM_STATE_INVALID) != 0) {
#line 3216 "DockRenderer.c"
		guint invalid_duration = 0U;
		gint64 invalid_time = 0LL;
		gint64 _tmp143_;
		gint64 _tmp144_;
		gint64 _tmp145_;
		gint64 _tmp146_;
#line 691 "../lib/DockRenderer.vala"
		invalid_duration = PLANK_ITEM_INVALID_DURATION * 1000;
#line 692 "../lib/DockRenderer.vala"
		_tmp143_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 692 "../lib/DockRenderer.vala"
		_tmp144_ = _tmp143_;
#line 692 "../lib/DockRenderer.vala"
		_tmp145_ = plank_dock_element_get_LastValid ((PlankDockElement*) item);
#line 692 "../lib/DockRenderer.vala"
		_tmp146_ = _tmp145_;
#line 692 "../lib/DockRenderer.vala"
		invalid_time = MAX (0LL, _tmp144_ - _tmp146_);
#line 693 "../lib/DockRenderer.vala"
		if (invalid_time < ((gint64) invalid_duration)) {
#line 694 "../lib/DockRenderer.vala"
			draw_value->opacity = 0.10 + ((0.90 * (cos (((invalid_time / ((gdouble) invalid_duration)) * 4.5) * G_PI) + 1)) / 2);
#line 3239 "DockRenderer.c"
		} else {
#line 696 "../lib/DockRenderer.vala"
			draw_value->opacity = 0.10;
#line 3243 "DockRenderer.c"
		}
	}
#line 700 "../lib/DockRenderer.vala"
	if (x_offset != 0.0) {
#line 701 "../lib/DockRenderer.vala"
		plank_dock_item_draw_value_move_right (draw_value, position, x_offset);
#line 3250 "DockRenderer.c"
	}
#line 703 "../lib/DockRenderer.vala"
	if (y_offset != 0.0) {
#line 704 "../lib/DockRenderer.vala"
		plank_dock_item_draw_value_move_in (draw_value, position, y_offset);
#line 3256 "DockRenderer.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 708 "../lib/DockRenderer.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 708 "../lib/DockRenderer.vala"
	return _data2_;
#line 3267 "DockRenderer.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 708 "../lib/DockRenderer.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3277 "DockRenderer.c"
		PlankDockRenderer* self;
#line 708 "../lib/DockRenderer.vala"
		self = _data2_->self;
#line 708 "../lib/DockRenderer.vala"
		_g_object_unref0 (self);
#line 708 "../lib/DockRenderer.vala"
		g_slice_free (Block2Data, _data2_);
#line 3285 "DockRenderer.c"
	}
}

static gboolean
__lambda46_ (Block2Data* _data2_,
             PlankDockElement* i,
             PlankDockItemDrawValue* val)
{
	PlankDockRenderer* self;
	gboolean result;
#line 747 "../lib/DockRenderer.vala"
	self = _data2_->self;
#line 747 "../lib/DockRenderer.vala"
	g_return_val_if_fail (i != NULL, FALSE);
#line 748 "../lib/DockRenderer.vala"
	plank_dock_item_draw_value_move_right (val, _data2_->position, _data2_->x_offset);
#line 749 "../lib/DockRenderer.vala"
	result = TRUE;
#line 749 "../lib/DockRenderer.vala"
	return result;
#line 3306 "DockRenderer.c"
}

static gboolean
___lambda46__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda46_ (self, (PlankDockElement*) k, (PlankDockItemDrawValue*) v);
#line 747 "../lib/DockRenderer.vala"
	return result;
#line 3318 "DockRenderer.c"
}

static void
plank_dock_renderer_post_process_draw_values (GeeHashMap* draw_values,
                                              PlankDockRenderer* self)
{
	Block2Data* _data2_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankPositionManager* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	PlankPositionManager* _tmp6_;
	GtkAlign _tmp7_;
	GtkAlign _tmp8_;
	GeeMapIterator* _tmp12_;
	GeeMapIterator* _tmp13_;
#line 708 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 708 "../lib/DockRenderer.vala"
	g_return_if_fail (draw_values != NULL);
#line 708 "../lib/DockRenderer.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 708 "../lib/DockRenderer.vala"
	_data2_->_ref_count_ = 1;
#line 708 "../lib/DockRenderer.vala"
	_data2_->self = g_object_ref (self);
#line 710 "../lib/DockRenderer.vala"
	if (self->priv->dynamic_animation_offset == 0.0) {
#line 711 "../lib/DockRenderer.vala"
		block2_data_unref (_data2_);
#line 711 "../lib/DockRenderer.vala"
		_data2_ = NULL;
#line 711 "../lib/DockRenderer.vala"
		return;
#line 3356 "DockRenderer.c"
	}
#line 713 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 713 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 713 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 713 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 714 "../lib/DockRenderer.vala"
	_tmp3_ = position_manager;
#line 714 "../lib/DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_Position (_tmp3_);
#line 714 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 714 "../lib/DockRenderer.vala"
	_data2_->position = _tmp5_;
#line 716 "../lib/DockRenderer.vala"
	_data2_->x_offset = 0.0;
#line 718 "../lib/DockRenderer.vala"
	_tmp6_ = position_manager;
#line 718 "../lib/DockRenderer.vala"
	_tmp7_ = plank_position_manager_get_Alignment (_tmp6_);
#line 718 "../lib/DockRenderer.vala"
	_tmp8_ = _tmp7_;
#line 718 "../lib/DockRenderer.vala"
	switch (_tmp8_) {
#line 3384 "DockRenderer.c"
		default:
#line 718 "../lib/DockRenderer.vala"
		case GTK_ALIGN_CENTER:
#line 3388 "DockRenderer.c"
		{
#line 721 "../lib/DockRenderer.vala"
			_data2_->x_offset -= round (self->priv->dynamic_animation_offset / 2.0);
#line 722 "../lib/DockRenderer.vala"
			break;
#line 3394 "DockRenderer.c"
		}
#line 718 "../lib/DockRenderer.vala"
		case GTK_ALIGN_START:
#line 3398 "DockRenderer.c"
		{
#line 724 "../lib/DockRenderer.vala"
			break;
#line 3402 "DockRenderer.c"
		}
#line 718 "../lib/DockRenderer.vala"
		case GTK_ALIGN_END:
#line 3406 "DockRenderer.c"
		{
#line 726 "../lib/DockRenderer.vala"
			_data2_->x_offset -= round (self->priv->dynamic_animation_offset);
#line 727 "../lib/DockRenderer.vala"
			break;
#line 3412 "DockRenderer.c"
		}
#line 718 "../lib/DockRenderer.vala"
		case GTK_ALIGN_FILL:
#line 3416 "DockRenderer.c"
		{
			PlankPositionManager* _tmp9_;
			GtkAlign _tmp10_;
			GtkAlign _tmp11_;
#line 729 "../lib/DockRenderer.vala"
			_tmp9_ = position_manager;
#line 729 "../lib/DockRenderer.vala"
			_tmp10_ = plank_position_manager_get_ItemsAlignment (_tmp9_);
#line 729 "../lib/DockRenderer.vala"
			_tmp11_ = _tmp10_;
#line 729 "../lib/DockRenderer.vala"
			switch (_tmp11_) {
#line 3429 "DockRenderer.c"
				default:
#line 729 "../lib/DockRenderer.vala"
				case GTK_ALIGN_FILL:
#line 729 "../lib/DockRenderer.vala"
				case GTK_ALIGN_CENTER:
#line 3435 "DockRenderer.c"
				{
#line 733 "../lib/DockRenderer.vala"
					_data2_->x_offset -= round (self->priv->dynamic_animation_offset / 2.0);
#line 734 "../lib/DockRenderer.vala"
					break;
#line 3441 "DockRenderer.c"
				}
#line 729 "../lib/DockRenderer.vala"
				case GTK_ALIGN_START:
#line 3445 "DockRenderer.c"
				{
#line 736 "../lib/DockRenderer.vala"
					break;
#line 3449 "DockRenderer.c"
				}
#line 729 "../lib/DockRenderer.vala"
				case GTK_ALIGN_END:
#line 3453 "DockRenderer.c"
				{
#line 738 "../lib/DockRenderer.vala"
					_data2_->x_offset -= round (self->priv->dynamic_animation_offset);
#line 739 "../lib/DockRenderer.vala"
					break;
#line 3459 "DockRenderer.c"
				}
			}
#line 741 "../lib/DockRenderer.vala"
			break;
#line 3464 "DockRenderer.c"
		}
	}
#line 744 "../lib/DockRenderer.vala"
	if (_data2_->x_offset == 0.0) {
#line 745 "../lib/DockRenderer.vala"
		block2_data_unref (_data2_);
#line 745 "../lib/DockRenderer.vala"
		_data2_ = NULL;
#line 745 "../lib/DockRenderer.vala"
		return;
#line 3475 "DockRenderer.c"
	}
#line 747 "../lib/DockRenderer.vala"
	_tmp12_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) draw_values);
#line 747 "../lib/DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 747 "../lib/DockRenderer.vala"
	gee_map_iterator_foreach (_tmp13_, ___lambda46__gee_forall_map_func, _data2_);
#line 747 "../lib/DockRenderer.vala"
	_g_object_unref0 (_tmp13_);
#line 708 "../lib/DockRenderer.vala"
	block2_data_unref (_data2_);
#line 708 "../lib/DockRenderer.vala"
	_data2_ = NULL;
#line 3489 "DockRenderer.c"
}

static inline PlankSurface*
plank_dock_renderer_get_item_surface (PlankDockRenderer* self,
                                      PlankDockItem* item,
                                      gint icon_size)
{
	PlankSurface* private_icon_surface = NULL;
	PlankSurface* _tmp0_;
	PlankSurface* _tmp1_;
	gchar* drawing_status = NULL;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp2_;
	PlankPositionManager* _tmp3_;
	PlankPositionManager* _tmp4_;
	gint max_icon_size = 0;
	PlankPositionManager* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_ = FALSE;
	PlankSurface* result;
#line 753 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 753 "../lib/DockRenderer.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 755 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->item_buffer;
#line 755 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_item_get_surface (item, icon_size, icon_size, _tmp0_);
#line 755 "../lib/DockRenderer.vala"
	private_icon_surface = _tmp1_;
#line 756 "../lib/DockRenderer.vala"
	if (!self->priv->screen_is_composited) {
#line 757 "../lib/DockRenderer.vala"
		result = private_icon_surface;
#line 757 "../lib/DockRenderer.vala"
		return result;
#line 3527 "DockRenderer.c"
	}
#line 763 "../lib/DockRenderer.vala"
	_tmp2_ = self->priv->_controller;
#line 763 "../lib/DockRenderer.vala"
	_tmp3_ = plank_dock_controller_get_position_manager (_tmp2_);
#line 763 "../lib/DockRenderer.vala"
	_tmp4_ = _tmp3_;
#line 763 "../lib/DockRenderer.vala"
	position_manager = _tmp4_;
#line 764 "../lib/DockRenderer.vala"
	_tmp5_ = position_manager;
#line 764 "../lib/DockRenderer.vala"
	_tmp6_ = plank_position_manager_get_ZoomIconSize (_tmp5_);
#line 764 "../lib/DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 764 "../lib/DockRenderer.vala"
	max_icon_size = _tmp7_ * self->priv->window_scale_factor;
#line 765 "../lib/DockRenderer.vala"
	if (icon_size < max_icon_size) {
#line 3547 "DockRenderer.c"
		gboolean _tmp9_ = FALSE;
		PlankSurface* _tmp10_;
		gpointer _tmp11_;
		const gchar* _tmp12_;
#line 766 "../lib/DockRenderer.vala"
		_tmp10_ = private_icon_surface;
#line 766 "../lib/DockRenderer.vala"
		_tmp11_ = g_object_steal_qdata ((GObject*) _tmp10_, plank_quark_surface_stats);
#line 766 "../lib/DockRenderer.vala"
		_g_free0 (drawing_status);
#line 766 "../lib/DockRenderer.vala"
		drawing_status = (gchar*) _tmp11_;
#line 766 "../lib/DockRenderer.vala"
		_tmp12_ = drawing_status;
#line 766 "../lib/DockRenderer.vala"
		if (_tmp12_ != NULL) {
#line 3564 "DockRenderer.c"
			const gchar* _tmp13_;
#line 767 "../lib/DockRenderer.vala"
			_tmp13_ = drawing_status;
#line 767 "../lib/DockRenderer.vala"
			_tmp9_ = g_strcmp0 (_tmp13_, PLANK_SURFACE_STATS_DRAWING_TIME_EXCEEDED) == 0;
#line 3570 "DockRenderer.c"
		} else {
#line 766 "../lib/DockRenderer.vala"
			_tmp9_ = FALSE;
#line 3574 "DockRenderer.c"
		}
#line 766 "../lib/DockRenderer.vala"
		_tmp8_ = _tmp9_;
#line 3578 "DockRenderer.c"
	} else {
#line 765 "../lib/DockRenderer.vala"
		_tmp8_ = FALSE;
#line 3582 "DockRenderer.c"
	}
#line 765 "../lib/DockRenderer.vala"
	if (_tmp8_) {
#line 3586 "DockRenderer.c"
		PlankSurface* _tmp14_;
		PlankSurface* _tmp15_;
		PlankSurface* _tmp16_;
#line 768 "../lib/DockRenderer.vala"
		_tmp14_ = self->priv->item_buffer;
#line 768 "../lib/DockRenderer.vala"
		_tmp15_ = plank_dock_item_get_surface (item, max_icon_size, max_icon_size, _tmp14_);
#line 768 "../lib/DockRenderer.vala"
		_tmp16_ = _tmp15_;
#line 768 "../lib/DockRenderer.vala"
		_g_object_unref0 (_tmp16_);
#line 3598 "DockRenderer.c"
	}
#line 770 "../lib/DockRenderer.vala"
	result = private_icon_surface;
#line 770 "../lib/DockRenderer.vala"
	_g_free0 (drawing_status);
#line 770 "../lib/DockRenderer.vala"
	return result;
#line 3606 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_item (PlankDockRenderer* self,
                               cairo_t* cr,
                               PlankDockItem* item,
                               PlankDockItemDrawValue* draw_value,
                               gint64 frame_time)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gint icon_size = 0;
	GtkPositionType position = 0;
	PlankPositionManager* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	PlankSurface* icon_surface = NULL;
	PlankSurface* _tmp6_;
	PlankSurface* _tmp7_;
	PlankSurface* _tmp8_;
	PlankSurface* _tmp9_;
	cairo_t* icon_cr = NULL;
	PlankSurface* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	PlankSurface* icon_overlay_surface = NULL;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_;
	gboolean _tmp15_;
	PlankSurface* _tmp20_;
	GdkRectangle draw_region = {0};
	GdkRectangle _tmp40_;
	PlankSurface* _tmp41_;
	cairo_surface_t* _tmp42_;
	cairo_surface_t* _tmp43_;
	GdkRectangle _tmp44_;
	GdkRectangle _tmp45_;
	gboolean _tmp46_ = FALSE;
#line 773 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 773 "../lib/DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 773 "../lib/DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 773 "../lib/DockRenderer.vala"
	g_return_if_fail (draw_value != NULL);
#line 775 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 775 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 775 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 775 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 776 "../lib/DockRenderer.vala"
	icon_size = ((gint) draw_value->icon_size) * self->priv->window_scale_factor;
#line 777 "../lib/DockRenderer.vala"
	_tmp3_ = position_manager;
#line 777 "../lib/DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_Position (_tmp3_);
#line 777 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 777 "../lib/DockRenderer.vala"
	position = _tmp5_;
#line 783 "../lib/DockRenderer.vala"
	_tmp6_ = plank_dock_renderer_get_item_surface (self, item, icon_size);
#line 783 "../lib/DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 783 "../lib/DockRenderer.vala"
	_tmp8_ = plank_surface_copy (_tmp7_);
#line 783 "../lib/DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 783 "../lib/DockRenderer.vala"
	_g_object_unref0 (_tmp7_);
#line 783 "../lib/DockRenderer.vala"
	icon_surface = _tmp9_;
#line 784 "../lib/DockRenderer.vala"
	_tmp10_ = icon_surface;
#line 784 "../lib/DockRenderer.vala"
	_tmp11_ = plank_surface_get_Context (_tmp10_);
#line 784 "../lib/DockRenderer.vala"
	_tmp12_ = _tmp11_;
#line 784 "../lib/DockRenderer.vala"
	icon_cr = _tmp12_;
#line 786 "../lib/DockRenderer.vala"
	icon_overlay_surface = NULL;
#line 787 "../lib/DockRenderer.vala"
	_tmp14_ = plank_dock_item_get_CountVisible (item);
#line 787 "../lib/DockRenderer.vala"
	_tmp15_ = _tmp14_;
#line 787 "../lib/DockRenderer.vala"
	if (_tmp15_) {
#line 787 "../lib/DockRenderer.vala"
		_tmp13_ = TRUE;
#line 3703 "DockRenderer.c"
	} else {
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 787 "../lib/DockRenderer.vala"
		_tmp16_ = plank_dock_item_get_ProgressVisible (item);
#line 787 "../lib/DockRenderer.vala"
		_tmp17_ = _tmp16_;
#line 787 "../lib/DockRenderer.vala"
		_tmp13_ = _tmp17_;
#line 3713 "DockRenderer.c"
	}
#line 787 "../lib/DockRenderer.vala"
	if (_tmp13_) {
#line 3717 "DockRenderer.c"
		PlankSurface* _tmp18_;
		PlankSurface* _tmp19_;
#line 788 "../lib/DockRenderer.vala"
		_tmp18_ = self->priv->item_buffer;
#line 788 "../lib/DockRenderer.vala"
		_tmp19_ = plank_dock_item_get_foreground_surface (item, icon_size, icon_size, _tmp18_, (PlankDrawDataFunc) plank_dock_renderer_draw_item_foreground, self);
#line 788 "../lib/DockRenderer.vala"
		_g_object_unref0 (icon_overlay_surface);
#line 788 "../lib/DockRenderer.vala"
		icon_overlay_surface = _tmp19_;
#line 3728 "DockRenderer.c"
	}
#line 790 "../lib/DockRenderer.vala"
	_tmp20_ = icon_overlay_surface;
#line 790 "../lib/DockRenderer.vala"
	if (_tmp20_ != NULL) {
#line 3734 "DockRenderer.c"
		cairo_t* _tmp21_;
		PlankSurface* _tmp22_;
		cairo_surface_t* _tmp23_;
		cairo_surface_t* _tmp24_;
		cairo_t* _tmp25_;
#line 791 "../lib/DockRenderer.vala"
		_tmp21_ = icon_cr;
#line 791 "../lib/DockRenderer.vala"
		_tmp22_ = icon_overlay_surface;
#line 791 "../lib/DockRenderer.vala"
		_tmp23_ = plank_surface_get_Internal (_tmp22_);
#line 791 "../lib/DockRenderer.vala"
		_tmp24_ = _tmp23_;
#line 791 "../lib/DockRenderer.vala"
		cairo_set_source_surface (_tmp21_, _tmp24_, (gdouble) 0, (gdouble) 0);
#line 792 "../lib/DockRenderer.vala"
		_tmp25_ = icon_cr;
#line 792 "../lib/DockRenderer.vala"
		cairo_paint (_tmp25_);
#line 3754 "DockRenderer.c"
	}
#line 801 "../lib/DockRenderer.vala"
	if (draw_value->lighten > ((gdouble) 0)) {
#line 3758 "DockRenderer.c"
		cairo_t* _tmp26_;
		cairo_t* _tmp27_;
		cairo_t* _tmp28_;
#line 802 "../lib/DockRenderer.vala"
		_tmp26_ = icon_cr;
#line 802 "../lib/DockRenderer.vala"
		cairo_set_operator (_tmp26_, CAIRO_OPERATOR_ADD);
#line 803 "../lib/DockRenderer.vala"
		_tmp27_ = icon_cr;
#line 803 "../lib/DockRenderer.vala"
		cairo_paint_with_alpha (_tmp27_, draw_value->lighten);
#line 804 "../lib/DockRenderer.vala"
		_tmp28_ = icon_cr;
#line 804 "../lib/DockRenderer.vala"
		cairo_set_operator (_tmp28_, CAIRO_OPERATOR_OVER);
#line 3774 "DockRenderer.c"
	}
#line 808 "../lib/DockRenderer.vala"
	if (draw_value->darken > ((gdouble) 0)) {
#line 3778 "DockRenderer.c"
		cairo_t* _tmp29_;
		PlankSurface* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		PlankSurface* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		cairo_t* _tmp36_;
		cairo_t* _tmp37_;
		cairo_t* _tmp38_;
		cairo_t* _tmp39_;
#line 809 "../lib/DockRenderer.vala"
		_tmp29_ = icon_cr;
#line 809 "../lib/DockRenderer.vala"
		_tmp30_ = icon_surface;
#line 809 "../lib/DockRenderer.vala"
		_tmp31_ = plank_surface_get_Width (_tmp30_);
#line 809 "../lib/DockRenderer.vala"
		_tmp32_ = _tmp31_;
#line 809 "../lib/DockRenderer.vala"
		_tmp33_ = icon_surface;
#line 809 "../lib/DockRenderer.vala"
		_tmp34_ = plank_surface_get_Height (_tmp33_);
#line 809 "../lib/DockRenderer.vala"
		_tmp35_ = _tmp34_;
#line 809 "../lib/DockRenderer.vala"
		cairo_rectangle (_tmp29_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp32_, (gdouble) _tmp35_);
#line 810 "../lib/DockRenderer.vala"
		_tmp36_ = icon_cr;
#line 810 "../lib/DockRenderer.vala"
		cairo_set_source_rgba (_tmp36_, (gdouble) 0, (gdouble) 0, (gdouble) 0, draw_value->darken);
#line 811 "../lib/DockRenderer.vala"
		_tmp37_ = icon_cr;
#line 811 "../lib/DockRenderer.vala"
		cairo_set_operator (_tmp37_, CAIRO_OPERATOR_ATOP);
#line 812 "../lib/DockRenderer.vala"
		_tmp38_ = icon_cr;
#line 812 "../lib/DockRenderer.vala"
		cairo_fill (_tmp38_);
#line 813 "../lib/DockRenderer.vala"
		_tmp39_ = icon_cr;
#line 813 "../lib/DockRenderer.vala"
		cairo_set_operator (_tmp39_, CAIRO_OPERATOR_OVER);
#line 3822 "DockRenderer.c"
	}
#line 817 "../lib/DockRenderer.vala"
	if (self->priv->window_scale_factor > 1) {
#line 818 "../lib/DockRenderer.vala"
		cairo_save (cr);
#line 819 "../lib/DockRenderer.vala"
		cairo_scale (cr, 1.0 / self->priv->window_scale_factor, 1.0 / self->priv->window_scale_factor);
#line 3830 "DockRenderer.c"
	}
#line 821 "../lib/DockRenderer.vala"
	_tmp40_ = draw_value->draw_region;
#line 821 "../lib/DockRenderer.vala"
	draw_region = _tmp40_;
#line 822 "../lib/DockRenderer.vala"
	_tmp41_ = icon_surface;
#line 822 "../lib/DockRenderer.vala"
	_tmp42_ = plank_surface_get_Internal (_tmp41_);
#line 822 "../lib/DockRenderer.vala"
	_tmp43_ = _tmp42_;
#line 822 "../lib/DockRenderer.vala"
	_tmp44_ = draw_region;
#line 822 "../lib/DockRenderer.vala"
	_tmp45_ = draw_region;
#line 822 "../lib/DockRenderer.vala"
	cairo_set_source_surface (cr, _tmp43_, (gdouble) (_tmp44_.x * self->priv->window_scale_factor), (gdouble) (_tmp45_.y * self->priv->window_scale_factor));
#line 823 "../lib/DockRenderer.vala"
	if (draw_value->opacity < 1.0) {
#line 824 "../lib/DockRenderer.vala"
		cairo_paint_with_alpha (cr, draw_value->opacity);
#line 3852 "DockRenderer.c"
	} else {
#line 826 "../lib/DockRenderer.vala"
		cairo_paint (cr);
#line 3856 "DockRenderer.c"
	}
#line 827 "../lib/DockRenderer.vala"
	if (self->priv->window_scale_factor > 1) {
#line 828 "../lib/DockRenderer.vala"
		cairo_restore (cr);
#line 3862 "DockRenderer.c"
	}
#line 831 "../lib/DockRenderer.vala"
	if (draw_value->show_indicator) {
#line 3866 "DockRenderer.c"
		PlankIndicatorState _tmp47_;
		PlankIndicatorState _tmp48_;
#line 831 "../lib/DockRenderer.vala"
		_tmp47_ = plank_dock_item_get_Indicator (item);
#line 831 "../lib/DockRenderer.vala"
		_tmp48_ = _tmp47_;
#line 831 "../lib/DockRenderer.vala"
		_tmp46_ = _tmp48_ != PLANK_INDICATOR_STATE_NONE;
#line 3875 "DockRenderer.c"
	} else {
#line 831 "../lib/DockRenderer.vala"
		_tmp46_ = FALSE;
#line 3879 "DockRenderer.c"
	}
#line 831 "../lib/DockRenderer.vala"
	if (_tmp46_) {
#line 3883 "DockRenderer.c"
		GdkRectangle _tmp49_;
		PlankIndicatorState _tmp50_;
		PlankIndicatorState _tmp51_;
		PlankItemState _tmp52_;
		PlankItemState _tmp53_;
#line 832 "../lib/DockRenderer.vala"
		_tmp49_ = draw_value->hover_region;
#line 832 "../lib/DockRenderer.vala"
		_tmp50_ = plank_dock_item_get_Indicator (item);
#line 832 "../lib/DockRenderer.vala"
		_tmp51_ = _tmp50_;
#line 832 "../lib/DockRenderer.vala"
		_tmp52_ = plank_dock_item_get_State (item);
#line 832 "../lib/DockRenderer.vala"
		_tmp53_ = _tmp52_;
#line 832 "../lib/DockRenderer.vala"
		plank_dock_renderer_draw_indicator_state (self, cr, &_tmp49_, _tmp51_, _tmp53_);
#line 3901 "DockRenderer.c"
	}
#line 773 "../lib/DockRenderer.vala"
	_g_object_unref0 (icon_overlay_surface);
#line 773 "../lib/DockRenderer.vala"
	_g_object_unref0 (icon_surface);
#line 3907 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_item_shadow (PlankDockRenderer* self,
                                      cairo_t* cr,
                                      PlankDockItem* item,
                                      PlankDockItemDrawValue* draw_value)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gint shadow_size = 0;
	PlankPositionManager* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint icon_size = 0;
	PlankSurface* icon_shadow_surface = NULL;
	PlankSurface* _tmp8_;
#line 835 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 835 "../lib/DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 835 "../lib/DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 835 "../lib/DockRenderer.vala"
	g_return_if_fail (draw_value != NULL);
#line 837 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 837 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 837 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 837 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 838 "../lib/DockRenderer.vala"
	_tmp3_ = position_manager;
#line 838 "../lib/DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_IconShadowSize (_tmp3_);
#line 838 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 838 "../lib/DockRenderer.vala"
	shadow_size = _tmp5_;
#line 840 "../lib/DockRenderer.vala"
	icon_size = ((gint) (draw_value->icon_size + (2 * shadow_size))) * self->priv->window_scale_factor;
#line 843 "../lib/DockRenderer.vala"
	icon_shadow_surface = NULL;
#line 844 "../lib/DockRenderer.vala"
	if (shadow_size > 0) {
#line 3957 "DockRenderer.c"
		PlankSurface* _tmp6_;
		PlankSurface* _tmp7_;
#line 845 "../lib/DockRenderer.vala"
		_tmp6_ = self->priv->item_buffer;
#line 845 "../lib/DockRenderer.vala"
		_tmp7_ = plank_dock_item_get_background_surface (item, icon_size, icon_size, _tmp6_, (PlankDrawDataFunc) plank_dock_renderer_draw_item_background, self);
#line 845 "../lib/DockRenderer.vala"
		_g_object_unref0 (icon_shadow_surface);
#line 845 "../lib/DockRenderer.vala"
		icon_shadow_surface = _tmp7_;
#line 3968 "DockRenderer.c"
	}
#line 847 "../lib/DockRenderer.vala"
	_tmp8_ = icon_shadow_surface;
#line 847 "../lib/DockRenderer.vala"
	if (_tmp8_ != NULL) {
#line 3974 "DockRenderer.c"
		GdkRectangle draw_region = {0};
		GdkRectangle _tmp9_;
		PlankSurface* _tmp10_;
		cairo_surface_t* _tmp11_;
		cairo_surface_t* _tmp12_;
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_;
#line 848 "../lib/DockRenderer.vala"
		if (self->priv->window_scale_factor > 1) {
#line 849 "../lib/DockRenderer.vala"
			cairo_save (cr);
#line 850 "../lib/DockRenderer.vala"
			cairo_scale (cr, 1.0 / self->priv->window_scale_factor, 1.0 / self->priv->window_scale_factor);
#line 3988 "DockRenderer.c"
		}
#line 852 "../lib/DockRenderer.vala"
		_tmp9_ = draw_value->draw_region;
#line 852 "../lib/DockRenderer.vala"
		draw_region = _tmp9_;
#line 853 "../lib/DockRenderer.vala"
		cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
#line 854 "../lib/DockRenderer.vala"
		_tmp10_ = icon_shadow_surface;
#line 854 "../lib/DockRenderer.vala"
		_tmp11_ = plank_surface_get_Internal (_tmp10_);
#line 854 "../lib/DockRenderer.vala"
		_tmp12_ = _tmp11_;
#line 854 "../lib/DockRenderer.vala"
		_tmp13_ = draw_region;
#line 854 "../lib/DockRenderer.vala"
		_tmp14_ = draw_region;
#line 854 "../lib/DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp12_, (gdouble) ((_tmp13_.x - shadow_size) * self->priv->window_scale_factor), (gdouble) ((_tmp14_.y - shadow_size) * self->priv->window_scale_factor));
#line 855 "../lib/DockRenderer.vala"
		if (draw_value->opacity < 1.0) {
#line 856 "../lib/DockRenderer.vala"
			cairo_paint_with_alpha (cr, draw_value->opacity);
#line 4012 "DockRenderer.c"
		} else {
#line 858 "../lib/DockRenderer.vala"
			cairo_paint (cr);
#line 4016 "DockRenderer.c"
		}
#line 859 "../lib/DockRenderer.vala"
		if (self->priv->window_scale_factor > 1) {
#line 860 "../lib/DockRenderer.vala"
			cairo_restore (cr);
#line 4022 "DockRenderer.c"
		}
	}
#line 835 "../lib/DockRenderer.vala"
	_g_object_unref0 (icon_shadow_surface);
#line 4027 "DockRenderer.c"
}

static PlankSurface*
plank_dock_renderer_draw_item_foreground (gint width,
                                          gint height,
                                          PlankSurface* model,
                                          PlankDockItem* item,
                                          PlankDockRenderer* self)
{
	PlankSurface* surface = NULL;
	PlankSurface* _tmp0_;
	gint icon_size = 0;
	PlankColor urgent_color = {0};
	PlankDockTheme* _tmp1_;
	PlankColor _tmp2_ = {0};
	PlankColor _tmp3_;
	GdkRGBA _tmp4_ = {0};
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	PlankSurface* result;
#line 865 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 865 "../lib/DockRenderer.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 865 "../lib/DockRenderer.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 867 "../lib/DockRenderer.vala"
	plank_logger_verbose ("DockItem.draw_item_overlay (width = %i, height = %i)", width, height, NULL);
#line 868 "../lib/DockRenderer.vala"
	_tmp0_ = plank_surface_new_with_surface (width, height, model);
#line 868 "../lib/DockRenderer.vala"
	surface = _tmp0_;
#line 870 "../lib/DockRenderer.vala"
	icon_size = MIN (width, height);
#line 871 "../lib/DockRenderer.vala"
	_tmp1_ = self->priv->_theme;
#line 871 "../lib/DockRenderer.vala"
	plank_dock_theme_get_BadgeColor (_tmp1_, &_tmp2_);
#line 871 "../lib/DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 871 "../lib/DockRenderer.vala"
	urgent_color = _tmp3_;
#line 872 "../lib/DockRenderer.vala"
	_tmp4_.red = 0.0;
#line 872 "../lib/DockRenderer.vala"
	_tmp4_.green = 0.0;
#line 872 "../lib/DockRenderer.vala"
	_tmp4_.blue = 0.0;
#line 872 "../lib/DockRenderer.vala"
	_tmp4_.alpha = 0.0;
#line 872 "../lib/DockRenderer.vala"
	if (gdk_rgba_equal (&urgent_color, &_tmp4_)) {
#line 4082 "DockRenderer.c"
		PlankColor _tmp5_ = {0};
		PlankDockTheme* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 873 "../lib/DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp5_);
#line 873 "../lib/DockRenderer.vala"
		urgent_color = _tmp5_;
#line 874 "../lib/DockRenderer.vala"
		_tmp6_ = self->priv->_theme;
#line 874 "../lib/DockRenderer.vala"
		_tmp7_ = plank_dock_theme_get_UrgentHueShift (_tmp6_);
#line 874 "../lib/DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 874 "../lib/DockRenderer.vala"
		plank_color_add_hue (&urgent_color, (gdouble) _tmp8_);
#line 4099 "DockRenderer.c"
	}
#line 878 "../lib/DockRenderer.vala"
	_tmp9_ = plank_dock_item_get_CountVisible (item);
#line 878 "../lib/DockRenderer.vala"
	_tmp10_ = _tmp9_;
#line 878 "../lib/DockRenderer.vala"
	if (_tmp10_) {
#line 4107 "DockRenderer.c"
		PlankDockTheme* _tmp11_;
		PlankSurface* _tmp12_;
		PlankColor _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
#line 879 "../lib/DockRenderer.vala"
		_tmp11_ = self->priv->_theme;
#line 879 "../lib/DockRenderer.vala"
		_tmp12_ = surface;
#line 879 "../lib/DockRenderer.vala"
		_tmp13_ = urgent_color;
#line 879 "../lib/DockRenderer.vala"
		_tmp14_ = plank_dock_item_get_Count (item);
#line 879 "../lib/DockRenderer.vala"
		_tmp15_ = _tmp14_;
#line 879 "../lib/DockRenderer.vala"
		plank_dock_theme_draw_item_count (_tmp11_, _tmp12_, icon_size, &_tmp13_, _tmp15_);
#line 4125 "DockRenderer.c"
	}
#line 882 "../lib/DockRenderer.vala"
	_tmp16_ = plank_dock_item_get_ProgressVisible (item);
#line 882 "../lib/DockRenderer.vala"
	_tmp17_ = _tmp16_;
#line 882 "../lib/DockRenderer.vala"
	if (_tmp17_) {
#line 4133 "DockRenderer.c"
		PlankDockTheme* _tmp18_;
		PlankSurface* _tmp19_;
		PlankColor _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp22_;
#line 883 "../lib/DockRenderer.vala"
		_tmp18_ = self->priv->_theme;
#line 883 "../lib/DockRenderer.vala"
		_tmp19_ = surface;
#line 883 "../lib/DockRenderer.vala"
		_tmp20_ = urgent_color;
#line 883 "../lib/DockRenderer.vala"
		_tmp21_ = plank_dock_item_get_Progress (item);
#line 883 "../lib/DockRenderer.vala"
		_tmp22_ = _tmp21_;
#line 883 "../lib/DockRenderer.vala"
		plank_dock_theme_draw_item_progress (_tmp18_, _tmp19_, icon_size, &_tmp20_, _tmp22_);
#line 4151 "DockRenderer.c"
	}
#line 885 "../lib/DockRenderer.vala"
	result = surface;
#line 885 "../lib/DockRenderer.vala"
	return result;
#line 4157 "DockRenderer.c"
}

static PlankSurface*
plank_dock_renderer_draw_item_background (gint width,
                                          gint height,
                                          PlankSurface* model,
                                          PlankDockItem* item,
                                          PlankDockRenderer* self)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	gint shadow_size = 0;
	PlankPositionManager* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	PlankDockItemDrawValue* draw_value = NULL;
	PlankPositionManager* _tmp6_;
	PlankDockItemDrawValue* _tmp7_;
	gint icon_size = 0;
	PlankDockItemDrawValue* _tmp8_;
	PlankSurface* icon_surface = NULL;
	PlankSurface* _tmp9_;
	PlankSurface* surface = NULL;
	PlankSurface* _tmp10_;
	cairo_t* cr = NULL;
	PlankSurface* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	PlankSurface* shadow_surface = NULL;
	PlankSurface* _tmp14_;
	PlankSurface* _tmp15_;
	gint xoffset = 0;
	gint yoffset = 0;
	PlankPositionManager* _tmp16_;
	GtkPositionType _tmp17_;
	GtkPositionType _tmp18_;
	cairo_t* _tmp19_;
	PlankSurface* _tmp20_;
	cairo_surface_t* _tmp21_;
	cairo_surface_t* _tmp22_;
	cairo_t* _tmp23_;
	PlankSurface* _tmp24_;
	PlankSurface* result;
#line 889 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 889 "../lib/DockRenderer.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 889 "../lib/DockRenderer.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 891 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 891 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 891 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 891 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 892 "../lib/DockRenderer.vala"
	_tmp3_ = position_manager;
#line 892 "../lib/DockRenderer.vala"
	_tmp4_ = plank_position_manager_get_IconShadowSize (_tmp3_);
#line 892 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 892 "../lib/DockRenderer.vala"
	shadow_size = _tmp5_ * self->priv->window_scale_factor;
#line 894 "../lib/DockRenderer.vala"
	_tmp6_ = position_manager;
#line 894 "../lib/DockRenderer.vala"
	_tmp7_ = plank_position_manager_get_draw_value_for_item (_tmp6_, item);
#line 894 "../lib/DockRenderer.vala"
	draw_value = _tmp7_;
#line 895 "../lib/DockRenderer.vala"
	_tmp8_ = draw_value;
#line 895 "../lib/DockRenderer.vala"
	icon_size = ((gint) _tmp8_->icon_size) * self->priv->window_scale_factor;
#line 896 "../lib/DockRenderer.vala"
	_tmp9_ = plank_dock_item_get_surface (item, icon_size, icon_size, model);
#line 896 "../lib/DockRenderer.vala"
	icon_surface = _tmp9_;
#line 898 "../lib/DockRenderer.vala"
	plank_logger_verbose ("DockItem.draw_icon_with_shadow (width = %i, height = %i, shadow_size =" \
" %i)", width, height, shadow_size, NULL);
#line 899 "../lib/DockRenderer.vala"
	_tmp10_ = plank_surface_new_with_surface (width, height, model);
#line 899 "../lib/DockRenderer.vala"
	surface = _tmp10_;
#line 900 "../lib/DockRenderer.vala"
	_tmp11_ = surface;
#line 900 "../lib/DockRenderer.vala"
	_tmp12_ = plank_surface_get_Context (_tmp11_);
#line 900 "../lib/DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 900 "../lib/DockRenderer.vala"
	cr = _tmp13_;
#line 901 "../lib/DockRenderer.vala"
	_tmp14_ = icon_surface;
#line 901 "../lib/DockRenderer.vala"
	_tmp15_ = plank_surface_create_mask (_tmp14_, 0.4, NULL);
#line 901 "../lib/DockRenderer.vala"
	shadow_surface = _tmp15_;
#line 903 "../lib/DockRenderer.vala"
	xoffset = 0;
#line 903 "../lib/DockRenderer.vala"
	yoffset = 0;
#line 904 "../lib/DockRenderer.vala"
	_tmp16_ = position_manager;
#line 904 "../lib/DockRenderer.vala"
	_tmp17_ = plank_position_manager_get_Position (_tmp16_);
#line 904 "../lib/DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 904 "../lib/DockRenderer.vala"
	switch (_tmp18_) {
#line 4271 "DockRenderer.c"
		default:
#line 904 "../lib/DockRenderer.vala"
		case GTK_POS_BOTTOM:
#line 4275 "DockRenderer.c"
		{
#line 907 "../lib/DockRenderer.vala"
			yoffset = (-shadow_size) / 4;
#line 908 "../lib/DockRenderer.vala"
			break;
#line 4281 "DockRenderer.c"
		}
#line 904 "../lib/DockRenderer.vala"
		case GTK_POS_TOP:
#line 4285 "DockRenderer.c"
		{
#line 910 "../lib/DockRenderer.vala"
			yoffset = shadow_size / 4;
#line 911 "../lib/DockRenderer.vala"
			break;
#line 4291 "DockRenderer.c"
		}
#line 904 "../lib/DockRenderer.vala"
		case GTK_POS_LEFT:
#line 4295 "DockRenderer.c"
		{
#line 913 "../lib/DockRenderer.vala"
			xoffset = shadow_size / 4;
#line 914 "../lib/DockRenderer.vala"
			break;
#line 4301 "DockRenderer.c"
		}
#line 904 "../lib/DockRenderer.vala"
		case GTK_POS_RIGHT:
#line 4305 "DockRenderer.c"
		{
#line 916 "../lib/DockRenderer.vala"
			xoffset = (-shadow_size) / 4;
#line 917 "../lib/DockRenderer.vala"
			break;
#line 4311 "DockRenderer.c"
		}
	}
#line 920 "../lib/DockRenderer.vala"
	_tmp19_ = cr;
#line 920 "../lib/DockRenderer.vala"
	_tmp20_ = shadow_surface;
#line 920 "../lib/DockRenderer.vala"
	_tmp21_ = plank_surface_get_Internal (_tmp20_);
#line 920 "../lib/DockRenderer.vala"
	_tmp22_ = _tmp21_;
#line 920 "../lib/DockRenderer.vala"
	cairo_set_source_surface (_tmp19_, _tmp22_, (gdouble) (shadow_size + xoffset), (gdouble) (shadow_size + yoffset));
#line 921 "../lib/DockRenderer.vala"
	_tmp23_ = cr;
#line 921 "../lib/DockRenderer.vala"
	cairo_paint_with_alpha (_tmp23_, 0.44);
#line 922 "../lib/DockRenderer.vala"
	_tmp24_ = surface;
#line 922 "../lib/DockRenderer.vala"
	plank_surface_gaussian_blur (_tmp24_, shadow_size);
#line 924 "../lib/DockRenderer.vala"
	result = surface;
#line 924 "../lib/DockRenderer.vala"
	_g_object_unref0 (shadow_surface);
#line 924 "../lib/DockRenderer.vala"
	_g_object_unref0 (icon_surface);
#line 924 "../lib/DockRenderer.vala"
	_plank_dock_item_draw_value_unref0 (draw_value);
#line 924 "../lib/DockRenderer.vala"
	return result;
#line 4342 "DockRenderer.c"
}

static void
plank_dock_renderer_draw_indicator_state (PlankDockRenderer* self,
                                          cairo_t* cr,
                                          GdkRectangle* item_rect,
                                          PlankIndicatorState indicator,
                                          PlankItemState item_state)
{
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp0_;
	PlankPositionManager* _tmp1_;
	PlankPositionManager* _tmp2_;
	PlankSurface* _tmp3_;
	PlankSurface* _tmp12_;
	PlankSurface* _tmp24_ = NULL;
	PlankSurface* indicator_surface = NULL;
	gdouble x = 0.0;
	gdouble y = 0.0;
	PlankPositionManager* _tmp27_;
	GtkPositionType _tmp28_;
	GtkPositionType _tmp29_;
#line 927 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 927 "../lib/DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 927 "../lib/DockRenderer.vala"
	g_return_if_fail (item_rect != NULL);
#line 929 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 929 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_position_manager (_tmp0_);
#line 929 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 929 "../lib/DockRenderer.vala"
	position_manager = _tmp2_;
#line 931 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->indicator_buffer;
#line 931 "../lib/DockRenderer.vala"
	if (_tmp3_ == NULL) {
#line 4383 "DockRenderer.c"
		PlankColor indicator_color = {0};
		PlankColor _tmp4_ = {0};
		PlankDockTheme* _tmp5_;
		PlankPositionManager* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		PlankColor _tmp9_;
		PlankSurface* _tmp10_;
		PlankSurface* _tmp11_;
#line 932 "../lib/DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp4_);
#line 932 "../lib/DockRenderer.vala"
		indicator_color = _tmp4_;
#line 933 "../lib/DockRenderer.vala"
		plank_color_set_min_sat (&indicator_color, 0.4);
#line 934 "../lib/DockRenderer.vala"
		_tmp5_ = self->priv->_theme;
#line 934 "../lib/DockRenderer.vala"
		_tmp6_ = position_manager;
#line 934 "../lib/DockRenderer.vala"
		_tmp7_ = plank_position_manager_get_IndicatorSize (_tmp6_);
#line 934 "../lib/DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 934 "../lib/DockRenderer.vala"
		_tmp9_ = indicator_color;
#line 934 "../lib/DockRenderer.vala"
		_tmp10_ = self->priv->item_buffer;
#line 934 "../lib/DockRenderer.vala"
		_tmp11_ = plank_dock_theme_create_indicator (_tmp5_, _tmp8_, &_tmp9_, _tmp10_);
#line 934 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->indicator_buffer);
#line 934 "../lib/DockRenderer.vala"
		self->priv->indicator_buffer = _tmp11_;
#line 4417 "DockRenderer.c"
	}
#line 936 "../lib/DockRenderer.vala"
	_tmp12_ = self->priv->urgent_indicator_buffer;
#line 936 "../lib/DockRenderer.vala"
	if (_tmp12_ == NULL) {
#line 4423 "DockRenderer.c"
		PlankColor urgent_indicator_color = {0};
		PlankColor _tmp13_ = {0};
		PlankDockTheme* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		PlankDockTheme* _tmp17_;
		PlankPositionManager* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		PlankColor _tmp21_;
		PlankSurface* _tmp22_;
		PlankSurface* _tmp23_;
#line 937 "../lib/DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp13_);
#line 937 "../lib/DockRenderer.vala"
		urgent_indicator_color = _tmp13_;
#line 938 "../lib/DockRenderer.vala"
		_tmp14_ = self->priv->_theme;
#line 938 "../lib/DockRenderer.vala"
		_tmp15_ = plank_dock_theme_get_UrgentHueShift (_tmp14_);
#line 938 "../lib/DockRenderer.vala"
		_tmp16_ = _tmp15_;
#line 938 "../lib/DockRenderer.vala"
		plank_color_add_hue (&urgent_indicator_color, (gdouble) _tmp16_);
#line 939 "../lib/DockRenderer.vala"
		plank_color_set_sat (&urgent_indicator_color, 1.0);
#line 940 "../lib/DockRenderer.vala"
		_tmp17_ = self->priv->_theme;
#line 940 "../lib/DockRenderer.vala"
		_tmp18_ = position_manager;
#line 940 "../lib/DockRenderer.vala"
		_tmp19_ = plank_position_manager_get_IndicatorSize (_tmp18_);
#line 940 "../lib/DockRenderer.vala"
		_tmp20_ = _tmp19_;
#line 940 "../lib/DockRenderer.vala"
		_tmp21_ = urgent_indicator_color;
#line 940 "../lib/DockRenderer.vala"
		_tmp22_ = self->priv->item_buffer;
#line 940 "../lib/DockRenderer.vala"
		_tmp23_ = plank_dock_theme_create_indicator (_tmp17_, _tmp20_, &_tmp21_, _tmp22_);
#line 940 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->urgent_indicator_buffer);
#line 940 "../lib/DockRenderer.vala"
		self->priv->urgent_indicator_buffer = _tmp23_;
#line 4468 "DockRenderer.c"
	}
#line 943 "../lib/DockRenderer.vala"
	if ((item_state & PLANK_ITEM_STATE_URGENT) != 0) {
#line 4472 "DockRenderer.c"
		PlankSurface* _tmp25_;
#line 943 "../lib/DockRenderer.vala"
		_tmp25_ = self->priv->urgent_indicator_buffer;
#line 943 "../lib/DockRenderer.vala"
		_tmp24_ = _tmp25_;
#line 4478 "DockRenderer.c"
	} else {
		PlankSurface* _tmp26_;
#line 943 "../lib/DockRenderer.vala"
		_tmp26_ = self->priv->indicator_buffer;
#line 943 "../lib/DockRenderer.vala"
		_tmp24_ = _tmp26_;
#line 4485 "DockRenderer.c"
	}
#line 943 "../lib/DockRenderer.vala"
	indicator_surface = _tmp24_;
#line 945 "../lib/DockRenderer.vala"
	x = 0.0;
#line 945 "../lib/DockRenderer.vala"
	y = 0.0;
#line 946 "../lib/DockRenderer.vala"
	_tmp27_ = position_manager;
#line 946 "../lib/DockRenderer.vala"
	_tmp28_ = plank_position_manager_get_Position (_tmp27_);
#line 946 "../lib/DockRenderer.vala"
	_tmp29_ = _tmp28_;
#line 946 "../lib/DockRenderer.vala"
	switch (_tmp29_) {
#line 4501 "DockRenderer.c"
		default:
#line 946 "../lib/DockRenderer.vala"
		case GTK_POS_BOTTOM:
#line 4505 "DockRenderer.c"
		{
			GdkRectangle _tmp30_;
			GdkRectangle _tmp31_;
			PlankSurface* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
			PlankSurface* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
			PlankSurface* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			PlankDockTheme* _tmp41_;
			PlankSurface* _tmp42_;
			gint _tmp43_;
			gint _tmp44_;
#line 949 "../lib/DockRenderer.vala"
			_tmp30_ = *item_rect;
#line 949 "../lib/DockRenderer.vala"
			_tmp31_ = *item_rect;
#line 949 "../lib/DockRenderer.vala"
			_tmp32_ = indicator_surface;
#line 949 "../lib/DockRenderer.vala"
			_tmp33_ = plank_surface_get_Width (_tmp32_);
#line 949 "../lib/DockRenderer.vala"
			_tmp34_ = _tmp33_;
#line 949 "../lib/DockRenderer.vala"
			x = (_tmp30_.x + (_tmp31_.width / 2.0)) - (_tmp34_ / 2.0);
#line 950 "../lib/DockRenderer.vala"
			_tmp35_ = self->priv->item_buffer;
#line 950 "../lib/DockRenderer.vala"
			_tmp36_ = plank_surface_get_Height (_tmp35_);
#line 950 "../lib/DockRenderer.vala"
			_tmp37_ = _tmp36_;
#line 950 "../lib/DockRenderer.vala"
			_tmp38_ = indicator_surface;
#line 950 "../lib/DockRenderer.vala"
			_tmp39_ = plank_surface_get_Height (_tmp38_);
#line 950 "../lib/DockRenderer.vala"
			_tmp40_ = _tmp39_;
#line 950 "../lib/DockRenderer.vala"
			_tmp41_ = self->priv->_theme;
#line 950 "../lib/DockRenderer.vala"
			_tmp42_ = indicator_surface;
#line 950 "../lib/DockRenderer.vala"
			_tmp43_ = plank_surface_get_Height (_tmp42_);
#line 950 "../lib/DockRenderer.vala"
			_tmp44_ = _tmp43_;
#line 950 "../lib/DockRenderer.vala"
			y = ((_tmp37_ - (_tmp40_ / 2.0)) - (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp41_))) - (_tmp44_ / 24.0);
#line 951 "../lib/DockRenderer.vala"
			break;
#line 4558 "DockRenderer.c"
		}
#line 946 "../lib/DockRenderer.vala"
		case GTK_POS_TOP:
#line 4562 "DockRenderer.c"
		{
			GdkRectangle _tmp45_;
			GdkRectangle _tmp46_;
			PlankSurface* _tmp47_;
			gint _tmp48_;
			gint _tmp49_;
			PlankSurface* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			PlankDockTheme* _tmp53_;
			PlankSurface* _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
#line 953 "../lib/DockRenderer.vala"
			_tmp45_ = *item_rect;
#line 953 "../lib/DockRenderer.vala"
			_tmp46_ = *item_rect;
#line 953 "../lib/DockRenderer.vala"
			_tmp47_ = indicator_surface;
#line 953 "../lib/DockRenderer.vala"
			_tmp48_ = plank_surface_get_Width (_tmp47_);
#line 953 "../lib/DockRenderer.vala"
			_tmp49_ = _tmp48_;
#line 953 "../lib/DockRenderer.vala"
			x = (_tmp45_.x + (_tmp46_.width / 2.0)) - (_tmp49_ / 2.0);
#line 954 "../lib/DockRenderer.vala"
			_tmp50_ = indicator_surface;
#line 954 "../lib/DockRenderer.vala"
			_tmp51_ = plank_surface_get_Height (_tmp50_);
#line 954 "../lib/DockRenderer.vala"
			_tmp52_ = _tmp51_;
#line 954 "../lib/DockRenderer.vala"
			_tmp53_ = self->priv->_theme;
#line 954 "../lib/DockRenderer.vala"
			_tmp54_ = indicator_surface;
#line 954 "../lib/DockRenderer.vala"
			_tmp55_ = plank_surface_get_Height (_tmp54_);
#line 954 "../lib/DockRenderer.vala"
			_tmp56_ = _tmp55_;
#line 954 "../lib/DockRenderer.vala"
			y = (((-_tmp52_) / 2.0) + (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp53_))) + (_tmp56_ / 24.0);
#line 955 "../lib/DockRenderer.vala"
			break;
#line 4606 "DockRenderer.c"
		}
#line 946 "../lib/DockRenderer.vala"
		case GTK_POS_LEFT:
#line 4610 "DockRenderer.c"
		{
			PlankSurface* _tmp57_;
			gint _tmp58_;
			gint _tmp59_;
			PlankDockTheme* _tmp60_;
			PlankSurface* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			GdkRectangle _tmp64_;
			GdkRectangle _tmp65_;
			PlankSurface* _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
#line 957 "../lib/DockRenderer.vala"
			_tmp57_ = indicator_surface;
#line 957 "../lib/DockRenderer.vala"
			_tmp58_ = plank_surface_get_Width (_tmp57_);
#line 957 "../lib/DockRenderer.vala"
			_tmp59_ = _tmp58_;
#line 957 "../lib/DockRenderer.vala"
			_tmp60_ = self->priv->_theme;
#line 957 "../lib/DockRenderer.vala"
			_tmp61_ = indicator_surface;
#line 957 "../lib/DockRenderer.vala"
			_tmp62_ = plank_surface_get_Width (_tmp61_);
#line 957 "../lib/DockRenderer.vala"
			_tmp63_ = _tmp62_;
#line 957 "../lib/DockRenderer.vala"
			x = (((-_tmp59_) / 2.0) + (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp60_))) + (_tmp63_ / 24.0);
#line 958 "../lib/DockRenderer.vala"
			_tmp64_ = *item_rect;
#line 958 "../lib/DockRenderer.vala"
			_tmp65_ = *item_rect;
#line 958 "../lib/DockRenderer.vala"
			_tmp66_ = indicator_surface;
#line 958 "../lib/DockRenderer.vala"
			_tmp67_ = plank_surface_get_Height (_tmp66_);
#line 958 "../lib/DockRenderer.vala"
			_tmp68_ = _tmp67_;
#line 958 "../lib/DockRenderer.vala"
			y = (_tmp64_.y + (_tmp65_.height / 2.0)) - (_tmp68_ / 2.0);
#line 959 "../lib/DockRenderer.vala"
			break;
#line 4654 "DockRenderer.c"
		}
#line 946 "../lib/DockRenderer.vala"
		case GTK_POS_RIGHT:
#line 4658 "DockRenderer.c"
		{
			PlankSurface* _tmp69_;
			gint _tmp70_;
			gint _tmp71_;
			PlankSurface* _tmp72_;
			gint _tmp73_;
			gint _tmp74_;
			PlankDockTheme* _tmp75_;
			PlankSurface* _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
			GdkRectangle _tmp79_;
			GdkRectangle _tmp80_;
			PlankSurface* _tmp81_;
			gint _tmp82_;
			gint _tmp83_;
#line 961 "../lib/DockRenderer.vala"
			_tmp69_ = self->priv->item_buffer;
#line 961 "../lib/DockRenderer.vala"
			_tmp70_ = plank_surface_get_Width (_tmp69_);
#line 961 "../lib/DockRenderer.vala"
			_tmp71_ = _tmp70_;
#line 961 "../lib/DockRenderer.vala"
			_tmp72_ = indicator_surface;
#line 961 "../lib/DockRenderer.vala"
			_tmp73_ = plank_surface_get_Width (_tmp72_);
#line 961 "../lib/DockRenderer.vala"
			_tmp74_ = _tmp73_;
#line 961 "../lib/DockRenderer.vala"
			_tmp75_ = self->priv->_theme;
#line 961 "../lib/DockRenderer.vala"
			_tmp76_ = indicator_surface;
#line 961 "../lib/DockRenderer.vala"
			_tmp77_ = plank_surface_get_Width (_tmp76_);
#line 961 "../lib/DockRenderer.vala"
			_tmp78_ = _tmp77_;
#line 961 "../lib/DockRenderer.vala"
			x = ((_tmp71_ - (_tmp74_ / 2.0)) - (2.0 * plank_theme_get_bottom_offset ((PlankTheme*) _tmp75_))) - (_tmp78_ / 24.0);
#line 962 "../lib/DockRenderer.vala"
			_tmp79_ = *item_rect;
#line 962 "../lib/DockRenderer.vala"
			_tmp80_ = *item_rect;
#line 962 "../lib/DockRenderer.vala"
			_tmp81_ = indicator_surface;
#line 962 "../lib/DockRenderer.vala"
			_tmp82_ = plank_surface_get_Height (_tmp81_);
#line 962 "../lib/DockRenderer.vala"
			_tmp83_ = _tmp82_;
#line 962 "../lib/DockRenderer.vala"
			y = (_tmp79_.y + (_tmp80_.height / 2.0)) - (_tmp83_ / 2.0);
#line 963 "../lib/DockRenderer.vala"
			break;
#line 4711 "DockRenderer.c"
		}
	}
#line 966 "../lib/DockRenderer.vala"
	if (indicator == PLANK_INDICATOR_STATE_SINGLE) {
#line 4716 "DockRenderer.c"
		PlankSurface* _tmp84_;
		cairo_surface_t* _tmp85_;
		cairo_surface_t* _tmp86_;
#line 967 "../lib/DockRenderer.vala"
		_tmp84_ = indicator_surface;
#line 967 "../lib/DockRenderer.vala"
		_tmp85_ = plank_surface_get_Internal (_tmp84_);
#line 967 "../lib/DockRenderer.vala"
		_tmp86_ = _tmp85_;
#line 967 "../lib/DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp86_, x, y);
#line 968 "../lib/DockRenderer.vala"
		cairo_paint (cr);
#line 4730 "DockRenderer.c"
	} else {
		gdouble x_offset = 0.0;
		gdouble y_offset = 0.0;
		PlankPositionManager* _tmp87_;
		PlankSurface* _tmp94_;
		cairo_surface_t* _tmp95_;
		cairo_surface_t* _tmp96_;
		PlankSurface* _tmp97_;
		cairo_surface_t* _tmp98_;
		cairo_surface_t* _tmp99_;
#line 970 "../lib/DockRenderer.vala"
		x_offset = 0.0;
#line 970 "../lib/DockRenderer.vala"
		y_offset = 0.0;
#line 971 "../lib/DockRenderer.vala"
		_tmp87_ = position_manager;
#line 971 "../lib/DockRenderer.vala"
		if (plank_position_manager_is_horizontal_dock (_tmp87_)) {
#line 4749 "DockRenderer.c"
			PlankPositionManager* _tmp88_;
			gint _tmp89_;
			gint _tmp90_;
#line 972 "../lib/DockRenderer.vala"
			_tmp88_ = position_manager;
#line 972 "../lib/DockRenderer.vala"
			_tmp89_ = plank_position_manager_get_IconSize (_tmp88_);
#line 972 "../lib/DockRenderer.vala"
			_tmp90_ = _tmp89_;
#line 972 "../lib/DockRenderer.vala"
			x_offset = _tmp90_ / 16.0;
#line 4761 "DockRenderer.c"
		} else {
			PlankPositionManager* _tmp91_;
			gint _tmp92_;
			gint _tmp93_;
#line 974 "../lib/DockRenderer.vala"
			_tmp91_ = position_manager;
#line 974 "../lib/DockRenderer.vala"
			_tmp92_ = plank_position_manager_get_IconSize (_tmp91_);
#line 974 "../lib/DockRenderer.vala"
			_tmp93_ = _tmp92_;
#line 974 "../lib/DockRenderer.vala"
			y_offset = _tmp93_ / 16.0;
#line 4774 "DockRenderer.c"
		}
#line 976 "../lib/DockRenderer.vala"
		_tmp94_ = indicator_surface;
#line 976 "../lib/DockRenderer.vala"
		_tmp95_ = plank_surface_get_Internal (_tmp94_);
#line 976 "../lib/DockRenderer.vala"
		_tmp96_ = _tmp95_;
#line 976 "../lib/DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp96_, x - x_offset, y - y_offset);
#line 977 "../lib/DockRenderer.vala"
		cairo_paint (cr);
#line 978 "../lib/DockRenderer.vala"
		_tmp97_ = indicator_surface;
#line 978 "../lib/DockRenderer.vala"
		_tmp98_ = plank_surface_get_Internal (_tmp97_);
#line 978 "../lib/DockRenderer.vala"
		_tmp99_ = _tmp98_;
#line 978 "../lib/DockRenderer.vala"
		cairo_set_source_surface (cr, _tmp99_, x + x_offset, y + y_offset);
#line 979 "../lib/DockRenderer.vala"
		cairo_paint (cr);
#line 4796 "DockRenderer.c"
	}
}

static void
plank_dock_renderer_draw_urgent_glow (PlankDockRenderer* self,
                                      PlankDockItem* item,
                                      cairo_t* cr,
                                      gint64 frame_time)
{
	PlankItemState _tmp0_;
	PlankItemState _tmp1_;
	gint64 diff = 0LL;
	gint64 _tmp2_;
	gint64 _tmp3_;
	PlankDockTheme* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	PlankPositionManager* position_manager = NULL;
	PlankDockController* _tmp7_;
	PlankPositionManager* _tmp8_;
	PlankPositionManager* _tmp9_;
	gint x_offset = 0;
	gint y_offset = 0;
	PlankSurface* _tmp10_;
	PlankPositionManager* _tmp22_;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	PlankSurface* _tmp25_;
	cairo_surface_t* _tmp26_;
	cairo_surface_t* _tmp27_;
	gdouble opacity = 0.0;
	PlankDockTheme* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
#line 983 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 983 "../lib/DockRenderer.vala"
	g_return_if_fail (item != NULL);
#line 983 "../lib/DockRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 985 "../lib/DockRenderer.vala"
	_tmp0_ = plank_dock_item_get_State (item);
#line 985 "../lib/DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 985 "../lib/DockRenderer.vala"
	if ((_tmp1_ & PLANK_ITEM_STATE_URGENT) == 0) {
#line 986 "../lib/DockRenderer.vala"
		return;
#line 4845 "DockRenderer.c"
	}
#line 988 "../lib/DockRenderer.vala"
	_tmp2_ = plank_dock_element_get_LastUrgent ((PlankDockElement*) item);
#line 988 "../lib/DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 988 "../lib/DockRenderer.vala"
	diff = MAX (0LL, frame_time - _tmp3_);
#line 989 "../lib/DockRenderer.vala"
	_tmp4_ = self->priv->_theme;
#line 989 "../lib/DockRenderer.vala"
	_tmp5_ = plank_dock_theme_get_GlowTime (_tmp4_);
#line 989 "../lib/DockRenderer.vala"
	_tmp6_ = _tmp5_;
#line 989 "../lib/DockRenderer.vala"
	if (diff >= ((gint64) (_tmp6_ * 1000))) {
#line 990 "../lib/DockRenderer.vala"
		return;
#line 4863 "DockRenderer.c"
	}
#line 992 "../lib/DockRenderer.vala"
	_tmp7_ = self->priv->_controller;
#line 992 "../lib/DockRenderer.vala"
	_tmp8_ = plank_dock_controller_get_position_manager (_tmp7_);
#line 992 "../lib/DockRenderer.vala"
	_tmp9_ = _tmp8_;
#line 992 "../lib/DockRenderer.vala"
	position_manager = _tmp9_;
#line 993 "../lib/DockRenderer.vala"
	x_offset = 0;
#line 993 "../lib/DockRenderer.vala"
	y_offset = 0;
#line 995 "../lib/DockRenderer.vala"
	_tmp10_ = self->priv->urgent_glow_buffer;
#line 995 "../lib/DockRenderer.vala"
	if (_tmp10_ == NULL) {
#line 4881 "DockRenderer.c"
		PlankColor urgent_color = {0};
		PlankColor _tmp11_ = {0};
		PlankDockTheme* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		PlankDockTheme* _tmp15_;
		PlankPositionManager* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		PlankColor _tmp19_;
		PlankSurface* _tmp20_;
		PlankSurface* _tmp21_;
#line 996 "../lib/DockRenderer.vala"
		plank_dock_renderer_get_styled_color (self, &_tmp11_);
#line 996 "../lib/DockRenderer.vala"
		urgent_color = _tmp11_;
#line 997 "../lib/DockRenderer.vala"
		_tmp12_ = self->priv->_theme;
#line 997 "../lib/DockRenderer.vala"
		_tmp13_ = plank_dock_theme_get_UrgentHueShift (_tmp12_);
#line 997 "../lib/DockRenderer.vala"
		_tmp14_ = _tmp13_;
#line 997 "../lib/DockRenderer.vala"
		plank_color_add_hue (&urgent_color, (gdouble) _tmp14_);
#line 998 "../lib/DockRenderer.vala"
		plank_color_set_sat (&urgent_color, 1.0);
#line 999 "../lib/DockRenderer.vala"
		_tmp15_ = self->priv->_theme;
#line 999 "../lib/DockRenderer.vala"
		_tmp16_ = position_manager;
#line 999 "../lib/DockRenderer.vala"
		_tmp17_ = plank_position_manager_get_GlowSize (_tmp16_);
#line 999 "../lib/DockRenderer.vala"
		_tmp18_ = _tmp17_;
#line 999 "../lib/DockRenderer.vala"
		_tmp19_ = urgent_color;
#line 999 "../lib/DockRenderer.vala"
		_tmp20_ = self->priv->main_buffer;
#line 999 "../lib/DockRenderer.vala"
		_tmp21_ = plank_dock_theme_create_urgent_glow (_tmp15_, _tmp18_, &_tmp19_, _tmp20_);
#line 999 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->urgent_glow_buffer);
#line 999 "../lib/DockRenderer.vala"
		self->priv->urgent_glow_buffer = _tmp21_;
#line 4926 "DockRenderer.c"
	}
#line 1002 "../lib/DockRenderer.vala"
	_tmp22_ = position_manager;
#line 1002 "../lib/DockRenderer.vala"
	plank_position_manager_get_urgent_glow_position (_tmp22_, item, &_tmp23_, &_tmp24_);
#line 1002 "../lib/DockRenderer.vala"
	x_offset = _tmp23_;
#line 1002 "../lib/DockRenderer.vala"
	y_offset = _tmp24_;
#line 1004 "../lib/DockRenderer.vala"
	_tmp25_ = self->priv->urgent_glow_buffer;
#line 1004 "../lib/DockRenderer.vala"
	_tmp26_ = plank_surface_get_Internal (_tmp25_);
#line 1004 "../lib/DockRenderer.vala"
	_tmp27_ = _tmp26_;
#line 1004 "../lib/DockRenderer.vala"
	cairo_set_source_surface (cr, _tmp27_, (gdouble) x_offset, (gdouble) y_offset);
#line 1005 "../lib/DockRenderer.vala"
	_tmp28_ = self->priv->_theme;
#line 1005 "../lib/DockRenderer.vala"
	_tmp29_ = plank_dock_theme_get_GlowPulseTime (_tmp28_);
#line 1005 "../lib/DockRenderer.vala"
	_tmp30_ = _tmp29_;
#line 1005 "../lib/DockRenderer.vala"
	opacity = 0.2 + ((0.75 * (sin (((diff / ((gdouble) (_tmp30_ * 1000))) * 2) * G_PI) + 1)) / 2);
#line 1006 "../lib/DockRenderer.vala"
	cairo_paint_with_alpha (cr, opacity);
#line 4954 "DockRenderer.c"
}

static void
plank_dock_renderer_get_styled_color (PlankDockRenderer* self,
                                      PlankColor* result)
{
	GtkStyleContext* context = NULL;
	PlankDockTheme* _tmp0_;
	GtkStyleContext* _tmp1_;
	PlankColor color = {0};
	GdkRGBA _tmp2_ = {0};
#line 1009 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1011 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 1011 "../lib/DockRenderer.vala"
	_tmp1_ = plank_theme_get_style_context ((PlankTheme*) _tmp0_);
#line 1011 "../lib/DockRenderer.vala"
	context = _tmp1_;
#line 1012 "../lib/DockRenderer.vala"
	gtk_style_context_get_background_color (context, gtk_style_context_get_state (context), &_tmp2_);
#line 1012 "../lib/DockRenderer.vala"
	color = (PlankColor) _tmp2_;
#line 1013 "../lib/DockRenderer.vala"
	plank_color_set_min_val (&color, 90 / ((gdouble) G_MAXUINT16));
#line 1014 "../lib/DockRenderer.vala"
	*result = color;
#line 1014 "../lib/DockRenderer.vala"
	return;
#line 4984 "DockRenderer.c"
}

static void
plank_dock_renderer_hidden_changed (PlankDockRenderer* self)
{
	gint64 now = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 diff = 0LL;
	gint _tmp2_ = 0;
	PlankDockTheme* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gint time = 0;
	PlankDockController* _tmp18_;
	PlankDockWindow* _tmp19_;
	PlankDockWindow* _tmp20_;
#line 1017 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1019 "../lib/DockRenderer.vala"
	plank_renderer_force_frame_time_update ((PlankRenderer*) self);
#line 1020 "../lib/DockRenderer.vala"
	_tmp0_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 1020 "../lib/DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 1020 "../lib/DockRenderer.vala"
	now = _tmp1_;
#line 1021 "../lib/DockRenderer.vala"
	diff = now - self->priv->last_hide;
#line 1022 "../lib/DockRenderer.vala"
	_tmp3_ = self->priv->_theme;
#line 1022 "../lib/DockRenderer.vala"
	_tmp4_ = plank_dock_theme_get_FadeOpacity (_tmp3_);
#line 1022 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 1022 "../lib/DockRenderer.vala"
	if (_tmp5_ == 1.0) {
#line 5022 "DockRenderer.c"
		PlankDockTheme* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1022 "../lib/DockRenderer.vala"
		_tmp6_ = self->priv->_theme;
#line 1022 "../lib/DockRenderer.vala"
		_tmp7_ = plank_dock_theme_get_HideTime (_tmp6_);
#line 1022 "../lib/DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 1022 "../lib/DockRenderer.vala"
		_tmp2_ = _tmp8_;
#line 5034 "DockRenderer.c"
	} else {
		PlankDockTheme* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 1022 "../lib/DockRenderer.vala"
		_tmp9_ = self->priv->_theme;
#line 1022 "../lib/DockRenderer.vala"
		_tmp10_ = plank_dock_theme_get_FadeTime (_tmp9_);
#line 1022 "../lib/DockRenderer.vala"
		_tmp11_ = _tmp10_;
#line 1022 "../lib/DockRenderer.vala"
		_tmp2_ = _tmp11_;
#line 5047 "DockRenderer.c"
	}
#line 1022 "../lib/DockRenderer.vala"
	time = _tmp2_ * 1000;
#line 1024 "../lib/DockRenderer.vala"
	if (diff < ((gint64) time)) {
#line 1025 "../lib/DockRenderer.vala"
		self->priv->last_hide = now + (diff - time);
#line 5055 "DockRenderer.c"
	} else {
#line 1027 "../lib/DockRenderer.vala"
		self->priv->last_hide = now;
#line 5059 "DockRenderer.c"
	}
#line 1029 "../lib/DockRenderer.vala"
	if (!self->priv->screen_is_composited) {
#line 5063 "DockRenderer.c"
		PlankDockController* _tmp12_;
		PlankPositionManager* _tmp13_;
		PlankPositionManager* _tmp14_;
		PlankDockController* _tmp15_;
		PlankDockWindow* _tmp16_;
		PlankDockWindow* _tmp17_;
#line 1030 "../lib/DockRenderer.vala"
		_tmp12_ = self->priv->_controller;
#line 1030 "../lib/DockRenderer.vala"
		_tmp13_ = plank_dock_controller_get_position_manager (_tmp12_);
#line 1030 "../lib/DockRenderer.vala"
		_tmp14_ = _tmp13_;
#line 1030 "../lib/DockRenderer.vala"
		plank_position_manager_update_dock_position (_tmp14_);
#line 1031 "../lib/DockRenderer.vala"
		_tmp15_ = self->priv->_controller;
#line 1031 "../lib/DockRenderer.vala"
		_tmp16_ = plank_dock_controller_get_window (_tmp15_);
#line 1031 "../lib/DockRenderer.vala"
		_tmp17_ = _tmp16_;
#line 1031 "../lib/DockRenderer.vala"
		plank_dock_window_update_size_and_position (_tmp17_);
#line 1032 "../lib/DockRenderer.vala"
		return;
#line 5088 "DockRenderer.c"
	}
#line 1035 "../lib/DockRenderer.vala"
	_tmp18_ = self->priv->_controller;
#line 1035 "../lib/DockRenderer.vala"
	_tmp19_ = plank_dock_controller_get_window (_tmp18_);
#line 1035 "../lib/DockRenderer.vala"
	_tmp20_ = _tmp19_;
#line 1035 "../lib/DockRenderer.vala"
	plank_dock_window_update_icon_regions (_tmp20_);
#line 1037 "../lib/DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5100 "DockRenderer.c"
}

static void
plank_dock_renderer_hovered_changed (PlankDockRenderer* self)
{
	gint64 now = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 diff = 0LL;
	guint time = 0U;
#line 1040 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1042 "../lib/DockRenderer.vala"
	plank_renderer_force_frame_time_update ((PlankRenderer*) self);
#line 1043 "../lib/DockRenderer.vala"
	_tmp0_ = plank_renderer_get_frame_time ((PlankRenderer*) self);
#line 1043 "../lib/DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 1043 "../lib/DockRenderer.vala"
	now = _tmp1_;
#line 1044 "../lib/DockRenderer.vala"
	diff = now - self->priv->last_hovered_changed;
#line 1045 "../lib/DockRenderer.vala"
	time = PLANK_DOCK_ZOOM_DURATION * 1000;
#line 1047 "../lib/DockRenderer.vala"
	if (diff < ((gint64) time)) {
#line 1048 "../lib/DockRenderer.vala"
		self->priv->last_hovered_changed = now + (diff - time);
#line 5129 "DockRenderer.c"
	} else {
#line 1050 "../lib/DockRenderer.vala"
		self->priv->last_hovered_changed = now;
#line 5133 "DockRenderer.c"
	}
#line 1052 "../lib/DockRenderer.vala"
	plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5137 "DockRenderer.c"
}

static gboolean
_gdk_point_equal (const GdkPoint * s1,
                  const GdkPoint * s2)
{
#line 1058 "../lib/DockRenderer.vala"
	if (s1 == s2) {
#line 1058 "../lib/DockRenderer.vala"
		return TRUE;
#line 5148 "DockRenderer.c"
	}
#line 1058 "../lib/DockRenderer.vala"
	if (s1 == NULL) {
#line 1058 "../lib/DockRenderer.vala"
		return FALSE;
#line 5154 "DockRenderer.c"
	}
#line 1058 "../lib/DockRenderer.vala"
	if (s2 == NULL) {
#line 1058 "../lib/DockRenderer.vala"
		return FALSE;
#line 5160 "DockRenderer.c"
	}
#line 1058 "../lib/DockRenderer.vala"
	if (s1->x != s2->x) {
#line 1058 "../lib/DockRenderer.vala"
		return FALSE;
#line 5166 "DockRenderer.c"
	}
#line 1058 "../lib/DockRenderer.vala"
	if (s1->y != s2->y) {
#line 1058 "../lib/DockRenderer.vala"
		return FALSE;
#line 5172 "DockRenderer.c"
	}
#line 1058 "../lib/DockRenderer.vala"
	return TRUE;
#line 5176 "DockRenderer.c"
}

void
plank_dock_renderer_update_local_cursor (PlankDockRenderer* self,
                                         gint x,
                                         gint y)
{
	GdkPoint new_cursor = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_;
	GdkPoint _tmp2_;
	GdkPoint _tmp3_;
#line 1055 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1057 "../lib/DockRenderer.vala"
	_tmp0_.x = x;
#line 1057 "../lib/DockRenderer.vala"
	_tmp0_.y = y;
#line 1057 "../lib/DockRenderer.vala"
	new_cursor = _tmp0_;
#line 1058 "../lib/DockRenderer.vala"
	_tmp1_ = self->priv->_local_cursor;
#line 1058 "../lib/DockRenderer.vala"
	_tmp2_ = new_cursor;
#line 1058 "../lib/DockRenderer.vala"
	if (_gdk_point_equal (&_tmp1_, &_tmp2_) == TRUE) {
#line 1059 "../lib/DockRenderer.vala"
		return;
#line 5205 "DockRenderer.c"
	}
#line 1061 "../lib/DockRenderer.vala"
	_tmp3_ = new_cursor;
#line 1061 "../lib/DockRenderer.vala"
	plank_dock_renderer_set_local_cursor (self, &_tmp3_);
#line 1063 "../lib/DockRenderer.vala"
	if (self->priv->screen_is_composited) {
#line 1064 "../lib/DockRenderer.vala"
		self->priv->zoom_changed = TRUE;
#line 1065 "../lib/DockRenderer.vala"
		plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5217 "DockRenderer.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 1075 "../lib/DockRenderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 5226 "DockRenderer.c"
}

void
plank_dock_renderer_animate_items (PlankDockRenderer* self,
                                   GeeList* elements)
{
	GeeHashSet* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 1069 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 1069 "../lib/DockRenderer.vala"
	g_return_if_fail (elements != NULL);
#line 1071 "../lib/DockRenderer.vala"
	if (!self->priv->screen_is_composited) {
#line 1072 "../lib/DockRenderer.vala"
		return;
#line 5244 "DockRenderer.c"
	}
	{
		GeeList* _element_list = NULL;
		gint _element_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _element_index = 0;
#line 1074 "../lib/DockRenderer.vala"
		_element_list = elements;
#line 1074 "../lib/DockRenderer.vala"
		_tmp0_ = _element_list;
#line 1074 "../lib/DockRenderer.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 1074 "../lib/DockRenderer.vala"
		_tmp2_ = _tmp1_;
#line 1074 "../lib/DockRenderer.vala"
		_element_size = _tmp2_;
#line 1074 "../lib/DockRenderer.vala"
		_element_index = -1;
#line 1074 "../lib/DockRenderer.vala"
		while (TRUE) {
#line 5267 "DockRenderer.c"
			gint _tmp3_;
			gint _tmp4_;
			PlankDockElement* element = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp7_;
			PlankDockItem* _tmp8_;
			PlankDockItem* _tmp9_;
#line 1074 "../lib/DockRenderer.vala"
			_element_index = _element_index + 1;
#line 1074 "../lib/DockRenderer.vala"
			_tmp3_ = _element_index;
#line 1074 "../lib/DockRenderer.vala"
			_tmp4_ = _element_size;
#line 1074 "../lib/DockRenderer.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1074 "../lib/DockRenderer.vala"
				break;
#line 5287 "DockRenderer.c"
			}
#line 1074 "../lib/DockRenderer.vala"
			_tmp5_ = _element_list;
#line 1074 "../lib/DockRenderer.vala"
			_tmp6_ = gee_list_get (_tmp5_, _element_index);
#line 1074 "../lib/DockRenderer.vala"
			element = (PlankDockElement*) _tmp6_;
#line 1075 "../lib/DockRenderer.vala"
			_tmp7_ = element;
#line 1075 "../lib/DockRenderer.vala"
			_tmp8_ = _g_object_ref0 (PLANK_IS_DOCK_ITEM (_tmp7_) ? ((PlankDockItem*) _tmp7_) : NULL);
#line 1075 "../lib/DockRenderer.vala"
			item = _tmp8_;
#line 1076 "../lib/DockRenderer.vala"
			_tmp9_ = item;
#line 1076 "../lib/DockRenderer.vala"
			if (_tmp9_ != NULL) {
#line 5305 "DockRenderer.c"
				GeeHashSet* _tmp10_;
				PlankDockItem* _tmp11_;
#line 1077 "../lib/DockRenderer.vala"
				_tmp10_ = self->priv->transient_items;
#line 1077 "../lib/DockRenderer.vala"
				_tmp11_ = item;
#line 1077 "../lib/DockRenderer.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 5314 "DockRenderer.c"
			}
#line 1074 "../lib/DockRenderer.vala"
			_g_object_unref0 (item);
#line 1074 "../lib/DockRenderer.vala"
			_g_object_unref0 (element);
#line 5320 "DockRenderer.c"
		}
	}
#line 1080 "../lib/DockRenderer.vala"
	_tmp12_ = self->priv->transient_items;
#line 1080 "../lib/DockRenderer.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 1080 "../lib/DockRenderer.vala"
	_tmp14_ = _tmp13_;
#line 1080 "../lib/DockRenderer.vala"
	if (_tmp14_ > 0) {
#line 1081 "../lib/DockRenderer.vala"
		plank_renderer_animated_draw ((PlankRenderer*) self);
#line 5333 "DockRenderer.c"
	}
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_dock_renderer_real_animation_needed (PlankRenderer* base,
                                           gint64 frame_time)
{
	PlankDockRenderer * self;
	PlankDockTheme* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GeeHashSet* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean result;
#line 1087 "../lib/DockRenderer.vala"
	self = (PlankDockRenderer*) base;
#line 1089 "../lib/DockRenderer.vala"
	if (self->priv->zoom_changed) {
#line 1091 "../lib/DockRenderer.vala"
		self->priv->zoom_changed = FALSE;
#line 1092 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1092 "../lib/DockRenderer.vala"
		return result;
#line 5362 "DockRenderer.c"
	}
#line 1095 "../lib/DockRenderer.vala"
	if ((frame_time - self->priv->last_hovered_changed) <= ((gint64) (PLANK_DOCK_ZOOM_DURATION * 1000))) {
#line 1096 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1096 "../lib/DockRenderer.vala"
		return result;
#line 5370 "DockRenderer.c"
	}
#line 1098 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 1098 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_theme_get_FadeOpacity (_tmp0_);
#line 1098 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 1098 "../lib/DockRenderer.vala"
	if (_tmp2_ == 1.0) {
#line 5380 "DockRenderer.c"
		PlankDockTheme* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 1099 "../lib/DockRenderer.vala"
		_tmp3_ = self->priv->_theme;
#line 1099 "../lib/DockRenderer.vala"
		_tmp4_ = plank_dock_theme_get_HideTime (_tmp3_);
#line 1099 "../lib/DockRenderer.vala"
		_tmp5_ = _tmp4_;
#line 1099 "../lib/DockRenderer.vala"
		if ((frame_time - self->priv->last_hide) <= ((gint64) (_tmp5_ * 1000))) {
#line 1100 "../lib/DockRenderer.vala"
			result = TRUE;
#line 1100 "../lib/DockRenderer.vala"
			return result;
#line 5396 "DockRenderer.c"
		}
	} else {
		PlankDockTheme* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1102 "../lib/DockRenderer.vala"
		_tmp6_ = self->priv->_theme;
#line 1102 "../lib/DockRenderer.vala"
		_tmp7_ = plank_dock_theme_get_FadeTime (_tmp6_);
#line 1102 "../lib/DockRenderer.vala"
		_tmp8_ = _tmp7_;
#line 1102 "../lib/DockRenderer.vala"
		if ((frame_time - self->priv->last_hide) <= ((gint64) (_tmp8_ * 1000))) {
#line 1103 "../lib/DockRenderer.vala"
			result = TRUE;
#line 1103 "../lib/DockRenderer.vala"
			return result;
#line 5414 "DockRenderer.c"
		}
	}
#line 1106 "../lib/DockRenderer.vala"
	_tmp9_ = self->priv->transient_items;
#line 1106 "../lib/DockRenderer.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 1106 "../lib/DockRenderer.vala"
	_tmp11_ = _tmp10_;
#line 1106 "../lib/DockRenderer.vala"
	if (_tmp11_ > 0) {
#line 1107 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1107 "../lib/DockRenderer.vala"
		return result;
#line 5429 "DockRenderer.c"
	}
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp12_;
		gint _item_size = 0;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _item_index = 0;
#line 1109 "../lib/DockRenderer.vala"
		_tmp12_ = self->priv->current_items;
#line 1109 "../lib/DockRenderer.vala"
		_item_list = _tmp12_;
#line 1109 "../lib/DockRenderer.vala"
		_tmp13_ = _item_list;
#line 1109 "../lib/DockRenderer.vala"
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 1109 "../lib/DockRenderer.vala"
		_tmp15_ = _tmp14_;
#line 1109 "../lib/DockRenderer.vala"
		_item_size = _tmp15_;
#line 1109 "../lib/DockRenderer.vala"
		_item_index = -1;
#line 1109 "../lib/DockRenderer.vala"
		while (TRUE) {
#line 5455 "DockRenderer.c"
			gint _tmp16_;
			gint _tmp17_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp18_;
			gpointer _tmp19_;
			PlankDockItem* _tmp20_;
			PlankDockItem* _tmp21_;
#line 1109 "../lib/DockRenderer.vala"
			_item_index = _item_index + 1;
#line 1109 "../lib/DockRenderer.vala"
			_tmp16_ = _item_index;
#line 1109 "../lib/DockRenderer.vala"
			_tmp17_ = _item_size;
#line 1109 "../lib/DockRenderer.vala"
			if (!(_tmp16_ < _tmp17_)) {
#line 1109 "../lib/DockRenderer.vala"
				break;
#line 5473 "DockRenderer.c"
			}
#line 1109 "../lib/DockRenderer.vala"
			_tmp18_ = _item_list;
#line 1109 "../lib/DockRenderer.vala"
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _item_index);
#line 1109 "../lib/DockRenderer.vala"
			_tmp20_ = _g_object_ref0 ((PlankDockItem*) _tmp19_);
#line 1109 "../lib/DockRenderer.vala"
			item = _tmp20_;
#line 1110 "../lib/DockRenderer.vala"
			_tmp21_ = item;
#line 1110 "../lib/DockRenderer.vala"
			if (plank_dock_renderer_item_animation_needed (self, _tmp21_, frame_time)) {
#line 1111 "../lib/DockRenderer.vala"
				result = TRUE;
#line 1111 "../lib/DockRenderer.vala"
				_g_object_unref0 (item);
#line 1111 "../lib/DockRenderer.vala"
				return result;
#line 5493 "DockRenderer.c"
			}
#line 1109 "../lib/DockRenderer.vala"
			_g_object_unref0 (item);
#line 5497 "DockRenderer.c"
		}
	}
#line 1113 "../lib/DockRenderer.vala"
	result = FALSE;
#line 1113 "../lib/DockRenderer.vala"
	return result;
#line 5504 "DockRenderer.c"
}

static inline gboolean
plank_dock_renderer_item_animation_needed (PlankDockRenderer* self,
                                           PlankDockItem* item,
                                           gint64 render_time)
{
	gboolean _tmp0_ = FALSE;
	PlankAnimationType _tmp1_;
	PlankAnimationType _tmp2_;
	gboolean _tmp14_ = FALSE;
	PlankAnimationType _tmp15_;
	PlankAnimationType _tmp16_;
	gboolean _tmp19_ = FALSE;
	PlankAnimationType _tmp20_;
	PlankAnimationType _tmp21_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	PlankDockTheme* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	gint64 _tmp40_;
	gint64 _tmp41_;
	PlankDockTheme* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	gint64 _tmp45_;
	gint64 _tmp46_;
	PlankDockTheme* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint64 _tmp50_;
	gint64 _tmp51_;
	PlankDockTheme* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	gint64 _tmp55_;
	gint64 _tmp56_;
	gboolean result;
#line 1116 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1116 "../lib/DockRenderer.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1118 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 1118 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 1118 "../lib/DockRenderer.vala"
	if (_tmp2_ != PLANK_ANIMATION_TYPE_NONE) {
#line 5555 "DockRenderer.c"
		gint _tmp3_ = 0;
		PlankAnimationType _tmp4_;
		PlankAnimationType _tmp5_;
		gint64 _tmp12_;
		gint64 _tmp13_;
#line 1119 "../lib/DockRenderer.vala"
		_tmp4_ = plank_dock_element_get_ClickedAnimation ((PlankDockElement*) item);
#line 1119 "../lib/DockRenderer.vala"
		_tmp5_ = _tmp4_;
#line 1119 "../lib/DockRenderer.vala"
		if (_tmp5_ == PLANK_ANIMATION_TYPE_BOUNCE) {
#line 5567 "DockRenderer.c"
			PlankDockTheme* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 1119 "../lib/DockRenderer.vala"
			_tmp6_ = self->priv->_theme;
#line 1119 "../lib/DockRenderer.vala"
			_tmp7_ = plank_dock_theme_get_LaunchBounceTime (_tmp6_);
#line 1119 "../lib/DockRenderer.vala"
			_tmp8_ = _tmp7_;
#line 1119 "../lib/DockRenderer.vala"
			_tmp3_ = _tmp8_;
#line 5579 "DockRenderer.c"
		} else {
			PlankDockTheme* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 1119 "../lib/DockRenderer.vala"
			_tmp9_ = self->priv->_theme;
#line 1119 "../lib/DockRenderer.vala"
			_tmp10_ = plank_dock_theme_get_ClickTime (_tmp9_);
#line 1119 "../lib/DockRenderer.vala"
			_tmp11_ = _tmp10_;
#line 1119 "../lib/DockRenderer.vala"
			_tmp3_ = _tmp11_;
#line 5592 "DockRenderer.c"
		}
#line 1119 "../lib/DockRenderer.vala"
		_tmp12_ = plank_dock_element_get_LastClicked ((PlankDockElement*) item);
#line 1119 "../lib/DockRenderer.vala"
		_tmp13_ = _tmp12_;
#line 1119 "../lib/DockRenderer.vala"
		_tmp0_ = (render_time - _tmp13_) <= ((gint64) (_tmp3_ * 1000));
#line 5600 "DockRenderer.c"
	} else {
#line 1118 "../lib/DockRenderer.vala"
		_tmp0_ = FALSE;
#line 5604 "DockRenderer.c"
	}
#line 1118 "../lib/DockRenderer.vala"
	if (_tmp0_) {
#line 1120 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1120 "../lib/DockRenderer.vala"
		return result;
#line 5612 "DockRenderer.c"
	}
#line 1121 "../lib/DockRenderer.vala"
	_tmp15_ = plank_dock_element_get_HoveredAnimation ((PlankDockElement*) item);
#line 1121 "../lib/DockRenderer.vala"
	_tmp16_ = _tmp15_;
#line 1121 "../lib/DockRenderer.vala"
	if (_tmp16_ != PLANK_ANIMATION_TYPE_NONE) {
#line 5620 "DockRenderer.c"
		gint64 _tmp17_;
		gint64 _tmp18_;
#line 1122 "../lib/DockRenderer.vala"
		_tmp17_ = plank_dock_element_get_LastHovered ((PlankDockElement*) item);
#line 1122 "../lib/DockRenderer.vala"
		_tmp18_ = _tmp17_;
#line 1122 "../lib/DockRenderer.vala"
		_tmp14_ = (render_time - _tmp18_) <= ((gint64) (PLANK_ITEM_HOVER_DURATION * 1000));
#line 5629 "DockRenderer.c"
	} else {
#line 1121 "../lib/DockRenderer.vala"
		_tmp14_ = FALSE;
#line 5633 "DockRenderer.c"
	}
#line 1121 "../lib/DockRenderer.vala"
	if (_tmp14_) {
#line 1123 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1123 "../lib/DockRenderer.vala"
		return result;
#line 5641 "DockRenderer.c"
	}
#line 1124 "../lib/DockRenderer.vala"
	_tmp20_ = plank_dock_element_get_ScrolledAnimation ((PlankDockElement*) item);
#line 1124 "../lib/DockRenderer.vala"
	_tmp21_ = _tmp20_;
#line 1124 "../lib/DockRenderer.vala"
	if (_tmp21_ != PLANK_ANIMATION_TYPE_NONE) {
#line 5649 "DockRenderer.c"
		gint64 _tmp22_;
		gint64 _tmp23_;
#line 1125 "../lib/DockRenderer.vala"
		_tmp22_ = plank_dock_element_get_LastScrolled ((PlankDockElement*) item);
#line 1125 "../lib/DockRenderer.vala"
		_tmp23_ = _tmp22_;
#line 1125 "../lib/DockRenderer.vala"
		_tmp19_ = (render_time - _tmp23_) <= ((gint64) (PLANK_ITEM_SCROLL_DURATION * 1000));
#line 5658 "DockRenderer.c"
	} else {
#line 1124 "../lib/DockRenderer.vala"
		_tmp19_ = FALSE;
#line 5662 "DockRenderer.c"
	}
#line 1124 "../lib/DockRenderer.vala"
	if (_tmp19_) {
#line 1126 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1126 "../lib/DockRenderer.vala"
		return result;
#line 5670 "DockRenderer.c"
	}
#line 1127 "../lib/DockRenderer.vala"
	_tmp24_ = plank_dock_element_get_LastActive ((PlankDockElement*) item);
#line 1127 "../lib/DockRenderer.vala"
	_tmp25_ = _tmp24_;
#line 1127 "../lib/DockRenderer.vala"
	_tmp26_ = self->priv->_theme;
#line 1127 "../lib/DockRenderer.vala"
	_tmp27_ = plank_dock_theme_get_ActiveTime (_tmp26_);
#line 1127 "../lib/DockRenderer.vala"
	_tmp28_ = _tmp27_;
#line 1127 "../lib/DockRenderer.vala"
	if ((render_time - _tmp25_) <= ((gint64) (_tmp28_ * 1000))) {
#line 1128 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1128 "../lib/DockRenderer.vala"
		return result;
#line 5688 "DockRenderer.c"
	}
#line 1129 "../lib/DockRenderer.vala"
	if (self->priv->show_notifications) {
#line 5692 "DockRenderer.c"
		gint _tmp30_ = 0;
		gdouble _tmp31_;
		gint64 _tmp38_;
		gint64 _tmp39_;
#line 1130 "../lib/DockRenderer.vala"
		_tmp31_ = self->priv->_hide_progress;
#line 1130 "../lib/DockRenderer.vala"
		if (_tmp31_ == 1.0) {
#line 5701 "DockRenderer.c"
			PlankDockTheme* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
#line 1130 "../lib/DockRenderer.vala"
			_tmp32_ = self->priv->_theme;
#line 1130 "../lib/DockRenderer.vala"
			_tmp33_ = plank_dock_theme_get_GlowTime (_tmp32_);
#line 1130 "../lib/DockRenderer.vala"
			_tmp34_ = _tmp33_;
#line 1130 "../lib/DockRenderer.vala"
			_tmp30_ = _tmp34_;
#line 5713 "DockRenderer.c"
		} else {
			PlankDockTheme* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
#line 1130 "../lib/DockRenderer.vala"
			_tmp35_ = self->priv->_theme;
#line 1130 "../lib/DockRenderer.vala"
			_tmp36_ = plank_dock_theme_get_UrgentBounceTime (_tmp35_);
#line 1130 "../lib/DockRenderer.vala"
			_tmp37_ = _tmp36_;
#line 1130 "../lib/DockRenderer.vala"
			_tmp30_ = _tmp37_;
#line 5726 "DockRenderer.c"
		}
#line 1130 "../lib/DockRenderer.vala"
		_tmp38_ = plank_dock_element_get_LastUrgent ((PlankDockElement*) item);
#line 1130 "../lib/DockRenderer.vala"
		_tmp39_ = _tmp38_;
#line 1130 "../lib/DockRenderer.vala"
		_tmp29_ = (render_time - _tmp39_) <= ((gint64) (_tmp30_ * 1000));
#line 5734 "DockRenderer.c"
	} else {
#line 1129 "../lib/DockRenderer.vala"
		_tmp29_ = FALSE;
#line 5738 "DockRenderer.c"
	}
#line 1129 "../lib/DockRenderer.vala"
	if (_tmp29_) {
#line 1131 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1131 "../lib/DockRenderer.vala"
		return result;
#line 5746 "DockRenderer.c"
	}
#line 1132 "../lib/DockRenderer.vala"
	_tmp40_ = plank_dock_element_get_LastMove ((PlankDockElement*) item);
#line 1132 "../lib/DockRenderer.vala"
	_tmp41_ = _tmp40_;
#line 1132 "../lib/DockRenderer.vala"
	_tmp42_ = self->priv->_theme;
#line 1132 "../lib/DockRenderer.vala"
	_tmp43_ = plank_dock_theme_get_ItemMoveTime (_tmp42_);
#line 1132 "../lib/DockRenderer.vala"
	_tmp44_ = _tmp43_;
#line 1132 "../lib/DockRenderer.vala"
	if ((render_time - _tmp41_) <= ((gint64) (_tmp44_ * 1000))) {
#line 1133 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1133 "../lib/DockRenderer.vala"
		return result;
#line 5764 "DockRenderer.c"
	}
#line 1134 "../lib/DockRenderer.vala"
	_tmp45_ = plank_dock_element_get_AddTime ((PlankDockElement*) item);
#line 1134 "../lib/DockRenderer.vala"
	_tmp46_ = _tmp45_;
#line 1134 "../lib/DockRenderer.vala"
	_tmp47_ = self->priv->_theme;
#line 1134 "../lib/DockRenderer.vala"
	_tmp48_ = plank_dock_theme_get_ItemMoveTime (_tmp47_);
#line 1134 "../lib/DockRenderer.vala"
	_tmp49_ = _tmp48_;
#line 1134 "../lib/DockRenderer.vala"
	if ((render_time - _tmp46_) <= ((gint64) (_tmp49_ * 1000))) {
#line 1135 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1135 "../lib/DockRenderer.vala"
		return result;
#line 5782 "DockRenderer.c"
	}
#line 1136 "../lib/DockRenderer.vala"
	_tmp50_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) item);
#line 1136 "../lib/DockRenderer.vala"
	_tmp51_ = _tmp50_;
#line 1136 "../lib/DockRenderer.vala"
	_tmp52_ = self->priv->_theme;
#line 1136 "../lib/DockRenderer.vala"
	_tmp53_ = plank_dock_theme_get_ItemMoveTime (_tmp52_);
#line 1136 "../lib/DockRenderer.vala"
	_tmp54_ = _tmp53_;
#line 1136 "../lib/DockRenderer.vala"
	if ((render_time - _tmp51_) <= ((gint64) (_tmp54_ * 1000))) {
#line 1137 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1137 "../lib/DockRenderer.vala"
		return result;
#line 5800 "DockRenderer.c"
	}
#line 1138 "../lib/DockRenderer.vala"
	_tmp55_ = plank_dock_element_get_LastValid ((PlankDockElement*) item);
#line 1138 "../lib/DockRenderer.vala"
	_tmp56_ = _tmp55_;
#line 1138 "../lib/DockRenderer.vala"
	if ((render_time - _tmp56_) <= ((gint64) (PLANK_ITEM_INVALID_DURATION * 1000))) {
#line 1139 "../lib/DockRenderer.vala"
		result = TRUE;
#line 1139 "../lib/DockRenderer.vala"
		return result;
#line 5812 "DockRenderer.c"
	}
#line 1141 "../lib/DockRenderer.vala"
	result = FALSE;
#line 1141 "../lib/DockRenderer.vala"
	return result;
#line 5818 "DockRenderer.c"
}

static gint
plank_dock_renderer_compare_dock_item_position (PlankDockItem* i1,
                                                PlankDockItem* i2)
{
	gint p_i1 = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint p_i2 = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint64 _tmp4_;
	gint64 _tmp5_;
	gint64 _tmp6_;
	gint64 _tmp7_;
	gint result;
#line 1144 "../lib/DockRenderer.vala"
	g_return_val_if_fail (i1 != NULL, 0);
#line 1144 "../lib/DockRenderer.vala"
	g_return_val_if_fail (i2 != NULL, 0);
#line 1146 "../lib/DockRenderer.vala"
	_tmp0_ = plank_dock_item_get_Position (i1);
#line 1146 "../lib/DockRenderer.vala"
	_tmp1_ = _tmp0_;
#line 1146 "../lib/DockRenderer.vala"
	p_i1 = _tmp1_;
#line 1147 "../lib/DockRenderer.vala"
	_tmp2_ = plank_dock_item_get_Position (i2);
#line 1147 "../lib/DockRenderer.vala"
	_tmp3_ = _tmp2_;
#line 1147 "../lib/DockRenderer.vala"
	p_i2 = _tmp3_;
#line 1149 "../lib/DockRenderer.vala"
	if (p_i1 > p_i2) {
#line 1150 "../lib/DockRenderer.vala"
		result = 1;
#line 1150 "../lib/DockRenderer.vala"
		return result;
#line 5858 "DockRenderer.c"
	}
#line 1152 "../lib/DockRenderer.vala"
	if (p_i1 < p_i2) {
#line 1153 "../lib/DockRenderer.vala"
		result = -1;
#line 1153 "../lib/DockRenderer.vala"
		return result;
#line 5866 "DockRenderer.c"
	}
#line 1155 "../lib/DockRenderer.vala"
	_tmp4_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) i1);
#line 1155 "../lib/DockRenderer.vala"
	_tmp5_ = _tmp4_;
#line 1155 "../lib/DockRenderer.vala"
	_tmp6_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) i2);
#line 1155 "../lib/DockRenderer.vala"
	_tmp7_ = _tmp6_;
#line 1155 "../lib/DockRenderer.vala"
	if (_tmp5_ > _tmp7_) {
#line 1156 "../lib/DockRenderer.vala"
		result = -1;
#line 1156 "../lib/DockRenderer.vala"
		return result;
#line 5882 "DockRenderer.c"
	}
#line 1158 "../lib/DockRenderer.vala"
	result = 1;
#line 1158 "../lib/DockRenderer.vala"
	return result;
#line 5888 "DockRenderer.c"
}

static gdouble
plank_dock_renderer_easing_bounce (gdouble t,
                                   gdouble d,
                                   gdouble n)
{
	gdouble p = 0.0;
	gdouble result;
#line 1161 "../lib/DockRenderer.vala"
	_vala_return_val_if_fail (((t >= 0.0) && (d > 0.0)) && (n >= 1.0), "t >= 0.0 && d > 0.0 && n >= 1.0", 0.0);
#line 1161 "../lib/DockRenderer.vala"
	_vala_return_val_if_fail (t <= d, "t <= d", 0.0);
#line 1165 "../lib/DockRenderer.vala"
	p = t / d;
#line 1166 "../lib/DockRenderer.vala"
	result = fabs (sin ((n * G_PI) * p) * MIN (1.0, ((1.0 - p) * (2.0 * n)) / ((2.0 * n) - 1.0)));
#line 1166 "../lib/DockRenderer.vala"
	return result;
#line 5908 "DockRenderer.c"
}

static const gchar*
plank_dock_renderer_cairo_surface_type_to_string (cairo_surface_type_t type)
{
	const gchar* _result_ = NULL;
	const gchar* _tmp0_;
	const gchar* result;
#line 1173 "../lib/DockRenderer.vala"
	switch (type) {
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_IMAGE:
#line 5921 "DockRenderer.c"
		{
#line 1174 "../lib/DockRenderer.vala"
			_result_ = "IMAGE";
#line 1174 "../lib/DockRenderer.vala"
			break;
#line 5927 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_PDF:
#line 5931 "DockRenderer.c"
		{
#line 1175 "../lib/DockRenderer.vala"
			_result_ = "PDF";
#line 1175 "../lib/DockRenderer.vala"
			break;
#line 5937 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_PS:
#line 5941 "DockRenderer.c"
		{
#line 1176 "../lib/DockRenderer.vala"
			_result_ = "PS";
#line 1176 "../lib/DockRenderer.vala"
			break;
#line 5947 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_XLIB:
#line 5951 "DockRenderer.c"
		{
#line 1177 "../lib/DockRenderer.vala"
			_result_ = "XLIB";
#line 1177 "../lib/DockRenderer.vala"
			break;
#line 5957 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_XCB:
#line 5961 "DockRenderer.c"
		{
#line 1178 "../lib/DockRenderer.vala"
			_result_ = "XCB";
#line 1178 "../lib/DockRenderer.vala"
			break;
#line 5967 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_GLITZ:
#line 5971 "DockRenderer.c"
		{
#line 1179 "../lib/DockRenderer.vala"
			_result_ = "GLITZ";
#line 1179 "../lib/DockRenderer.vala"
			break;
#line 5977 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_QUARTZ:
#line 5981 "DockRenderer.c"
		{
#line 1180 "../lib/DockRenderer.vala"
			_result_ = "QUARTZ";
#line 1180 "../lib/DockRenderer.vala"
			break;
#line 5987 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_WIN32:
#line 5991 "DockRenderer.c"
		{
#line 1181 "../lib/DockRenderer.vala"
			_result_ = "WIN32";
#line 1181 "../lib/DockRenderer.vala"
			break;
#line 5997 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_BEOS:
#line 6001 "DockRenderer.c"
		{
#line 1182 "../lib/DockRenderer.vala"
			_result_ = "BEOS";
#line 1182 "../lib/DockRenderer.vala"
			break;
#line 6007 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_DIRECTFB:
#line 6011 "DockRenderer.c"
		{
#line 1183 "../lib/DockRenderer.vala"
			_result_ = "DIRECTFB";
#line 1183 "../lib/DockRenderer.vala"
			break;
#line 6017 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SVG:
#line 6021 "DockRenderer.c"
		{
#line 1184 "../lib/DockRenderer.vala"
			_result_ = "SVG";
#line 1184 "../lib/DockRenderer.vala"
			break;
#line 6027 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_OS2:
#line 6031 "DockRenderer.c"
		{
#line 1185 "../lib/DockRenderer.vala"
			_result_ = "OS2";
#line 1185 "../lib/DockRenderer.vala"
			break;
#line 6037 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_WIN32_PRINTING:
#line 6041 "DockRenderer.c"
		{
#line 1186 "../lib/DockRenderer.vala"
			_result_ = "WIN32_PRINTING";
#line 1186 "../lib/DockRenderer.vala"
			break;
#line 6047 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_QUARTZ_IMAGE:
#line 6051 "DockRenderer.c"
		{
#line 1187 "../lib/DockRenderer.vala"
			_result_ = "QUARTZ_IMAGE";
#line 1187 "../lib/DockRenderer.vala"
			break;
#line 6057 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SCRIPT:
#line 6061 "DockRenderer.c"
		{
#line 1188 "../lib/DockRenderer.vala"
			_result_ = "SCRIPT";
#line 1188 "../lib/DockRenderer.vala"
			break;
#line 6067 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_QT:
#line 6071 "DockRenderer.c"
		{
#line 1189 "../lib/DockRenderer.vala"
			_result_ = "QT";
#line 1189 "../lib/DockRenderer.vala"
			break;
#line 6077 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_RECORDING:
#line 6081 "DockRenderer.c"
		{
#line 1190 "../lib/DockRenderer.vala"
			_result_ = "RECORDING";
#line 1190 "../lib/DockRenderer.vala"
			break;
#line 6087 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_VG:
#line 6091 "DockRenderer.c"
		{
#line 1191 "../lib/DockRenderer.vala"
			_result_ = "VG";
#line 1191 "../lib/DockRenderer.vala"
			break;
#line 6097 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_GL:
#line 6101 "DockRenderer.c"
		{
#line 1192 "../lib/DockRenderer.vala"
			_result_ = "GL";
#line 1192 "../lib/DockRenderer.vala"
			break;
#line 6107 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_DRM:
#line 6111 "DockRenderer.c"
		{
#line 1193 "../lib/DockRenderer.vala"
			_result_ = "DRM";
#line 1193 "../lib/DockRenderer.vala"
			break;
#line 6117 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_TEE:
#line 6121 "DockRenderer.c"
		{
#line 1194 "../lib/DockRenderer.vala"
			_result_ = "TEE";
#line 1194 "../lib/DockRenderer.vala"
			break;
#line 6127 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_XML:
#line 6131 "DockRenderer.c"
		{
#line 1195 "../lib/DockRenderer.vala"
			_result_ = "XML";
#line 1195 "../lib/DockRenderer.vala"
			break;
#line 6137 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SKIA:
#line 6141 "DockRenderer.c"
		{
#line 1196 "../lib/DockRenderer.vala"
			_result_ = "SKIA";
#line 1196 "../lib/DockRenderer.vala"
			break;
#line 6147 "DockRenderer.c"
		}
#line 1173 "../lib/DockRenderer.vala"
		case CAIRO_SURFACE_TYPE_SUBSURFACE:
#line 6151 "DockRenderer.c"
		{
#line 1197 "../lib/DockRenderer.vala"
			_result_ = "SUBSURFACE";
#line 1197 "../lib/DockRenderer.vala"
			break;
#line 6157 "DockRenderer.c"
		}
		default:
		{
#line 1200 "../lib/DockRenderer.vala"
			_result_ = "???";
#line 1200 "../lib/DockRenderer.vala"
			break;
#line 6165 "DockRenderer.c"
		}
	}
#line 1203 "../lib/DockRenderer.vala"
	_tmp0_ = _result_;
#line 1203 "../lib/DockRenderer.vala"
	result = _tmp0_;
#line 1203 "../lib/DockRenderer.vala"
	return result;
#line 6174 "DockRenderer.c"
}

static PlankDockController*
plank_dock_renderer_get_controller (PlankDockRenderer* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 27 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 27 "../lib/DockRenderer.vala"
	result = _tmp0_;
#line 27 "../lib/DockRenderer.vala"
	return result;
#line 6190 "DockRenderer.c"
}

static void
plank_dock_renderer_set_controller (PlankDockRenderer* self,
                                    PlankDockController* value)
{
	PlankDockController* old_value;
#line 27 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/DockRenderer.vala"
	old_value = plank_dock_renderer_get_controller (self);
#line 27 "../lib/DockRenderer.vala"
	if (old_value != value) {
#line 6204 "DockRenderer.c"
		PlankDockController* _tmp0_;
#line 27 "../lib/DockRenderer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->_controller);
#line 27 "../lib/DockRenderer.vala"
		self->priv->_controller = _tmp0_;
#line 27 "../lib/DockRenderer.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY]);
#line 6214 "DockRenderer.c"
	}
}

PlankDockTheme*
plank_dock_renderer_get_theme (PlankDockRenderer* self)
{
	PlankDockTheme* result;
	PlankDockTheme* _tmp0_;
#line 29 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_theme;
#line 29 "../lib/DockRenderer.vala"
	result = _tmp0_;
#line 29 "../lib/DockRenderer.vala"
	return result;
#line 6231 "DockRenderer.c"
}

static void
plank_dock_renderer_set_theme (PlankDockRenderer* self,
                               PlankDockTheme* value)
{
	PlankDockTheme* old_value;
#line 29 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 29 "../lib/DockRenderer.vala"
	old_value = plank_dock_renderer_get_theme (self);
#line 29 "../lib/DockRenderer.vala"
	if (old_value != value) {
#line 6245 "DockRenderer.c"
		PlankDockTheme* _tmp0_;
#line 29 "../lib/DockRenderer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../lib/DockRenderer.vala"
		_g_object_unref0 (self->priv->_theme);
#line 29 "../lib/DockRenderer.vala"
		self->priv->_theme = _tmp0_;
#line 29 "../lib/DockRenderer.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_THEME_PROPERTY]);
#line 6255 "DockRenderer.c"
	}
}

gdouble
plank_dock_renderer_get_hide_progress (PlankDockRenderer* self)
{
	gdouble result;
#line 35 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 35 "../lib/DockRenderer.vala"
	result = self->priv->_hide_progress;
#line 35 "../lib/DockRenderer.vala"
	return result;
#line 6269 "DockRenderer.c"
}

static void
plank_dock_renderer_set_hide_progress (PlankDockRenderer* self,
                                       gdouble value)
{
#line 35 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 35 "../lib/DockRenderer.vala"
	self->priv->_hide_progress = value;
#line 6280 "DockRenderer.c"
}

static gdouble
plank_dock_renderer_get_opacity (PlankDockRenderer* self)
{
	gdouble result;
#line 41 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "../lib/DockRenderer.vala"
	result = self->priv->_opacity;
#line 41 "../lib/DockRenderer.vala"
	return result;
#line 6293 "DockRenderer.c"
}

static void
plank_dock_renderer_set_opacity (PlankDockRenderer* self,
                                 gdouble value)
{
#line 41 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/DockRenderer.vala"
	self->priv->_opacity = value;
#line 6304 "DockRenderer.c"
}

gdouble
plank_dock_renderer_get_zoom_in_progress (PlankDockRenderer* self)
{
	gdouble result;
#line 47 "../lib/DockRenderer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 47 "../lib/DockRenderer.vala"
	result = self->priv->_zoom_in_progress;
#line 47 "../lib/DockRenderer.vala"
	return result;
#line 6317 "DockRenderer.c"
}

static void
plank_dock_renderer_set_zoom_in_progress (PlankDockRenderer* self,
                                          gdouble value)
{
#line 47 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 47 "../lib/DockRenderer.vala"
	self->priv->_zoom_in_progress = value;
#line 6328 "DockRenderer.c"
}

void
plank_dock_renderer_get_local_cursor (PlankDockRenderer* self,
                                      GdkPoint * result)
{
	GdkPoint _tmp0_;
#line 53 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 53 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_local_cursor;
#line 53 "../lib/DockRenderer.vala"
	*result = _tmp0_;
#line 53 "../lib/DockRenderer.vala"
	return;
#line 6344 "DockRenderer.c"
}

static void
plank_dock_renderer_set_local_cursor (PlankDockRenderer* self,
                                      GdkPoint * value)
{
	GdkPoint _tmp0_;
#line 53 "../lib/DockRenderer.vala"
	g_return_if_fail (self != NULL);
#line 53 "../lib/DockRenderer.vala"
	_tmp0_ = *value;
#line 53 "../lib/DockRenderer.vala"
	self->priv->_local_cursor = _tmp0_;
#line 6358 "DockRenderer.c"
}

static GObject *
plank_dock_renderer_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockRenderer * self;
	GeeHashSet* _tmp0_;
	GeeArrayList* _tmp1_;
	PlankDockController* _tmp2_;
	PlankDockPreferences* _tmp3_;
	PlankDockPreferences* _tmp4_;
#line 98 "../lib/DockRenderer.vala"
	parent_class = G_OBJECT_CLASS (plank_dock_renderer_parent_class);
#line 98 "../lib/DockRenderer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 98 "../lib/DockRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 100 "../lib/DockRenderer.vala"
	_tmp0_ = gee_hash_set_new (PLANK_TYPE_DOCK_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 100 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->transient_items);
#line 100 "../lib/DockRenderer.vala"
	self->priv->transient_items = _tmp0_;
#line 101 "../lib/DockRenderer.vala"
	_tmp1_ = gee_array_list_new (PLANK_TYPE_DOCK_ITEM, NULL, NULL, NULL, NULL, NULL);
#line 101 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->current_items);
#line 101 "../lib/DockRenderer.vala"
	self->priv->current_items = _tmp1_;
#line 105 "../lib/DockRenderer.vala"
	_tmp2_ = self->priv->_controller;
#line 105 "../lib/DockRenderer.vala"
	_tmp3_ = plank_dock_controller_get_prefs (_tmp2_);
#line 105 "../lib/DockRenderer.vala"
	_tmp4_ = _tmp3_;
#line 105 "../lib/DockRenderer.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify", (GCallback) _plank_dock_renderer_prefs_changed_g_object_notify, self, 0);
#line 107 "../lib/DockRenderer.vala"
	plank_dock_renderer_load_theme (self);
#line 98 "../lib/DockRenderer.vala"
	return obj;
#line 6404 "DockRenderer.c"
}

static void
plank_dock_renderer_class_init (PlankDockRendererClass * klass,
                                gpointer klass_data)
{
#line 25 "../lib/DockRenderer.vala"
	plank_dock_renderer_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/DockRenderer.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockRenderer_private_offset);
#line 25 "../lib/DockRenderer.vala"
	((PlankRendererClass *) klass)->initialize_frame = (void (*) (PlankRenderer*, gint64)) plank_dock_renderer_real_initialize_frame;
#line 25 "../lib/DockRenderer.vala"
	((PlankRendererClass *) klass)->draw = (void (*) (PlankRenderer*, cairo_t*, gint64)) plank_dock_renderer_real_draw;
#line 25 "../lib/DockRenderer.vala"
	((PlankRendererClass *) klass)->animation_needed = (gboolean (*) (PlankRenderer*, gint64)) plank_dock_renderer_real_animation_needed;
#line 25 "../lib/DockRenderer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_renderer_get_property;
#line 25 "../lib/DockRenderer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_renderer_set_property;
#line 25 "../lib/DockRenderer.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dock_renderer_constructor;
#line 25 "../lib/DockRenderer.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_renderer_finalize;
#line 25 "../lib/DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "../lib/DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_THEME_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_THEME_PROPERTY] = g_param_spec_object ("theme", "theme", "theme", PLANK_TYPE_DOCK_THEME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6433 "DockRenderer.c"
	/**
	 * The current progress [0.0..1.0] of the hide-animation of the dock.
	 */
#line 25 "../lib/DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY] = g_param_spec_double ("hide-progress", "hide-progress", "hide-progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 6439 "DockRenderer.c"
	/**
	 * The current progress [0.0..1.0] of the zoom-in-animation of the dock.
	 */
#line 25 "../lib/DockRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY, plank_dock_renderer_properties[PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY] = g_param_spec_double ("zoom-in-progress", "zoom-in-progress", "zoom-in-progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 6445 "DockRenderer.c"
}

static void
plank_dock_renderer_instance_init (PlankDockRenderer * self,
                                   gpointer klass)
{
#line 25 "../lib/DockRenderer.vala"
	self->priv = plank_dock_renderer_get_instance_private (self);
#line 55 "../lib/DockRenderer.vala"
	self->priv->main_buffer = NULL;
#line 56 "../lib/DockRenderer.vala"
	self->priv->fade_buffer = NULL;
#line 57 "../lib/DockRenderer.vala"
	self->priv->item_buffer = NULL;
#line 58 "../lib/DockRenderer.vala"
	self->priv->shadow_buffer = NULL;
#line 60 "../lib/DockRenderer.vala"
	self->priv->background_buffer = NULL;
#line 62 "../lib/DockRenderer.vala"
	self->priv->indicator_buffer = NULL;
#line 63 "../lib/DockRenderer.vala"
	self->priv->urgent_indicator_buffer = NULL;
#line 64 "../lib/DockRenderer.vala"
	self->priv->urgent_glow_buffer = NULL;
#line 66 "../lib/DockRenderer.vala"
	self->priv->last_hide = 0LL;
#line 67 "../lib/DockRenderer.vala"
	self->priv->last_hovered_changed = 0LL;
#line 69 "../lib/DockRenderer.vala"
	self->priv->screen_is_composited = FALSE;
#line 70 "../lib/DockRenderer.vala"
	self->priv->show_notifications = TRUE;
#line 71 "../lib/DockRenderer.vala"
	self->priv->reset_position_manager_timer_id = 0U;
#line 72 "../lib/DockRenderer.vala"
	self->priv->window_scale_factor = 1;
#line 73 "../lib/DockRenderer.vala"
	self->priv->is_first_frame = TRUE;
#line 74 "../lib/DockRenderer.vala"
	self->priv->zoom_changed = FALSE;
#line 76 "../lib/DockRenderer.vala"
	self->priv->gtk_theme_name_changed_handler_id = 0UL;
#line 77 "../lib/DockRenderer.vala"
	self->priv->granite_prefers_color_scheme_handler_id = 0UL;
#line 79 "../lib/DockRenderer.vala"
	self->priv->dynamic_animation_offset = 0.0;
#line 6492 "DockRenderer.c"
}

static void
plank_dock_renderer_finalize (GObject * obj)
{
	PlankDockRenderer * self;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	guint _tmp3_;
	PlankDockTheme* _tmp4_;
	guint _tmp5_;
	PlankDockController* _tmp6_;
	PlankHideManager* _tmp7_;
	PlankHideManager* _tmp8_;
	guint _tmp9_;
	GQuark _tmp10_;
	PlankDockController* _tmp11_;
	PlankHideManager* _tmp12_;
	PlankHideManager* _tmp13_;
	guint _tmp14_;
	GQuark _tmp15_;
	PlankDockController* _tmp16_;
	PlankDockWindow* _tmp17_;
	PlankDockWindow* _tmp18_;
	guint _tmp19_;
	GQuark _tmp20_;
#line 25 "../lib/DockRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 125 "../lib/DockRenderer.vala"
	_tmp0_ = self->priv->_controller;
#line 125 "../lib/DockRenderer.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 125 "../lib/DockRenderer.vala"
	_tmp2_ = _tmp1_;
#line 125 "../lib/DockRenderer.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp3_, NULL, FALSE);
#line 125 "../lib/DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_dock_renderer_prefs_changed_g_object_notify, self);
#line 126 "../lib/DockRenderer.vala"
	_tmp4_ = self->priv->_theme;
#line 126 "../lib/DockRenderer.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
#line 126 "../lib/DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_dock_renderer_theme_changed_g_object_notify, self);
#line 128 "../lib/DockRenderer.vala"
	_tmp6_ = self->priv->_controller;
#line 128 "../lib/DockRenderer.vala"
	_tmp7_ = plank_dock_controller_get_hide_manager (_tmp6_);
#line 128 "../lib/DockRenderer.vala"
	_tmp8_ = _tmp7_;
#line 128 "../lib/DockRenderer.vala"
	g_signal_parse_name ("notify::Hidden", G_TYPE_OBJECT, &_tmp9_, &_tmp10_, TRUE);
#line 128 "../lib/DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, _tmp10_, NULL, (GCallback) _plank_dock_renderer_hidden_changed_g_object_notify, self);
#line 129 "../lib/DockRenderer.vala"
	_tmp11_ = self->priv->_controller;
#line 129 "../lib/DockRenderer.vala"
	_tmp12_ = plank_dock_controller_get_hide_manager (_tmp11_);
#line 129 "../lib/DockRenderer.vala"
	_tmp13_ = _tmp12_;
#line 129 "../lib/DockRenderer.vala"
	g_signal_parse_name ("notify::Hovered", G_TYPE_OBJECT, &_tmp14_, &_tmp15_, TRUE);
#line 129 "../lib/DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, _tmp15_, NULL, (GCallback) _plank_dock_renderer_hovered_changed_g_object_notify, self);
#line 130 "../lib/DockRenderer.vala"
	_tmp16_ = self->priv->_controller;
#line 130 "../lib/DockRenderer.vala"
	_tmp17_ = plank_dock_controller_get_window (_tmp16_);
#line 130 "../lib/DockRenderer.vala"
	_tmp18_ = _tmp17_;
#line 130 "../lib/DockRenderer.vala"
	g_signal_parse_name ("notify::HoveredItem", G_TYPE_OBJECT, &_tmp19_, &_tmp20_, TRUE);
#line 130 "../lib/DockRenderer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, _tmp20_, NULL, (GCallback) _plank_renderer_animated_draw_g_object_notify, (PlankRenderer*) self);
#line 27 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->_controller);
#line 29 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->_theme);
#line 55 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->main_buffer);
#line 56 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->fade_buffer);
#line 57 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->item_buffer);
#line 58 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->shadow_buffer);
#line 60 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->background_buffer);
#line 62 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->indicator_buffer);
#line 63 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_indicator_buffer);
#line 64 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->urgent_glow_buffer);
#line 81 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->current_items);
#line 82 "../lib/DockRenderer.vala"
	_g_object_unref0 (self->priv->transient_items);
#line 25 "../lib/DockRenderer.vala"
	G_OBJECT_CLASS (plank_dock_renderer_parent_class)->finalize (obj);
#line 6594 "DockRenderer.c"
}

/**
 * Handles all of the drawing for a dock.
 */
static GType
plank_dock_renderer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockRenderer), 0, (GInstanceInitFunc) plank_dock_renderer_instance_init, NULL };
	GType plank_dock_renderer_type_id;
	plank_dock_renderer_type_id = g_type_register_static (PLANK_TYPE_RENDERER, "PlankDockRenderer", &g_define_type_info, 0);
	PlankDockRenderer_private_offset = g_type_add_instance_private (plank_dock_renderer_type_id, sizeof (PlankDockRendererPrivate));
	return plank_dock_renderer_type_id;
}

GType
plank_dock_renderer_get_type (void)
{
	static volatile gsize plank_dock_renderer_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_renderer_type_id__once)) {
		GType plank_dock_renderer_type_id;
		plank_dock_renderer_type_id = plank_dock_renderer_get_type_once ();
		g_once_init_leave (&plank_dock_renderer_type_id__once, plank_dock_renderer_type_id);
	}
	return plank_dock_renderer_type_id__once;
}

static void
_vala_plank_dock_renderer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	PlankDockRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 25 "../lib/DockRenderer.vala"
	switch (property_id) {
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		g_value_set_object (value, plank_dock_renderer_get_controller (self));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_THEME_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		g_value_set_object (value, plank_dock_renderer_get_theme (self));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		g_value_set_double (value, plank_dock_renderer_get_hide_progress (self));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		g_value_set_double (value, plank_dock_renderer_get_zoom_in_progress (self));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 6656 "DockRenderer.c"
		default:
#line 25 "../lib/DockRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/DockRenderer.vala"
		break;
#line 6662 "DockRenderer.c"
	}
}

static void
_vala_plank_dock_renderer_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	PlankDockRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_RENDERER, PlankDockRenderer);
#line 25 "../lib/DockRenderer.vala"
	switch (property_id) {
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_CONTROLLER_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_controller (self, g_value_get_object (value));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_THEME_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_theme (self, g_value_get_object (value));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_HIDE_PROGRESS_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_hide_progress (self, g_value_get_double (value));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 25 "../lib/DockRenderer.vala"
		case PLANK_DOCK_RENDERER_ZOOM_IN_PROGRESS_PROPERTY:
#line 25 "../lib/DockRenderer.vala"
		plank_dock_renderer_set_zoom_in_progress (self, g_value_get_double (value));
#line 25 "../lib/DockRenderer.vala"
		break;
#line 6700 "DockRenderer.c"
		default:
#line 25 "../lib/DockRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/DockRenderer.vala"
		break;
#line 6706 "DockRenderer.c"
	}
}

