/* ApplicationDockItem.c generated by valac 0.56.9, the Vala compiler
 * generated from ApplicationDockItem.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <libbamf/libbamf.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "plank-internal.h"
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>

#define PLANK_APPLICATION_DOCK_ITEM_DESKTOP_ACTION_KEY "Actions"
#define PLANK_APPLICATION_DOCK_ITEM_DESKTOP_ACTION_GROUP_NAME "Desktop Action %s"
#define PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_KEY "X-Ayatana-Desktop-Shortcuts"
#define PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_SHORTCUT_GROUP_NAME "%s Shortcut Group"
#define PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_TARGET_KEY "TargetEnvironment"
#define PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_TARGET_VALUE "Unity"

enum  {
	PLANK_APPLICATION_DOCK_ITEM_0_PROPERTY,
	PLANK_APPLICATION_DOCK_ITEM_APP_PROPERTY,
	PLANK_APPLICATION_DOCK_ITEM_NUM_PROPERTIES
};
static GParamSpec* plank_application_dock_item_properties[PLANK_APPLICATION_DOCK_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	PLANK_APPLICATION_DOCK_ITEM_PIN_LAUNCHER_SIGNAL,
	PLANK_APPLICATION_DOCK_ITEM_APP_CLOSED_SIGNAL,
	PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_ADDED_SIGNAL,
	PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_REMOVED_SIGNAL,
	PLANK_APPLICATION_DOCK_ITEM_NUM_SIGNALS
};
static guint plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankApplicationDockItemPrivate {
	BamfApplication* app;
	GeeArrayList* supported_mime_types;
	GeeArrayList* actions;
	GeeHashMap* actions_map;
	gchar* unity_application_uri;
	gchar* unity_dbusname;
};

struct _Block7Data {
	int _ref_count_;
	PlankApplicationDockItem* self;
	guint32 event_time;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	gchar** values;
	gint values_length1;
	gint _values_size_;
};

struct _Block9Data {
	int _ref_count_;
	Block7Data * _data7_;
	BamfWindow* window;
};

static gint PlankApplicationDockItem_private_offset;
static gpointer plank_application_dock_item_parent_class = NULL;

 G_GNUC_INTERNAL void plank_application_dock_item_set_App (PlankApplicationDockItem* self,
                                          BamfApplication* value);
static void plank_application_dock_item_app_signals_connect (PlankApplicationDockItem* self,
                                                      BamfApplication* app);
static void plank_application_dock_item_handle_active_changed (PlankApplicationDockItem* self,
                                                        gboolean is_active);
static void _plank_application_dock_item_handle_active_changed_bamf_view_active_changed (BamfView* _sender,
                                                                                  gboolean active,
                                                                                  gpointer self);
static void plank_application_dock_item_handle_name_changed (PlankApplicationDockItem* self,
                                                      const gchar* old_name,
                                                      const gchar* new_name);
static void _plank_application_dock_item_handle_name_changed_bamf_view_name_changed (BamfView* _sender,
                                                                              const gchar* old_name,
                                                                              const gchar* new_name,
                                                                              gpointer self);
static void plank_application_dock_item_handle_running_changed (PlankApplicationDockItem* self,
                                                         gboolean is_running);
static void _plank_application_dock_item_handle_running_changed_bamf_view_running_changed (BamfView* _sender,
                                                                                    gboolean running,
                                                                                    gpointer self);
static void plank_application_dock_item_handle_urgent_changed (PlankApplicationDockItem* self,
                                                        gboolean is_urgent);
static void _plank_application_dock_item_handle_urgent_changed_bamf_view_urgent_changed (BamfView* _sender,
                                                                                  gboolean urgent,
                                                                                  gpointer self);
static void plank_application_dock_item_handle_user_visible_changed (PlankApplicationDockItem* self,
                                                              gboolean user_visible);
static void _plank_application_dock_item_handle_user_visible_changed_bamf_view_user_visible_changed (BamfView* _sender,
                                                                                              gboolean user_visible,
                                                                                              gpointer self);
static void plank_application_dock_item_handle_window_added (PlankApplicationDockItem* self,
                                                      BamfView* child);
static void _plank_application_dock_item_handle_window_added_bamf_view_child_added (BamfView* _sender,
                                                                             BamfView* child,
                                                                             gpointer self);
static void plank_application_dock_item_handle_window_removed (PlankApplicationDockItem* self,
                                                        BamfView* child);
static void _plank_application_dock_item_handle_window_removed_bamf_view_child_removed (BamfView* _sender,
                                                                                 BamfView* child,
                                                                                 gpointer self);
static void plank_application_dock_item_handle_closed (PlankApplicationDockItem* self);
static void _plank_application_dock_item_handle_closed_bamf_view_closed (BamfView* _sender,
                                                                  gpointer self);
static void plank_application_dock_item_app_signals_disconnect (PlankApplicationDockItem* self,
                                                         BamfApplication* app);
static void plank_application_dock_item_initialize_states (PlankApplicationDockItem* self);
 G_GNUC_INTERNAL BamfApplication* plank_application_dock_item_get_App (PlankApplicationDockItem* self);
static void plank_application_dock_item_update_indicator (PlankApplicationDockItem* self);
static inline void plank_application_dock_item_reset_application_status (PlankApplicationDockItem* self);
static void plank_application_dock_item_launch (PlankApplicationDockItem* self);
static PlankAnimationType plank_application_dock_item_real_on_clicked (PlankDockElement* base,
                                                                PlankPopupButton button,
                                                                GdkModifierType mod,
                                                                guint32 event_time);
static PlankAnimationType plank_application_dock_item_real_on_scrolled (PlankDockElement* base,
                                                                 GdkScrollDirection direction,
                                                                 GdkModifierType mod,
                                                                 guint32 event_time);
static gchar* plank_application_dock_item_shorten_window_name (PlankApplicationDockItem* self,
                                                        const gchar* window_name);
static GeeArrayList* plank_application_dock_item_real_get_menu_items (PlankDockElement* base);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda40_ (PlankApplicationDockItem* self);
static void ____lambda40__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda41_ (Block7Data* _data7_);
static void ____lambda41__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void _____lambda42_ (Block8Data* _data8_);
static void ______lambda42__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void ______lambda43_ (Block9Data* _data9_);
static void _______lambda43__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static gchar* plank_application_dock_item_real_get_drop_text (PlankDockElement* base);
static gboolean plank_application_dock_item_real_can_accept_drop (PlankDockElement* base,
                                                           GeeArrayList* uris);
static gboolean plank_application_dock_item_real_accept_drop (PlankDockElement* base,
                                                       GeeArrayList* uris);
static void plank_application_dock_item_real_load_from_launcher (PlankDockItem* base);
static void plank_application_dock_item_unity_update_application_uri (PlankApplicationDockItem* self);
static GObject * plank_application_dock_item_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void plank_application_dock_item_finalize (GObject * obj);
static GType plank_application_dock_item_get_type_once (void);
static void _vala_plank_application_dock_item_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_plank_application_dock_item_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const gchar* PLANK_APPLICATION_DOCK_ITEM_SUPPORTED_GETTEXT_DOMAINS_KEYS[2] = {"X-Ubuntu-Gettext-Domain", "X-GNOME-Gettext-Domain"};

static inline gpointer
plank_application_dock_item_get_instance_private (PlankApplicationDockItem* self)
{
	return G_STRUCT_MEMBER_P (self, PlankApplicationDockItem_private_offset);
}

/**
 * {@inheritDoc}
 */
PlankApplicationDockItem*
plank_application_dock_item_construct_with_dockitem_file (GType object_type,
                                                          GFile* file)
{
	PlankApplicationDockItem * self = NULL;
	PlankDockItemPreferences* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
#line 114 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 116 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new_with_file (file);
#line 116 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 116 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) g_object_new (object_type, "Prefs", _tmp1_, NULL);
#line 116 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (_tmp1_);
#line 114 "../lib/Items/ApplicationDockItem.vala"
	return self;
#line 246 "ApplicationDockItem.c"
}

PlankApplicationDockItem*
plank_application_dock_item_new_with_dockitem_file (GFile* file)
{
#line 114 "../lib/Items/ApplicationDockItem.vala"
	return plank_application_dock_item_construct_with_dockitem_file (PLANK_TYPE_APPLICATION_DOCK_ITEM, file);
#line 254 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
PlankApplicationDockItem*
plank_application_dock_item_construct_with_dockitem_filename (GType object_type,
                                                              const gchar* filename)
{
	PlankApplicationDockItem * self = NULL;
	PlankDockItemPreferences* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
#line 122 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 124 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new_with_filename (filename);
#line 124 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 124 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) g_object_new (object_type, "Prefs", _tmp1_, NULL);
#line 124 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (_tmp1_);
#line 122 "../lib/Items/ApplicationDockItem.vala"
	return self;
#line 279 "ApplicationDockItem.c"
}

PlankApplicationDockItem*
plank_application_dock_item_new_with_dockitem_filename (const gchar* filename)
{
#line 122 "../lib/Items/ApplicationDockItem.vala"
	return plank_application_dock_item_construct_with_dockitem_filename (PLANK_TYPE_APPLICATION_DOCK_ITEM, filename);
#line 287 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_active_changed_bamf_view_active_changed (BamfView* _sender,
                                                                             gboolean active,
                                                                             gpointer self)
{
#line 150 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_active_changed ((PlankApplicationDockItem*) self, active);
#line 297 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_name_changed_bamf_view_name_changed (BamfView* _sender,
                                                                         const gchar* old_name,
                                                                         const gchar* new_name,
                                                                         gpointer self)
{
#line 151 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_name_changed ((PlankApplicationDockItem*) self, old_name, new_name);
#line 308 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_running_changed_bamf_view_running_changed (BamfView* _sender,
                                                                               gboolean running,
                                                                               gpointer self)
{
#line 152 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_running_changed ((PlankApplicationDockItem*) self, running);
#line 318 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_urgent_changed_bamf_view_urgent_changed (BamfView* _sender,
                                                                             gboolean urgent,
                                                                             gpointer self)
{
#line 153 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_urgent_changed ((PlankApplicationDockItem*) self, urgent);
#line 328 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_user_visible_changed_bamf_view_user_visible_changed (BamfView* _sender,
                                                                                         gboolean user_visible,
                                                                                         gpointer self)
{
#line 154 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_user_visible_changed ((PlankApplicationDockItem*) self, user_visible);
#line 338 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_window_added_bamf_view_child_added (BamfView* _sender,
                                                                        BamfView* child,
                                                                        gpointer self)
{
#line 155 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_window_added ((PlankApplicationDockItem*) self, child);
#line 348 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_window_removed_bamf_view_child_removed (BamfView* _sender,
                                                                            BamfView* child,
                                                                            gpointer self)
{
#line 156 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_window_removed ((PlankApplicationDockItem*) self, child);
#line 358 "ApplicationDockItem.c"
}

static void
_plank_application_dock_item_handle_closed_bamf_view_closed (BamfView* _sender,
                                                             gpointer self)
{
#line 157 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_closed ((PlankApplicationDockItem*) self);
#line 367 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_app_signals_connect (PlankApplicationDockItem* self,
                                                 BamfApplication* app)
{
#line 148 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 148 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (app != NULL);
#line 150 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "active-changed", (GCallback) _plank_application_dock_item_handle_active_changed_bamf_view_active_changed, self, G_CONNECT_AFTER);
#line 151 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "name-changed", (GCallback) _plank_application_dock_item_handle_name_changed_bamf_view_name_changed, self, G_CONNECT_AFTER);
#line 152 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "running-changed", (GCallback) _plank_application_dock_item_handle_running_changed_bamf_view_running_changed, self, G_CONNECT_AFTER);
#line 153 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "urgent-changed", (GCallback) _plank_application_dock_item_handle_urgent_changed_bamf_view_urgent_changed, self, G_CONNECT_AFTER);
#line 154 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "user-visible-changed", (GCallback) _plank_application_dock_item_handle_user_visible_changed_bamf_view_user_visible_changed, self, G_CONNECT_AFTER);
#line 155 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "child-added", (GCallback) _plank_application_dock_item_handle_window_added_bamf_view_child_added, self, G_CONNECT_AFTER);
#line 156 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "child-removed", (GCallback) _plank_application_dock_item_handle_window_removed_bamf_view_child_removed, self, G_CONNECT_AFTER);
#line 157 "../lib/Items/ApplicationDockItem.vala"
	g_signal_connect_object ((BamfView*) app, "closed", (GCallback) _plank_application_dock_item_handle_closed_bamf_view_closed, self, G_CONNECT_AFTER);
#line 394 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_app_signals_disconnect (PlankApplicationDockItem* self,
                                                    BamfApplication* app)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
#line 160 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 160 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (app != NULL);
#line 162 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("active-changed", bamf_view_get_type (), &_tmp0_, NULL, FALSE);
#line 162 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _plank_application_dock_item_handle_active_changed_bamf_view_active_changed, self);
#line 163 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("name-changed", bamf_view_get_type (), &_tmp1_, NULL, FALSE);
#line 163 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_application_dock_item_handle_name_changed_bamf_view_name_changed, self);
#line 164 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("running-changed", bamf_view_get_type (), &_tmp2_, NULL, FALSE);
#line 164 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_application_dock_item_handle_running_changed_bamf_view_running_changed, self);
#line 165 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("urgent-changed", bamf_view_get_type (), &_tmp3_, NULL, FALSE);
#line 165 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_application_dock_item_handle_urgent_changed_bamf_view_urgent_changed, self);
#line 166 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("user-visible-changed", bamf_view_get_type (), &_tmp4_, NULL, FALSE);
#line 166 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _plank_application_dock_item_handle_user_visible_changed_bamf_view_user_visible_changed, self);
#line 167 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("child-added", bamf_view_get_type (), &_tmp5_, NULL, FALSE);
#line 167 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_application_dock_item_handle_window_added_bamf_view_child_added, self);
#line 168 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("child-removed", bamf_view_get_type (), &_tmp6_, NULL, FALSE);
#line 168 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_application_dock_item_handle_window_removed_bamf_view_child_removed, self);
#line 169 "../lib/Items/ApplicationDockItem.vala"
	g_signal_parse_name ("closed", bamf_view_get_type (), &_tmp7_, NULL, FALSE);
#line 169 "../lib/Items/ApplicationDockItem.vala"
	g_signal_handlers_disconnect_matched ((BamfView*) app, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _plank_application_dock_item_handle_closed_bamf_view_closed, self);
#line 445 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_initialize_states (PlankApplicationDockItem* self)
{
	BamfApplication* _tmp0_;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	BamfApplication* _tmp3_;
	BamfApplication* _tmp4_;
	BamfApplication* _tmp5_;
#line 172 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 172 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_application_dock_item_get_App (self);
#line 172 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 172 "../lib/Items/ApplicationDockItem.vala"
	_vala_return_if_fail (_tmp1_ != NULL, "App != null");
#line 175 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = plank_application_dock_item_get_App (self);
#line 175 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = _tmp2_;
#line 175 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_active_changed (self, bamf_view_is_active ((BamfView*) _tmp3_));
#line 176 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = plank_application_dock_item_get_App (self);
#line 176 "../lib/Items/ApplicationDockItem.vala"
	_tmp5_ = _tmp4_;
#line 176 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_urgent_changed (self, bamf_view_is_urgent ((BamfView*) _tmp5_));
#line 178 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_update_indicator (self);
#line 479 "ApplicationDockItem.c"
}

gboolean
plank_application_dock_item_is_running (PlankApplicationDockItem* self)
{
	gboolean _tmp0_ = FALSE;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	gboolean result;
#line 181 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 183 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = plank_application_dock_item_get_App (self);
#line 183 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = _tmp1_;
#line 183 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_ != NULL) {
#line 497 "ApplicationDockItem.c"
		BamfApplication* _tmp3_;
		BamfApplication* _tmp4_;
#line 183 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_application_dock_item_get_App (self);
#line 183 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 183 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = bamf_view_is_running ((BamfView*) _tmp4_);
#line 506 "ApplicationDockItem.c"
	} else {
#line 183 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = FALSE;
#line 510 "ApplicationDockItem.c"
	}
#line 183 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp0_;
#line 183 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 516 "ApplicationDockItem.c"
}

gboolean
plank_application_dock_item_is_window (PlankApplicationDockItem* self)
{
	BamfApplication* _tmp0_;
	BamfApplication* _tmp1_;
	const gchar* desktop_file = NULL;
	BamfApplication* _tmp2_;
	BamfApplication* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gboolean result;
#line 186 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 188 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_application_dock_item_get_App (self);
#line 188 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 188 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp1_ == NULL) {
#line 189 "../lib/Items/ApplicationDockItem.vala"
		result = FALSE;
#line 189 "../lib/Items/ApplicationDockItem.vala"
		return result;
#line 543 "ApplicationDockItem.c"
	}
#line 191 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = plank_application_dock_item_get_App (self);
#line 191 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = _tmp2_;
#line 191 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = bamf_application_get_desktop_file (_tmp3_);
#line 191 "../lib/Items/ApplicationDockItem.vala"
	desktop_file = _tmp4_;
#line 192 "../lib/Items/ApplicationDockItem.vala"
	_tmp6_ = desktop_file;
#line 192 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp6_ == NULL) {
#line 192 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = TRUE;
#line 559 "ApplicationDockItem.c"
	} else {
		const gchar* _tmp7_;
#line 192 "../lib/Items/ApplicationDockItem.vala"
		_tmp7_ = desktop_file;
#line 192 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") == 0;
#line 566 "ApplicationDockItem.c"
	}
#line 192 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp5_;
#line 192 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 572 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_handle_user_visible_changed (PlankApplicationDockItem* self,
                                                         gboolean user_visible)
{
#line 195 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 197 "../lib/Items/ApplicationDockItem.vala"
	if (user_visible) {
#line 198 "../lib/Items/ApplicationDockItem.vala"
		g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_ADDED_SIGNAL], 0);
#line 585 "ApplicationDockItem.c"
	} else {
#line 200 "../lib/Items/ApplicationDockItem.vala"
		g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_REMOVED_SIGNAL], 0);
#line 589 "ApplicationDockItem.c"
	}
}

static void
plank_application_dock_item_handle_closed (PlankApplicationDockItem* self)
{
#line 203 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 205 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_set_App (self, NULL);
#line 207 "../lib/Items/ApplicationDockItem.vala"
	g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_CLOSED_SIGNAL], 0);
#line 602 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_handle_active_changed (PlankApplicationDockItem* self,
                                                   gboolean is_active)
{
	gboolean was_active = FALSE;
	PlankItemState _tmp0_;
	PlankItemState _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 210 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 212 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_item_get_State ((PlankDockItem*) self);
#line 212 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 212 "../lib/Items/ApplicationDockItem.vala"
	was_active = (_tmp1_ & PLANK_ITEM_STATE_ACTIVE) == PLANK_ITEM_STATE_ACTIVE;
#line 214 "../lib/Items/ApplicationDockItem.vala"
	if (is_active) {
#line 214 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = !was_active;
#line 625 "ApplicationDockItem.c"
	} else {
#line 214 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = FALSE;
#line 629 "ApplicationDockItem.c"
	}
#line 214 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_) {
#line 633 "ApplicationDockItem.c"
		PlankItemState _tmp3_;
		PlankItemState _tmp4_;
#line 215 "../lib/Items/ApplicationDockItem.vala"
		plank_dock_element_set_LastActive ((PlankDockElement*) self, g_get_monotonic_time ());
#line 216 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_dock_item_get_State ((PlankDockItem*) self);
#line 216 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 216 "../lib/Items/ApplicationDockItem.vala"
		plank_dock_item_set_State ((PlankDockItem*) self, _tmp4_ | PLANK_ITEM_STATE_ACTIVE);
#line 644 "ApplicationDockItem.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 217 "../lib/Items/ApplicationDockItem.vala"
		if (!is_active) {
#line 217 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = was_active;
#line 651 "ApplicationDockItem.c"
		} else {
#line 217 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = FALSE;
#line 655 "ApplicationDockItem.c"
		}
#line 217 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp5_) {
#line 659 "ApplicationDockItem.c"
			PlankItemState _tmp6_;
			PlankItemState _tmp7_;
#line 218 "../lib/Items/ApplicationDockItem.vala"
			plank_dock_element_set_LastActive ((PlankDockElement*) self, g_get_monotonic_time ());
#line 219 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = plank_dock_item_get_State ((PlankDockItem*) self);
#line 219 "../lib/Items/ApplicationDockItem.vala"
			_tmp7_ = _tmp6_;
#line 219 "../lib/Items/ApplicationDockItem.vala"
			plank_dock_item_set_State ((PlankDockItem*) self, _tmp7_ & (~PLANK_ITEM_STATE_ACTIVE));
#line 670 "ApplicationDockItem.c"
		}
	}
}

static void
plank_application_dock_item_handle_name_changed (PlankApplicationDockItem* self,
                                                 const gchar* old_name,
                                                 const gchar* new_name)
{
#line 223 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 223 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (old_name != NULL);
#line 223 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (new_name != NULL);
#line 226 "../lib/Items/ApplicationDockItem.vala"
	if (PLANK_IS_TRANSIENT_DOCK_ITEM (self)) {
#line 227 "../lib/Items/ApplicationDockItem.vala"
		plank_dock_element_set_Text ((PlankDockElement*) self, new_name);
#line 690 "ApplicationDockItem.c"
	}
}

static void
plank_application_dock_item_handle_running_changed (PlankApplicationDockItem* self,
                                                    gboolean is_running)
{
#line 230 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 232 "../lib/Items/ApplicationDockItem.vala"
	if (!is_running) {
#line 233 "../lib/Items/ApplicationDockItem.vala"
		plank_application_dock_item_reset_application_status (self);
#line 234 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 706 "ApplicationDockItem.c"
	}
#line 237 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_update_indicator (self);
#line 239 "../lib/Items/ApplicationDockItem.vala"
	g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_ADDED_SIGNAL], 0);
#line 712 "ApplicationDockItem.c"
}

void
plank_application_dock_item_set_urgent (PlankApplicationDockItem* self,
                                        gboolean is_urgent)
{
#line 242 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 244 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_urgent_changed (self, is_urgent);
#line 723 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_handle_urgent_changed (PlankApplicationDockItem* self,
                                                   gboolean is_urgent)
{
	gboolean was_urgent = FALSE;
	PlankItemState _tmp0_;
	PlankItemState _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 247 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 249 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_item_get_State ((PlankDockItem*) self);
#line 249 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 249 "../lib/Items/ApplicationDockItem.vala"
	was_urgent = (_tmp1_ & PLANK_ITEM_STATE_URGENT) == PLANK_ITEM_STATE_URGENT;
#line 251 "../lib/Items/ApplicationDockItem.vala"
	if (is_urgent) {
#line 251 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = !was_urgent;
#line 746 "ApplicationDockItem.c"
	} else {
#line 251 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = FALSE;
#line 750 "ApplicationDockItem.c"
	}
#line 251 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_) {
#line 754 "ApplicationDockItem.c"
		PlankItemState _tmp3_;
		PlankItemState _tmp4_;
#line 252 "../lib/Items/ApplicationDockItem.vala"
		plank_dock_element_set_LastUrgent ((PlankDockElement*) self, g_get_monotonic_time ());
#line 253 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_dock_item_get_State ((PlankDockItem*) self);
#line 253 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 253 "../lib/Items/ApplicationDockItem.vala"
		plank_dock_item_set_State ((PlankDockItem*) self, _tmp4_ | PLANK_ITEM_STATE_URGENT);
#line 765 "ApplicationDockItem.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 254 "../lib/Items/ApplicationDockItem.vala"
		if (!is_urgent) {
#line 254 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = was_urgent;
#line 772 "ApplicationDockItem.c"
		} else {
#line 254 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = FALSE;
#line 776 "ApplicationDockItem.c"
		}
#line 254 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp5_) {
#line 780 "ApplicationDockItem.c"
			PlankItemState _tmp6_;
			PlankItemState _tmp7_;
#line 255 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = plank_dock_item_get_State ((PlankDockItem*) self);
#line 255 "../lib/Items/ApplicationDockItem.vala"
			_tmp7_ = _tmp6_;
#line 255 "../lib/Items/ApplicationDockItem.vala"
			plank_dock_item_set_State ((PlankDockItem*) self, _tmp7_ & (~PLANK_ITEM_STATE_URGENT));
#line 789 "ApplicationDockItem.c"
		}
	}
}

static void
plank_application_dock_item_handle_window_added (PlankApplicationDockItem* self,
                                                 BamfView* child)
{
#line 259 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 261 "../lib/Items/ApplicationDockItem.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (child, bamf_window_get_type ())) {
#line 262 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 804 "ApplicationDockItem.c"
	}
#line 264 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_update_indicator (self);
#line 266 "../lib/Items/ApplicationDockItem.vala"
	g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_ADDED_SIGNAL], 0);
#line 810 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_handle_window_removed (PlankApplicationDockItem* self,
                                                   BamfView* child)
{
#line 269 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 271 "../lib/Items/ApplicationDockItem.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (child, bamf_window_get_type ())) {
#line 272 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 823 "ApplicationDockItem.c"
	}
#line 274 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_update_indicator (self);
#line 276 "../lib/Items/ApplicationDockItem.vala"
	g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_REMOVED_SIGNAL], 0);
#line 829 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_update_indicator (PlankApplicationDockItem* self)
{
	gboolean is_running = FALSE;
	guint window_count = 0U;
	BamfApplication* _tmp2_;
	BamfApplication* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	guint _tmp6_;
#line 279 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 284 "../lib/Items/ApplicationDockItem.vala"
	is_running = plank_application_dock_item_is_running (self);
#line 286 "../lib/Items/ApplicationDockItem.vala"
	if (!is_running) {
#line 848 "ApplicationDockItem.c"
		PlankIndicatorState _tmp0_;
		PlankIndicatorState _tmp1_;
#line 287 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = plank_dock_item_get_Indicator ((PlankDockItem*) self);
#line 287 "../lib/Items/ApplicationDockItem.vala"
		_tmp1_ = _tmp0_;
#line 287 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp1_ != PLANK_INDICATOR_STATE_NONE) {
#line 288 "../lib/Items/ApplicationDockItem.vala"
			plank_dock_item_set_Indicator ((PlankDockItem*) self, PLANK_INDICATOR_STATE_NONE);
#line 859 "ApplicationDockItem.c"
		}
#line 289 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 863 "ApplicationDockItem.c"
	}
#line 292 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = plank_application_dock_item_get_App (self);
#line 292 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = _tmp2_;
#line 292 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = bamf_application_get_windows (_tmp3_);
#line 292 "../lib/Items/ApplicationDockItem.vala"
	_tmp5_ = _tmp4_;
#line 292 "../lib/Items/ApplicationDockItem.vala"
	_tmp6_ = g_list_length (_tmp5_);
#line 292 "../lib/Items/ApplicationDockItem.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 292 "../lib/Items/ApplicationDockItem.vala"
	window_count = _tmp6_;
#line 294 "../lib/Items/ApplicationDockItem.vala"
	if (window_count <= ((guint) 1)) {
#line 881 "ApplicationDockItem.c"
		PlankIndicatorState _tmp7_;
		PlankIndicatorState _tmp8_;
#line 295 "../lib/Items/ApplicationDockItem.vala"
		_tmp7_ = plank_dock_item_get_Indicator ((PlankDockItem*) self);
#line 295 "../lib/Items/ApplicationDockItem.vala"
		_tmp8_ = _tmp7_;
#line 295 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp8_ != PLANK_INDICATOR_STATE_SINGLE) {
#line 296 "../lib/Items/ApplicationDockItem.vala"
			plank_dock_item_set_Indicator ((PlankDockItem*) self, PLANK_INDICATOR_STATE_SINGLE);
#line 892 "ApplicationDockItem.c"
		}
	} else {
		PlankIndicatorState _tmp9_;
		PlankIndicatorState _tmp10_;
#line 298 "../lib/Items/ApplicationDockItem.vala"
		_tmp9_ = plank_dock_item_get_Indicator ((PlankDockItem*) self);
#line 298 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = _tmp9_;
#line 298 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp10_ != PLANK_INDICATOR_STATE_SINGLE_PLUS) {
#line 299 "../lib/Items/ApplicationDockItem.vala"
			plank_dock_item_set_Indicator ((PlankDockItem*) self, PLANK_INDICATOR_STATE_SINGLE_PLUS);
#line 905 "ApplicationDockItem.c"
		}
	}
}

static inline void
plank_application_dock_item_reset_application_status (PlankApplicationDockItem* self)
{
	PlankIndicatorState _tmp0_;
	PlankIndicatorState _tmp1_;
#line 303 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 305 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_urgent_changed (self, FALSE);
#line 306 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_handle_active_changed (self, FALSE);
#line 308 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_item_get_Indicator ((PlankDockItem*) self);
#line 308 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 308 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp1_ != PLANK_INDICATOR_STATE_NONE) {
#line 309 "../lib/Items/ApplicationDockItem.vala"
		plank_dock_item_set_Indicator ((PlankDockItem*) self, PLANK_INDICATOR_STATE_NONE);
#line 929 "ApplicationDockItem.c"
	}
}

static void
plank_application_dock_item_launch (PlankApplicationDockItem* self)
{
	PlankSystem* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
	PlankDockItemPreferences* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
#line 312 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_system_get_default ();
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = plank_dock_item_get_Prefs ((PlankDockItem*) self);
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = _tmp1_;
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = plank_dock_item_preferences_get_Launcher (_tmp2_);
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = _tmp3_;
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp5_ = g_file_new_for_uri (_tmp4_);
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_tmp6_ = _tmp5_;
#line 314 "../lib/Items/ApplicationDockItem.vala"
	plank_system_launch (_tmp0_, _tmp6_);
#line 314 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (_tmp6_);
#line 963 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static PlankAnimationType
plank_application_dock_item_real_on_clicked (PlankDockElement* base,
                                             PlankPopupButton button,
                                             GdkModifierType mod,
                                             guint32 event_time)
{
	PlankApplicationDockItem * self;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PlankAnimationType result;
#line 320 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 322 "../lib/Items/ApplicationDockItem.vala"
	if (!plank_application_dock_item_is_window (self)) {
#line 983 "ApplicationDockItem.c"
		gboolean _tmp0_ = FALSE;
#line 323 "../lib/Items/ApplicationDockItem.vala"
		if (button == PLANK_POPUP_BUTTON_MIDDLE) {
#line 323 "../lib/Items/ApplicationDockItem.vala"
			_tmp0_ = TRUE;
#line 989 "ApplicationDockItem.c"
		} else {
			gboolean _tmp1_ = FALSE;
#line 324 "../lib/Items/ApplicationDockItem.vala"
			if (button == PLANK_POPUP_BUTTON_LEFT) {
#line 994 "ApplicationDockItem.c"
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				BamfApplication* _tmp4_;
				BamfApplication* _tmp5_;
#line 324 "../lib/Items/ApplicationDockItem.vala"
				_tmp4_ = plank_application_dock_item_get_App (self);
#line 324 "../lib/Items/ApplicationDockItem.vala"
				_tmp5_ = _tmp4_;
#line 324 "../lib/Items/ApplicationDockItem.vala"
				if (_tmp5_ == NULL) {
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp3_ = TRUE;
#line 1007 "ApplicationDockItem.c"
				} else {
					BamfApplication* _tmp6_;
					BamfApplication* _tmp7_;
					GList* _tmp8_;
					GList* _tmp9_;
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp6_ = plank_application_dock_item_get_App (self);
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp7_ = _tmp6_;
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp8_ = bamf_application_get_windows (_tmp7_);
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp9_ = _tmp8_;
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp3_ = g_list_length (_tmp9_) == ((guint) 0);
#line 324 "../lib/Items/ApplicationDockItem.vala"
					(_tmp9_ == NULL) ? NULL : (_tmp9_ = (g_list_free (_tmp9_), NULL));
#line 1025 "ApplicationDockItem.c"
				}
#line 324 "../lib/Items/ApplicationDockItem.vala"
				if (_tmp3_) {
#line 324 "../lib/Items/ApplicationDockItem.vala"
					_tmp2_ = TRUE;
#line 1031 "ApplicationDockItem.c"
				} else {
#line 325 "../lib/Items/ApplicationDockItem.vala"
					_tmp2_ = (mod & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 1035 "ApplicationDockItem.c"
				}
#line 324 "../lib/Items/ApplicationDockItem.vala"
				_tmp1_ = _tmp2_;
#line 1039 "ApplicationDockItem.c"
			} else {
#line 324 "../lib/Items/ApplicationDockItem.vala"
				_tmp1_ = FALSE;
#line 1043 "ApplicationDockItem.c"
			}
#line 324 "../lib/Items/ApplicationDockItem.vala"
			_tmp0_ = _tmp1_;
#line 1047 "ApplicationDockItem.c"
		}
#line 323 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp0_) {
#line 326 "../lib/Items/ApplicationDockItem.vala"
			plank_application_dock_item_launch (self);
#line 327 "../lib/Items/ApplicationDockItem.vala"
			result = PLANK_ANIMATION_TYPE_BOUNCE;
#line 327 "../lib/Items/ApplicationDockItem.vala"
			return result;
#line 1057 "ApplicationDockItem.c"
		}
	}
#line 330 "../lib/Items/ApplicationDockItem.vala"
	if (button == PLANK_POPUP_BUTTON_LEFT) {
#line 1062 "ApplicationDockItem.c"
		BamfApplication* _tmp12_;
		BamfApplication* _tmp13_;
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp12_ = plank_application_dock_item_get_App (self);
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp13_ = _tmp12_;
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp11_ = _tmp13_ != NULL;
#line 1071 "ApplicationDockItem.c"
	} else {
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp11_ = FALSE;
#line 1075 "ApplicationDockItem.c"
	}
#line 330 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp11_) {
#line 1079 "ApplicationDockItem.c"
		BamfApplication* _tmp14_;
		BamfApplication* _tmp15_;
		GList* _tmp16_;
		GList* _tmp17_;
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp14_ = plank_application_dock_item_get_App (self);
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp15_ = _tmp14_;
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp16_ = bamf_application_get_windows (_tmp15_);
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp17_ = _tmp16_;
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = g_list_length (_tmp17_) > ((guint) 0);
#line 330 "../lib/Items/ApplicationDockItem.vala"
		(_tmp17_ == NULL) ? NULL : (_tmp17_ = (g_list_free (_tmp17_), NULL));
#line 1096 "ApplicationDockItem.c"
	} else {
#line 330 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = FALSE;
#line 1100 "ApplicationDockItem.c"
	}
#line 330 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp10_) {
#line 1104 "ApplicationDockItem.c"
		BamfApplication* _tmp18_;
		BamfApplication* _tmp19_;
#line 331 "../lib/Items/ApplicationDockItem.vala"
		_tmp18_ = plank_application_dock_item_get_App (self);
#line 331 "../lib/Items/ApplicationDockItem.vala"
		_tmp19_ = _tmp18_;
#line 331 "../lib/Items/ApplicationDockItem.vala"
		plank_window_control_smart_focus (_tmp19_, event_time);
#line 332 "../lib/Items/ApplicationDockItem.vala"
		result = PLANK_ANIMATION_TYPE_DARKEN;
#line 332 "../lib/Items/ApplicationDockItem.vala"
		return result;
#line 1117 "ApplicationDockItem.c"
	}
#line 335 "../lib/Items/ApplicationDockItem.vala"
	result = PLANK_ANIMATION_TYPE_NONE;
#line 335 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 1123 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static PlankAnimationType
plank_application_dock_item_real_on_scrolled (PlankDockElement* base,
                                              GdkScrollDirection direction,
                                              GdkModifierType mod,
                                              guint32 event_time)
{
	PlankApplicationDockItem * self;
	gboolean _tmp0_ = FALSE;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	gint64 _tmp7_;
	gint64 _tmp8_;
	gboolean _tmp9_ = FALSE;
	PlankAnimationType result;
#line 341 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 343 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = plank_application_dock_item_get_App (self);
#line 343 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = _tmp1_;
#line 343 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_ == NULL) {
#line 343 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = TRUE;
#line 1153 "ApplicationDockItem.c"
	} else {
		BamfApplication* _tmp3_;
		BamfApplication* _tmp4_;
		GList* _tmp5_;
		GList* _tmp6_;
#line 343 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_application_dock_item_get_App (self);
#line 343 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 343 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = bamf_application_get_windows (_tmp4_);
#line 343 "../lib/Items/ApplicationDockItem.vala"
		_tmp6_ = _tmp5_;
#line 343 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = g_list_length (_tmp6_) == ((guint) 0);
#line 343 "../lib/Items/ApplicationDockItem.vala"
		(_tmp6_ == NULL) ? NULL : (_tmp6_ = (g_list_free (_tmp6_), NULL));
#line 1171 "ApplicationDockItem.c"
	}
#line 343 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp0_) {
#line 344 "../lib/Items/ApplicationDockItem.vala"
		result = PLANK_ANIMATION_TYPE_NONE;
#line 344 "../lib/Items/ApplicationDockItem.vala"
		return result;
#line 1179 "ApplicationDockItem.c"
	}
#line 346 "../lib/Items/ApplicationDockItem.vala"
	_tmp7_ = plank_dock_element_get_LastScrolled ((PlankDockElement*) self);
#line 346 "../lib/Items/ApplicationDockItem.vala"
	_tmp8_ = _tmp7_;
#line 346 "../lib/Items/ApplicationDockItem.vala"
	if ((g_get_monotonic_time () - _tmp8_) < ((gint64) (PLANK_ITEM_SCROLL_DURATION * 1000))) {
#line 347 "../lib/Items/ApplicationDockItem.vala"
		result = PLANK_ANIMATION_TYPE_DARKEN;
#line 347 "../lib/Items/ApplicationDockItem.vala"
		return result;
#line 1191 "ApplicationDockItem.c"
	}
#line 349 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_element_set_LastScrolled ((PlankDockElement*) self, g_get_monotonic_time ());
#line 351 "../lib/Items/ApplicationDockItem.vala"
	if (direction == GDK_SCROLL_UP) {
#line 351 "../lib/Items/ApplicationDockItem.vala"
		_tmp9_ = TRUE;
#line 1199 "ApplicationDockItem.c"
	} else {
#line 351 "../lib/Items/ApplicationDockItem.vala"
		_tmp9_ = direction == GDK_SCROLL_LEFT;
#line 1203 "ApplicationDockItem.c"
	}
#line 351 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp9_) {
#line 1207 "ApplicationDockItem.c"
		BamfApplication* _tmp10_;
		BamfApplication* _tmp11_;
#line 352 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = plank_application_dock_item_get_App (self);
#line 352 "../lib/Items/ApplicationDockItem.vala"
		_tmp11_ = _tmp10_;
#line 352 "../lib/Items/ApplicationDockItem.vala"
		plank_window_control_focus_previous (_tmp11_, event_time);
#line 1216 "ApplicationDockItem.c"
	} else {
		BamfApplication* _tmp12_;
		BamfApplication* _tmp13_;
#line 354 "../lib/Items/ApplicationDockItem.vala"
		_tmp12_ = plank_application_dock_item_get_App (self);
#line 354 "../lib/Items/ApplicationDockItem.vala"
		_tmp13_ = _tmp12_;
#line 354 "../lib/Items/ApplicationDockItem.vala"
		plank_window_control_focus_next (_tmp13_, event_time);
#line 1226 "ApplicationDockItem.c"
	}
#line 356 "../lib/Items/ApplicationDockItem.vala"
	result = PLANK_ANIMATION_TYPE_DARKEN;
#line 356 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 1232 "ApplicationDockItem.c"
}

static gchar*
plank_application_dock_item_shorten_window_name (PlankApplicationDockItem* self,
                                                 const gchar* window_name)
{
#line 361 "../lib/Items/ApplicationDockItem.vala"
	static const gchar* WINDOW_NAME_PATTERN[5] = {"%s - (.+)", "(.+) - %s", "%s – (.+)", "(.+) – %s", "%s: (.+)"};
#line 362 "../lib/Items/ApplicationDockItem.vala"
	static const gchar* APP_NAME_DELIMITER[3] = {" ", "-", "–"};
#line 1243 "ApplicationDockItem.c"
	gchar** app_strings = NULL;
	gint app_strings_length1;
	gint _app_strings_size_;
	GMatchInfo* m = NULL;
	gchar* _tmp23_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 359 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (window_name != NULL, NULL);
#line 364 "../lib/Items/ApplicationDockItem.vala"
	app_strings = NULL;
#line 364 "../lib/Items/ApplicationDockItem.vala"
	app_strings_length1 = 0;
#line 364 "../lib/Items/ApplicationDockItem.vala"
	_app_strings_size_ = app_strings_length1;
#line 1261 "ApplicationDockItem.c"
	{
		const gchar** d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 365 "../lib/Items/ApplicationDockItem.vala"
		d_collection = APP_NAME_DELIMITER;
#line 365 "../lib/Items/ApplicationDockItem.vala"
		d_collection_length1 = G_N_ELEMENTS (APP_NAME_DELIMITER);
#line 365 "../lib/Items/ApplicationDockItem.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 1273 "ApplicationDockItem.c"
			const gchar* d = NULL;
#line 365 "../lib/Items/ApplicationDockItem.vala"
			d = d_collection[d_it];
#line 1277 "ApplicationDockItem.c"
			{
				const gchar* _tmp0_;
				const gchar* _tmp1_;
				const gchar* _tmp2_;
				gint _tmp3_ = 0;
				gchar** _tmp4_;
				gchar** _tmp5_;
				gint _tmp5__length1;
#line 366 "../lib/Items/ApplicationDockItem.vala"
				_tmp0_ = plank_dock_element_get_Text ((PlankDockElement*) self);
#line 366 "../lib/Items/ApplicationDockItem.vala"
				_tmp1_ = _tmp0_;
#line 366 "../lib/Items/ApplicationDockItem.vala"
				_tmp2_ = d;
#line 366 "../lib/Items/ApplicationDockItem.vala"
				_tmp4_ = plank_string_split_combine (_tmp1_, _tmp2_, &_tmp3_);
#line 366 "../lib/Items/ApplicationDockItem.vala"
				app_strings = (_vala_array_free (app_strings, app_strings_length1, (GDestroyNotify) g_free), NULL);
#line 366 "../lib/Items/ApplicationDockItem.vala"
				app_strings = _tmp4_;
#line 366 "../lib/Items/ApplicationDockItem.vala"
				app_strings_length1 = _tmp3_;
#line 366 "../lib/Items/ApplicationDockItem.vala"
				_app_strings_size_ = app_strings_length1;
#line 367 "../lib/Items/ApplicationDockItem.vala"
				_tmp5_ = app_strings;
#line 367 "../lib/Items/ApplicationDockItem.vala"
				_tmp5__length1 = app_strings_length1;
#line 367 "../lib/Items/ApplicationDockItem.vala"
				if (_tmp5__length1 > 1) {
#line 368 "../lib/Items/ApplicationDockItem.vala"
					break;
#line 1310 "ApplicationDockItem.c"
				}
			}
		}
	}
	{
		const gchar** p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 372 "../lib/Items/ApplicationDockItem.vala"
		p_collection = WINDOW_NAME_PATTERN;
#line 372 "../lib/Items/ApplicationDockItem.vala"
		p_collection_length1 = G_N_ELEMENTS (WINDOW_NAME_PATTERN);
#line 372 "../lib/Items/ApplicationDockItem.vala"
		for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 1326 "ApplicationDockItem.c"
			const gchar* p = NULL;
#line 372 "../lib/Items/ApplicationDockItem.vala"
			p = p_collection[p_it];
#line 1330 "ApplicationDockItem.c"
			{
				gchar** _tmp6_;
				gint _tmp6__length1;
#line 373 "../lib/Items/ApplicationDockItem.vala"
				_tmp6_ = app_strings;
#line 373 "../lib/Items/ApplicationDockItem.vala"
				_tmp6__length1 = app_strings_length1;
#line 1338 "ApplicationDockItem.c"
				{
					gchar** s_collection = NULL;
					gint s_collection_length1 = 0;
					gint _s_collection_size_ = 0;
					gint s_it = 0;
#line 373 "../lib/Items/ApplicationDockItem.vala"
					s_collection = _tmp6_;
#line 373 "../lib/Items/ApplicationDockItem.vala"
					s_collection_length1 = _tmp6__length1;
#line 373 "../lib/Items/ApplicationDockItem.vala"
					for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 1350 "ApplicationDockItem.c"
						const gchar* s = NULL;
#line 373 "../lib/Items/ApplicationDockItem.vala"
						s = s_collection[s_it];
#line 1354 "ApplicationDockItem.c"
						{
							const gchar* _tmp7_;
#line 374 "../lib/Items/ApplicationDockItem.vala"
							_tmp7_ = s;
#line 374 "../lib/Items/ApplicationDockItem.vala"
							if (g_utf8_strlen (_tmp7_, (gssize) -1) < 3) {
#line 375 "../lib/Items/ApplicationDockItem.vala"
								continue;
#line 1363 "ApplicationDockItem.c"
							}
							{
								GRegex* r = NULL;
								const gchar* _tmp8_;
								const gchar* _tmp9_;
								gchar* _tmp10_;
								gchar* _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								GRegex* _tmp14_;
								GRegex* _tmp15_;
								GRegex* _tmp16_;
								GMatchInfo* _tmp17_ = NULL;
								GMatchInfo* _tmp18_;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp8_ = p;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp9_ = s;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp10_ = g_strdup_printf (_tmp8_, _tmp9_);
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp11_ = _tmp10_;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp12_ = g_strdup_printf ("^%s$", _tmp11_);
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp13_ = _tmp12_;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp14_ = g_regex_new (_tmp13_, (G_REGEX_CASELESS | G_REGEX_ANCHORED) | G_REGEX_DOLLAR_ENDONLY, G_REGEX_MATCH_ANCHORED | G_REGEX_MATCH_NOTEMPTY, &_inner_error0_);
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_tmp15_ = _tmp14_;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_g_free0 (_tmp13_);
#line 378 "../lib/Items/ApplicationDockItem.vala"
								_g_free0 (_tmp11_);
#line 378 "../lib/Items/ApplicationDockItem.vala"
								r = _tmp15_;
#line 378 "../lib/Items/ApplicationDockItem.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 378 "../lib/Items/ApplicationDockItem.vala"
									if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1404 "ApplicationDockItem.c"
										goto __catch0_g_regex_error;
									}
#line 378 "../lib/Items/ApplicationDockItem.vala"
									_g_match_info_unref0 (m);
#line 378 "../lib/Items/ApplicationDockItem.vala"
									app_strings = (_vala_array_free (app_strings, app_strings_length1, (GDestroyNotify) g_free), NULL);
#line 378 "../lib/Items/ApplicationDockItem.vala"
									g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 378 "../lib/Items/ApplicationDockItem.vala"
									g_clear_error (&_inner_error0_);
#line 378 "../lib/Items/ApplicationDockItem.vala"
									return NULL;
#line 1417 "ApplicationDockItem.c"
								}
#line 381 "../lib/Items/ApplicationDockItem.vala"
								_tmp16_ = r;
#line 381 "../lib/Items/ApplicationDockItem.vala"
								g_regex_match (_tmp16_, window_name, G_REGEX_MATCH_ANCHORED | G_REGEX_MATCH_NOTEMPTY, &_tmp17_);
#line 381 "../lib/Items/ApplicationDockItem.vala"
								_g_match_info_unref0 (m);
#line 381 "../lib/Items/ApplicationDockItem.vala"
								m = _tmp17_;
#line 382 "../lib/Items/ApplicationDockItem.vala"
								_tmp18_ = m;
#line 382 "../lib/Items/ApplicationDockItem.vala"
								if (g_match_info_matches (_tmp18_)) {
#line 1431 "ApplicationDockItem.c"
									GMatchInfo* _tmp19_;
									gchar* _tmp20_;
#line 383 "../lib/Items/ApplicationDockItem.vala"
									_tmp19_ = m;
#line 383 "../lib/Items/ApplicationDockItem.vala"
									_tmp20_ = g_match_info_fetch (_tmp19_, 1);
#line 383 "../lib/Items/ApplicationDockItem.vala"
									result = _tmp20_;
#line 383 "../lib/Items/ApplicationDockItem.vala"
									_g_regex_unref0 (r);
#line 383 "../lib/Items/ApplicationDockItem.vala"
									_g_match_info_unref0 (m);
#line 383 "../lib/Items/ApplicationDockItem.vala"
									app_strings = (_vala_array_free (app_strings, app_strings_length1, (GDestroyNotify) g_free), NULL);
#line 383 "../lib/Items/ApplicationDockItem.vala"
									return result;
#line 1448 "ApplicationDockItem.c"
								}
#line 377 "../lib/Items/ApplicationDockItem.vala"
								_g_regex_unref0 (r);
#line 1452 "ApplicationDockItem.c"
							}
							goto __finally0;
							__catch0_g_regex_error:
							{
								GError* e = NULL;
								GError* _tmp21_;
								const gchar* _tmp22_;
#line 377 "../lib/Items/ApplicationDockItem.vala"
								e = _inner_error0_;
#line 377 "../lib/Items/ApplicationDockItem.vala"
								_inner_error0_ = NULL;
#line 385 "../lib/Items/ApplicationDockItem.vala"
								_tmp21_ = e;
#line 385 "../lib/Items/ApplicationDockItem.vala"
								_tmp22_ = _tmp21_->message;
#line 385 "../lib/Items/ApplicationDockItem.vala"
								g_warning ("ApplicationDockItem.vala:385: %s", _tmp22_);
#line 377 "../lib/Items/ApplicationDockItem.vala"
								_g_error_free0 (e);
#line 1472 "ApplicationDockItem.c"
							}
							__finally0:
#line 377 "../lib/Items/ApplicationDockItem.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "../lib/Items/ApplicationDockItem.vala"
								_g_match_info_unref0 (m);
#line 377 "../lib/Items/ApplicationDockItem.vala"
								app_strings = (_vala_array_free (app_strings, app_strings_length1, (GDestroyNotify) g_free), NULL);
#line 377 "../lib/Items/ApplicationDockItem.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 377 "../lib/Items/ApplicationDockItem.vala"
								g_clear_error (&_inner_error0_);
#line 377 "../lib/Items/ApplicationDockItem.vala"
								return NULL;
#line 1487 "ApplicationDockItem.c"
							}
						}
					}
				}
			}
		}
	}
#line 390 "../lib/Items/ApplicationDockItem.vala"
	_tmp23_ = g_strdup (window_name);
#line 390 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp23_;
#line 390 "../lib/Items/ApplicationDockItem.vala"
	_g_match_info_unref0 (m);
#line 390 "../lib/Items/ApplicationDockItem.vala"
	app_strings = (_vala_array_free (app_strings, app_strings_length1, (GDestroyNotify) g_free), NULL);
#line 390 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 1505 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 396 "../lib/Items/ApplicationDockItem.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 396 "../lib/Items/ApplicationDockItem.vala"
	return _data7_;
#line 1518 "ApplicationDockItem.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 396 "../lib/Items/ApplicationDockItem.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1528 "ApplicationDockItem.c"
		PlankApplicationDockItem* self;
#line 396 "../lib/Items/ApplicationDockItem.vala"
		self = _data7_->self;
#line 396 "../lib/Items/ApplicationDockItem.vala"
		_g_object_unref0 (self);
#line 396 "../lib/Items/ApplicationDockItem.vala"
		g_slice_free (Block7Data, _data7_);
#line 1536 "ApplicationDockItem.c"
	}
}

static void
___lambda40_ (PlankApplicationDockItem* self)
{
#line 414 "../lib/Items/ApplicationDockItem.vala"
	g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_PIN_LAUNCHER_SIGNAL], 0);
#line 1545 "ApplicationDockItem.c"
}

static void
____lambda40__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 414 "../lib/Items/ApplicationDockItem.vala"
	___lambda40_ ((PlankApplicationDockItem*) self);
#line 1554 "ApplicationDockItem.c"
}

static void
___lambda41_ (Block7Data* _data7_)
{
	PlankApplicationDockItem* self;
	BamfApplication* _tmp0_;
	BamfApplication* _tmp1_;
#line 421 "../lib/Items/ApplicationDockItem.vala"
	self = _data7_->self;
#line 421 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_application_dock_item_get_App (self);
#line 421 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 421 "../lib/Items/ApplicationDockItem.vala"
	plank_window_control_close_all (_tmp1_, _data7_->event_time);
#line 1571 "ApplicationDockItem.c"
}

static void
____lambda41__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 421 "../lib/Items/ApplicationDockItem.vala"
	___lambda41_ (self);
#line 1580 "ApplicationDockItem.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 443 "../lib/Items/ApplicationDockItem.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
	return _data8_;
#line 1590 "ApplicationDockItem.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 443 "../lib/Items/ApplicationDockItem.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1600 "ApplicationDockItem.c"
		PlankApplicationDockItem* self;
#line 443 "../lib/Items/ApplicationDockItem.vala"
		self = _data8_->_data7_->self;
#line 443 "../lib/Items/ApplicationDockItem.vala"
		_data8_->values = (_vala_array_free (_data8_->values, _data8_->values_length1, (GDestroyNotify) g_free), NULL);
#line 443 "../lib/Items/ApplicationDockItem.vala"
		block7_data_unref (_data8_->_data7_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
		_data8_->_data7_ = NULL;
#line 443 "../lib/Items/ApplicationDockItem.vala"
		g_slice_free (Block8Data, _data8_);
#line 1612 "ApplicationDockItem.c"
	}
}

static void
_____lambda42_ (Block8Data* _data8_)
{
	Block7Data* _data7_;
	PlankApplicationDockItem* self;
	GError* _inner_error0_ = NULL;
#line 447 "../lib/Items/ApplicationDockItem.vala"
	_data7_ = _data8_->_data7_;
#line 447 "../lib/Items/ApplicationDockItem.vala"
	self = _data7_->self;
#line 1626 "ApplicationDockItem.c"
	{
		GAppInfo* _tmp0_ = NULL;
		gchar** _tmp1_;
		gint _tmp1__length1;
		const gchar* _tmp2_;
		GAppInfo* _tmp3_;
#line 449 "../lib/Items/ApplicationDockItem.vala"
		_tmp1_ = _data8_->values;
#line 449 "../lib/Items/ApplicationDockItem.vala"
		_tmp1__length1 = _data8_->values_length1;
#line 449 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = _tmp1_[0];
#line 449 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = g_app_info_create_from_commandline (_tmp2_, NULL, G_APP_INFO_CREATE_NONE, &_inner_error0_);
#line 449 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = _tmp3_;
#line 449 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1645 "ApplicationDockItem.c"
			goto __catch0_g_error;
		}
#line 449 "../lib/Items/ApplicationDockItem.vala"
		g_app_info_launch (_tmp0_, NULL, NULL, &_inner_error0_);
#line 449 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 449 "../lib/Items/ApplicationDockItem.vala"
			_g_object_unref0 (_tmp0_);
#line 1654 "ApplicationDockItem.c"
			goto __catch0_g_error;
		}
#line 448 "../lib/Items/ApplicationDockItem.vala"
		_g_object_unref0 (_tmp0_);
#line 1659 "ApplicationDockItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 448 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 1666 "ApplicationDockItem.c"
	}
	__finally0:
#line 448 "../lib/Items/ApplicationDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 448 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 448 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 448 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 1677 "ApplicationDockItem.c"
	}
}

static void
______lambda42__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 447 "../lib/Items/ApplicationDockItem.vala"
	_____lambda42_ (self);
#line 1687 "ApplicationDockItem.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 460 "../lib/Items/ApplicationDockItem.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 460 "../lib/Items/ApplicationDockItem.vala"
	return _data9_;
#line 1697 "ApplicationDockItem.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 460 "../lib/Items/ApplicationDockItem.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 1707 "ApplicationDockItem.c"
		PlankApplicationDockItem* self;
#line 460 "../lib/Items/ApplicationDockItem.vala"
		self = _data9_->_data7_->self;
#line 460 "../lib/Items/ApplicationDockItem.vala"
		block7_data_unref (_data9_->_data7_);
#line 460 "../lib/Items/ApplicationDockItem.vala"
		_data9_->_data7_ = NULL;
#line 460 "../lib/Items/ApplicationDockItem.vala"
		g_slice_free (Block9Data, _data9_);
#line 1717 "ApplicationDockItem.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 466 "../lib/Items/ApplicationDockItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 1726 "ApplicationDockItem.c"
}

static void
______lambda43_ (Block9Data* _data9_)
{
	Block7Data* _data7_;
	PlankApplicationDockItem* self;
	BamfWindow* _tmp0_;
#line 478 "../lib/Items/ApplicationDockItem.vala"
	_data7_ = _data9_->_data7_;
#line 478 "../lib/Items/ApplicationDockItem.vala"
	self = _data7_->self;
#line 478 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = _data9_->window;
#line 478 "../lib/Items/ApplicationDockItem.vala"
	plank_window_control_focus_window (_tmp0_, _data7_->event_time);
#line 1743 "ApplicationDockItem.c"
}

static void
_______lambda43__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 478 "../lib/Items/ApplicationDockItem.vala"
	______lambda43_ (self);
#line 1752 "ApplicationDockItem.c"
}

static GeeArrayList*
plank_application_dock_item_real_get_menu_items (PlankDockElement* base)
{
	PlankApplicationDockItem * self;
	Block7Data* _data7_;
	GeeArrayList* items = NULL;
	GeeArrayList* _tmp0_;
	GList* windows = NULL;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	guint window_count = 0U;
	GList* _tmp6_;
	PlankDefaultApplicationDockItemProvider* default_provider = NULL;
	PlankDockContainer* _tmp8_;
	PlankDockContainer* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PlankDefaultApplicationDockItemProvider* _tmp12_;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp61_ = FALSE;
	GeeArrayList* result;
#line 396 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 396 "../lib/Items/ApplicationDockItem.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 396 "../lib/Items/ApplicationDockItem.vala"
	_data7_->_ref_count_ = 1;
#line 396 "../lib/Items/ApplicationDockItem.vala"
	_data7_->self = g_object_ref (self);
#line 398 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 398 "../lib/Items/ApplicationDockItem.vala"
	items = _tmp0_;
#line 400 "../lib/Items/ApplicationDockItem.vala"
	windows = NULL;
#line 401 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = plank_application_dock_item_get_App (self);
#line 401 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = _tmp1_;
#line 401 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_ != NULL) {
#line 1797 "ApplicationDockItem.c"
		BamfApplication* _tmp3_;
		BamfApplication* _tmp4_;
		GList* _tmp5_;
#line 402 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_application_dock_item_get_App (self);
#line 402 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 402 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = bamf_application_get_windows (_tmp4_);
#line 402 "../lib/Items/ApplicationDockItem.vala"
		(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 402 "../lib/Items/ApplicationDockItem.vala"
		windows = _tmp5_;
#line 1811 "ApplicationDockItem.c"
	}
#line 404 "../lib/Items/ApplicationDockItem.vala"
	window_count = 0U;
#line 405 "../lib/Items/ApplicationDockItem.vala"
	_tmp6_ = windows;
#line 405 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp6_ != NULL) {
#line 1819 "ApplicationDockItem.c"
		GList* _tmp7_;
#line 406 "../lib/Items/ApplicationDockItem.vala"
		_tmp7_ = windows;
#line 406 "../lib/Items/ApplicationDockItem.vala"
		window_count = g_list_length (_tmp7_);
#line 1825 "ApplicationDockItem.c"
	}
#line 408 "../lib/Items/ApplicationDockItem.vala"
	_tmp8_ = plank_dock_element_get_Container ((PlankDockElement*) self);
#line 408 "../lib/Items/ApplicationDockItem.vala"
	_tmp9_ = _tmp8_;
#line 408 "../lib/Items/ApplicationDockItem.vala"
	default_provider = PLANK_IS_DEFAULT_APPLICATION_DOCK_ITEM_PROVIDER (_tmp9_) ? ((PlankDefaultApplicationDockItemProvider*) _tmp9_) : NULL;
#line 409 "../lib/Items/ApplicationDockItem.vala"
	_tmp12_ = default_provider;
#line 409 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp12_ != NULL) {
#line 1837 "ApplicationDockItem.c"
		PlankDefaultApplicationDockItemProvider* _tmp13_;
		PlankDockPreferences* _tmp14_;
		PlankDockPreferences* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 410 "../lib/Items/ApplicationDockItem.vala"
		_tmp13_ = default_provider;
#line 410 "../lib/Items/ApplicationDockItem.vala"
		_tmp14_ = plank_default_application_dock_item_provider_get_Prefs (_tmp13_);
#line 410 "../lib/Items/ApplicationDockItem.vala"
		_tmp15_ = _tmp14_;
#line 410 "../lib/Items/ApplicationDockItem.vala"
		_tmp16_ = plank_dock_preferences_get_LockItems (_tmp15_);
#line 410 "../lib/Items/ApplicationDockItem.vala"
		_tmp17_ = _tmp16_;
#line 410 "../lib/Items/ApplicationDockItem.vala"
		_tmp11_ = !_tmp17_;
#line 1855 "ApplicationDockItem.c"
	} else {
#line 409 "../lib/Items/ApplicationDockItem.vala"
		_tmp11_ = FALSE;
#line 1859 "ApplicationDockItem.c"
	}
#line 409 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp11_) {
#line 411 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = !plank_application_dock_item_is_window (self);
#line 1865 "ApplicationDockItem.c"
	} else {
#line 409 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = FALSE;
#line 1869 "ApplicationDockItem.c"
	}
#line 409 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp10_) {
#line 1873 "ApplicationDockItem.c"
		GtkCheckMenuItem* item = NULL;
		GtkCheckMenuItem* _tmp18_;
		GtkCheckMenuItem* _tmp19_;
		GtkCheckMenuItem* _tmp20_;
		GeeArrayList* _tmp21_;
		GtkCheckMenuItem* _tmp22_;
#line 412 "../lib/Items/ApplicationDockItem.vala"
		_tmp18_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("_Keep in Dock"));
#line 412 "../lib/Items/ApplicationDockItem.vala"
		g_object_ref_sink (_tmp18_);
#line 412 "../lib/Items/ApplicationDockItem.vala"
		item = _tmp18_;
#line 413 "../lib/Items/ApplicationDockItem.vala"
		_tmp19_ = item;
#line 413 "../lib/Items/ApplicationDockItem.vala"
		gtk_check_menu_item_set_active (_tmp19_, !PLANK_IS_TRANSIENT_DOCK_ITEM (self));
#line 414 "../lib/Items/ApplicationDockItem.vala"
		_tmp20_ = item;
#line 414 "../lib/Items/ApplicationDockItem.vala"
		g_signal_connect_object ((GtkMenuItem*) _tmp20_, "activate", (GCallback) ____lambda40__gtk_menu_item_activate, self, 0);
#line 415 "../lib/Items/ApplicationDockItem.vala"
		_tmp21_ = items;
#line 415 "../lib/Items/ApplicationDockItem.vala"
		_tmp22_ = item;
#line 415 "../lib/Items/ApplicationDockItem.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, (GtkMenuItem*) _tmp22_);
#line 409 "../lib/Items/ApplicationDockItem.vala"
		_g_object_unref0 (item);
#line 1902 "ApplicationDockItem.c"
	}
#line 418 "../lib/Items/ApplicationDockItem.vala"
	_data7_->event_time = gtk_get_current_event_time ();
#line 419 "../lib/Items/ApplicationDockItem.vala"
	if (plank_application_dock_item_is_running (self)) {
#line 419 "../lib/Items/ApplicationDockItem.vala"
		_tmp23_ = window_count > ((guint) 0);
#line 1910 "ApplicationDockItem.c"
	} else {
#line 419 "../lib/Items/ApplicationDockItem.vala"
		_tmp23_ = FALSE;
#line 1914 "ApplicationDockItem.c"
	}
#line 419 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp23_) {
#line 1918 "ApplicationDockItem.c"
		const gchar* _tmp24_ = NULL;
		GtkMenuItem* item = NULL;
		GtkMenuItem* _tmp25_;
		GtkMenuItem* _tmp26_;
		GeeArrayList* _tmp27_;
		GtkMenuItem* _tmp28_;
#line 420 "../lib/Items/ApplicationDockItem.vala"
		if (window_count > ((guint) 1)) {
#line 420 "../lib/Items/ApplicationDockItem.vala"
			_tmp24_ = _ ("_Close All");
#line 1929 "ApplicationDockItem.c"
		} else {
#line 420 "../lib/Items/ApplicationDockItem.vala"
			_tmp24_ = _ ("_Close");
#line 1933 "ApplicationDockItem.c"
		}
#line 420 "../lib/Items/ApplicationDockItem.vala"
		_tmp25_ = plank_dock_element_create_menu_item (_tmp24_, "window-close-symbolic;;window-close", FALSE);
#line 420 "../lib/Items/ApplicationDockItem.vala"
		item = _tmp25_;
#line 421 "../lib/Items/ApplicationDockItem.vala"
		_tmp26_ = item;
#line 421 "../lib/Items/ApplicationDockItem.vala"
		g_signal_connect_data (_tmp26_, "activate", (GCallback) ____lambda41__gtk_menu_item_activate, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 422 "../lib/Items/ApplicationDockItem.vala"
		_tmp27_ = items;
#line 422 "../lib/Items/ApplicationDockItem.vala"
		_tmp28_ = item;
#line 422 "../lib/Items/ApplicationDockItem.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 419 "../lib/Items/ApplicationDockItem.vala"
		_g_object_unref0 (item);
#line 1951 "ApplicationDockItem.c"
	}
#line 439 "../lib/Items/ApplicationDockItem.vala"
	if (!plank_application_dock_item_is_window (self)) {
#line 1955 "ApplicationDockItem.c"
		GeeArrayList* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
#line 439 "../lib/Items/ApplicationDockItem.vala"
		_tmp30_ = self->priv->actions;
#line 439 "../lib/Items/ApplicationDockItem.vala"
		_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 439 "../lib/Items/ApplicationDockItem.vala"
		_tmp32_ = _tmp31_;
#line 439 "../lib/Items/ApplicationDockItem.vala"
		_tmp29_ = _tmp32_ > 0;
#line 1967 "ApplicationDockItem.c"
	} else {
#line 439 "../lib/Items/ApplicationDockItem.vala"
		_tmp29_ = FALSE;
#line 1971 "ApplicationDockItem.c"
	}
#line 439 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp29_) {
#line 1975 "ApplicationDockItem.c"
		GeeArrayList* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 440 "../lib/Items/ApplicationDockItem.vala"
		_tmp33_ = items;
#line 440 "../lib/Items/ApplicationDockItem.vala"
		_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 440 "../lib/Items/ApplicationDockItem.vala"
		_tmp35_ = _tmp34_;
#line 440 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp35_ > 0) {
#line 1987 "ApplicationDockItem.c"
			GeeArrayList* _tmp36_;
			GtkSeparatorMenuItem* _tmp37_;
			GtkSeparatorMenuItem* _tmp38_;
#line 441 "../lib/Items/ApplicationDockItem.vala"
			_tmp36_ = items;
#line 441 "../lib/Items/ApplicationDockItem.vala"
			_tmp37_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 441 "../lib/Items/ApplicationDockItem.vala"
			g_object_ref_sink (_tmp37_);
#line 441 "../lib/Items/ApplicationDockItem.vala"
			_tmp38_ = _tmp37_;
#line 441 "../lib/Items/ApplicationDockItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, (GtkMenuItem*) _tmp38_);
#line 441 "../lib/Items/ApplicationDockItem.vala"
			_g_object_unref0 (_tmp38_);
#line 2003 "ApplicationDockItem.c"
		}
		{
			GeeArrayList* _s_list = NULL;
			GeeArrayList* _tmp39_;
			gint _s_size = 0;
			GeeArrayList* _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			gint _s_index = 0;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_tmp39_ = self->priv->actions;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_s_list = _tmp39_;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_tmp40_ = _s_list;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp40_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_tmp42_ = _tmp41_;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_s_size = _tmp42_;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			_s_index = -1;
#line 443 "../lib/Items/ApplicationDockItem.vala"
			while (TRUE) {
#line 2029 "ApplicationDockItem.c"
				Block8Data* _data8_;
				gint _tmp43_;
				gint _tmp44_;
				gchar* s = NULL;
				GeeArrayList* _tmp45_;
				gpointer _tmp46_;
				GeeHashMap* _tmp47_;
				const gchar* _tmp48_;
				gpointer _tmp49_;
				gchar* _tmp50_;
				gchar** _tmp51_;
				gchar** _tmp52_;
				gchar** _tmp53_;
				gint _tmp53__length1;
				GtkMenuItem* item = NULL;
				const gchar* _tmp54_;
				gchar** _tmp55_;
				gint _tmp55__length1;
				const gchar* _tmp56_;
				GtkMenuItem* _tmp57_;
				GtkMenuItem* _tmp58_;
				GeeArrayList* _tmp59_;
				GtkMenuItem* _tmp60_;
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_data8_ = g_slice_new0 (Block8Data);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_data8_->_ref_count_ = 1;
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_data8_->_data7_ = block7_data_ref (_data7_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_s_index = _s_index + 1;
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_tmp43_ = _s_index;
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_tmp44_ = _s_size;
#line 443 "../lib/Items/ApplicationDockItem.vala"
				if (!(_tmp43_ < _tmp44_)) {
#line 443 "../lib/Items/ApplicationDockItem.vala"
					block8_data_unref (_data8_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
					_data8_ = NULL;
#line 443 "../lib/Items/ApplicationDockItem.vala"
					break;
#line 2073 "ApplicationDockItem.c"
				}
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_tmp45_ = _s_list;
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, _s_index);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				s = (gchar*) _tmp46_;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp47_ = self->priv->actions_map;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp48_ = s;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp49_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp47_, _tmp48_);
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp50_ = (gchar*) _tmp49_;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp52_ = _tmp51_ = g_strsplit (_tmp50_, ";;", 0);
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp53_ = _tmp52_;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_tmp53__length1 = _vala_array_length (_tmp51_);
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_tmp50_);
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_data8_->values = _tmp53_;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_data8_->values_length1 = _tmp53__length1;
#line 444 "../lib/Items/ApplicationDockItem.vala"
				_data8_->_values_size_ = _data8_->values_length1;
#line 446 "../lib/Items/ApplicationDockItem.vala"
				_tmp54_ = s;
#line 446 "../lib/Items/ApplicationDockItem.vala"
				_tmp55_ = _data8_->values;
#line 446 "../lib/Items/ApplicationDockItem.vala"
				_tmp55__length1 = _data8_->values_length1;
#line 446 "../lib/Items/ApplicationDockItem.vala"
				_tmp56_ = _tmp55_[1];
#line 446 "../lib/Items/ApplicationDockItem.vala"
				_tmp57_ = plank_dock_element_create_menu_item (_tmp54_, _tmp56_, TRUE);
#line 446 "../lib/Items/ApplicationDockItem.vala"
				item = _tmp57_;
#line 447 "../lib/Items/ApplicationDockItem.vala"
				_tmp58_ = item;
#line 447 "../lib/Items/ApplicationDockItem.vala"
				g_signal_connect_data (_tmp58_, "activate", (GCallback) ______lambda42__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 452 "../lib/Items/ApplicationDockItem.vala"
				_tmp59_ = items;
#line 452 "../lib/Items/ApplicationDockItem.vala"
				_tmp60_ = item;
#line 452 "../lib/Items/ApplicationDockItem.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp59_, _tmp60_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_g_object_unref0 (item);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (s);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				block8_data_unref (_data8_);
#line 443 "../lib/Items/ApplicationDockItem.vala"
				_data8_ = NULL;
#line 2133 "ApplicationDockItem.c"
			}
		}
	}
#line 456 "../lib/Items/ApplicationDockItem.vala"
	if (plank_application_dock_item_is_running (self)) {
#line 456 "../lib/Items/ApplicationDockItem.vala"
		_tmp61_ = window_count > ((guint) 1);
#line 2141 "ApplicationDockItem.c"
	} else {
#line 456 "../lib/Items/ApplicationDockItem.vala"
		_tmp61_ = FALSE;
#line 2145 "ApplicationDockItem.c"
	}
#line 456 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp61_) {
#line 2149 "ApplicationDockItem.c"
		GeeArrayList* _tmp62_;
		gint _tmp63_;
		gint _tmp64_;
		GList* _tmp68_;
#line 457 "../lib/Items/ApplicationDockItem.vala"
		_tmp62_ = items;
#line 457 "../lib/Items/ApplicationDockItem.vala"
		_tmp63_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp62_);
#line 457 "../lib/Items/ApplicationDockItem.vala"
		_tmp64_ = _tmp63_;
#line 457 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp64_ > 0) {
#line 2162 "ApplicationDockItem.c"
			GeeArrayList* _tmp65_;
			GtkSeparatorMenuItem* _tmp66_;
			GtkSeparatorMenuItem* _tmp67_;
#line 458 "../lib/Items/ApplicationDockItem.vala"
			_tmp65_ = items;
#line 458 "../lib/Items/ApplicationDockItem.vala"
			_tmp66_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 458 "../lib/Items/ApplicationDockItem.vala"
			g_object_ref_sink (_tmp66_);
#line 458 "../lib/Items/ApplicationDockItem.vala"
			_tmp67_ = _tmp66_;
#line 458 "../lib/Items/ApplicationDockItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp65_, (GtkMenuItem*) _tmp67_);
#line 458 "../lib/Items/ApplicationDockItem.vala"
			_g_object_unref0 (_tmp67_);
#line 2178 "ApplicationDockItem.c"
		}
#line 460 "../lib/Items/ApplicationDockItem.vala"
		_tmp68_ = windows;
#line 2182 "ApplicationDockItem.c"
		{
			GList* view_collection = NULL;
			GList* view_it = NULL;
#line 460 "../lib/Items/ApplicationDockItem.vala"
			view_collection = _tmp68_;
#line 460 "../lib/Items/ApplicationDockItem.vala"
			for (view_it = view_collection; view_it != NULL; view_it = view_it->next) {
#line 2190 "ApplicationDockItem.c"
				BamfView* view = NULL;
#line 460 "../lib/Items/ApplicationDockItem.vala"
				view = (BamfView*) view_it->data;
#line 2194 "ApplicationDockItem.c"
				{
					Block9Data* _data9_;
					BamfView* _tmp69_;
					gboolean _tmp70_ = FALSE;
					BamfWindow* _tmp71_;
					GtkMenuItem* window_item = NULL;
					GdkPixbuf* pbuf = NULL;
					BamfWindow* _tmp74_;
					GdkPixbuf* _tmp75_;
					GdkPixbuf* _tmp76_;
					gchar* window_name = NULL;
					BamfWindow* _tmp77_;
					gchar* _tmp78_;
					const gchar* _tmp79_;
					gchar* _tmp80_;
					GdkPixbuf* _tmp81_;
					BamfWindow* _tmp90_;
					GeeArrayList* _tmp93_;
					GtkMenuItem* _tmp94_;
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_data9_ = g_slice_new0 (Block9Data);
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_data9_->_ref_count_ = 1;
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_data9_->_data7_ = block7_data_ref (_data7_);
#line 461 "../lib/Items/ApplicationDockItem.vala"
					_tmp69_ = view;
#line 461 "../lib/Items/ApplicationDockItem.vala"
					_data9_->window = G_TYPE_CHECK_INSTANCE_TYPE (_tmp69_, bamf_window_get_type ()) ? ((BamfWindow*) _tmp69_) : NULL;
#line 462 "../lib/Items/ApplicationDockItem.vala"
					_tmp71_ = _data9_->window;
#line 462 "../lib/Items/ApplicationDockItem.vala"
					if (_tmp71_ == NULL) {
#line 462 "../lib/Items/ApplicationDockItem.vala"
						_tmp70_ = TRUE;
#line 2230 "ApplicationDockItem.c"
					} else {
						BamfWindow* _tmp72_;
						BamfWindow* _tmp73_;
#line 462 "../lib/Items/ApplicationDockItem.vala"
						_tmp72_ = _data9_->window;
#line 462 "../lib/Items/ApplicationDockItem.vala"
						_tmp73_ = bamf_window_get_transient (_tmp72_);
#line 462 "../lib/Items/ApplicationDockItem.vala"
						_tmp70_ = _tmp73_ != NULL;
#line 2240 "ApplicationDockItem.c"
					}
#line 462 "../lib/Items/ApplicationDockItem.vala"
					if (_tmp70_) {
#line 463 "../lib/Items/ApplicationDockItem.vala"
						block9_data_unref (_data9_);
#line 463 "../lib/Items/ApplicationDockItem.vala"
						_data9_ = NULL;
#line 463 "../lib/Items/ApplicationDockItem.vala"
						continue;
#line 2250 "ApplicationDockItem.c"
					}
#line 466 "../lib/Items/ApplicationDockItem.vala"
					_tmp74_ = _data9_->window;
#line 466 "../lib/Items/ApplicationDockItem.vala"
					_tmp75_ = plank_window_control_get_window_icon (_tmp74_);
#line 466 "../lib/Items/ApplicationDockItem.vala"
					_tmp76_ = _g_object_ref0 (_tmp75_);
#line 466 "../lib/Items/ApplicationDockItem.vala"
					pbuf = _tmp76_;
#line 467 "../lib/Items/ApplicationDockItem.vala"
					_tmp77_ = _data9_->window;
#line 467 "../lib/Items/ApplicationDockItem.vala"
					_tmp78_ = bamf_view_get_name ((BamfView*) _tmp77_);
#line 467 "../lib/Items/ApplicationDockItem.vala"
					window_name = _tmp78_;
#line 468 "../lib/Items/ApplicationDockItem.vala"
					_tmp79_ = window_name;
#line 468 "../lib/Items/ApplicationDockItem.vala"
					_tmp80_ = plank_application_dock_item_shorten_window_name (self, _tmp79_);
#line 468 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (window_name);
#line 468 "../lib/Items/ApplicationDockItem.vala"
					window_name = _tmp80_;
#line 470 "../lib/Items/ApplicationDockItem.vala"
					_tmp81_ = pbuf;
#line 470 "../lib/Items/ApplicationDockItem.vala"
					if (_tmp81_ != NULL) {
#line 2278 "ApplicationDockItem.c"
						const gchar* _tmp82_;
						GdkPixbuf* _tmp83_;
						GdkPixbuf* _tmp84_;
						GtkMenuItem* _tmp85_;
#line 471 "../lib/Items/ApplicationDockItem.vala"
						_tmp82_ = window_name;
#line 471 "../lib/Items/ApplicationDockItem.vala"
						_tmp83_ = pbuf;
#line 471 "../lib/Items/ApplicationDockItem.vala"
						_tmp84_ = _g_object_ref0 (_tmp83_);
#line 471 "../lib/Items/ApplicationDockItem.vala"
						_tmp85_ = plank_dock_element_create_literal_menu_item_with_pixbuf (_tmp82_, _tmp84_, TRUE);
#line 471 "../lib/Items/ApplicationDockItem.vala"
						_g_object_unref0 (window_item);
#line 471 "../lib/Items/ApplicationDockItem.vala"
						window_item = _tmp85_;
#line 2295 "ApplicationDockItem.c"
					} else {
						const gchar* _tmp86_;
						const gchar* _tmp87_;
						const gchar* _tmp88_;
						GtkMenuItem* _tmp89_;
#line 473 "../lib/Items/ApplicationDockItem.vala"
						_tmp86_ = window_name;
#line 473 "../lib/Items/ApplicationDockItem.vala"
						_tmp87_ = plank_dock_item_get_Icon ((PlankDockItem*) self);
#line 473 "../lib/Items/ApplicationDockItem.vala"
						_tmp88_ = _tmp87_;
#line 473 "../lib/Items/ApplicationDockItem.vala"
						_tmp89_ = plank_dock_element_create_literal_menu_item (_tmp86_, _tmp88_, TRUE);
#line 473 "../lib/Items/ApplicationDockItem.vala"
						_g_object_unref0 (window_item);
#line 473 "../lib/Items/ApplicationDockItem.vala"
						window_item = _tmp89_;
#line 2313 "ApplicationDockItem.c"
					}
#line 475 "../lib/Items/ApplicationDockItem.vala"
					_tmp90_ = _data9_->window;
#line 475 "../lib/Items/ApplicationDockItem.vala"
					if (bamf_view_is_active ((BamfView*) _tmp90_)) {
#line 2319 "ApplicationDockItem.c"
						GtkMenuItem* _tmp91_;
#line 476 "../lib/Items/ApplicationDockItem.vala"
						_tmp91_ = window_item;
#line 476 "../lib/Items/ApplicationDockItem.vala"
						gtk_widget_set_sensitive ((GtkWidget*) _tmp91_, FALSE);
#line 2325 "ApplicationDockItem.c"
					} else {
						GtkMenuItem* _tmp92_;
#line 478 "../lib/Items/ApplicationDockItem.vala"
						_tmp92_ = window_item;
#line 478 "../lib/Items/ApplicationDockItem.vala"
						g_signal_connect_data (_tmp92_, "activate", (GCallback) _______lambda43__gtk_menu_item_activate, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 2332 "ApplicationDockItem.c"
					}
#line 480 "../lib/Items/ApplicationDockItem.vala"
					_tmp93_ = items;
#line 480 "../lib/Items/ApplicationDockItem.vala"
					_tmp94_ = window_item;
#line 480 "../lib/Items/ApplicationDockItem.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp93_, _tmp94_);
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (window_name);
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_g_object_unref0 (pbuf);
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_g_object_unref0 (window_item);
#line 460 "../lib/Items/ApplicationDockItem.vala"
					block9_data_unref (_data9_);
#line 460 "../lib/Items/ApplicationDockItem.vala"
					_data9_ = NULL;
#line 2350 "ApplicationDockItem.c"
				}
			}
		}
	}
#line 484 "../lib/Items/ApplicationDockItem.vala"
	result = items;
#line 484 "../lib/Items/ApplicationDockItem.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 484 "../lib/Items/ApplicationDockItem.vala"
	block7_data_unref (_data7_);
#line 484 "../lib/Items/ApplicationDockItem.vala"
	_data7_ = NULL;
#line 484 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 2365 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static gchar*
plank_application_dock_item_real_get_drop_text (PlankDockElement* base)
{
	PlankApplicationDockItem * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 490 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 492 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_element_get_Text ((PlankDockElement*) self);
#line 492 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 492 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = g_strdup_printf (_ ("Drop to open with %s"), _tmp1_);
#line 492 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp2_;
#line 492 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 2391 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_application_dock_item_real_can_accept_drop (PlankDockElement* base,
                                                  GeeArrayList* uris)
{
	PlankApplicationDockItem * self;
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 498 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 498 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (uris != NULL, FALSE);
#line 500 "../lib/Items/ApplicationDockItem.vala"
	if (uris == NULL) {
#line 500 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = TRUE;
#line 2416 "ApplicationDockItem.c"
	} else {
#line 500 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = plank_application_dock_item_is_window (self);
#line 2420 "ApplicationDockItem.c"
	}
#line 500 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp0_) {
#line 501 "../lib/Items/ApplicationDockItem.vala"
		result = FALSE;
#line 501 "../lib/Items/ApplicationDockItem.vala"
		return result;
#line 2428 "ApplicationDockItem.c"
	}
#line 505 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = self->priv->supported_mime_types;
#line 505 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 505 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = _tmp2_;
#line 505 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp3_ == 0) {
#line 506 "../lib/Items/ApplicationDockItem.vala"
		result = TRUE;
#line 506 "../lib/Items/ApplicationDockItem.vala"
		return result;
#line 2442 "ApplicationDockItem.c"
	}
	{
		{
			GeeArrayList* _uri_list = NULL;
			gint _uri_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _uri_index = 0;
#line 509 "../lib/Items/ApplicationDockItem.vala"
			_uri_list = uris;
#line 509 "../lib/Items/ApplicationDockItem.vala"
			_tmp4_ = _uri_list;
#line 509 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 509 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = _tmp5_;
#line 509 "../lib/Items/ApplicationDockItem.vala"
			_uri_size = _tmp6_;
#line 509 "../lib/Items/ApplicationDockItem.vala"
			_uri_index = -1;
#line 509 "../lib/Items/ApplicationDockItem.vala"
			while (TRUE) {
#line 2466 "ApplicationDockItem.c"
				gint _tmp7_;
				gint _tmp8_;
				gchar* uri = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				GFileInfo* info = NULL;
				const gchar* _tmp11_;
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFileInfo* _tmp14_;
				GFileInfo* _tmp15_;
				const gchar* uri_content_type = NULL;
				GFileInfo* _tmp16_;
				const gchar* _tmp17_;
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_uri_index = _uri_index + 1;
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_tmp7_ = _uri_index;
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_tmp8_ = _uri_size;
#line 509 "../lib/Items/ApplicationDockItem.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 509 "../lib/Items/ApplicationDockItem.vala"
					break;
#line 2491 "ApplicationDockItem.c"
				}
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_tmp9_ = _uri_list;
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _uri_index);
#line 509 "../lib/Items/ApplicationDockItem.vala"
				uri = (gchar*) _tmp10_;
#line 510 "../lib/Items/ApplicationDockItem.vala"
				_tmp11_ = uri;
#line 510 "../lib/Items/ApplicationDockItem.vala"
				_tmp12_ = g_file_new_for_uri (_tmp11_);
#line 510 "../lib/Items/ApplicationDockItem.vala"
				_tmp13_ = _tmp12_;
#line 510 "../lib/Items/ApplicationDockItem.vala"
				_tmp14_ = g_file_query_info (_tmp13_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 510 "../lib/Items/ApplicationDockItem.vala"
				_tmp15_ = _tmp14_;
#line 510 "../lib/Items/ApplicationDockItem.vala"
				_g_object_unref0 (_tmp13_);
#line 510 "../lib/Items/ApplicationDockItem.vala"
				info = _tmp15_;
#line 510 "../lib/Items/ApplicationDockItem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 510 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (uri);
#line 2517 "ApplicationDockItem.c"
					goto __catch0_g_error;
				}
#line 511 "../lib/Items/ApplicationDockItem.vala"
				_tmp16_ = info;
#line 511 "../lib/Items/ApplicationDockItem.vala"
				_tmp17_ = g_file_info_get_content_type (_tmp16_);
#line 511 "../lib/Items/ApplicationDockItem.vala"
				uri_content_type = _tmp17_;
#line 2526 "ApplicationDockItem.c"
				{
					GeeArrayList* _content_type_list = NULL;
					GeeArrayList* _tmp18_;
					gint _content_type_size = 0;
					GeeArrayList* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _content_type_index = 0;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_tmp18_ = self->priv->supported_mime_types;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_content_type_list = _tmp18_;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_tmp19_ = _content_type_list;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_tmp21_ = _tmp20_;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_content_type_size = _tmp21_;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					_content_type_index = -1;
#line 512 "../lib/Items/ApplicationDockItem.vala"
					while (TRUE) {
#line 2551 "ApplicationDockItem.c"
						gint _tmp22_;
						gint _tmp23_;
						gchar* content_type = NULL;
						GeeArrayList* _tmp24_;
						gpointer _tmp25_;
						gboolean _tmp26_ = FALSE;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
#line 512 "../lib/Items/ApplicationDockItem.vala"
						_content_type_index = _content_type_index + 1;
#line 512 "../lib/Items/ApplicationDockItem.vala"
						_tmp22_ = _content_type_index;
#line 512 "../lib/Items/ApplicationDockItem.vala"
						_tmp23_ = _content_type_size;
#line 512 "../lib/Items/ApplicationDockItem.vala"
						if (!(_tmp22_ < _tmp23_)) {
#line 512 "../lib/Items/ApplicationDockItem.vala"
							break;
#line 2570 "ApplicationDockItem.c"
						}
#line 512 "../lib/Items/ApplicationDockItem.vala"
						_tmp24_ = _content_type_list;
#line 512 "../lib/Items/ApplicationDockItem.vala"
						_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _content_type_index);
#line 512 "../lib/Items/ApplicationDockItem.vala"
						content_type = (gchar*) _tmp25_;
#line 513 "../lib/Items/ApplicationDockItem.vala"
						_tmp27_ = uri_content_type;
#line 513 "../lib/Items/ApplicationDockItem.vala"
						_tmp28_ = content_type;
#line 513 "../lib/Items/ApplicationDockItem.vala"
						if (g_content_type_is_a (_tmp27_, _tmp28_)) {
#line 513 "../lib/Items/ApplicationDockItem.vala"
							_tmp26_ = TRUE;
#line 2586 "ApplicationDockItem.c"
						} else {
							const gchar* _tmp29_;
							const gchar* _tmp30_;
#line 513 "../lib/Items/ApplicationDockItem.vala"
							_tmp29_ = uri_content_type;
#line 513 "../lib/Items/ApplicationDockItem.vala"
							_tmp30_ = content_type;
#line 513 "../lib/Items/ApplicationDockItem.vala"
							_tmp26_ = g_content_type_equals (_tmp29_, _tmp30_);
#line 2596 "ApplicationDockItem.c"
						}
#line 513 "../lib/Items/ApplicationDockItem.vala"
						if (_tmp26_) {
#line 514 "../lib/Items/ApplicationDockItem.vala"
							result = TRUE;
#line 514 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (content_type);
#line 514 "../lib/Items/ApplicationDockItem.vala"
							_g_object_unref0 (info);
#line 514 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (uri);
#line 514 "../lib/Items/ApplicationDockItem.vala"
							return result;
#line 2610 "ApplicationDockItem.c"
						}
#line 512 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (content_type);
#line 2614 "ApplicationDockItem.c"
					}
				}
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_g_object_unref0 (info);
#line 509 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (uri);
#line 2621 "ApplicationDockItem.c"
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 508 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 2630 "ApplicationDockItem.c"
	}
	__finally0:
#line 508 "../lib/Items/ApplicationDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2635 "ApplicationDockItem.c"
		gboolean _tmp31_ = FALSE;
#line 508 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 508 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 508 "../lib/Items/ApplicationDockItem.vala"
		return _tmp31_;
#line 2643 "ApplicationDockItem.c"
	}
#line 518 "../lib/Items/ApplicationDockItem.vala"
	result = FALSE;
#line 518 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 2649 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_application_dock_item_real_accept_drop (PlankDockElement* base,
                                              GeeArrayList* uris)
{
	PlankApplicationDockItem * self;
	GeeArrayList* files = NULL;
	GeeArrayList* _tmp0_;
	PlankSystem* _tmp12_;
	PlankDockItemPreferences* _tmp13_;
	PlankDockItemPreferences* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GeeArrayList* _tmp19_;
	gint _tmp20_ = 0;
	gpointer* _tmp21_;
	GFile** _tmp22_;
	gint _tmp22__length1;
	gboolean result;
#line 524 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 524 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (uris != NULL, FALSE);
#line 526 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 526 "../lib/Items/ApplicationDockItem.vala"
	files = _tmp0_;
#line 2683 "ApplicationDockItem.c"
	{
		GeeArrayList* _uri_list = NULL;
		gint _uri_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _uri_index = 0;
#line 527 "../lib/Items/ApplicationDockItem.vala"
		_uri_list = uris;
#line 527 "../lib/Items/ApplicationDockItem.vala"
		_tmp1_ = _uri_list;
#line 527 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 527 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = _tmp2_;
#line 527 "../lib/Items/ApplicationDockItem.vala"
		_uri_size = _tmp3_;
#line 527 "../lib/Items/ApplicationDockItem.vala"
		_uri_index = -1;
#line 527 "../lib/Items/ApplicationDockItem.vala"
		while (TRUE) {
#line 2705 "ApplicationDockItem.c"
			gint _tmp4_;
			gint _tmp5_;
			gchar* uri = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			GeeArrayList* _tmp8_;
			const gchar* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
#line 527 "../lib/Items/ApplicationDockItem.vala"
			_uri_index = _uri_index + 1;
#line 527 "../lib/Items/ApplicationDockItem.vala"
			_tmp4_ = _uri_index;
#line 527 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = _uri_size;
#line 527 "../lib/Items/ApplicationDockItem.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 527 "../lib/Items/ApplicationDockItem.vala"
				break;
#line 2725 "ApplicationDockItem.c"
			}
#line 527 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = _uri_list;
#line 527 "../lib/Items/ApplicationDockItem.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _uri_index);
#line 527 "../lib/Items/ApplicationDockItem.vala"
			uri = (gchar*) _tmp7_;
#line 528 "../lib/Items/ApplicationDockItem.vala"
			_tmp8_ = files;
#line 528 "../lib/Items/ApplicationDockItem.vala"
			_tmp9_ = uri;
#line 528 "../lib/Items/ApplicationDockItem.vala"
			_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 528 "../lib/Items/ApplicationDockItem.vala"
			_tmp11_ = _tmp10_;
#line 528 "../lib/Items/ApplicationDockItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp11_);
#line 528 "../lib/Items/ApplicationDockItem.vala"
			_g_object_unref0 (_tmp11_);
#line 527 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (uri);
#line 2747 "ApplicationDockItem.c"
		}
	}
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp12_ = plank_system_get_default ();
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp13_ = plank_dock_item_get_Prefs ((PlankDockItem*) self);
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp14_ = _tmp13_;
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp15_ = plank_dock_item_preferences_get_Launcher (_tmp14_);
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp16_ = _tmp15_;
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp17_ = g_file_new_for_uri (_tmp16_);
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp18_ = _tmp17_;
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp19_ = files;
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp21_ = gee_collection_to_array ((GeeCollection*) _tmp19_, &_tmp20_);
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp22_ = _tmp21_;
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp22__length1 = _tmp20_;
#line 530 "../lib/Items/ApplicationDockItem.vala"
	plank_system_launch_with_files (_tmp12_, _tmp18_, _tmp22_, (gint) _tmp20_);
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_object_unref), NULL);
#line 530 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (_tmp18_);
#line 532 "../lib/Items/ApplicationDockItem.vala"
	result = TRUE;
#line 532 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (files);
#line 532 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 2784 "ApplicationDockItem.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_application_dock_item_real_load_from_launcher (PlankDockItem* base)
{
	PlankApplicationDockItem * self;
	PlankDockItemPreferences* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* icon = NULL;
	gchar* text = NULL;
	PlankDockItemPreferences* _tmp4_;
	PlankDockItemPreferences* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeHashMap* _tmp9_;
	GeeArrayList* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
#line 538 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) base;
#line 540 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = plank_dock_item_get_Prefs ((PlankDockItem*) self);
#line 540 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = _tmp0_;
#line 540 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = plank_dock_item_preferences_get_Launcher (_tmp1_);
#line 540 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = _tmp2_;
#line 540 "../lib/Items/ApplicationDockItem.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 541 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 2825 "ApplicationDockItem.c"
	}
#line 543 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_unity_update_application_uri (self);
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = plank_dock_item_get_Prefs ((PlankDockItem*) self);
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp5_ = _tmp4_;
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp6_ = plank_dock_item_preferences_get_Launcher (_tmp5_);
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp7_ = _tmp6_;
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp8_ = self->priv->actions;
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp9_ = self->priv->actions_map;
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_tmp10_ = self->priv->supported_mime_types;
#line 546 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_parse_launcher (_tmp7_, &_tmp11_, &_tmp12_, _tmp8_, (GeeMap*) _tmp9_, _tmp10_);
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (icon);
#line 546 "../lib/Items/ApplicationDockItem.vala"
	icon = _tmp11_;
#line 546 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (text);
#line 546 "../lib/Items/ApplicationDockItem.vala"
	text = _tmp12_;
#line 547 "../lib/Items/ApplicationDockItem.vala"
	_tmp13_ = icon;
#line 547 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_set_Icon ((PlankDockItem*) self, _tmp13_);
#line 548 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_set_ForcePixbuf ((PlankDockItem*) self, NULL);
#line 549 "../lib/Items/ApplicationDockItem.vala"
	_tmp14_ = text;
#line 549 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_element_set_Text ((PlankDockElement*) self, _tmp14_);
#line 538 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (text);
#line 538 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (icon);
#line 2867 "ApplicationDockItem.c"
}

/**
 * Parses a launcher to get the text, icon and actions.
 *
 * @param launcher the launcher file (.desktop file) to parse
 * @param icon the icon key from the launcher
 * @param text the text key from the launcher
 * @param actions a list of all actions by name
 * @param actions_map a map of actions from name to exec;;icon
 * @param mimes a list of all supported mime types
 */
void
plank_application_dock_item_parse_launcher (const gchar* launcher,
                                            gchar** icon,
                                            gchar** text,
                                            GeeArrayList* actions,
                                            GeeMap* actions_map,
                                            GeeArrayList* mimes)
{
	gchar* _vala_icon = NULL;
	gchar* _vala_text = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GKeyFile* file = NULL;
	GError* _inner_error0_ = NULL;
#line 562 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (launcher != NULL);
#line 564 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = g_strdup ("");
#line 564 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (_vala_icon);
#line 564 "../lib/Items/ApplicationDockItem.vala"
	_vala_icon = _tmp0_;
#line 565 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = g_strdup ("");
#line 565 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (_vala_text);
#line 565 "../lib/Items/ApplicationDockItem.vala"
	_vala_text = _tmp1_;
#line 567 "../lib/Items/ApplicationDockItem.vala"
	if (launcher == NULL) {
#line 567 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = TRUE;
#line 2913 "ApplicationDockItem.c"
	} else {
#line 567 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = g_strcmp0 (launcher, "") == 0;
#line 2917 "ApplicationDockItem.c"
	}
#line 567 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_) {
#line 568 "../lib/Items/ApplicationDockItem.vala"
		if (icon) {
#line 568 "../lib/Items/ApplicationDockItem.vala"
			*icon = _vala_icon;
#line 2925 "ApplicationDockItem.c"
		} else {
#line 568 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 2929 "ApplicationDockItem.c"
		}
#line 568 "../lib/Items/ApplicationDockItem.vala"
		if (text) {
#line 568 "../lib/Items/ApplicationDockItem.vala"
			*text = _vala_text;
#line 2935 "ApplicationDockItem.c"
		} else {
#line 568 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 2939 "ApplicationDockItem.c"
		}
#line 568 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 2943 "ApplicationDockItem.c"
	}
	{
		GKeyFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		GKeyFile* _tmp6_;
#line 573 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = g_key_file_new ();
#line 573 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 573 "../lib/Items/ApplicationDockItem.vala"
		file = _tmp3_;
#line 574 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = g_filename_from_uri (launcher, NULL, &_inner_error0_);
#line 574 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp5_;
#line 574 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2962 "ApplicationDockItem.c"
			goto __catch0_g_error;
		}
#line 574 "../lib/Items/ApplicationDockItem.vala"
		_tmp6_ = file;
#line 574 "../lib/Items/ApplicationDockItem.vala"
		g_key_file_load_from_file (_tmp6_, _tmp4_, 0, &_inner_error0_);
#line 574 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 574 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_tmp4_);
#line 2973 "ApplicationDockItem.c"
			goto __catch0_g_error;
		}
#line 572 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_tmp4_);
#line 2978 "ApplicationDockItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 572 "../lib/Items/ApplicationDockItem.vala"
		e = _inner_error0_;
#line 572 "../lib/Items/ApplicationDockItem.vala"
		_inner_error0_ = NULL;
#line 576 "../lib/Items/ApplicationDockItem.vala"
		_tmp7_ = e;
#line 576 "../lib/Items/ApplicationDockItem.vala"
		_tmp8_ = _tmp7_->message;
#line 576 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("ApplicationDockItem.vala:576: %s: %s", launcher, _tmp8_);
#line 577 "../lib/Items/ApplicationDockItem.vala"
		_g_error_free0 (e);
#line 577 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 577 "../lib/Items/ApplicationDockItem.vala"
		if (icon) {
#line 577 "../lib/Items/ApplicationDockItem.vala"
			*icon = _vala_icon;
#line 3004 "ApplicationDockItem.c"
		} else {
#line 577 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 3008 "ApplicationDockItem.c"
		}
#line 577 "../lib/Items/ApplicationDockItem.vala"
		if (text) {
#line 577 "../lib/Items/ApplicationDockItem.vala"
			*text = _vala_text;
#line 3014 "ApplicationDockItem.c"
		} else {
#line 577 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 3018 "ApplicationDockItem.c"
		}
#line 577 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 3022 "ApplicationDockItem.c"
	}
	__finally0:
#line 572 "../lib/Items/ApplicationDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 572 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 572 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_icon);
#line 572 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_text);
#line 572 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 572 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 572 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 3039 "ApplicationDockItem.c"
	}
	{
		gchar* _tmp9_ = NULL;
		GKeyFile* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
		GKeyFile* _tmp14_;
		gchar* type = NULL;
		GKeyFile* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		GQuark _tmp24_ = 0U;
#line 587 "../lib/Items/ApplicationDockItem.vala"
		static GQuark _tmp23_label0 = 0;
#line 587 "../lib/Items/ApplicationDockItem.vala"
		static GQuark _tmp23_label1 = 0;
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = file;
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_tmp11_ = g_key_file_get_locale_string (_tmp10_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_NAME, NULL, &_inner_error0_);
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_tmp9_ = _tmp11_;
#line 581 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 581 "../lib/Items/ApplicationDockItem.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3068 "ApplicationDockItem.c"
				goto __catch1_g_key_file_error;
			}
#line 581 "../lib/Items/ApplicationDockItem.vala"
			_g_key_file_unref0 (file);
#line 581 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 581 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 581 "../lib/Items/ApplicationDockItem.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 581 "../lib/Items/ApplicationDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 581 "../lib/Items/ApplicationDockItem.vala"
			return;
#line 3083 "ApplicationDockItem.c"
		}
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_tmp12_ = _tmp9_;
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_tmp9_ = NULL;
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_text);
#line 581 "../lib/Items/ApplicationDockItem.vala"
		_vala_text = _tmp12_;
#line 583 "../lib/Items/ApplicationDockItem.vala"
		_tmp14_ = file;
#line 583 "../lib/Items/ApplicationDockItem.vala"
		_tmp13_ = g_key_file_has_key (_tmp14_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, &_inner_error0_);
#line 583 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 583 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_tmp9_);
#line 583 "../lib/Items/ApplicationDockItem.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3103 "ApplicationDockItem.c"
				goto __catch1_g_key_file_error;
			}
#line 583 "../lib/Items/ApplicationDockItem.vala"
			_g_key_file_unref0 (file);
#line 583 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 583 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 583 "../lib/Items/ApplicationDockItem.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 583 "../lib/Items/ApplicationDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 583 "../lib/Items/ApplicationDockItem.vala"
			return;
#line 3118 "ApplicationDockItem.c"
		}
#line 583 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp13_) {
#line 3122 "ApplicationDockItem.c"
			gchar* _tmp15_ = NULL;
			GKeyFile* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_tmp16_ = file;
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_tmp17_ = g_key_file_get_locale_string (_tmp16_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, NULL, &_inner_error0_);
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_tmp15_ = _tmp17_;
#line 584 "../lib/Items/ApplicationDockItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 584 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_tmp9_);
#line 584 "../lib/Items/ApplicationDockItem.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3139 "ApplicationDockItem.c"
					goto __catch1_g_key_file_error;
				}
#line 584 "../lib/Items/ApplicationDockItem.vala"
				_g_key_file_unref0 (file);
#line 584 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_vala_icon);
#line 584 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_vala_text);
#line 584 "../lib/Items/ApplicationDockItem.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 584 "../lib/Items/ApplicationDockItem.vala"
				g_clear_error (&_inner_error0_);
#line 584 "../lib/Items/ApplicationDockItem.vala"
				return;
#line 3154 "ApplicationDockItem.c"
			}
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_tmp18_ = _tmp15_;
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_tmp15_ = NULL;
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 584 "../lib/Items/ApplicationDockItem.vala"
			_vala_icon = _tmp18_;
#line 583 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_tmp15_);
#line 3166 "ApplicationDockItem.c"
		}
#line 586 "../lib/Items/ApplicationDockItem.vala"
		_tmp19_ = file;
#line 586 "../lib/Items/ApplicationDockItem.vala"
		_tmp20_ = g_key_file_get_string (_tmp19_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, &_inner_error0_);
#line 586 "../lib/Items/ApplicationDockItem.vala"
		type = _tmp20_;
#line 586 "../lib/Items/ApplicationDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 586 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_tmp9_);
#line 586 "../lib/Items/ApplicationDockItem.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3180 "ApplicationDockItem.c"
				goto __catch1_g_key_file_error;
			}
#line 586 "../lib/Items/ApplicationDockItem.vala"
			_g_key_file_unref0 (file);
#line 586 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 586 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 586 "../lib/Items/ApplicationDockItem.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 586 "../lib/Items/ApplicationDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 586 "../lib/Items/ApplicationDockItem.vala"
			return;
#line 3195 "ApplicationDockItem.c"
		}
#line 587 "../lib/Items/ApplicationDockItem.vala"
		_tmp21_ = type;
#line 587 "../lib/Items/ApplicationDockItem.vala"
		_tmp22_ = _tmp21_;
#line 587 "../lib/Items/ApplicationDockItem.vala"
		_tmp24_ = (NULL == _tmp22_) ? 0 : g_quark_from_string (_tmp22_);
#line 587 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp24_ == ((0 != _tmp23_label0) ? _tmp23_label0 : (_tmp23_label0 = g_quark_from_static_string (G_KEY_FILE_DESKTOP_TYPE_DIRECTORY)))) {
#line 587 "../lib/Items/ApplicationDockItem.vala"
			switch (0) {
#line 3207 "ApplicationDockItem.c"
				default:
				{
					const gchar* _tmp25_;
#line 592 "../lib/Items/ApplicationDockItem.vala"
					_tmp25_ = _vala_icon;
#line 592 "../lib/Items/ApplicationDockItem.vala"
					if (g_strcmp0 (_tmp25_, "") == 0) {
#line 3215 "ApplicationDockItem.c"
						gchar* _tmp26_;
#line 593 "../lib/Items/ApplicationDockItem.vala"
						_tmp26_ = g_strdup ("inode-directory");
#line 593 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_icon);
#line 593 "../lib/Items/ApplicationDockItem.vala"
						_vala_icon = _tmp26_;
#line 3223 "ApplicationDockItem.c"
					}
#line 594 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (type);
#line 594 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (_tmp9_);
#line 594 "../lib/Items/ApplicationDockItem.vala"
					_g_key_file_unref0 (file);
#line 594 "../lib/Items/ApplicationDockItem.vala"
					if (icon) {
#line 594 "../lib/Items/ApplicationDockItem.vala"
						*icon = _vala_icon;
#line 3235 "ApplicationDockItem.c"
					} else {
#line 594 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_icon);
#line 3239 "ApplicationDockItem.c"
					}
#line 594 "../lib/Items/ApplicationDockItem.vala"
					if (text) {
#line 594 "../lib/Items/ApplicationDockItem.vala"
						*text = _vala_text;
#line 3245 "ApplicationDockItem.c"
					} else {
#line 594 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_text);
#line 3249 "ApplicationDockItem.c"
					}
#line 594 "../lib/Items/ApplicationDockItem.vala"
					return;
#line 3253 "ApplicationDockItem.c"
				}
			}
		} else if (_tmp24_ == ((0 != _tmp23_label1) ? _tmp23_label1 : (_tmp23_label1 = g_quark_from_static_string (G_KEY_FILE_DESKTOP_TYPE_LINK)))) {
#line 587 "../lib/Items/ApplicationDockItem.vala"
			switch (0) {
#line 3259 "ApplicationDockItem.c"
				default:
				{
					const gchar* _tmp27_;
#line 596 "../lib/Items/ApplicationDockItem.vala"
					_tmp27_ = _vala_icon;
#line 596 "../lib/Items/ApplicationDockItem.vala"
					if (g_strcmp0 (_tmp27_, "") == 0) {
#line 3267 "ApplicationDockItem.c"
						gchar* _tmp28_;
#line 597 "../lib/Items/ApplicationDockItem.vala"
						_tmp28_ = g_strdup ("document");
#line 597 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_icon);
#line 597 "../lib/Items/ApplicationDockItem.vala"
						_vala_icon = _tmp28_;
#line 3275 "ApplicationDockItem.c"
					}
#line 598 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (type);
#line 598 "../lib/Items/ApplicationDockItem.vala"
					_g_free0 (_tmp9_);
#line 598 "../lib/Items/ApplicationDockItem.vala"
					_g_key_file_unref0 (file);
#line 598 "../lib/Items/ApplicationDockItem.vala"
					if (icon) {
#line 598 "../lib/Items/ApplicationDockItem.vala"
						*icon = _vala_icon;
#line 3287 "ApplicationDockItem.c"
					} else {
#line 598 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_icon);
#line 3291 "ApplicationDockItem.c"
					}
#line 598 "../lib/Items/ApplicationDockItem.vala"
					if (text) {
#line 598 "../lib/Items/ApplicationDockItem.vala"
						*text = _vala_text;
#line 3297 "ApplicationDockItem.c"
					} else {
#line 598 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_text);
#line 3301 "ApplicationDockItem.c"
					}
#line 598 "../lib/Items/ApplicationDockItem.vala"
					return;
#line 3305 "ApplicationDockItem.c"
				}
			}
		} else {
#line 587 "../lib/Items/ApplicationDockItem.vala"
			switch (0) {
#line 3311 "ApplicationDockItem.c"
				default:
				{
#line 590 "../lib/Items/ApplicationDockItem.vala"
					break;
#line 3316 "ApplicationDockItem.c"
				}
			}
		}
#line 580 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (type);
#line 580 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_tmp9_);
#line 3324 "ApplicationDockItem.c"
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
#line 580 "../lib/Items/ApplicationDockItem.vala"
		e = _inner_error0_;
#line 580 "../lib/Items/ApplicationDockItem.vala"
		_inner_error0_ = NULL;
#line 601 "../lib/Items/ApplicationDockItem.vala"
		_tmp29_ = e;
#line 601 "../lib/Items/ApplicationDockItem.vala"
		_tmp30_ = _tmp29_->message;
#line 601 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("ApplicationDockItem.vala:601: %s: %s", launcher, _tmp30_);
#line 602 "../lib/Items/ApplicationDockItem.vala"
		_g_error_free0 (e);
#line 602 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 602 "../lib/Items/ApplicationDockItem.vala"
		if (icon) {
#line 602 "../lib/Items/ApplicationDockItem.vala"
			*icon = _vala_icon;
#line 3350 "ApplicationDockItem.c"
		} else {
#line 602 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 3354 "ApplicationDockItem.c"
		}
#line 602 "../lib/Items/ApplicationDockItem.vala"
		if (text) {
#line 602 "../lib/Items/ApplicationDockItem.vala"
			*text = _vala_text;
#line 3360 "ApplicationDockItem.c"
		} else {
#line 602 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 3364 "ApplicationDockItem.c"
		}
#line 602 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 3368 "ApplicationDockItem.c"
	}
	__finally1:
#line 580 "../lib/Items/ApplicationDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 580 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 580 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_icon);
#line 580 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_text);
#line 580 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 580 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 580 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 3385 "ApplicationDockItem.c"
	}
	{
		gboolean _tmp31_ = FALSE;
		gchar* textdomain = NULL;
		gboolean _tmp49_ = FALSE;
#line 606 "../lib/Items/ApplicationDockItem.vala"
		if (mimes != NULL) {
#line 3393 "ApplicationDockItem.c"
			gboolean _tmp32_ = FALSE;
			GKeyFile* _tmp33_;
#line 606 "../lib/Items/ApplicationDockItem.vala"
			_tmp33_ = file;
#line 606 "../lib/Items/ApplicationDockItem.vala"
			_tmp32_ = g_key_file_has_key (_tmp33_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_MIME_TYPE, &_inner_error0_);
#line 606 "../lib/Items/ApplicationDockItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 606 "../lib/Items/ApplicationDockItem.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3404 "ApplicationDockItem.c"
					goto __catch2_g_key_file_error;
				}
#line 606 "../lib/Items/ApplicationDockItem.vala"
				_g_key_file_unref0 (file);
#line 606 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_vala_icon);
#line 606 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_vala_text);
#line 606 "../lib/Items/ApplicationDockItem.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 606 "../lib/Items/ApplicationDockItem.vala"
				g_clear_error (&_inner_error0_);
#line 606 "../lib/Items/ApplicationDockItem.vala"
				return;
#line 3419 "ApplicationDockItem.c"
			}
#line 606 "../lib/Items/ApplicationDockItem.vala"
			_tmp31_ = _tmp32_;
#line 3423 "ApplicationDockItem.c"
		} else {
#line 606 "../lib/Items/ApplicationDockItem.vala"
			_tmp31_ = FALSE;
#line 3427 "ApplicationDockItem.c"
		}
#line 606 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp31_) {
#line 3431 "ApplicationDockItem.c"
			gchar** mimestrings = NULL;
			GKeyFile* _tmp34_;
			gsize _tmp35_ = 0;
			gchar** _tmp36_;
			gint mimestrings_length1;
			gint _mimestrings_size_;
			gchar** _tmp37_;
			gint _tmp37__length1;
#line 607 "../lib/Items/ApplicationDockItem.vala"
			_tmp34_ = file;
#line 607 "../lib/Items/ApplicationDockItem.vala"
			_tmp36_ = g_key_file_get_string_list (_tmp34_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_MIME_TYPE, &_tmp35_, &_inner_error0_);
#line 607 "../lib/Items/ApplicationDockItem.vala"
			mimestrings = _tmp36_;
#line 607 "../lib/Items/ApplicationDockItem.vala"
			mimestrings_length1 = _tmp35_;
#line 607 "../lib/Items/ApplicationDockItem.vala"
			_mimestrings_size_ = mimestrings_length1;
#line 607 "../lib/Items/ApplicationDockItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "../lib/Items/ApplicationDockItem.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3454 "ApplicationDockItem.c"
					goto __catch2_g_key_file_error;
				}
#line 607 "../lib/Items/ApplicationDockItem.vala"
				_g_key_file_unref0 (file);
#line 607 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_vala_icon);
#line 607 "../lib/Items/ApplicationDockItem.vala"
				_g_free0 (_vala_text);
#line 607 "../lib/Items/ApplicationDockItem.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 607 "../lib/Items/ApplicationDockItem.vala"
				g_clear_error (&_inner_error0_);
#line 607 "../lib/Items/ApplicationDockItem.vala"
				return;
#line 3469 "ApplicationDockItem.c"
			}
#line 608 "../lib/Items/ApplicationDockItem.vala"
			_tmp37_ = mimestrings;
#line 608 "../lib/Items/ApplicationDockItem.vala"
			_tmp37__length1 = mimestrings_length1;
#line 3475 "ApplicationDockItem.c"
			{
				gchar** mime_collection = NULL;
				gint mime_collection_length1 = 0;
				gint _mime_collection_size_ = 0;
				gint mime_it = 0;
#line 608 "../lib/Items/ApplicationDockItem.vala"
				mime_collection = _tmp37_;
#line 608 "../lib/Items/ApplicationDockItem.vala"
				mime_collection_length1 = _tmp37__length1;
#line 608 "../lib/Items/ApplicationDockItem.vala"
				for (mime_it = 0; mime_it < mime_collection_length1; mime_it = mime_it + 1) {
#line 3487 "ApplicationDockItem.c"
					const gchar* mime = NULL;
#line 608 "../lib/Items/ApplicationDockItem.vala"
					mime = mime_collection[mime_it];
#line 3491 "ApplicationDockItem.c"
					{
						const gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
#line 609 "../lib/Items/ApplicationDockItem.vala"
						_tmp38_ = mime;
#line 609 "../lib/Items/ApplicationDockItem.vala"
						_tmp39_ = g_content_type_from_mime_type (_tmp38_);
#line 609 "../lib/Items/ApplicationDockItem.vala"
						_tmp40_ = _tmp39_;
#line 609 "../lib/Items/ApplicationDockItem.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) mimes, _tmp40_);
#line 609 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_tmp40_);
#line 3506 "ApplicationDockItem.c"
					}
				}
			}
#line 606 "../lib/Items/ApplicationDockItem.vala"
			mimestrings = (_vala_array_free (mimestrings, mimestrings_length1, (GDestroyNotify) g_free), NULL);
#line 3512 "ApplicationDockItem.c"
		}
#line 612 "../lib/Items/ApplicationDockItem.vala"
		textdomain = NULL;
#line 3516 "ApplicationDockItem.c"
		{
			const gchar** domain_key_collection = NULL;
			gint domain_key_collection_length1 = 0;
			gint _domain_key_collection_size_ = 0;
			gint domain_key_it = 0;
#line 613 "../lib/Items/ApplicationDockItem.vala"
			domain_key_collection = PLANK_APPLICATION_DOCK_ITEM_SUPPORTED_GETTEXT_DOMAINS_KEYS;
#line 613 "../lib/Items/ApplicationDockItem.vala"
			domain_key_collection_length1 = G_N_ELEMENTS (PLANK_APPLICATION_DOCK_ITEM_SUPPORTED_GETTEXT_DOMAINS_KEYS);
#line 613 "../lib/Items/ApplicationDockItem.vala"
			for (domain_key_it = 0; domain_key_it < domain_key_collection_length1; domain_key_it = domain_key_it + 1) {
#line 3528 "ApplicationDockItem.c"
				const gchar* domain_key = NULL;
#line 613 "../lib/Items/ApplicationDockItem.vala"
				domain_key = domain_key_collection[domain_key_it];
#line 3532 "ApplicationDockItem.c"
				{
					gboolean _tmp41_ = FALSE;
					GKeyFile* _tmp42_;
					const gchar* _tmp43_;
#line 614 "../lib/Items/ApplicationDockItem.vala"
					_tmp42_ = file;
#line 614 "../lib/Items/ApplicationDockItem.vala"
					_tmp43_ = domain_key;
#line 614 "../lib/Items/ApplicationDockItem.vala"
					_tmp41_ = g_key_file_has_key (_tmp42_, G_KEY_FILE_DESKTOP_GROUP, _tmp43_, &_inner_error0_);
#line 614 "../lib/Items/ApplicationDockItem.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 614 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (textdomain);
#line 614 "../lib/Items/ApplicationDockItem.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3549 "ApplicationDockItem.c"
							goto __catch2_g_key_file_error;
						}
#line 614 "../lib/Items/ApplicationDockItem.vala"
						_g_key_file_unref0 (file);
#line 614 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_icon);
#line 614 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_vala_text);
#line 614 "../lib/Items/ApplicationDockItem.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 614 "../lib/Items/ApplicationDockItem.vala"
						g_clear_error (&_inner_error0_);
#line 614 "../lib/Items/ApplicationDockItem.vala"
						return;
#line 3564 "ApplicationDockItem.c"
					}
#line 614 "../lib/Items/ApplicationDockItem.vala"
					if (_tmp41_) {
#line 3568 "ApplicationDockItem.c"
						gchar* _tmp44_ = NULL;
						GKeyFile* _tmp45_;
						const gchar* _tmp46_;
						gchar* _tmp47_;
						gchar* _tmp48_;
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_tmp45_ = file;
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_tmp46_ = domain_key;
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_tmp47_ = g_key_file_get_string (_tmp45_, G_KEY_FILE_DESKTOP_GROUP, _tmp46_, &_inner_error0_);
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_tmp44_ = _tmp47_;
#line 615 "../lib/Items/ApplicationDockItem.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 615 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (textdomain);
#line 615 "../lib/Items/ApplicationDockItem.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3588 "ApplicationDockItem.c"
								goto __catch2_g_key_file_error;
							}
#line 615 "../lib/Items/ApplicationDockItem.vala"
							_g_key_file_unref0 (file);
#line 615 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (_vala_icon);
#line 615 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (_vala_text);
#line 615 "../lib/Items/ApplicationDockItem.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 615 "../lib/Items/ApplicationDockItem.vala"
							g_clear_error (&_inner_error0_);
#line 615 "../lib/Items/ApplicationDockItem.vala"
							return;
#line 3603 "ApplicationDockItem.c"
						}
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_tmp48_ = _tmp44_;
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_tmp44_ = NULL;
#line 615 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (textdomain);
#line 615 "../lib/Items/ApplicationDockItem.vala"
						textdomain = _tmp48_;
#line 616 "../lib/Items/ApplicationDockItem.vala"
						_g_free0 (_tmp44_);
#line 616 "../lib/Items/ApplicationDockItem.vala"
						break;
#line 3617 "ApplicationDockItem.c"
					}
				}
			}
		}
#line 623 "../lib/Items/ApplicationDockItem.vala"
		if (actions != NULL) {
#line 623 "../lib/Items/ApplicationDockItem.vala"
			_tmp49_ = actions_map != NULL;
#line 3626 "ApplicationDockItem.c"
		} else {
#line 623 "../lib/Items/ApplicationDockItem.vala"
			_tmp49_ = FALSE;
#line 3630 "ApplicationDockItem.c"
		}
#line 623 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp49_) {
#line 3634 "ApplicationDockItem.c"
			gchar** keys = NULL;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar** _tmp52_;
			gint keys_length1;
			gint _keys_size_;
			gchar** _tmp53_;
			gint _tmp53__length1;
#line 624 "../lib/Items/ApplicationDockItem.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) actions);
#line 625 "../lib/Items/ApplicationDockItem.vala"
			gee_map_clear (actions_map);
#line 627 "../lib/Items/ApplicationDockItem.vala"
			_tmp50_ = g_strdup (PLANK_APPLICATION_DOCK_ITEM_DESKTOP_ACTION_KEY);
#line 627 "../lib/Items/ApplicationDockItem.vala"
			_tmp51_ = g_strdup (PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_KEY);
#line 627 "../lib/Items/ApplicationDockItem.vala"
			_tmp52_ = g_new0 (gchar*, 2 + 1);
#line 627 "../lib/Items/ApplicationDockItem.vala"
			_tmp52_[0] = _tmp50_;
#line 627 "../lib/Items/ApplicationDockItem.vala"
			_tmp52_[1] = _tmp51_;
#line 627 "../lib/Items/ApplicationDockItem.vala"
			keys = _tmp52_;
#line 627 "../lib/Items/ApplicationDockItem.vala"
			keys_length1 = 2;
#line 627 "../lib/Items/ApplicationDockItem.vala"
			_keys_size_ = keys_length1;
#line 629 "../lib/Items/ApplicationDockItem.vala"
			_tmp53_ = keys;
#line 629 "../lib/Items/ApplicationDockItem.vala"
			_tmp53__length1 = keys_length1;
#line 3667 "ApplicationDockItem.c"
			{
				gchar** key_collection = NULL;
				gint key_collection_length1 = 0;
				gint _key_collection_size_ = 0;
				gint key_it = 0;
#line 629 "../lib/Items/ApplicationDockItem.vala"
				key_collection = _tmp53_;
#line 629 "../lib/Items/ApplicationDockItem.vala"
				key_collection_length1 = _tmp53__length1;
#line 629 "../lib/Items/ApplicationDockItem.vala"
				for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 3679 "ApplicationDockItem.c"
					const gchar* key = NULL;
#line 629 "../lib/Items/ApplicationDockItem.vala"
					key = key_collection[key_it];
#line 3683 "ApplicationDockItem.c"
					{
						gboolean _tmp54_ = FALSE;
						GKeyFile* _tmp55_;
						const gchar* _tmp56_;
						gchar** _tmp57_ = NULL;
						GKeyFile* _tmp58_;
						const gchar* _tmp59_;
						gsize _tmp60_ = 0;
						gchar** _tmp61_;
						gint _tmp57__length1;
						gint __tmp57__size_;
#line 630 "../lib/Items/ApplicationDockItem.vala"
						_tmp55_ = file;
#line 630 "../lib/Items/ApplicationDockItem.vala"
						_tmp56_ = key;
#line 630 "../lib/Items/ApplicationDockItem.vala"
						_tmp54_ = g_key_file_has_key (_tmp55_, G_KEY_FILE_DESKTOP_GROUP, _tmp56_, &_inner_error0_);
#line 630 "../lib/Items/ApplicationDockItem.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 630 "../lib/Items/ApplicationDockItem.vala"
							keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (textdomain);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3709 "ApplicationDockItem.c"
								goto __catch2_g_key_file_error;
							}
#line 630 "../lib/Items/ApplicationDockItem.vala"
							_g_key_file_unref0 (file);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (_vala_icon);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (_vala_text);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							g_clear_error (&_inner_error0_);
#line 630 "../lib/Items/ApplicationDockItem.vala"
							return;
#line 3724 "ApplicationDockItem.c"
						}
#line 630 "../lib/Items/ApplicationDockItem.vala"
						if (!_tmp54_) {
#line 631 "../lib/Items/ApplicationDockItem.vala"
							continue;
#line 3730 "ApplicationDockItem.c"
						}
#line 633 "../lib/Items/ApplicationDockItem.vala"
						_tmp58_ = file;
#line 633 "../lib/Items/ApplicationDockItem.vala"
						_tmp59_ = key;
#line 633 "../lib/Items/ApplicationDockItem.vala"
						_tmp61_ = g_key_file_get_string_list (_tmp58_, G_KEY_FILE_DESKTOP_GROUP, _tmp59_, &_tmp60_, &_inner_error0_);
#line 633 "../lib/Items/ApplicationDockItem.vala"
						_tmp57_ = _tmp61_;
#line 633 "../lib/Items/ApplicationDockItem.vala"
						_tmp57__length1 = _tmp60_;
#line 633 "../lib/Items/ApplicationDockItem.vala"
						__tmp57__size_ = _tmp57__length1;
#line 633 "../lib/Items/ApplicationDockItem.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 633 "../lib/Items/ApplicationDockItem.vala"
							keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (textdomain);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3752 "ApplicationDockItem.c"
								goto __catch2_g_key_file_error;
							}
#line 633 "../lib/Items/ApplicationDockItem.vala"
							_g_key_file_unref0 (file);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (_vala_icon);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							_g_free0 (_vala_text);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							g_clear_error (&_inner_error0_);
#line 633 "../lib/Items/ApplicationDockItem.vala"
							return;
#line 3767 "ApplicationDockItem.c"
						}
						{
							gchar** action_collection = NULL;
							gint action_collection_length1 = 0;
							gint _action_collection_size_ = 0;
							gint action_it = 0;
#line 633 "../lib/Items/ApplicationDockItem.vala"
							action_collection = _tmp57_;
#line 633 "../lib/Items/ApplicationDockItem.vala"
							action_collection_length1 = _tmp57__length1;
#line 633 "../lib/Items/ApplicationDockItem.vala"
							for (action_it = 0; action_it < action_collection_length1; action_it = action_it + 1) {
#line 3780 "ApplicationDockItem.c"
								const gchar* action = NULL;
#line 633 "../lib/Items/ApplicationDockItem.vala"
								action = action_collection[action_it];
#line 3784 "ApplicationDockItem.c"
								{
									gchar* group = NULL;
									const gchar* _tmp62_;
									gchar* _tmp63_;
									GKeyFile* _tmp64_;
									const gchar* _tmp65_;
									gboolean _tmp70_ = FALSE;
									GKeyFile* _tmp71_;
									const gchar* _tmp72_;
									gboolean _tmp79_ = FALSE;
									GKeyFile* _tmp80_;
									const gchar* _tmp81_;
									gboolean _tmp88_ = FALSE;
									GKeyFile* _tmp89_;
									const gchar* _tmp90_;
									gchar* action_name = NULL;
									GKeyFile* _tmp99_;
									const gchar* _tmp100_;
									gchar* _tmp101_;
									gchar* action_icon = NULL;
									gchar* _tmp102_;
									gboolean _tmp103_ = FALSE;
									GKeyFile* _tmp104_;
									const gchar* _tmp105_;
									gchar* action_exec = NULL;
									gchar* _tmp111_;
									gboolean _tmp112_ = FALSE;
									GKeyFile* _tmp113_;
									const gchar* _tmp114_;
									const gchar* _tmp120_;
									const gchar* _tmp124_;
									const gchar* _tmp125_;
									const gchar* _tmp126_;
									const gchar* _tmp127_;
									gchar* _tmp128_;
									gchar* _tmp129_;
#line 634 "../lib/Items/ApplicationDockItem.vala"
									_tmp62_ = action;
#line 634 "../lib/Items/ApplicationDockItem.vala"
									_tmp63_ = g_strdup_printf (PLANK_APPLICATION_DOCK_ITEM_DESKTOP_ACTION_GROUP_NAME, _tmp62_);
#line 634 "../lib/Items/ApplicationDockItem.vala"
									group = _tmp63_;
#line 635 "../lib/Items/ApplicationDockItem.vala"
									_tmp64_ = file;
#line 635 "../lib/Items/ApplicationDockItem.vala"
									_tmp65_ = group;
#line 635 "../lib/Items/ApplicationDockItem.vala"
									if (!g_key_file_has_group (_tmp64_, _tmp65_)) {
#line 3833 "ApplicationDockItem.c"
										const gchar* _tmp66_;
										gchar* _tmp67_;
										GKeyFile* _tmp68_;
										const gchar* _tmp69_;
#line 636 "../lib/Items/ApplicationDockItem.vala"
										_tmp66_ = action;
#line 636 "../lib/Items/ApplicationDockItem.vala"
										_tmp67_ = g_strdup_printf (PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_SHORTCUT_GROUP_NAME, _tmp66_);
#line 636 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 636 "../lib/Items/ApplicationDockItem.vala"
										group = _tmp67_;
#line 637 "../lib/Items/ApplicationDockItem.vala"
										_tmp68_ = file;
#line 637 "../lib/Items/ApplicationDockItem.vala"
										_tmp69_ = group;
#line 637 "../lib/Items/ApplicationDockItem.vala"
										if (!g_key_file_has_group (_tmp68_, _tmp69_)) {
#line 638 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 638 "../lib/Items/ApplicationDockItem.vala"
											continue;
#line 3856 "ApplicationDockItem.c"
										}
									}
#line 642 "../lib/Items/ApplicationDockItem.vala"
									_tmp71_ = file;
#line 642 "../lib/Items/ApplicationDockItem.vala"
									_tmp72_ = group;
#line 642 "../lib/Items/ApplicationDockItem.vala"
									_tmp70_ = g_key_file_has_key (_tmp71_, _tmp72_, PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_TARGET_KEY, &_inner_error0_);
#line 642 "../lib/Items/ApplicationDockItem.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (textdomain);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3877 "ApplicationDockItem.c"
											goto __catch2_g_key_file_error;
										}
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_g_key_file_unref0 (file);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_icon);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_text);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										g_clear_error (&_inner_error0_);
#line 642 "../lib/Items/ApplicationDockItem.vala"
										return;
#line 3892 "ApplicationDockItem.c"
									}
#line 642 "../lib/Items/ApplicationDockItem.vala"
									if (_tmp70_) {
#line 3896 "ApplicationDockItem.c"
										gchar* target = NULL;
										GKeyFile* _tmp73_;
										const gchar* _tmp74_;
										gchar* _tmp75_;
										gboolean _tmp76_ = FALSE;
										const gchar* _tmp77_;
#line 643 "../lib/Items/ApplicationDockItem.vala"
										_tmp73_ = file;
#line 643 "../lib/Items/ApplicationDockItem.vala"
										_tmp74_ = group;
#line 643 "../lib/Items/ApplicationDockItem.vala"
										_tmp75_ = g_key_file_get_string (_tmp73_, _tmp74_, PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_TARGET_KEY, &_inner_error0_);
#line 643 "../lib/Items/ApplicationDockItem.vala"
										target = _tmp75_;
#line 643 "../lib/Items/ApplicationDockItem.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 643 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (textdomain);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3923 "ApplicationDockItem.c"
												goto __catch2_g_key_file_error;
											}
#line 643 "../lib/Items/ApplicationDockItem.vala"
											_g_key_file_unref0 (file);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_icon);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_text);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											g_clear_error (&_inner_error0_);
#line 643 "../lib/Items/ApplicationDockItem.vala"
											return;
#line 3938 "ApplicationDockItem.c"
										}
#line 644 "../lib/Items/ApplicationDockItem.vala"
										_tmp77_ = target;
#line 644 "../lib/Items/ApplicationDockItem.vala"
										if (g_strcmp0 (_tmp77_, PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_TARGET_VALUE) != 0) {
#line 3944 "ApplicationDockItem.c"
											const gchar* _tmp78_;
#line 644 "../lib/Items/ApplicationDockItem.vala"
											_tmp78_ = target;
#line 644 "../lib/Items/ApplicationDockItem.vala"
											_tmp76_ = g_strcmp0 (_tmp78_, "Plank") != 0;
#line 3950 "ApplicationDockItem.c"
										} else {
#line 644 "../lib/Items/ApplicationDockItem.vala"
											_tmp76_ = FALSE;
#line 3954 "ApplicationDockItem.c"
										}
#line 644 "../lib/Items/ApplicationDockItem.vala"
										if (_tmp76_) {
#line 645 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (target);
#line 645 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 645 "../lib/Items/ApplicationDockItem.vala"
											continue;
#line 3964 "ApplicationDockItem.c"
										}
#line 642 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (target);
#line 3968 "ApplicationDockItem.c"
									}
#line 649 "../lib/Items/ApplicationDockItem.vala"
									_tmp80_ = file;
#line 649 "../lib/Items/ApplicationDockItem.vala"
									_tmp81_ = group;
#line 649 "../lib/Items/ApplicationDockItem.vala"
									_tmp79_ = g_key_file_has_key (_tmp80_, _tmp81_, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN, &_inner_error0_);
#line 649 "../lib/Items/ApplicationDockItem.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (textdomain);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3988 "ApplicationDockItem.c"
											goto __catch2_g_key_file_error;
										}
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_g_key_file_unref0 (file);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_icon);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_text);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										g_clear_error (&_inner_error0_);
#line 649 "../lib/Items/ApplicationDockItem.vala"
										return;
#line 4003 "ApplicationDockItem.c"
									}
#line 649 "../lib/Items/ApplicationDockItem.vala"
									if (_tmp79_) {
#line 4007 "ApplicationDockItem.c"
										gboolean found = FALSE;
										gchar** _tmp82_ = NULL;
										GKeyFile* _tmp83_;
										const gchar* _tmp84_;
										gsize _tmp85_ = 0;
										gchar** _tmp86_;
										gint _tmp82__length1;
										gint __tmp82__size_;
#line 650 "../lib/Items/ApplicationDockItem.vala"
										found = FALSE;
#line 652 "../lib/Items/ApplicationDockItem.vala"
										_tmp83_ = file;
#line 652 "../lib/Items/ApplicationDockItem.vala"
										_tmp84_ = group;
#line 652 "../lib/Items/ApplicationDockItem.vala"
										_tmp86_ = g_key_file_get_string_list (_tmp83_, _tmp84_, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN, &_tmp85_, &_inner_error0_);
#line 652 "../lib/Items/ApplicationDockItem.vala"
										_tmp82_ = _tmp86_;
#line 652 "../lib/Items/ApplicationDockItem.vala"
										_tmp82__length1 = _tmp85_;
#line 652 "../lib/Items/ApplicationDockItem.vala"
										__tmp82__size_ = _tmp82__length1;
#line 652 "../lib/Items/ApplicationDockItem.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 652 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (textdomain);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4042 "ApplicationDockItem.c"
												goto __catch2_g_key_file_error;
											}
#line 652 "../lib/Items/ApplicationDockItem.vala"
											_g_key_file_unref0 (file);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_icon);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_text);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											g_clear_error (&_inner_error0_);
#line 652 "../lib/Items/ApplicationDockItem.vala"
											return;
#line 4057 "ApplicationDockItem.c"
										}
										{
											gchar** s_collection = NULL;
											gint s_collection_length1 = 0;
											gint _s_collection_size_ = 0;
											gint s_it = 0;
#line 652 "../lib/Items/ApplicationDockItem.vala"
											s_collection = _tmp82_;
#line 652 "../lib/Items/ApplicationDockItem.vala"
											s_collection_length1 = _tmp82__length1;
#line 652 "../lib/Items/ApplicationDockItem.vala"
											for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 4070 "ApplicationDockItem.c"
												const gchar* s = NULL;
#line 652 "../lib/Items/ApplicationDockItem.vala"
												s = s_collection[s_it];
#line 4074 "ApplicationDockItem.c"
												{
													const gchar* _tmp87_;
#line 653 "../lib/Items/ApplicationDockItem.vala"
													_tmp87_ = s;
#line 653 "../lib/Items/ApplicationDockItem.vala"
													if (g_strcmp0 (_tmp87_, "Plank") == 0) {
#line 654 "../lib/Items/ApplicationDockItem.vala"
														found = TRUE;
#line 655 "../lib/Items/ApplicationDockItem.vala"
														break;
#line 4085 "ApplicationDockItem.c"
													}
												}
											}
										}
#line 658 "../lib/Items/ApplicationDockItem.vala"
										if (found) {
#line 659 "../lib/Items/ApplicationDockItem.vala"
											_tmp82_ = (_vala_array_free (_tmp82_, _tmp82__length1, (GDestroyNotify) g_free), NULL);
#line 659 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 659 "../lib/Items/ApplicationDockItem.vala"
											continue;
#line 4098 "ApplicationDockItem.c"
										}
#line 649 "../lib/Items/ApplicationDockItem.vala"
										_tmp82_ = (_vala_array_free (_tmp82_, _tmp82__length1, (GDestroyNotify) g_free), NULL);
#line 4102 "ApplicationDockItem.c"
									}
#line 663 "../lib/Items/ApplicationDockItem.vala"
									_tmp89_ = file;
#line 663 "../lib/Items/ApplicationDockItem.vala"
									_tmp90_ = group;
#line 663 "../lib/Items/ApplicationDockItem.vala"
									_tmp88_ = g_key_file_has_key (_tmp89_, _tmp90_, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN, &_inner_error0_);
#line 663 "../lib/Items/ApplicationDockItem.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (textdomain);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4122 "ApplicationDockItem.c"
											goto __catch2_g_key_file_error;
										}
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_g_key_file_unref0 (file);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_icon);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_text);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										g_clear_error (&_inner_error0_);
#line 663 "../lib/Items/ApplicationDockItem.vala"
										return;
#line 4137 "ApplicationDockItem.c"
									}
#line 663 "../lib/Items/ApplicationDockItem.vala"
									if (_tmp88_) {
#line 4141 "ApplicationDockItem.c"
										gboolean found = FALSE;
										gchar** _tmp91_ = NULL;
										GKeyFile* _tmp92_;
										const gchar* _tmp93_;
										gsize _tmp94_ = 0;
										gchar** _tmp95_;
										gint _tmp91__length1;
										gint __tmp91__size_;
#line 664 "../lib/Items/ApplicationDockItem.vala"
										found = FALSE;
#line 666 "../lib/Items/ApplicationDockItem.vala"
										_tmp92_ = file;
#line 666 "../lib/Items/ApplicationDockItem.vala"
										_tmp93_ = group;
#line 666 "../lib/Items/ApplicationDockItem.vala"
										_tmp95_ = g_key_file_get_string_list (_tmp92_, _tmp93_, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN, &_tmp94_, &_inner_error0_);
#line 666 "../lib/Items/ApplicationDockItem.vala"
										_tmp91_ = _tmp95_;
#line 666 "../lib/Items/ApplicationDockItem.vala"
										_tmp91__length1 = _tmp94_;
#line 666 "../lib/Items/ApplicationDockItem.vala"
										__tmp91__size_ = _tmp91__length1;
#line 666 "../lib/Items/ApplicationDockItem.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 666 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (textdomain);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4176 "ApplicationDockItem.c"
												goto __catch2_g_key_file_error;
											}
#line 666 "../lib/Items/ApplicationDockItem.vala"
											_g_key_file_unref0 (file);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_icon);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_text);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											g_clear_error (&_inner_error0_);
#line 666 "../lib/Items/ApplicationDockItem.vala"
											return;
#line 4191 "ApplicationDockItem.c"
										}
										{
											gchar** s_collection = NULL;
											gint s_collection_length1 = 0;
											gint _s_collection_size_ = 0;
											gint s_it = 0;
#line 666 "../lib/Items/ApplicationDockItem.vala"
											s_collection = _tmp91_;
#line 666 "../lib/Items/ApplicationDockItem.vala"
											s_collection_length1 = _tmp91__length1;
#line 666 "../lib/Items/ApplicationDockItem.vala"
											for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 4204 "ApplicationDockItem.c"
												const gchar* s = NULL;
#line 666 "../lib/Items/ApplicationDockItem.vala"
												s = s_collection[s_it];
#line 4208 "ApplicationDockItem.c"
												{
													gboolean _tmp96_ = FALSE;
													const gchar* _tmp97_;
#line 667 "../lib/Items/ApplicationDockItem.vala"
													_tmp97_ = s;
#line 667 "../lib/Items/ApplicationDockItem.vala"
													if (g_strcmp0 (_tmp97_, PLANK_APPLICATION_DOCK_ITEM_UNITY_QUICKLISTS_TARGET_VALUE) == 0) {
#line 667 "../lib/Items/ApplicationDockItem.vala"
														_tmp96_ = TRUE;
#line 4218 "ApplicationDockItem.c"
													} else {
														const gchar* _tmp98_;
#line 667 "../lib/Items/ApplicationDockItem.vala"
														_tmp98_ = s;
#line 667 "../lib/Items/ApplicationDockItem.vala"
														_tmp96_ = g_strcmp0 (_tmp98_, "Plank") == 0;
#line 4225 "ApplicationDockItem.c"
													}
#line 667 "../lib/Items/ApplicationDockItem.vala"
													if (_tmp96_) {
#line 668 "../lib/Items/ApplicationDockItem.vala"
														found = TRUE;
#line 669 "../lib/Items/ApplicationDockItem.vala"
														break;
#line 4233 "ApplicationDockItem.c"
													}
												}
											}
										}
#line 672 "../lib/Items/ApplicationDockItem.vala"
										if (!found) {
#line 673 "../lib/Items/ApplicationDockItem.vala"
											_tmp91_ = (_vala_array_free (_tmp91_, _tmp91__length1, (GDestroyNotify) g_free), NULL);
#line 673 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 673 "../lib/Items/ApplicationDockItem.vala"
											continue;
#line 4246 "ApplicationDockItem.c"
										}
#line 663 "../lib/Items/ApplicationDockItem.vala"
										_tmp91_ = (_vala_array_free (_tmp91_, _tmp91__length1, (GDestroyNotify) g_free), NULL);
#line 4250 "ApplicationDockItem.c"
									}
#line 676 "../lib/Items/ApplicationDockItem.vala"
									_tmp99_ = file;
#line 676 "../lib/Items/ApplicationDockItem.vala"
									_tmp100_ = group;
#line 676 "../lib/Items/ApplicationDockItem.vala"
									_tmp101_ = g_key_file_get_locale_string (_tmp99_, _tmp100_, G_KEY_FILE_DESKTOP_KEY_NAME, NULL, &_inner_error0_);
#line 676 "../lib/Items/ApplicationDockItem.vala"
									action_name = _tmp101_;
#line 676 "../lib/Items/ApplicationDockItem.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 676 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (textdomain);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4272 "ApplicationDockItem.c"
											goto __catch2_g_key_file_error;
										}
#line 676 "../lib/Items/ApplicationDockItem.vala"
										_g_key_file_unref0 (file);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_icon);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_text);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										g_clear_error (&_inner_error0_);
#line 676 "../lib/Items/ApplicationDockItem.vala"
										return;
#line 4287 "ApplicationDockItem.c"
									}
#line 678 "../lib/Items/ApplicationDockItem.vala"
									_tmp102_ = g_strdup ("");
#line 678 "../lib/Items/ApplicationDockItem.vala"
									action_icon = _tmp102_;
#line 679 "../lib/Items/ApplicationDockItem.vala"
									_tmp104_ = file;
#line 679 "../lib/Items/ApplicationDockItem.vala"
									_tmp105_ = group;
#line 679 "../lib/Items/ApplicationDockItem.vala"
									_tmp103_ = g_key_file_has_key (_tmp104_, _tmp105_, G_KEY_FILE_DESKTOP_KEY_ICON, &_inner_error0_);
#line 679 "../lib/Items/ApplicationDockItem.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_icon);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_name);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (textdomain);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4315 "ApplicationDockItem.c"
											goto __catch2_g_key_file_error;
										}
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_key_file_unref0 (file);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_icon);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_text);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										g_clear_error (&_inner_error0_);
#line 679 "../lib/Items/ApplicationDockItem.vala"
										return;
#line 4330 "ApplicationDockItem.c"
									}
#line 679 "../lib/Items/ApplicationDockItem.vala"
									if (_tmp103_) {
#line 4334 "ApplicationDockItem.c"
										gchar* _tmp106_ = NULL;
										GKeyFile* _tmp107_;
										const gchar* _tmp108_;
										gchar* _tmp109_;
										gchar* _tmp110_;
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_tmp107_ = file;
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_tmp108_ = group;
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_tmp109_ = g_key_file_get_locale_string (_tmp107_, _tmp108_, G_KEY_FILE_DESKTOP_KEY_ICON, NULL, &_inner_error0_);
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_tmp106_ = _tmp109_;
#line 680 "../lib/Items/ApplicationDockItem.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (action_icon);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (action_name);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (textdomain);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4364 "ApplicationDockItem.c"
												goto __catch2_g_key_file_error;
											}
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_key_file_unref0 (file);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_icon);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_text);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											g_clear_error (&_inner_error0_);
#line 680 "../lib/Items/ApplicationDockItem.vala"
											return;
#line 4379 "ApplicationDockItem.c"
										}
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_tmp110_ = _tmp106_;
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_tmp106_ = NULL;
#line 680 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_icon);
#line 680 "../lib/Items/ApplicationDockItem.vala"
										action_icon = _tmp110_;
#line 679 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_tmp106_);
#line 4391 "ApplicationDockItem.c"
									}
#line 682 "../lib/Items/ApplicationDockItem.vala"
									_tmp111_ = g_strdup ("");
#line 682 "../lib/Items/ApplicationDockItem.vala"
									action_exec = _tmp111_;
#line 683 "../lib/Items/ApplicationDockItem.vala"
									_tmp113_ = file;
#line 683 "../lib/Items/ApplicationDockItem.vala"
									_tmp114_ = group;
#line 683 "../lib/Items/ApplicationDockItem.vala"
									_tmp112_ = g_key_file_has_key (_tmp113_, _tmp114_, G_KEY_FILE_DESKTOP_KEY_EXEC, &_inner_error0_);
#line 683 "../lib/Items/ApplicationDockItem.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_exec);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_icon);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_name);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (group);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (textdomain);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4421 "ApplicationDockItem.c"
											goto __catch2_g_key_file_error;
										}
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_key_file_unref0 (file);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_icon);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_vala_text);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										g_clear_error (&_inner_error0_);
#line 683 "../lib/Items/ApplicationDockItem.vala"
										return;
#line 4436 "ApplicationDockItem.c"
									}
#line 683 "../lib/Items/ApplicationDockItem.vala"
									if (_tmp112_) {
#line 4440 "ApplicationDockItem.c"
										gchar* _tmp115_ = NULL;
										GKeyFile* _tmp116_;
										const gchar* _tmp117_;
										gchar* _tmp118_;
										gchar* _tmp119_;
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_tmp116_ = file;
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_tmp117_ = group;
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_tmp118_ = g_key_file_get_string (_tmp116_, _tmp117_, G_KEY_FILE_DESKTOP_KEY_EXEC, &_inner_error0_);
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_tmp115_ = _tmp118_;
#line 684 "../lib/Items/ApplicationDockItem.vala"
										if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (action_exec);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (action_icon);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (action_name);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (group);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (textdomain);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 4472 "ApplicationDockItem.c"
												goto __catch2_g_key_file_error;
											}
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_key_file_unref0 (file);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_icon);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											_g_free0 (_vala_text);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											g_clear_error (&_inner_error0_);
#line 684 "../lib/Items/ApplicationDockItem.vala"
											return;
#line 4487 "ApplicationDockItem.c"
										}
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_tmp119_ = _tmp115_;
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_tmp115_ = NULL;
#line 684 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_exec);
#line 684 "../lib/Items/ApplicationDockItem.vala"
										action_exec = _tmp119_;
#line 683 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (_tmp115_);
#line 4499 "ApplicationDockItem.c"
									}
#line 687 "../lib/Items/ApplicationDockItem.vala"
									_tmp120_ = textdomain;
#line 687 "../lib/Items/ApplicationDockItem.vala"
									if (_tmp120_ != NULL) {
#line 4505 "ApplicationDockItem.c"
										const gchar* _tmp121_;
										const gchar* _tmp122_;
										gchar* _tmp123_;
#line 688 "../lib/Items/ApplicationDockItem.vala"
										_tmp121_ = textdomain;
#line 688 "../lib/Items/ApplicationDockItem.vala"
										_tmp122_ = action_name;
#line 688 "../lib/Items/ApplicationDockItem.vala"
										_tmp123_ = g_strdup (g_dgettext (_tmp121_, _tmp122_));
#line 688 "../lib/Items/ApplicationDockItem.vala"
										_g_free0 (action_name);
#line 688 "../lib/Items/ApplicationDockItem.vala"
										action_name = _tmp123_;
#line 4519 "ApplicationDockItem.c"
									}
#line 690 "../lib/Items/ApplicationDockItem.vala"
									_tmp124_ = action_name;
#line 690 "../lib/Items/ApplicationDockItem.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) actions, _tmp124_);
#line 691 "../lib/Items/ApplicationDockItem.vala"
									_tmp125_ = action_name;
#line 691 "../lib/Items/ApplicationDockItem.vala"
									_tmp126_ = action_exec;
#line 691 "../lib/Items/ApplicationDockItem.vala"
									_tmp127_ = action_icon;
#line 691 "../lib/Items/ApplicationDockItem.vala"
									_tmp128_ = g_strdup_printf ("%s;;%s", _tmp126_, _tmp127_);
#line 691 "../lib/Items/ApplicationDockItem.vala"
									_tmp129_ = _tmp128_;
#line 691 "../lib/Items/ApplicationDockItem.vala"
									gee_map_set (actions_map, _tmp125_, _tmp129_);
#line 691 "../lib/Items/ApplicationDockItem.vala"
									_g_free0 (_tmp129_);
#line 633 "../lib/Items/ApplicationDockItem.vala"
									_g_free0 (action_exec);
#line 633 "../lib/Items/ApplicationDockItem.vala"
									_g_free0 (action_icon);
#line 633 "../lib/Items/ApplicationDockItem.vala"
									_g_free0 (action_name);
#line 633 "../lib/Items/ApplicationDockItem.vala"
									_g_free0 (group);
#line 4547 "ApplicationDockItem.c"
								}
							}
						}
#line 629 "../lib/Items/ApplicationDockItem.vala"
						_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 4553 "ApplicationDockItem.c"
					}
				}
			}
#line 623 "../lib/Items/ApplicationDockItem.vala"
			keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 4559 "ApplicationDockItem.c"
		}
#line 605 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (textdomain);
#line 4563 "ApplicationDockItem.c"
	}
	goto __finally2;
	__catch2_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp130_;
		const gchar* _tmp131_;
#line 605 "../lib/Items/ApplicationDockItem.vala"
		e = _inner_error0_;
#line 605 "../lib/Items/ApplicationDockItem.vala"
		_inner_error0_ = NULL;
#line 696 "../lib/Items/ApplicationDockItem.vala"
		_tmp130_ = e;
#line 696 "../lib/Items/ApplicationDockItem.vala"
		_tmp131_ = _tmp130_->message;
#line 696 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("ApplicationDockItem.vala:696: %s: %s", launcher, _tmp131_);
#line 697 "../lib/Items/ApplicationDockItem.vala"
		_g_error_free0 (e);
#line 697 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 697 "../lib/Items/ApplicationDockItem.vala"
		if (icon) {
#line 697 "../lib/Items/ApplicationDockItem.vala"
			*icon = _vala_icon;
#line 4589 "ApplicationDockItem.c"
		} else {
#line 697 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_icon);
#line 4593 "ApplicationDockItem.c"
		}
#line 697 "../lib/Items/ApplicationDockItem.vala"
		if (text) {
#line 697 "../lib/Items/ApplicationDockItem.vala"
			*text = _vala_text;
#line 4599 "ApplicationDockItem.c"
		} else {
#line 697 "../lib/Items/ApplicationDockItem.vala"
			_g_free0 (_vala_text);
#line 4603 "ApplicationDockItem.c"
		}
#line 697 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 4607 "ApplicationDockItem.c"
	}
	__finally2:
#line 605 "../lib/Items/ApplicationDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 605 "../lib/Items/ApplicationDockItem.vala"
		_g_key_file_unref0 (file);
#line 605 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_icon);
#line 605 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_text);
#line 605 "../lib/Items/ApplicationDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 605 "../lib/Items/ApplicationDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 605 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 4624 "ApplicationDockItem.c"
	}
#line 562 "../lib/Items/ApplicationDockItem.vala"
	_g_key_file_unref0 (file);
#line 562 "../lib/Items/ApplicationDockItem.vala"
	if (icon) {
#line 562 "../lib/Items/ApplicationDockItem.vala"
		*icon = _vala_icon;
#line 4632 "ApplicationDockItem.c"
	} else {
#line 562 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_icon);
#line 4636 "ApplicationDockItem.c"
	}
#line 562 "../lib/Items/ApplicationDockItem.vala"
	if (text) {
#line 562 "../lib/Items/ApplicationDockItem.vala"
		*text = _vala_text;
#line 4642 "ApplicationDockItem.c"
	} else {
#line 562 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (_vala_text);
#line 4646 "ApplicationDockItem.c"
	}
}

static void
plank_application_dock_item_unity_update_application_uri (PlankApplicationDockItem* self)
{
	const gchar* _tmp0_ = NULL;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp2_;
	const gchar* desktop_file = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar** p = NULL;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint p_length1;
	gint _p_size_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp17_;
	gchar* _tmp18_;
#line 702 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 704 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (self->priv->unity_application_uri);
#line 704 "../lib/Items/ApplicationDockItem.vala"
	self->priv->unity_application_uri = NULL;
#line 706 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = plank_application_dock_item_get_App (self);
#line 706 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = _tmp1_;
#line 706 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_ != NULL) {
#line 4685 "ApplicationDockItem.c"
		BamfApplication* _tmp3_;
		BamfApplication* _tmp4_;
		const gchar* _tmp5_;
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_application_dock_item_get_App (self);
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = bamf_application_get_desktop_file (_tmp4_);
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = _tmp5_;
#line 4697 "ApplicationDockItem.c"
	} else {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp6_ = plank_dock_item_get_Launcher ((PlankDockItem*) self);
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp7_ = _tmp6_;
#line 706 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = _tmp7_;
#line 4707 "ApplicationDockItem.c"
	}
#line 706 "../lib/Items/ApplicationDockItem.vala"
	desktop_file = _tmp0_;
#line 707 "../lib/Items/ApplicationDockItem.vala"
	_tmp9_ = desktop_file;
#line 707 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp9_ == NULL) {
#line 707 "../lib/Items/ApplicationDockItem.vala"
		_tmp8_ = TRUE;
#line 4717 "ApplicationDockItem.c"
	} else {
		const gchar* _tmp10_;
#line 707 "../lib/Items/ApplicationDockItem.vala"
		_tmp10_ = desktop_file;
#line 707 "../lib/Items/ApplicationDockItem.vala"
		_tmp8_ = g_strcmp0 (_tmp10_, "") == 0;
#line 4724 "ApplicationDockItem.c"
	}
#line 707 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp8_) {
#line 708 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 4730 "ApplicationDockItem.c"
	}
#line 710 "../lib/Items/ApplicationDockItem.vala"
	_tmp11_ = desktop_file;
#line 710 "../lib/Items/ApplicationDockItem.vala"
	_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, "/", 0);
#line 710 "../lib/Items/ApplicationDockItem.vala"
	p = _tmp13_;
#line 710 "../lib/Items/ApplicationDockItem.vala"
	p_length1 = _vala_array_length (_tmp12_);
#line 710 "../lib/Items/ApplicationDockItem.vala"
	_p_size_ = p_length1;
#line 711 "../lib/Items/ApplicationDockItem.vala"
	_tmp14_ = p;
#line 711 "../lib/Items/ApplicationDockItem.vala"
	_tmp14__length1 = p_length1;
#line 711 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp14__length1 == 0) {
#line 712 "../lib/Items/ApplicationDockItem.vala"
		p = (_vala_array_free (p, p_length1, (GDestroyNotify) g_free), NULL);
#line 712 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 4752 "ApplicationDockItem.c"
	}
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_tmp15_ = p;
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_tmp15__length1 = p_length1;
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_tmp16_ = p;
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_tmp16__length1 = p_length1;
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_tmp17_ = _tmp15_[_tmp16__length1 - 1];
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_tmp18_ = g_strdup_printf ("application://%s", _tmp17_);
#line 714 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (self->priv->unity_application_uri);
#line 714 "../lib/Items/ApplicationDockItem.vala"
	self->priv->unity_application_uri = _tmp18_;
#line 702 "../lib/Items/ApplicationDockItem.vala"
	p = (_vala_array_free (p, p_length1, (GDestroyNotify) g_free), NULL);
#line 4772 "ApplicationDockItem.c"
}

/**
 * Get libunity application URI
 *
 * @return the libunity application uri of this item, or NULL
 */
const gchar*
plank_application_dock_item_get_unity_application_uri (PlankApplicationDockItem* self)
{
	const gchar* _tmp0_;
	const gchar* result;
#line 722 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 724 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = self->priv->unity_application_uri;
#line 724 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp0_;
#line 724 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 4793 "ApplicationDockItem.c"
}

/**
 * Get current libunity dbusname
 *
 * @return the dbusname which provides the LauncherEntry interface, or NULL
 */
const gchar*
plank_application_dock_item_get_unity_dbusname (PlankApplicationDockItem* self)
{
	const gchar* _tmp0_;
	const gchar* result;
#line 732 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 734 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = self->priv->unity_dbusname;
#line 734 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp0_;
#line 734 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 4814 "ApplicationDockItem.c"
}

/**
 * Whether this item provides information worth showing
 */
gboolean
plank_application_dock_item_has_unity_info (PlankApplicationDockItem* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 740 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 742 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = plank_dock_item_get_ProgressVisible ((PlankDockItem*) self);
#line 742 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = _tmp1_;
#line 742 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp2_) {
#line 742 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = TRUE;
#line 4837 "ApplicationDockItem.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 742 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = plank_dock_item_get_CountVisible ((PlankDockItem*) self);
#line 742 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = _tmp3_;
#line 742 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = _tmp4_;
#line 4847 "ApplicationDockItem.c"
	}
#line 742 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp0_;
#line 742 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 4853 "ApplicationDockItem.c"
}

/**
 * Update this item's remote libunity value based on the given data
 *
 * @param sender_name the corressponding dbusname
 * @param prop_iter the data in a standardize format from libunity
 */
void
plank_application_dock_item_unity_update (PlankApplicationDockItem* self,
                                          const gchar* sender_name,
                                          GVariantIter* prop_iter)
{
	gchar* _tmp0_;
	gchar* prop_key = NULL;
	GVariant* prop_value = NULL;
#line 751 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 751 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (sender_name != NULL);
#line 751 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (prop_iter != NULL);
#line 753 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = g_strdup (sender_name);
#line 753 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (self->priv->unity_dbusname);
#line 753 "../lib/Items/ApplicationDockItem.vala"
	self->priv->unity_dbusname = _tmp0_;
#line 758 "../lib/Items/ApplicationDockItem.vala"
	while (TRUE) {
#line 4884 "ApplicationDockItem.c"
		gchar* _tmp1_ = NULL;
		GVariant* _tmp2_ = NULL;
		gboolean _tmp3_;
		const gchar* _tmp4_;
#line 758 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = g_variant_iter_next (prop_iter, "{sv}", &_tmp1_, &_tmp2_, NULL);
#line 758 "../lib/Items/ApplicationDockItem.vala"
		_g_free0 (prop_key);
#line 758 "../lib/Items/ApplicationDockItem.vala"
		prop_key = _tmp1_;
#line 758 "../lib/Items/ApplicationDockItem.vala"
		_g_variant_unref0 (prop_value);
#line 758 "../lib/Items/ApplicationDockItem.vala"
		prop_value = _tmp2_;
#line 758 "../lib/Items/ApplicationDockItem.vala"
		if (!_tmp3_) {
#line 758 "../lib/Items/ApplicationDockItem.vala"
			break;
#line 4903 "ApplicationDockItem.c"
		}
#line 759 "../lib/Items/ApplicationDockItem.vala"
		_tmp4_ = prop_key;
#line 759 "../lib/Items/ApplicationDockItem.vala"
		if (g_strcmp0 (_tmp4_, "count") == 0) {
#line 4909 "ApplicationDockItem.c"
			gint64 val = 0LL;
			GVariant* _tmp5_;
			gint64 _tmp6_;
			gint64 _tmp7_;
#line 760 "../lib/Items/ApplicationDockItem.vala"
			_tmp5_ = prop_value;
#line 760 "../lib/Items/ApplicationDockItem.vala"
			val = g_variant_get_int64 (_tmp5_);
#line 761 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = plank_dock_item_get_Count ((PlankDockItem*) self);
#line 761 "../lib/Items/ApplicationDockItem.vala"
			_tmp7_ = _tmp6_;
#line 761 "../lib/Items/ApplicationDockItem.vala"
			if (_tmp7_ != val) {
#line 762 "../lib/Items/ApplicationDockItem.vala"
				plank_dock_item_set_Count ((PlankDockItem*) self, val);
#line 4926 "ApplicationDockItem.c"
			}
		} else {
			const gchar* _tmp8_;
#line 763 "../lib/Items/ApplicationDockItem.vala"
			_tmp8_ = prop_key;
#line 763 "../lib/Items/ApplicationDockItem.vala"
			if (g_strcmp0 (_tmp8_, "count-visible") == 0) {
#line 4934 "ApplicationDockItem.c"
				gboolean val = FALSE;
				GVariant* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 764 "../lib/Items/ApplicationDockItem.vala"
				_tmp9_ = prop_value;
#line 764 "../lib/Items/ApplicationDockItem.vala"
				val = g_variant_get_boolean (_tmp9_);
#line 765 "../lib/Items/ApplicationDockItem.vala"
				_tmp10_ = plank_dock_item_get_CountVisible ((PlankDockItem*) self);
#line 765 "../lib/Items/ApplicationDockItem.vala"
				_tmp11_ = _tmp10_;
#line 765 "../lib/Items/ApplicationDockItem.vala"
				if (_tmp11_ != val) {
#line 766 "../lib/Items/ApplicationDockItem.vala"
					plank_dock_item_set_CountVisible ((PlankDockItem*) self, val);
#line 4951 "ApplicationDockItem.c"
				}
			} else {
				const gchar* _tmp12_;
#line 767 "../lib/Items/ApplicationDockItem.vala"
				_tmp12_ = prop_key;
#line 767 "../lib/Items/ApplicationDockItem.vala"
				if (g_strcmp0 (_tmp12_, "progress") == 0) {
#line 4959 "ApplicationDockItem.c"
					gdouble val = 0.0;
					GVariant* _tmp13_;
					gdouble _tmp14_;
					gdouble _tmp15_;
#line 768 "../lib/Items/ApplicationDockItem.vala"
					_tmp13_ = prop_value;
#line 768 "../lib/Items/ApplicationDockItem.vala"
					val = plank_nround (g_variant_get_double (_tmp13_), 3U);
#line 769 "../lib/Items/ApplicationDockItem.vala"
					_tmp14_ = plank_dock_item_get_Progress ((PlankDockItem*) self);
#line 769 "../lib/Items/ApplicationDockItem.vala"
					_tmp15_ = _tmp14_;
#line 769 "../lib/Items/ApplicationDockItem.vala"
					if (_tmp15_ != val) {
#line 770 "../lib/Items/ApplicationDockItem.vala"
						plank_dock_item_set_Progress ((PlankDockItem*) self, val);
#line 4976 "ApplicationDockItem.c"
					}
				} else {
					const gchar* _tmp16_;
#line 771 "../lib/Items/ApplicationDockItem.vala"
					_tmp16_ = prop_key;
#line 771 "../lib/Items/ApplicationDockItem.vala"
					if (g_strcmp0 (_tmp16_, "progress-visible") == 0) {
#line 4984 "ApplicationDockItem.c"
						gboolean val = FALSE;
						GVariant* _tmp17_;
						gboolean _tmp18_;
						gboolean _tmp19_;
#line 772 "../lib/Items/ApplicationDockItem.vala"
						_tmp17_ = prop_value;
#line 772 "../lib/Items/ApplicationDockItem.vala"
						val = g_variant_get_boolean (_tmp17_);
#line 773 "../lib/Items/ApplicationDockItem.vala"
						_tmp18_ = plank_dock_item_get_ProgressVisible ((PlankDockItem*) self);
#line 773 "../lib/Items/ApplicationDockItem.vala"
						_tmp19_ = _tmp18_;
#line 773 "../lib/Items/ApplicationDockItem.vala"
						if (_tmp19_ != val) {
#line 774 "../lib/Items/ApplicationDockItem.vala"
							plank_dock_item_set_ProgressVisible ((PlankDockItem*) self, val);
#line 5001 "ApplicationDockItem.c"
						}
					} else {
						const gchar* _tmp20_;
#line 775 "../lib/Items/ApplicationDockItem.vala"
						_tmp20_ = prop_key;
#line 775 "../lib/Items/ApplicationDockItem.vala"
						if (g_strcmp0 (_tmp20_, "urgent") == 0) {
#line 5009 "ApplicationDockItem.c"
							GVariant* _tmp21_;
#line 776 "../lib/Items/ApplicationDockItem.vala"
							_tmp21_ = prop_value;
#line 776 "../lib/Items/ApplicationDockItem.vala"
							plank_application_dock_item_set_urgent (self, g_variant_get_boolean (_tmp21_));
#line 5015 "ApplicationDockItem.c"
						}
					}
				}
			}
		}
	}
#line 751 "../lib/Items/ApplicationDockItem.vala"
	_g_variant_unref0 (prop_value);
#line 751 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (prop_key);
#line 5026 "ApplicationDockItem.c"
}

/**
 * Reset this item's remote libunity values
 */
void
plank_application_dock_item_unity_reset (PlankApplicationDockItem* self)
{
#line 797 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 799 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (self->priv->unity_dbusname);
#line 799 "../lib/Items/ApplicationDockItem.vala"
	self->priv->unity_dbusname = NULL;
#line 801 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_set_Count ((PlankDockItem*) self, (gint64) 0);
#line 802 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_set_CountVisible ((PlankDockItem*) self, FALSE);
#line 803 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_set_Progress ((PlankDockItem*) self, 0.0);
#line 804 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_set_ProgressVisible ((PlankDockItem*) self, FALSE);
#line 805 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_set_urgent (self, FALSE);
#line 5051 "ApplicationDockItem.c"
}

PlankApplicationDockItem*
plank_application_dock_item_construct (GType object_type)
{
	PlankApplicationDockItem * self = NULL;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	self = (PlankApplicationDockItem*) plank_dock_item_construct (object_type);
#line 25 "../lib/Items/ApplicationDockItem.vala"
	return self;
#line 5062 "ApplicationDockItem.c"
}

PlankApplicationDockItem*
plank_application_dock_item_new (void)
{
#line 25 "../lib/Items/ApplicationDockItem.vala"
	return plank_application_dock_item_construct (PLANK_TYPE_APPLICATION_DOCK_ITEM);
#line 5070 "ApplicationDockItem.c"
}

 G_GNUC_INTERNAL BamfApplication*
plank_application_dock_item_get_App (PlankApplicationDockItem* self)
{
	BamfApplication* result;
	gboolean _tmp0_ = FALSE;
	BamfApplication* _tmp1_;
	gboolean _tmp3_ = FALSE;
	BamfApplication* _tmp4_;
	BamfApplication* _tmp6_;
#line 70 "../lib/Items/ApplicationDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = self->priv->app;
#line 76 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp1_ == NULL) {
#line 76 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = TRUE;
#line 5090 "ApplicationDockItem.c"
	} else {
		BamfApplication* _tmp2_;
#line 76 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = self->priv->app;
#line 76 "../lib/Items/ApplicationDockItem.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, bamf_application_get_type ());
#line 5097 "ApplicationDockItem.c"
	}
#line 76 "../lib/Items/ApplicationDockItem.vala"
	g_warn_if_fail (_tmp0_);
#line 77 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = self->priv->app;
#line 77 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp4_ != NULL) {
#line 5105 "ApplicationDockItem.c"
		BamfApplication* _tmp5_;
#line 77 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = self->priv->app;
#line 77 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, bamf_application_get_type ());
#line 5111 "ApplicationDockItem.c"
	} else {
#line 77 "../lib/Items/ApplicationDockItem.vala"
		_tmp3_ = FALSE;
#line 5115 "ApplicationDockItem.c"
	}
#line 77 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp3_) {
#line 78 "../lib/Items/ApplicationDockItem.vala"
		_g_object_unref0 (self->priv->app);
#line 78 "../lib/Items/ApplicationDockItem.vala"
		self->priv->app = NULL;
#line 5123 "ApplicationDockItem.c"
	}
#line 80 "../lib/Items/ApplicationDockItem.vala"
	_tmp6_ = self->priv->app;
#line 80 "../lib/Items/ApplicationDockItem.vala"
	result = _tmp6_;
#line 80 "../lib/Items/ApplicationDockItem.vala"
	return result;
#line 5131 "ApplicationDockItem.c"
}

 G_GNUC_INTERNAL void
plank_application_dock_item_set_App (PlankApplicationDockItem* self,
                                     BamfApplication* value)
{
	BamfApplication* _tmp0_;
	BamfApplication* _tmp1_;
	BamfApplication* _tmp3_;
	BamfApplication* _tmp4_;
#line 82 "../lib/Items/ApplicationDockItem.vala"
	g_return_if_fail (self != NULL);
#line 83 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = self->priv->app;
#line 83 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp0_ == value) {
#line 84 "../lib/Items/ApplicationDockItem.vala"
		return;
#line 5150 "ApplicationDockItem.c"
	}
#line 86 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = self->priv->app;
#line 86 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp1_ != NULL) {
#line 5156 "ApplicationDockItem.c"
		BamfApplication* _tmp2_;
#line 87 "../lib/Items/ApplicationDockItem.vala"
		_tmp2_ = self->priv->app;
#line 87 "../lib/Items/ApplicationDockItem.vala"
		plank_application_dock_item_app_signals_disconnect (self, _tmp2_);
#line 5162 "ApplicationDockItem.c"
	}
#line 89 "../lib/Items/ApplicationDockItem.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 89 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->app);
#line 89 "../lib/Items/ApplicationDockItem.vala"
	self->priv->app = _tmp3_;
#line 91 "../lib/Items/ApplicationDockItem.vala"
	_tmp4_ = self->priv->app;
#line 91 "../lib/Items/ApplicationDockItem.vala"
	if (_tmp4_ != NULL) {
#line 5174 "ApplicationDockItem.c"
		BamfApplication* _tmp5_;
		gboolean _tmp6_ = FALSE;
		BamfApplication* _tmp7_;
#line 92 "../lib/Items/ApplicationDockItem.vala"
		_tmp5_ = self->priv->app;
#line 92 "../lib/Items/ApplicationDockItem.vala"
		plank_application_dock_item_app_signals_connect (self, _tmp5_);
#line 93 "../lib/Items/ApplicationDockItem.vala"
		plank_application_dock_item_initialize_states (self);
#line 94 "../lib/Items/ApplicationDockItem.vala"
		_tmp7_ = self->priv->app;
#line 94 "../lib/Items/ApplicationDockItem.vala"
		if (bamf_view_is_running ((BamfView*) _tmp7_)) {
#line 5188 "ApplicationDockItem.c"
			BamfApplication* _tmp8_;
#line 94 "../lib/Items/ApplicationDockItem.vala"
			_tmp8_ = self->priv->app;
#line 94 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = bamf_view_is_user_visible ((BamfView*) _tmp8_);
#line 5194 "ApplicationDockItem.c"
		} else {
#line 94 "../lib/Items/ApplicationDockItem.vala"
			_tmp6_ = FALSE;
#line 5198 "ApplicationDockItem.c"
		}
#line 94 "../lib/Items/ApplicationDockItem.vala"
		if (_tmp6_) {
#line 95 "../lib/Items/ApplicationDockItem.vala"
			g_signal_emit (self, plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_ADDED_SIGNAL], 0);
#line 5204 "ApplicationDockItem.c"
		}
	} else {
#line 97 "../lib/Items/ApplicationDockItem.vala"
		plank_application_dock_item_reset_application_status (self);
#line 5209 "ApplicationDockItem.c"
	}
#line 100 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_unity_update_application_uri (self);
#line 82 "../lib/Items/ApplicationDockItem.vala"
	g_object_notify_by_pspec ((GObject *) self, plank_application_dock_item_properties[PLANK_APPLICATION_DOCK_ITEM_APP_PROPERTY]);
#line 5215 "ApplicationDockItem.c"
}

static GObject *
plank_application_dock_item_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankApplicationDockItem * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashMap* _tmp2_;
#line 127 "../lib/Items/ApplicationDockItem.vala"
	parent_class = G_OBJECT_CLASS (plank_application_dock_item_parent_class);
#line 127 "../lib/Items/ApplicationDockItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 127 "../lib/Items/ApplicationDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_APPLICATION_DOCK_ITEM, PlankApplicationDockItem);
#line 129 "../lib/Items/ApplicationDockItem.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 129 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->supported_mime_types);
#line 129 "../lib/Items/ApplicationDockItem.vala"
	self->priv->supported_mime_types = _tmp0_;
#line 130 "../lib/Items/ApplicationDockItem.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 130 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->actions);
#line 130 "../lib/Items/ApplicationDockItem.vala"
	self->priv->actions = _tmp1_;
#line 131 "../lib/Items/ApplicationDockItem.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 131 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->actions_map);
#line 131 "../lib/Items/ApplicationDockItem.vala"
	self->priv->actions_map = _tmp2_;
#line 133 "../lib/Items/ApplicationDockItem.vala"
	plank_dock_item_load_from_launcher ((PlankDockItem*) self);
#line 127 "../lib/Items/ApplicationDockItem.vala"
	return obj;
#line 5257 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_class_init (PlankApplicationDockItemClass * klass,
                                        gpointer klass_data)
{
#line 25 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Items/ApplicationDockItem.vala"
	g_type_class_adjust_private_offset (klass, &PlankApplicationDockItem_private_offset);
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockElementClass *) klass)->on_clicked = (PlankAnimationType (*) (PlankDockElement*, PlankPopupButton, GdkModifierType, guint32)) plank_application_dock_item_real_on_clicked;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockElementClass *) klass)->on_scrolled = (PlankAnimationType (*) (PlankDockElement*, GdkScrollDirection, GdkModifierType, guint32)) plank_application_dock_item_real_on_scrolled;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockElementClass *) klass)->get_menu_items = (GeeArrayList* (*) (PlankDockElement*)) plank_application_dock_item_real_get_menu_items;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockElementClass *) klass)->get_drop_text = (gchar* (*) (PlankDockElement*)) plank_application_dock_item_real_get_drop_text;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockElementClass *) klass)->can_accept_drop = (gboolean (*) (PlankDockElement*, GeeArrayList*)) plank_application_dock_item_real_can_accept_drop;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockElementClass *) klass)->accept_drop = (gboolean (*) (PlankDockElement*, GeeArrayList*)) plank_application_dock_item_real_accept_drop;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	((PlankDockItemClass *) klass)->load_from_launcher = (void (*) (PlankDockItem*)) plank_application_dock_item_real_load_from_launcher;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_application_dock_item_get_property;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_application_dock_item_set_property;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_application_dock_item_constructor;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_application_dock_item_finalize;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_APPLICATION_DOCK_ITEM_APP_PROPERTY, plank_application_dock_item_properties[PLANK_APPLICATION_DOCK_ITEM_APP_PROPERTY] = g_param_spec_object ("App", "App", "App", bamf_application_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 5292 "ApplicationDockItem.c"
	/**
	 * Signal fired when the item's 'keep in dock' menu item is pressed.
	 */
#line 25 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_PIN_LAUNCHER_SIGNAL] = g_signal_new ("pin-launcher", PLANK_TYPE_APPLICATION_DOCK_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5298 "ApplicationDockItem.c"
	/**
	 * Signal fired when the application associated with this item closes.
	 */
#line 25 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_CLOSED_SIGNAL] = g_signal_new ("app-closed", PLANK_TYPE_APPLICATION_DOCK_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5304 "ApplicationDockItem.c"
	/**
	 * Signal fired when the application associated with this item opened a new window.
	 */
#line 25 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_ADDED_SIGNAL] = g_signal_new ("app-window-added", PLANK_TYPE_APPLICATION_DOCK_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5310 "ApplicationDockItem.c"
	/**
	 * Signal fired when the application associated with this item closed a window.
	 */
#line 25 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_signals[PLANK_APPLICATION_DOCK_ITEM_APP_WINDOW_REMOVED_SIGNAL] = g_signal_new ("app-window-removed", PLANK_TYPE_APPLICATION_DOCK_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5316 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_instance_init (PlankApplicationDockItem * self,
                                           gpointer klass)
{
#line 25 "../lib/Items/ApplicationDockItem.vala"
	self->priv = plank_application_dock_item_get_instance_private (self);
#line 68 "../lib/Items/ApplicationDockItem.vala"
	self->priv->app = NULL;
#line 108 "../lib/Items/ApplicationDockItem.vala"
	self->priv->unity_application_uri = NULL;
#line 109 "../lib/Items/ApplicationDockItem.vala"
	self->priv->unity_dbusname = NULL;
#line 5331 "ApplicationDockItem.c"
}

static void
plank_application_dock_item_finalize (GObject * obj)
{
	PlankApplicationDockItem * self;
#line 25 "../lib/Items/ApplicationDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_APPLICATION_DOCK_ITEM, PlankApplicationDockItem);
#line 138 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->supported_mime_types);
#line 138 "../lib/Items/ApplicationDockItem.vala"
	self->priv->supported_mime_types = NULL;
#line 139 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->actions);
#line 139 "../lib/Items/ApplicationDockItem.vala"
	self->priv->actions = NULL;
#line 140 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->actions_map);
#line 140 "../lib/Items/ApplicationDockItem.vala"
	self->priv->actions_map = NULL;
#line 142 "../lib/Items/ApplicationDockItem.vala"
	plank_application_dock_item_set_App (self, NULL);
#line 68 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->app);
#line 104 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->supported_mime_types);
#line 105 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->actions);
#line 106 "../lib/Items/ApplicationDockItem.vala"
	_g_object_unref0 (self->priv->actions_map);
#line 108 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (self->priv->unity_application_uri);
#line 109 "../lib/Items/ApplicationDockItem.vala"
	_g_free0 (self->priv->unity_dbusname);
#line 25 "../lib/Items/ApplicationDockItem.vala"
	G_OBJECT_CLASS (plank_application_dock_item_parent_class)->finalize (obj);
#line 5368 "ApplicationDockItem.c"
}

/**
 * A dock item for applications (with .desktop launchers).
 */
static GType
plank_application_dock_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankApplicationDockItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_application_dock_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankApplicationDockItem), 0, (GInstanceInitFunc) plank_application_dock_item_instance_init, NULL };
	GType plank_application_dock_item_type_id;
	plank_application_dock_item_type_id = g_type_register_static (PLANK_TYPE_DOCK_ITEM, "PlankApplicationDockItem", &g_define_type_info, 0);
	PlankApplicationDockItem_private_offset = g_type_add_instance_private (plank_application_dock_item_type_id, sizeof (PlankApplicationDockItemPrivate));
	return plank_application_dock_item_type_id;
}

GType
plank_application_dock_item_get_type (void)
{
	static volatile gsize plank_application_dock_item_type_id__once = 0;
	if (g_once_init_enter (&plank_application_dock_item_type_id__once)) {
		GType plank_application_dock_item_type_id;
		plank_application_dock_item_type_id = plank_application_dock_item_get_type_once ();
		g_once_init_leave (&plank_application_dock_item_type_id__once, plank_application_dock_item_type_id);
	}
	return plank_application_dock_item_type_id__once;
}

static void
_vala_plank_application_dock_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	PlankApplicationDockItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_APPLICATION_DOCK_ITEM, PlankApplicationDockItem);
#line 25 "../lib/Items/ApplicationDockItem.vala"
	switch (property_id) {
#line 25 "../lib/Items/ApplicationDockItem.vala"
		case PLANK_APPLICATION_DOCK_ITEM_APP_PROPERTY:
#line 25 "../lib/Items/ApplicationDockItem.vala"
		g_value_set_object (value, plank_application_dock_item_get_App (self));
#line 25 "../lib/Items/ApplicationDockItem.vala"
		break;
#line 5412 "ApplicationDockItem.c"
		default:
#line 25 "../lib/Items/ApplicationDockItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Items/ApplicationDockItem.vala"
		break;
#line 5418 "ApplicationDockItem.c"
	}
}

static void
_vala_plank_application_dock_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	PlankApplicationDockItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_APPLICATION_DOCK_ITEM, PlankApplicationDockItem);
#line 25 "../lib/Items/ApplicationDockItem.vala"
	switch (property_id) {
#line 25 "../lib/Items/ApplicationDockItem.vala"
		case PLANK_APPLICATION_DOCK_ITEM_APP_PROPERTY:
#line 25 "../lib/Items/ApplicationDockItem.vala"
		plank_application_dock_item_set_App (self, g_value_get_object (value));
#line 25 "../lib/Items/ApplicationDockItem.vala"
		break;
#line 5438 "ApplicationDockItem.c"
		default:
#line 25 "../lib/Items/ApplicationDockItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Items/ApplicationDockItem.vala"
		break;
#line 5444 "ApplicationDockItem.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 5455 "ApplicationDockItem.c"
		gssize i;
#line 52 "../lib/Docklets/DockletManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 52 "../lib/Docklets/DockletManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 52 "../lib/Docklets/DockletManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 5463 "ApplicationDockItem.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 52 "../lib/Docklets/DockletManager.vala"
	g_free (array);
#line 5478 "ApplicationDockItem.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 52 "../lib/Docklets/DockletManager.vala"
	if (array) {
#line 52 "../lib/Docklets/DockletManager.vala"
		while (((gpointer*) array)[length]) {
#line 52 "../lib/Docklets/DockletManager.vala"
			length++;
#line 5492 "ApplicationDockItem.c"
		}
	}
#line 52 "../lib/Docklets/DockletManager.vala"
	return length;
#line 5497 "ApplicationDockItem.c"
}

